C  This program numerically solve dx/dt=Vo+c to obtain shape of POS. Char.
C  It is similar to C1-CHAR.FOR with the exception that dq/dt is specified
C  at origin rather than dY/dt.  In addition statements have been added to
C solve for the flow variables at x=0 and other given positions.
C  The x axis is positive in the direction of flow, so the given x's are neg.
      PARAMETER (PI2=6.2831853)
      COMMON Yo,DQDT,VOC,C,G,V,qo
      REAL XD(10),CDD(10)
1     WRITE(*,*)' Give: Yo,Vo,dq/dt,To,DT,g'
      READ(*,*) Yo,Vo,DQDT,To,DT,G
      IF(Yo.LT.0.) STOP
      WRITE(*,*)' Give number of x position & these x''s'
      READ(*,*) N,(XD(I),I=1,N)
      Co=SQRT(G*Yo)
      DXDTo=Vo-co
      VOC=Vo+2.*Co
      VOCH=.5*VOC
      qo=Yo*Vo
      qmax=VOCH**3/(3.375*G)
      q=qo+To*DQDT
      IF(q.GT.qmax) THEN
      To=(qmax-qo)/DQDT
      q=qmax-1.E-5
      WRITE(*,*)' Flow rate limited to',qmax,' and To set to',To
      ENDIF
C Solves gq=c**2(2c+Vo-2co) using CRI method
      THETA=ACOS(6.75*G*q/VOCH**3-1.)
      C=VOCH*(1.-2.*COS((THETA+PI2)/3.))/3.
      V=VOC-2.*C
      DXT=V+C
      X=0.
      DTS=-.01
      Y=C*C/G
      WRITE(3,100) IFIX(To),X,C,Y,V,Y*V,DXT,C,Y,V,V*Y
100   FORMAT(I7,F8.1,4F7.3,5F8.3)
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XXX)
      IF(X.GT.DXDTo*T2) THEN
      CALL SLOPE(T2,X,DXT)
      Y=C*C/G
      QOR=qo+T2*DQDT
      THETA=ACOS(6.75*G*QOR/VOCH**3-1.)
      COR=VOCH*(1.-2.*COS((THETA+PI2)/3.))/3.
      YOR=COR**2/G
      VOR=VOC-2.*COR
      WRITE(3,100) IFIX(T2),X,C,Y,V,Y*V,DXT,COR,YOR,VOR,VOR*YOR
      IF(N.GT.0) THEN
      CD=COR
      DO 20 K=1,N
      IF(DXDTo*T2.GT.XD(K)) THEN
      CD=co
      ELSE
      M=0
15    F=ABS(qo-CD**2/G*(VOC-2.*CD))/ABS(DQDT)+XD(K)/(VOC-3.*CD)-T2
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      CC=CD
      CD=1.005*CD
      GO TO 15
      ENDIF
      DIF=(CD-CC)*FF/(F-FF)
      CD=CC-DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. M.LT.30) GO TO 15
      IF(M.EQ.30) WRITE(*,*)' Did not converge',DIF,K,CD
      ENDIF
20    CDD(K)=CD
      WRITE(4,120)IFIX(T2),(CDD(K),CDD(K)**2/G,VOC-2.*CDD(K),CDD(K)**2/G
     &*(VOC-2.*CDD(K)),K=1,N)
120   FORMAT(I5,40F8.3)
      ENDIF
      XO=X
      T1=T2
      GO TO 10
      ELSE
      B=(XO-X)/DT
      A=XO-B*T1
      T2=A/(DXDTo-B)
      X=DXDTo*T2
      Y=Co*Co/G
      QOR=qo+T2*DQDT
      THETA=ACOS(6.75*G*q/VOCH**3-1.)
      COR=VOCH*(1.-2.*COS((THETA+PI2)/3.))/3.
      YOR=COR**2/G
      VOR=VOC-2.*COR
      WRITE(3,110) T2,X,Co,Y,Vo,Vo*Y,Vo-Co,COR,YOR,VOR,YOR*VOR
110   FORMAT(F7.2,F8.1,4F7.3,5F8.3)
      GO TO 1
      ENDIF
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,DQDT,VOC,C,G,V,qo
      M=0
1     F=ABS(qo-C*C/G*(VOC-2.*C))/ABS(DQDT)+X/(VOC-3.*C)-T
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      CC=C
      C=1.005*C
      GO TO 1
      ENDIF
      DIF=(C-CC)*FF/(F-FF)
      C=CC-DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. M.LT.30) GO TO 1
      IF(M.EQ.30) THEN
      WRITE(*,*) ' Not conve.',T,X,C,DIF
      READ(*,*)
      ENDIF
      V=VOC-2.*C
      DXT=V+C
      RETURN
      END