C  This program numerically solve dx/dt=v+c to obtain shape of pos. Char.
C  It applies for a circular channel and generates a table of w values
C to interpolate from.   Program C1_CHWYQ is the same program as this program
C  except it applies for a trapezoidal channel.
      PARAMETER (N=200) 
      COMMON Yo,Qo,Q,DQDT,VOW,C,G,V,YY,D,RAD,SRAD,F,DY,W(N+10),IM
      WRITE(*,*)' Give: Yo,Qo,dQ/dt,To,DT,g,D, Est. for 1st Y'
      READ(*,*) Yo,Qo,DQDT,To,DT,G,D,YY
      RAD=D/2.
      SRAD=RAD*RAD
      SGD=SQRT(G*D)
      BETA=ACOS(1.-Yo/RAD)
      Ao=SRAD*(BETA-COS(BETA)*SIN(BETA))
      Vo=Qo/Ao
      Co=SQRT(G*Ao/(D*SIN(BETA)))
      DXDTo=Vo-co
1     DY=(Yo-.01)/FLOAT(N-1) 
      Y=.01 
      B1=ACOS(1.-Y/RAD)
      WF1=SGD*FW(B1) 
      W(1)=0. 
      DO 6 I=2,N+10
      SUM=0.
      Y=Y+DY
      B2=ACOS(1.-Y/RAD)
      DB=(B2-B1)/10.
      DB2=.5*DB
      DO 5 J=1,10
      WF=SGD*FW(B1+DB*FLOAT(J))
      SUM=SUM+DB2*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM
6     B1=B2
      VOW=Vo+W(N) 
      WRITE(*,300) Vo,VOW,W(N)
300   FORMAT(' Vo=',F8.3,' VOW=',F9.3,' wo=',F9.3)
      Q=Qo+DQDT*To
      X=0.
      DTS=-.01
      CALL SLOPE(To,X,DXT)
      WRITE(3,100) IFIX(To),X,C,YY,V,Q,DXT
100   FORMAT(I7,F9.2,3F7.3,F8.2,F8.3)
      F=0.
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XX)
      IF(X.GT.DXDTo*T2 .AND. YY.LE.Yo) THEN
      BETA=ACOS(1.-YY/RAD)
      A=SRAD*(BETA-COS(BETA)*SIN(BETA))
      WRITE(3,100) IFIX(T2),X,C,YY,V,V*A,V+C
      XO=X
      T1=T2
      GO TO 10
      ELSE
      B=(XO-X)/DT
      A=XO-B*T1
      T2=A/(DXDTo-B)
      X=DXDTo*T2
      WRITE(3,110) T2,X,Co,Yo,Vo,Qo,Vo+Co
110   FORMAT(F7.2,F9.2,3F7.3,F8.2,F8.3)
      STOP
      ENDIF
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,Qo,Q,DQDT,VOW,C,G,V,YY,D,RAD,SRAD,F,DY,W(210),IM
      IMM=0
      IF(ABS(X).LT. .001) THEN
      M=0
      GQ=G*Q
7     BETA=ACOS(1.-YY/RAD)
      TOP=D*SIN(BETA)
      CS=G*SRAD*(BETA-COS(BETA)*SIN(BETA))/TOP
      IM=IFIX((YY-.01)/DY)+1
      IF(IM.GT.219) THEN
      WRITE(*,*)' Table not large enough IM=',IM
      STOP
      ENDIF
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      V=VOW-(W(IM)+FAC*(W(IM+1)-W(IM)))
      F=CS*V-GQ/TOP
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      YT=YY
      YY=1.005*YY
      GO TO 7
      ENDIF
      DIF=(YY-YT)*FF/(F-FF)
      YY=YT-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 7
      IF(M.EQ.30) WRITE(*,*)' Failed to converge DIF=',DIF,IM,YY,X
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      ELSE
45    F1=F 
      V=VOW-W(IM) 
      Y=.01+FLOAT(IM-1)*DY 
      BETA=ACOS(1.-Y/RAD)
      A=SRAD*(BETA-COS(BETA)*SIN(BETA))
      Q=A*V 
      C=SQRT(G*A/(D*SIN(BETA)))
      F=ABS(Qo-Q)/ABS(DQDT)+ABS(X)/ABS(V-C)-T
      IF(F.EQ.0.) THEN
      FAC=0.
      GO TO 49
      ENDIF
      IF(((F.GT.0.).AND.(F1.LT.0.)).OR.((F.LT.0).AND.(F1.GT.0.)))
     & GO TO 48
      IF(F.LT.0.) THEN 
      IM=IM-1 
      IF(IM.GT.0) GO TO 45
      ELSE
      IM=IM+1
      IF(IM.LE.200) GO TO 45
      IF((F.GT.0. .AND. F1.GT.0.) .AND. (IMM.EQ.0)) THEN
      IM=IM-3
      IMM=1
      ENDIF
      IF(IM.LT.210) GO TO 45
      IM=209
      ENDIF 
48    IF(ABS(F1-F).LT.1.E-6) THEN
      FAC=0.
      ELSE
      FAC=ABS(F/(F1-F)) 
      ENDIF
49    YY=ABS(Y-FAC*DY)
      ENDIF
      V=VOW-(W(IM)+FAC*(W(IM+1)-W(IM)))
      BETA=ACOS(1.-YY/RAD)
      C=SQRT(G*SRAD*(BETA-COS(BETA)*SIN(BETA))/(D*SIN(BETA)))
      DXT=V+C
      RETURN
      END
      FUNCTION FW(BETA)
      SINB=SIN(BETA)
      FW=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END
