C  This program numerically solve dx/dt=v+c to obtain shape of pos. Char.
C  It applies for a trapezoidal channel and generates a table of w values
C to interpolate from.  The difference between this program and C2_CHWYQ is
C that it obtains the shape of the positive Char. in the xt-plane where x
C  is negative.
      PARAMETER (N=200) 
      COMMON Yo,Qo,Q,DQDT,VOW,C,G,V,YY,B,FM,FM2,F,DY,W(N+10),IM
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(*,*)' Give: Yo,Qo,dQ/dt,To,DT,g,b,m, Est. for 1st Y'
      READ(*,*) Yo,Qo,DQDT,To,DT,G,B,FM,YY
      FM2=2.*FM
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      Co=SQRT(G*Ao/(B+FM2*Yo))
      DXDTo=Vo-co
1     DY=(Yo-.01)/FLOAT(N-1) 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 6 I=2,N+10
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
6     Y=Y+DY 
      VOW=Vo+W(N) 
      WRITE(*,*) Vo,W(N),VOW
      Q=Qo+DQDT*To
      X=0.
      DTS=-.01
      CALL SLOPE(To,X,DXT)
      Q=V*(B+FM*YY)*YY
      WRITE(3,100) IFIX(To),X,C,YY,V,Q,DXT
100   FORMAT(I7,F9.2,3F7.3,F8.2,F8.3)
      F=ABS(Qo-Q)/ABS(DQDT)-To
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XX)
      IF(X.GT.DXDTo*T2 .AND. YY.LE.Yo) THEN
      WRITE(3,100) IFIX(T2),X,C,YY,V,V*(B+FM*YY)*YY,V+C
      XO=X
      T1=T2
      GO TO 10
      ELSE
      B=(XO-X)/DT
      A=XO-B*T1
      T2=A/(DXDTo-B)
      X=DXDTo*T2
      WRITE(3,110) T2,X,Co,Yo,Vo,Qo,Vo+Co
110   FORMAT(F7.2,F9.2,3F7.3,F8.2,F8.3)
      STOP
      ENDIF
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,Qo,Q,DQDT,VOW,C,G,V,YY,B,FM,FM2,F,DY,W(210),IM
      IMM=0
      IF(ABS(X).LT. .001) THEN
      M=0
      GQ=G*Q
7     CS=G*((B+FM*YY)*YY/(B+FM2*YY))
      IM=IFIX((YY-.01)/DY)+1
      IF(IM.GT.219) THEN
      WRITE(*,*)' Table not large enough IM=',IM
      STOP
      ENDIF
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      V=VOW-(W(IM)+FAC*(W(IM+1)-W(IM)))
      F=CS*V-GQ/(B+FM2*YY)
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      YT=YY
      YY=1.005*YY
      GO TO 7
      ENDIF
      DIF=(YY-YT)*FF/(F-FF)
      YY=YT-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 7
      IF(M.EQ.30) WRITE(*,*)' Failed to converge DIF=',DIF,IM,YY,X
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      ELSE
45    F1=F 
      V=VOW-W(IM) 
      Y=.01+FLOAT(IM-1)*DY 
      A=(B+FM*Y)*Y
      Q=A*V 
      F=ABS(Qo-Q)/ABS(DQDT)+ABS(X)/ABS(V-SQRT(G*A/(B+FM2*Y)))-T
      IF(F.EQ.0.) THEN
      FAC=0.
      GO TO 49
      ENDIF
      IF(((F.GT.0.).AND.(F1.LT.0.)).OR.((F.LT.0).AND.(F1.GT.0.)))
     & GO TO 48
      IF(F.LT.0.) THEN 
      IM=IM-1 
      IF(IM.GT.0) GO TO 45
      ELSE
      IM=IM+1
      IF(IM.LE.200) GO TO 45
      IF((F.GT.0. .AND. F1.GT.0.) .AND. (IMM.EQ.0)) THEN
      IM=IM-3
      IMM=1
      ENDIF
      IF(IM.LT.210) GO TO 45
      IM=209
      ENDIF 
48    IF(ABS(F1-F).LT.1.E-6) THEN
      FAC=0.
      ELSE
      FAC=ABS(F/(F1-F)) 
      ENDIF
49    YY=ABS(Y-FAC*DY)
      ENDIF
      V=VOW-(W(IM)+FAC*(W(IM+1)-W(IM)))
      C=SQRT(G*(B+FM*YY)*YY/(B+FM2*YY))
      DXT=V+C
      RETURN
      END