C  This program numerically solve dx/dt=v-c to obtain shape of neg. Char.
C  Rather than solve the implicit equation |Yo-c**2/g|/dYdt+x/(3c+VOC)-t=0
C by the Newton method it uses the solution available for a cubic equation
C to obtain c from this equation based on the given x(dependent var.) and t.
      COMMON Yo,VOC,C,G,V,rdY,p,p3,ps,pp3,Gr,Co
      WRITE(*,*)' Give: Yo,Vo,dYdt,To,DT,g'
      READ(*,*) Yo,Vo,DYDT,To,DT,G
      rdY=1./ABS(DYDT)
      Gr=G/(3.*rdY)
      Co=SQRT(G*Yo)
      DXDTo=Co+Vo
      VOC=Vo-2.*Co
      p=VOC/3.
      p3=p/3.
      ps=2.*p*p
      pp3=p*p/3.
      C=SQRT(G*(Yo+DYDT*To))
      V=2.*C+VOC
      DXT=V-C
      X=0.
      DTS=-.01
      Y=C*C/G
      WRITE(3,100) IFIX(To),X,C,Y,V,Y*V,DXT
100   FORMAT(I7,F8.2,4F7.3,F8.3)
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XX)
      IF(X.LT.DXDTo*T2) THEN
      CALL SLOPE(T2,X,DXT)
      Y=C*C/G
      WRITE(3,100) IFIX(T2),X,C,Y,V,Y*V,DXT
      XO=X
      T1=T2
      GO TO 10
      ELSE
      B=(XO-X)/DT
      A=XO-B*T1
      T2=A/(DXDTo-B)
      X=DXDTo*T2
      Y=Co*Co/G
      WRITE(3,110) T2,X,Co,Y,Vo,Vo*Y,Vo-Co
110   FORMAT(F7.2,F8.2,4F7.3,F8.3)
      STOP
      ENDIF
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,VOC,C,G,V,rdY,p,p3,ps,pp3,Gr,Co
      q=G*(T/rdY-Yo)
      r=q*p-Gr*X
      ca=q-pp3
      cb=((ps-9.*q)*p)/27.+r
      phi=ACOS(SQRT(6.75*(cb/ca)**2/ABS(ca)))
      C=-2.*SQRT(ABS(ca)/3.)*COS(phi/3.+2.094395)-p3
      V=2.*C+VOC
      DXT=V-C
      RETURN
      END