C  This program numerically solve dx/dt=v-c to obtain shape of neg. Char.
C  It applies for a circular channel and generates a table of w values
C in interpolate from. The difference between this program and C2_CHWYQ
C is that a series of characteristics are obtained.  Also two different
C rates of flow rate change dQ/dt are allowed DQDT1 and DQDT2
      PARAMETER (N=200,N1=240) 
      REAL TTo(19)/50.,75.,100.,125.,150.,175.,200.,225.,250.,275.,300.,
     &325.,350.,375.,400.,425.,450.,475.,500./
      COMMON Yo,Qo,DQDT1,DQDT2,TQ,VOW,C,G,V,YY,WW,D,RAD,RAD2,F,DY,Q,
     &QQ2,W(N1),IM,IMM
      WRITE(*,*)' Give: Yo,Qo,DQDT1,DQDT2,TQ,DT,g,D'
      READ(*,*) Yo,Qo,DQDT1,DQDT2,TQ,DT,G,D
      QQ2=Qo+DQDT1*TQ
      RAD=.5*D
      RAD2=RAD*RAD
      SGD=SQRT(G*D)
      BETA=ACOS(1.-Yo/RAD)
      Ao=RAD2*(BETA-COS(BETA)*SIN(BETA))
      Vo=Qo/Ao
      Qo=Ao*Vo
      Co=SQRT(G*Ao/(D*SIN(BETA)))
      DXDTo=Co+Vo
1     DY=(YO-.01)/FLOAT(N-1) 
      Y=.01
      B1=ACOS(1.-Y/RAD)
      WF1=SGD*FW(B1) 
      W(1)=0. 
      DO 6 I=2,N1
      SUM=0.
      Y=Y+DY
      B2=ACOS(1.-Y/RAD)
      DB=(B2-B1)/10.
      DB2=.5*DB
      DO 5 J=1,10
      WF=SGD*FW(B1+DB*FLOAT(J))
      SUM=SUM+DB2*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM
6     B1=B2
      VOW=VO-W(N) 
      WRITE(4,330) 0.,0.,3000./DXDTo,3000.
      DO 50 I=1,19
      To=TTo(I)
      IF(To.LE.TQ) THEN
      Q=Qo+DQDT1*To
      ELSE
      Q=QQ2+DQDT2*(To-TQ)
      ENDIF
      X=0.
      DTS=-.01
      YY=(Q/Qo)*Yo
      IF(YY.LT. .6*Yo) YY=.6*Yo 
      CALL SLOPE(To,X,DXT)
      IM=IFIX((Y-.01)/DY)+1
      IMM=IM-1
      WRITE(4,330) To,0.,To+3000./(V+C),3000.
330   FORMAT(/,2F10.3,/,2F10.3)
      WRITE(3,100) IFIX(To),X,C,YY,V,Q,DXT,V-WW
100   FORMAT(I7,F8.2,3F7.3,F8.2,2F8.3)
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XX)
      IF(X.LT.DXDTo*T2) THEN
      CALL SLOPE(T2,X,DXT)
      IF(YY.LE.Yo) THEN
      BETA=ACOS(1.-YY/RAD)
      Q=V*RAD2*(BETA-SIN(BETA)*COS(BETA))
      WRITE(3,100) IFIX(T2),X,C,YY,V,Q,DXT,V-WW
C  Right side of graph
      IF(X.GT. 3000.) GO TO 50
      XO=X
      T1=T2
      GO TO 10
      ENDIF
      ELSE
      BB=(XO-X)/DT
      A=XO-BB*T1
      T2=A/(DXDTo-BB)
      X=DXDTo*T2
      WRITE(3,110) T2,X,Co,Yo,Vo,Qo,Vo-Co
110   FORMAT(F7.2,F8.2,3F7.3,F8.2,F8.3)
      ENDIF
50    WRITE(3,112)
112   FORMAT('                                      ')
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,Qo,DQDT1,DQDT2,TQ,VOW,C,G,V,YY,WW,D,RAD,RAD2,F,DY,Q,
     &QQ2,W(240),IM,IMM
      IF(X.LT. .001) THEN
      M=0
      GQ=G*Q
7     BETA=ACOS(1.-YY/RAD)
      TOP=D*SIN(BETA)
      CS=G*((RAD2*(BETA-COS(BETA)*SIN(BETA)))/TOP)
      IM=IFIX((YY-.01)/DY)+1
      IF(IM.GT.239) THEN
      WRITE(*,*)' Table not large enough IM=',IM
      STOP
      ENDIF
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      F=CS*V-GQ/TOP
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      YT=YY
      YY=1.005*YY
      GO TO 7
      ENDIF
      DIF=(YY-YT)*FF/(F-FF)
      YY=YT-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 7
      IF(M.EQ.30) WRITE(*,*)' Not conv.',DIF,T,X
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      WW=W(IM)+FAC*(W(IM+1)-W(IM))
      V=WW+VOW
      ELSE
45    F1=F 
      V=W(IM)+VOW 
      Y=.01+FLOAT(IM-1)*DY 
      BETA=ACOS(1.-Y/RAD)
      A=RAD2*(BETA-SIN(BETA)*COS(BETA))
      Q=V*A
      IF(T.LE.TQ) THEN
      F=(Qo-Q)/ABS(DQDT1)+X/(V+SQRT(G*A/(D*SIN(BETA))))-T
      ELSE
      F=(QQ2-Q)/ABS(DQDT2)+X/(V+SQRT(G*A/(D*SIN(BETA))))-T+TQ
      ENDIF
      IF((F.GT.0.).AND.(F1.LT.0.) .OR.(F.LT.0).AND.(F1.GT.0.)) GO TO 48
      IF(F.LT.0.) THEN
      IMM=IM 
      IM=IM-1 
      IF(IM.GT.1) GO TO 45
      YY=0.
      WW=W(1)
      GO TO 49
      ELSE
      IMM=IM
      IM=IM+1
      IF(IM.LT.240) GO TO 45
      YY=Yo
      WW=W(239)
      GO TO 49
      ENDIF 
48    IF(ABS(F1-F).LT.1.E-6) THEN
      FAC=0.
      ELSE
      FAC=ABS(F/(F1-F))
      ENDIF
      IF(IM.GT.IMM) FAC=-FAC
      YY=Y+FAC*DY
      WW=W(IM)+FAC*ABS(W(IM)-W(IMM))
49    V=WW+VOW
      ENDIF
      COSB=1.-YY/RAD
      IF(COSB.GT.1.) COSB=1.
      IF(COSB.LT.-1.) COSB=-1.
      BETA=ACOS(COSB)
      C=SQRT(ABS(G*RAD2*(BETA-SIN(BETA)*COSB)/(D*SIN(BETA))))
      DXT=V-C
      RETURN
      END
      FUNCTION FW(BETA)
      SINB=SIN(BETA)
      FW=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END
