C  This program numerically solve dx/dt=v-c to obtain shape of neg. Char.
C  It applies for a trapezoidal channel and generates a table of w values
C to interpolate from.  The difference between this program and C2_CHWYQ
C is that a series of characteristics are obtained.  Also two different
C rates of flow rate change dQ/dt are allowed DQDT1 and DQDT2
      PARAMETER (N=200,N1=240) 
      REAL TTo(19)/50.,75.,100.,125.,150.,175.,200.,225.,250.,275.,300.,
     &325.,350.,375.,400.,425.,450.,475.,500./
      COMMON Yo,Qo,Q,QQ2,DQDT1,DQDT2,TQ,VOW,C,G,V,YY,B,FM,FM2,F,DY,
     &W(N1),IM
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y)) 
      WRITE(*,*)' Give: Yo,Qo,DQDT1,DQDT2,TQ,DT,g,b,m'
      READ(*,*) Yo,Qo,DQDT1,DQDT2,TQ,DT,G,B,FM
      QQ2=Qo+DQDT1*TQ
      FM2=2.*FM
      Ao=(B+FM*Yo)*Yo
      Vo=Qo/Ao
      Co=SQRT(G*Ao/(B+FM2*Yo))
      DXDTo=Co+Vo
1     DY=(Yo-.01)/FLOAT(N-1) 
      DY2=DY/10. 
      DYH=DY2/2. 
      Y=.01 
      WF1=FW(Y) 
      W(1)=0. 
      DO 6 I=2,N1
      SUM=0. 
      DO 5 J=1,10 
      WF=FW(Y+DY2*FLOAT(J)) 
      SUM=SUM+DYH*(WF1+WF) 
5     WF1=WF 
      W(I)=W(I-1)+SUM 
6     Y=Y+DY 
      VOW=VO-W(N) 
      WRITE(4,330) 0.,0.,3000./DXDTo,3000.
      DO 50 I=1,19
      To=TTo(I)
      IF(To.LE.TQ) THEN
      Q=Qo+DQDT1*To
      ELSE
      Q=QQ2+DQDT2*(To-TQ)
      ENDIF
7     IM=IFIX(((Q/Qo+.5)*Yo-.01)/DY)+1
      X=0.
      YY=(Q/Qo)*Yo
      IF(YY.LT. .6*Yo) YY=.6*Yo
      DTS=-.01
      CALL SLOPE(To,X,DXT)
      WRITE(4,330) To,0.,To+3000./(V+C),3000.
330   FORMAT(/,2F10.3,/,2F10.3)
      WRITE(3,100) IFIX(To),X,C,YY,V,V*(B+FM*YY)*YY,DXT
100   FORMAT(I7,F8.2,3F7.3,F8.2,F8.3)
      T1=To
10    T2=T1-DT
      CALL RUKUSTF(DTS,T1,T2,1.E-5,X,XX)
      IF(X.LT.DXDTo*T2) THEN
      CALL SLOPE(T2,X,DXT)
      IF(YY.LE.Yo) THEN
      WRITE(3,100) IFIX(T2),X,C,YY,V,V*(B+FM*YY)*YY,DXT
C  Right side of graph
      IF(X.GT. 3000.) GO TO 50
      XO=X
      T1=T2
      GO TO 10
      ENDIF
      ELSE
      BB=(XO-X)/DT
      A=XO-BB*T1
      T2=A/(DXDTo-BB)
      X=DXDTo*T2
      WRITE(3,110) T2,X,Co,Yo,Vo,Qo,Vo-Co
110   FORMAT(F7.2,F8.2,3F7.3,F8.2,F8.3)
      ENDIF
50    WRITE(3,112)
112   FORMAT('                                      ')
      END
      SUBROUTINE SLOPE(T,X,DXT)
      COMMON Yo,Qo,Q,QQ2,DQDT1,DQDT2,TQ,VOW,C,G,V,YY,B,FM,FM2,F,DY,
     &W(240),IM
      IF(X.LT. .001) THEN
      M=0
      GQ=G*Q
7     CS=G*((B+FM*YY)*YY/(B+FM2*YY))
      IM=IFIX((YY-.01)/DY)+1
      IF(IM.GT.239) THEN
      WRITE(*,*)' Table not large enough IM=',IM
      STOP
      ENDIF
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      F=CS*V-GQ/(B+FM2*YY)
      M=M+1
      IF(MOD(M,2).NE.0) THEN
      FF=F
      YT=YY
      YY=1.005*YY
      GO TO 7
      ENDIF
      DIF=(YY-YT)*FF/(F-FF)
      YY=YT-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 7
      IF(M.EQ.30) WRITE(*,*)' Not conv.',DIF,T,X
      FAC=(YY-(.01+FLOAT(IM-1)*DY))/DY
      ELSE
45    F1=F 
      V=W(IM)+VOW 
      Y=.01+FLOAT(IM-1)*DY 
      A=(B+FM*Y)*Y
      Q=A*V 
      IF(T.LE.TQ) THEN
      F=(Qo-Q)/ABS(DQDT1)+X/(V+SQRT(G*A/(B+FM2*Y)))-T
      ELSE
      F=(QQ2-Q)/ABS(DQDT2)+X/(V+SQRT(G*A/(B+FM2*Y)))-T+TQ
      ENDIF
      IF((F.GT.0.).AND.(F1.LT.0.) .OR.(F.LT.0).AND.(F1.GT.0.)) GO TO 48
      IF(F.LT.0.) THEN 
      IM=IM-1 
      IF(IM.GT.0) GO TO 45
      ELSE
      IM=IM+1
      IF(IM.LT.240) GO TO 45
      IM=239
      ENDIF 
48    IF(ABS(F1-F).LT.1.E-6) THEN
      FAC=0.
      ELSE
      FAC=ABS(F/(F1-F)) 
      ENDIF
      YY=ABS(Y-FAC*DY)
      ENDIF
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
      C=SQRT(G*(B+FM*YY)*YY/(B+FM2*YY))
      DXT=V-C
      RETURN
      END