C Program to solve flow in culverts with downstream control
C It is a modification of CULVERTD.FOR that uses Chezy's equation
      PARAMETER (N=3)
      LOGICAL BCDWN,GUESS/.FALSE./
      EXTERNAL DYX
      INTEGER*2 INDX(N)
      REAL FF(N),FF1(N),DJ(N,N)
      COMMON /ODE/ W(1,13),YODE(1),DY(1),XP(1),YP(1,1),H11
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/D,DH,D25,So,FL,G,TOL,X(3),Q2G,H1,H2,Chezye,FKE,eD,VIS
     &,E,FL1,Sf,IOUT,NEQ,BCDWN,SSF,C,SQG,QV4,SG
      WRITE(*,*)' Give kinematic viscosity'
      READ(*,*) VIS
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,D,H1,H2,Ke,L,Chezy_e,So,g,DX,e'
      READ(*,*) IOUT,TOL,ERR,D,H1,H2,FKE,FL,Chezye,So,G,DXI,e
      IOUTA=IABS(IOUT)
      WRITE(IOUTA,203) D,H1,H2,FKE,FL,Chezye,SO,e
203   FORMAT(' D=',F7.2,' H1=',F7.2,' H2=',F7.2,' Ke=',F7.3,' L=',F8.1,
     &/,' Chezy-e=',F8.5,' So=',F9.6,' e=',F8.5)
      Chezye=Chezye/12.
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      SSF=7.5
      IF(IOUT.LT.0) THEN
      GUESS=.TRUE.
      IOUT=IOUTA
      ENDIF
      IF(H2.GT.H1+So*FL) THEN
      WRITE(*,111) H2,H1,H2-So*FL-H1
111   FORMAT(' Downstream head',F8.2,' has a water surface elev. above u
     &pstream head',F8.2,/' This difference of',F8.3,' Will cause revers
     &e flow.')
      STOP
      ENDIF
      X(3)=0.
      FL1=FL
      BCDWN=.FALSE.
      DH=.5*D
      D25=.25*D*D
      eD=e/D
      AT=.78539816*D*D
      C=SQG*ALOG10(Chezye/(.75*AT/(2.356*D)))
      Q=C*AT*SQRT(So*AT/(3.14*D))
      QV4=4*Q/VIS
      FKE=(FKE+1.)/(2.*G)
      IF(GUESS) THEN
      WRITE(*,*)' Give est. for uniform & critical depths'
      READ(*,*) Y,YB
      ELSE
      Y=.92*H1
      ENDIF
C  To determine Uniform conditions 3 simultaneous equations need to be solved
C Chezy's, Energy at entrance & Chezy's C equations.  When using Mannings Eq. in
C Program CULVERTD the technique was used to substitute Q from Mannings Eq. into
C the Energy at entrance eq., getting a single equation giving the normal depth.
C The same technique is used here, i.e. Q from Chezy's is subst. into Energy.
C However, since C depends upon Q, Q must be evaluated within the iteration.
      M=0
      COSB=1.-Y/DH
      BETA=ACOS(COSB)
      CC=.221*VIS/SG
1     A=D25*(BETA-SIN(BETA)*COS(BETA))
      P=D*BETA
      Rh=A/P
4     C1=C
      Q=C*A*SQRT(Rh*So)
      C=SQG*ALOG10(Chezye/Rh+CC*C*P/Q)
      IF(ABS(C-C1).GT. 1.E-4) GO TO 4
      F=H1-DH*(1.-COS(BETA))-FKE*C**2*Rh*So
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 2
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 1
2     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 1
      Y=DH*(1.-COS(BETA))
      A=D25*(BETA-COS(BETA)*SIN(BETA))
      P=D*BETA
      Rh=A/P
3     C1=C
      Q=C*A*SQRT(Rh*So)
      C=SQG*ALOG10(Chezye/Rh+CC*C*P/Q)
      IF(ABS(C-C1).GT. 1.E-4) GO TO 3
      FKE=G*FKE
      WRITE(IOUT,112) Q,Y,A,C
112   FORMAT(' Uniform Q =',F9.2,' Y =',F8.3,' Area =',F8.2,' C=',F8.2)
      Q2G=Q*Q/G
      IF(.NOT.GUESS) YB=.6*Y
      CALL CRIT(YB,YC)
      WRITE(IOUT,113) YC
113   FORMAT(' Corresponding Critical Depth, Yc =',F8.3)
      IF(GUESS) THEN
      WRITE(*,*)' Give guess of Q and Y at entrance'
      READ(*,*) X(1),X(2)
      Q=X(1)
      QV4=4.*Q/VIS
      ELSE IF(Y+So*FL.GT.H2) THEN
      X(1)=Q
      X(2)=Y
      ELSE
      X(1)=.6*Q
      X(2)=1.01*Y
      ENDIF
      Q2G=Q*Q/G
      NEQ=2
      IF(H2.GT.YC) GO TO 8
      NEQ=3
      X(3)=YC
      BCDWN=.TRUE.
8     M=0
10    CALL FUN(FF)
      IF(FL1.LT.FL) NEQ=3
      DO 30 J=1,NEQ
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(FF1)
      DO 20 I=1,NEQ
20    DJ(I,J)=(FF1(I)-FF(I))/DX
30    X(J)=X(J)-DX
      CALL SOLVEQ(NEQ,1,N,DJ,FF,1,DD,INDX)
      SUM=0.
      DO 40 I=1,NEQ
      IF(FF(I).GT. 0.8*X(I)) FF(I)=.5*X(I)
      X(I)=X(I)-FF(I)
40    SUM=SUM+ABS(FF(I))
      M=M+1
      IF(M.LT.40 .AND. SUM.GT.ERR) GO TO 10
      IF(FL1.LT.FL) THEN
      FL1=X(3)+.025*D*(So-Sf)
      WRITE(IOUT,114) Sf,FL1
114   FORMAT(' Slope HGL for submerged culvert=',E10.4,' Intersection wi
     &th top at x=',F8.2)
      ENDIF
      WRITE(IOUT,100) X(1),X(2)
100   FORMAT(' Flowrate =',F10.2,', Upstream Depth =',F10.3)
      IF(BCDWN) WRITE(IOUT,101) X(3)
101   FORMAT(' Critical Depth at Downstream End =',F10.3)
      WRITE(IOUT,115) 
115   FORMAT(' Solution to GVF',/,'      x         Y       C',/,1X,
     &27('-'))
      XX=FL1
      IF(BCDWN) THEN
      YODE(1)=1.05*X(3)
      ELSE
      IF(FL1.LT.FL) THEN
      YODE(1)=.975*D
      ELSE
      YODE(1)=H2
      ENDIF
      ENDIF
      WRITE(IOUT,120) FL1,YODE,C
      DO 50 I=1,IFIX(FL1/DXI+.95)
      X2=XX-DXI
      IF(X2.LT.0.) X2=0.
      CALL ODESOL(YODE,DY,1,XX,X2,TOL,H11,.000001,1,XP,YP,W,DYX)
      WRITE(IOUT,120) X2,YODE,C
120   FORMAT(F10.2,F10.3,F8.2)
50    XX=X2 
      END
      SUBROUTINE CRIT(YB,YC)
      LOGICAL BCDWN
      COMMON /TRAS/D,DH,D25,So,FL,G,TOL,X(3),Q2G,H1,H2,Chezye,FKE,eD,VIS
     &,E,FL1,Sf,IOUT,NEQ,BCDWN,SSF,C,SQG,QV4,SG
      M=0
      COSB=1.-YB/DH
      BETA=ACOS(COSB)
1     F=Q2G*D*SIN(BETA)-(D25*(BETA-COS(BETA)*SIN(BETA)))**3
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 2
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 1
2     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 1
      YC=DH*(1.-COS(BETA))
      RETURN
      END
      SUBROUTINE FUN(F)
      LOGICAL BCDWN
      EXTERNAL DYX
      REAL F(3)
      COMMON /ODE/ W(1,13),Y(1),DY(1),XP(1),YP(1,1),H11
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/D,DH,D25,So,FL,G,TOL,X(3),Q2G,H1,H2,Chezye,FKE,eD,VIS
     &,E,FL1,Sf,IOUT,NEQ,BCDWN,SSF,C,SQG,QV4,SG
      H11=-1.
      Q2G=X(1)**2/G
      QV4=4.*X(1)/VIS
      COSB=1.-X(2)/DH
      IF(COSB.LT. -1.) COSB=-.98
      BETA=ACOS(COSB)
      A=D25*(BETA-COSB*SIN(BETA))
      F(1)=H1-X(2)-FKE*Q2G/A**2
      IF(BCDWN) THEN
      Y(1)=1.05*X(3)
      H11=-.05
      ELSE
      IF(H2.LT.D) THEN
      Y(1)=H2
      ELSE
      IF(e.LT.1.E-12) THEN
      Sf=.000668*X(1)**2/D**5.3333333
      ELSE
3     SSF1=SSF
      SSF=1.14-2.*ALOG(eD+7.3434728*VIS*D/(X(1)*SSF1))
      IF(ABS(SSF-SSF1).GT.1.E-6) GO TO 3
      Sf=Q2G/(2.*(SSF*.78539816*D*D)**2)
      ENDIF
      IF(X(3).EQ.0.) THEN
      FL1=FL-(H2-D)/(So-Sf)
      X(3)=FL1-.025*D*(So-Sf)
      ELSE
      F(3)=FL-(H2-.975*D)/(So-Sf)-X(3)
      ENDIF
      Y(1)=.975*D
      IF(X(3).LT.0. .OR. (Sf-So).GT.0.) THEN
      F(2)=H1-H2-FL*(Sf-So)
      WRITE(IOUT,112) H1,H1+1.6211389*FKE*Q2G/D**4
112   FORMAT(' Submerged to entrance, HGL at beg. =',F8.2, ' H1=',F8.2)
      RETURN
      ENDIF
      ENDIF
      ENDIF
      CALL ODESOL(Y,DY,1,FL1,0.,TOL,H11,.00001,1,XP,YP,W,DYX)
      F(2)=X(2)-Y(1)
      IF(NEQ.LT.3 .OR.FL1.LT.FL) RETURN
      BETA=ACOS(1.-X(3)/DH)
      A=D25*(BETA-COS(BETA)*SIN(BETA))
      F(3)=Q2G*D*SIN(BETA)-A**3
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL BCDWN
      REAL Y(1),DY(1)
      COMMON /TRAS/D,DH,D25,So,FL,G,TOL,X(3),Q2G,H1,H2,Chezye,FKE,eD,VIS
     &,E,FL1,Sf,IOUT,NEQ,BCDWN,SSF,C,SQG,QV4,SG
      YY=Y(1)
      IF(YY.LT. 0.05) YY=.05
      COSB=1.-YY/DH
      IF(COSB.LT. -1.) COSB=-.995
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      P=D*BETA
      A=D25*(BETA-COSB*SINB)
      Rh=A/P
      NCT=0
1     C1=C
      C=SQG*ALOG10(ABS(Chezye/Rh+.884*C/(SG*QV4/P)))
      NCT=NCT+1
      IF(ABS(C-C1).GT. 1.E-4 .AND. NCT.LT.20) GO TO 1
      SF=(X(1)/(C*A))**2/Rh
      DY(1)=(So-SF)/(1.-Q2G*D*SINB/A**3)
      RETURN
      END