C  Program to solve Flow in Culvert with upstream control.
C  This difference with this program and CULVERT is that Chezy's eq. is used.
      PARAMETER (N=3)
      EXTERNAL DYX
      INTEGER*2 INDX(N)
      REAL FF(N),FF1(N),DJ(N,N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/D,DH,DS6,D25,So,FL,G,TOL,e,C,SQG,QV4,SG,X(N),Q2G,H1,
     &Q,H2,DXU,DXD,AT,FMT,XTOP,HH2,YC,IOUT
      COMMON /TRANS1/ W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      WRITE(*,*)' Give kinematic viscosity'
      READ(*,*) VISC
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,D,Q,H1,H2,Ke,L,e,So,g,DXU,DXD'
      READ(*,*) IOUT,TOL,ERR,D,Q,H1,H2,FKE,FL,e,So,G,DXU,DXD
      IF(Q.EQ.0. .OR. H1.EQ.0.) GO TO 1
      WRITE(*,*)' Both Q and H1 cannot be given.  Which is unknown?'
      WRITE(*,*)' Give 1 = Q, or 2 = H1'
      READ(*,*) M
      IF(M.EQ.1) THEN
      Q=0.
      ELSE
      H1=0.
      ENDIF
1     e=e/12.
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      DH=.5*D
      DS6=D*D/6.
      D25=.25*D*D
      AT=.78539816*D*D
      C=SQG*ALOG10(e/(.75*AT/(2.356*D)))
      FKE1=(FKE+1.)/(2.*G)
      FKE=(FKE+1.)/8.
      M=0
      IF(Q.EQ. 0.) THEN
      IQ=0
      H1D=H1/D
      Q=.2687*H1D**3.906
      YC=Q**.254
      COSB=1.-2.*YC
      IF(COSB.LT. -1.) COSB=-.98
      BETA=ACOS(COSB)
      WRITE(*,*) YC,Q,BETA,H1D
2     F=.5*(1.-COS(BETA))+FKE*(BETA-COS(BETA)*SIN(BETA))/SIN(BETA)-H1D
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 3
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 2
3     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      WRITE(*,*)' M=',M,BETA,DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. M.LT.30) GO TO 2
      IF(M.GE.30) WRITE(*,*) DIF,BETA
      Q=(BETA-COS(BETA)*SIN(BETA))**3/(64.*SIN(BETA))
      WRITE(*,*) Q
      Q=SQRT(G*Q*D**5)
      YC=DH*(1.-COS(BETA))
      Q2G=Q*Q/G
      ELSE
      IQ=1
      Q2G=Q*Q/G
      BETA=1.5
      Q2GD=D*Q2G
4     F=Q2GD*SIN(BETA)-(D25*(BETA-COS(BETA)*SIN(BETA)))**3
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 5
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 4
5     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      WRITE(*,*)' M=',M,BETA,DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 4
      YC=DH*(1.-COS(BETA))
      H1=YC+4.*FKE*Q2G/(D25*(BETA-COS(BETA)*SIN(BETA)))**2
      ENDIF
      QV4=4.*Q/VISC
      WRITE(IOUT,100) Q,YC,H1,H2,D,FL,12.*e,So
100   FORMAT(' Q=',F8.2,', Yc=',F8.3,', H1=',F8.3,', H2=',F8.3,/' D=',
     &F7.1,', L=',F8.0, ', e=',F8.6,', So=',F8.6)
      FMT=DH*AT*Q2G/AT
      XTOP=0.
      X(3)=FL
      CALL FUN(FF,1)
      Y1=FF(1)
      Y2=2.*YC-Y1
      IF(Y2.GT.D) Y2=.98*D
      COSB=1.-Y1/DH
      BET1=ACOS(COSB)
      A1=D25*(BET1-SIN(BET1)*COSB)
      FMOM1=DH*(DS6*SIN(BET1)**3-A1*COSB)+Q2G/A1
      M=0
      BET2=ACOS(1.-2.*Y2/D)
30    A2=D25*(BET2-SIN(BET2)*COS(BET2))
      F=FMOM1-DH*(DS6*SIN(BET2)**3-A2*COS(BET2))-Q2G/A2
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 40
      F1=F
      BET=BET2
      BET2=1.02*BET2
      GO TO 30
40    DIF=(BET2-BET)*F1/(F-F1)
      BET2=BET-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 30
      Y2=DH*(1.-COS(BET2))
      IF(H2.LE.Y2) THEN
      WRITE(IOUT,110) H1,H2,Q,YC,Y1,Y2
110   FORMAT(' Case I occurs with S2-GVF thru entire length of culvert',
     &/,' H1 =',F8.2,' H2 =',F8.2,' Q =',F8.2,' Yc =',F8.2,' Depth at en
     &d =',F8.2,/,' Conjugate depth =',F8.2)
      IF(H2.GT.YC) WRITE(IOUT,120) Y2-H2
120   FORMAT(' Roller exists at end of culvert with height =',F8.2)
      IF(XTOP.GT.0.) WRITE(IOUT,130) HH2,XTOP
130   FORMAT(' Case III begins if the downstr. depth is',F8.2,' Pipe wil
     &l flow full from x=',F8.2)
      STOP
      ENDIF
      WRITE(*,*) ' Y1=',Y1,' Y2=',Y2
      X1=.8333*(.95*H2-Y1)/(So+(.95*YC-Y1)/FL)
      X1=.25*X1+.75*FL
      DELY=(YC-Y1)*X1/FL
      X(3)=FL-X1
      X(2)=H2-.2*DELY
      X(1)=Y1+DELY
      WRITE(*,*)' Initial',X
      READ(*,*) IK
      IF(IK.GT.0) READ(*,*) X
50    M=0
60    CALL FUN(FF,2)
      WRITE(*,*) ' FF=',FF
      DO 80 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(FF1,2)
      DO 70 I=1,N
70    DJ(I,J)=(FF1(I)-FF(I))/DX
80    X(J)=X(J)-DX
      CALL SOLVEQ(N,1,N,DJ,FF,1,DD,INDX)
      WRITE(*,*)' DIF',FF
      SUM=0.
      IF(ABS(FF(3)).GT.10.) THEN
      READ(*,*) IK
      IF(IK.GT.0) READ(*,*) FF
      ENDIF
      DO 90 I=1,N
      X(I)=X(I)-FF(I)
90    SUM=SUM+ABS(FF(I))
      M=M+1
      WRITE(*,140) M,SUM,X
140   FORMAT(' NCT=',I2,' SUM=',E12.5,3F10.4)
      read(*,*)
C      TOL=.25*TOL
C  Handles special case II of downstream control- GVF S1 reaches entrance
      IF(X(3).GT.0.) GO TO 98
      IF(M.LT.2) THEN
      X(3)=1.
      ELSE
      IF(IQ.EQ.1) THEN
      WRITE(*,141) Q
141   FORMAT(' Downstream GVF extends to entrance.',/,' Given Q too larg
     &e and for this Q downstream control occurs.  Q=',F10.1)
      STOP
      ELSE
      Y1=1.05*YC
      Q=.95*Q
      HMIN=.0001
      H11=-1.
      M=0
91    COSB=1.-2.*Y1/D
      BETA=ACOS(COSB)
      A=D25*(BETA-SIN(BETA)*COSB)
      FF(1)=H1-FKE1*(Q/A)**2
      Y(1)=H2
      CALL ODESOL(Y,DY,1,FL,0.,TOL,H11,HMIN,1,XP,YP,W,DYX)
      FF(2)=Y1-Y(1)
      M=M+1
      IF(MOD(M,3).EQ.1) THEN
      FF1(1)=FF(1)
      FF1(2)=FF(2)
      Y2=Y1
      Y1=1.02*Y1
      GO TO 91
      ELSE IF(MOD(M,3).EQ.2) THEN
      DJ(1,1)=(FF(1)-FF1(1))/(Y1-Y2)
      DJ(2,1)=(FF(2)-FF1(2))/(Y1-Y2)
      Y1=Y2
      Q2=Q
      Q=1.02*Q
      GO TO 91
      ELSE
      DJ(1,2)=(FF(1)-FF1(1))/(Q-Q2)
      DJ(2,2)=(FF(2)-FF1(2))/(Q-Q2)
      F1=DJ(2,1)/DJ(1,1)
      DJ(2,2)=DJ(2,2)-F1*DJ(1,2)
      FF1(2)=FF1(2)-F1*FF1(1)
      DIF=FF1(2)/DJ(2,2)
      Q=Q2-DIF
      SUM=ABS(DIF)
      DIF=(FF1(1)-DIF*DJ(1,2))/DJ(1,1)
      Y1=Y1-DIF
      SUM=SUM+ABS(DIF)
      WRITE(*,*)' M=',M,SUM,Y1,Q
      IF(M.LT.45 .AND.SUM.GT. .001) GO TO 91
      ENDIF
      QV4=4.*Q/VISC
      WRITE(IOUT,142) Y1,Q
142   FORMAT(' S-GVF reaches to entrance and control is actually downstr
     &eam.',/,' Flowrate reduced from critical and Q =',F10.1,' Y1=',
     &F10.2)
      STOP
      ENDIF
      ENDIF
98    IF(M.LT.30 .AND. SUM.GT. ERR) GO TO 60
      WRITE(IOUT,150) Q,YC,X
150   FORMAT(' Case II, Jump occurs within culvert: Q =',F8.2,' Yc =',
     &F8.2,' Depth upst. jump =',F8.2,' Depth downst. jump =',F8.2,
     &' Jump at position x =',F8.2)
      END
      SUBROUTINE FUN(F,N2)
      EXTERNAL DYX
      REAL F(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/D,DH,DS6,D25,So,FL,G,TOL,e,C,SQG,QV4,SG,X(3),Q2G,H1,
     &Q,H2,DXU,DXD,AT,FMT,XTOP,HH2,YC,IOUT
      COMMON /TRANS1/ W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      HMIN=.00001
      DO 10 I=1,N2
      IF(I.EQ.1) THEN
      H11=1.
      XX=0.
      XZ=X(3)
      DELX=DXU
      Y(1)=.95*YC
      ELSE
      H11=-1.
      XX=FL
      XZ=X(3)
      DELX=-ABS(DXD)
      Y(1)=H2
      ENDIF
      NS=(XZ-XX)/DELX+.98
      WRITE(IOUT,100) XX,Y
      DO 5 J=1,NS
      X2=XX+DELX
      IF(I.EQ.1) THEN
      IF(X2.GT.XZ) X2=XZ
      ELSE
      IF(X2.LT.XZ) X2=XZ
      ENDIF
      CALL ODESOL(Y,DY,1,XX,X2,TOL,H11,HMIN,1,XP,YP,W,DYX)
      COSB=1.-Y(1)/DH
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=D25*(BETA-COSB*SINB)
      FM=DH*(DS6*SINB**3-A*COSB)+Q2G/A
      WRITE(IOUT,100) X2,Y(1),A,FM,C
100   FORMAT(F8.1,2F8.3,2F8.2)
      F(I)=Y(1)
      IF(N2.EQ.1) THEN
      IF(FM.GT.FMT) THEN
      PHEAD=(FM-FMT)/AT
      XTOP=.5*(X2+XX)
      ENDIF
      ENDIF
5     XX=X2
      IF(N2.EQ.1) THEN
      IF(XTOP.GT.0.) THEN
      P=D*BETA
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QV4/P))
      IF(ABS(C-C1).GT. 1.E-5) GO TO 1
      SF=(Q/(C*A))**2/Rh
      HH2=PHEAD+D+(SO-SF)*(FL-XTOP)
      ENDIF
      RETURN
      ENDIF
      WRITE(*,*) I,F(I)
10    F(I)=F(I)-X(1)
      BET1=ACOS(1.-X(1)/DH)
      A1=D25*(BET1-COS(BET1)*SIN(BET1))
      BET2=ACOS(1.-X(2)/DH)
      A2=D25*(BET2-COS(BET2)*SIN(BET2))
      F(3)=DH*(DS6*(SIN(BET1)**3-SIN(BET2)**3)-A1*COS(BET1)+A2*COS(BET2)
     &)+Q2G*(1./A1-1./A2)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/D,DH,DS6,D25,So,FL,G,TOL,e,C,SQG,QV4,SG,X(3),Q2G,H1,
     &Q,H2,DXU,DXD,AT,FMT,XTOP,HH2,YC,IOUT
      YY=Y(1)
      IF(YY.LT. 0.05) YY=.05
      COSB=1.-YY/DH
      IF(COSB.LT. -1.) COSB=-.995
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      P=D*BETA
      A=D25*(BETA-COSB*SINB)
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QV4/P))
      IF(ABS(C-C1).GT. 1.E-5) GO TO 1
      SF=(Q/(C*A))**2/Rh
      SoSf=So-SF
      FRM1=1.-Q2G*D*SINB/A**3
      DY(1)=SoSf/FRM1
      RETURN
      END