C Program to solve flow in culverts with downstream control-Q (given)
C  Makes a table of upstream Y1 and H1 for increments of flowrate
      EXTERNAL DYX
      REAL Y(1),DY(1),W(1,13),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/D,DH,D25,So,Q2G,QN
      WRITE(*,*)' GIVE:TOL,D,Qbeg,Qend,Qinc,H2,Ke,L,n,So,g'
      READ(*,*) TOL,D,Qbeg,Qend,Qinc,H2,FKE,FL,FN,So,G
      G2=2.*G
      CC=1.486
      IF(G.LT.30.) CC=1.
      DH=.5*D
      D25=.25*D*D
      NUM=(Qend-Qbeg)/Qinc+.9
      DO 50 I=1,NUM
      Q=Qbeg+FLOAT(I-1)*Qinc
      QN=(FN*Q/CC)**2
      Q2G=Q*Q/G
      CALL CRIT(D*(Q2G/D**5)**.254,YC)
C      WRITE(*,113) YC
C113   FORMAT(' Critical Depth =',F8.3)
      HMIN=.00001
      H11=1.
      IF(H2.GT.1.1*YC) THEN
      Y(1)=H2
      ELSE
      Y(1)=1.1*YC
      WRITE(*,114) YC,H2,Q
114   FORMAT(' Depth at downstream end is critical',F8.2,' rather than H
     &2=',F8.2,' With Q=',F8.2)
      ENDIF
      CALL ODESOL(Y,DY,1,FL,0.,TOL,H11,HMIN,1,XP,YP,W,DYX)
      COSB=1.-Y(1)/DH
      BETA=ACOS(COSB)
      A=D25*(BETA-COSB*SIN(BETA))
      H1=Y(1)+(FKE+1.)*Q2G/(2.*A*A)
50    WRITE(3,115) Q,Y(1),H1,A,Yc
115   FORMAT(F8.2,2F8.3,F8.2,F8.3)
      END
      SUBROUTINE CRIT(YB,YC)
      COMMON /TRAS/D,DH,D25,So,Q2G,QN
      M=0
      COSB=1.-YB/DH
      BETA=ACOS(COSB)
1     F=Q2G*D*SIN(BETA)-(D25*(BETA-COS(BETA)*SIN(BETA)))**3
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 2
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 1
2     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      IF(ABS(DIF).GT.1.E-5 .AND. M.LT.30) GO TO 1
      YC=DH*(1.-COS(BETA))
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/D,DH,D25,So,Q2G,QN
      YY=Y(1)
      IF(YY.LT. 0.05) YY=.05
      COSB=1.-YY/DH
      IF(COSB.LT. -1.) COSB=-.995
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      P=D*BETA
      A=D25*(BETA-COSB*SINB)
      SoSf=So-QN*((P/A)**.666666667/A)**2
      FRM1=1.-Q2G*D*SINB/A**3
      DY(1)=SoSf/FRM1
      RETURN
      END