C  Program to solve Flow in Box Culvert with upstream control.
      PARAMETER (N=3,NP=31)
      EXTERNAL DYX
      CHARACTER*3 CASE
      REAL FMU(NP),FMD(NP),YU(NP),YD(NP)
      REAL W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/b,Height,So,G,QN,Q2G,SQ2G,H1,H2,YC,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,b,Height,Q,H1,H2,Ke,L,n,So,g'
      READ(*,*) IOUT,TOL,b,Height,Q,H1,H2,FKE,FL,FN,So,G
      IF(Q.EQ.0. .OR. H1.EQ.0.) GO TO 1
      WRITE(*,*)' Both Q and H1 cannot be given.  Which is unknown?'
      WRITE(*,*)' Give 1 = Q, or 2 = H1'
      READ(*,*) M
      IF(M.EQ.1) THEN
      Q=0.
      ELSE
      H1=0.
      ENDIF
1     IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      AT=b*Height
      IF(Q.EQ. 0.) THEN
      IQ=0
      YC=2.*H1/(3.+FKE)
      Q=b*SQRT(G*YC**3)
      ELSE
      YC=((Q/b)**2/G)**.33333333
      H1=YC*(3.+FKE)/2.
      ENDIF
      Q2G=Q*Q/G
      QN=(FN*Q/CC)**2
      SQ2G=(Q/b)**2/G
      WRITE(IOUT,100) Q,YC,H1,H2,b,Height,FL,FN,So
100   FORMAT(' Q=',F8.2,', Yc=',F8.3,', H1=',F8.3,', H2=',F8.3,/' b=',
     &F7.1,' Height=',F7.1,', L=',F8.0, ', n=',F8.4,', So=',F8.6)
      FMT=b*Height**2/2.+Q2G/AT
      YCP=(1.15+SO)*YC
      HMIN=.000001
      DELX=FL/FLOAT(NP-1)
C  Solves S2-GVF from entrance to end of culvert
      XX=0.
      XZ=DELX
      H11=.05
      Y(1)=.95*YC
      YU(1)=Y(1)
      FMU(1)=b*Y(1)**2/2.+Q2G/(b*Y(1))
      WRITE(IOUT,115) 'S2',0.,YU(1),b*Y(1),FMU(1)
115   FORMAT(/,A3,' - GVF Profile',/,4F10.3,/,'       x         Y         
     &  A       MOM.')
118   FORMAT(4F10.3)
      DO 10 I=2,NP
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
      YU(I)=Y(1)
      FMU(I)=b*Y(1)**2/2.+Q2G/(b*Y(1))
      WRITE(IOUT,118) XZ,YU(I),b*Y(1),FMU(I)
      XX=XZ
10    XZ=XZ+DELX
      Y2=2.*YC-YU(NP)
      IF(Y2.GT.Height) Y2=.9*Height
C  Solves Conjugate Depth at end of culvert
      Y2=.5*YU(NP)*(SQRT(1.+8.*(Q/b)**2/(G*YU(NP)**3))-1.)
      IF(H2.GT.Y2) THEN
      IF(Y2.GT.Height) WRITE(IOUT,106) Y2
106   FORMAT(' Conjugate depth at end is above top of culvert',F8.2)
      GO TO 15
      ENDIF
      WRITE(IOUT,110) H1,H2,Q,YC,YU(NP),Y2
110   FORMAT(' Case I occurs with S2-GVF thru entire length of culvert',
     &/,' H1 =',F8.2,' H2 =',F8.2,' Q =',F8.2,' Yc =',F8.2,' Depth at en
     &d =',F8.2,/,' Conjugate depth =',F8.2)
      IF(H2.LE.Y2) WRITE(IOUT,120) Y2-YU(NP)
120   FORMAT(' Roller exists at end of culvert with height =',F8.2)
      STOP
15    IF(H2.GT.Height) GO TO 40  
C     Case II - Hyd. Jump in culvert
      XX=FL
      H11=-1.
      XZ=XX-DELX
      IB=1
      Y(1)=H2
      YD(NP)=H2
      FMD(NP)=b*H2**2/2.+Q2G/(b*H2)
      WRITE(IOUT,115)'S1',FL,YD(NP),b*H2,FMD(NP)
      IE=NP
      CASE='II '
C  Solves S1-GVF profile
19    DO 20 I=IE-1,1,-1
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
      YD(I)=Y(1)
      FMD(I)=b*Y(1)**2/2.+Q2G/(b*Y(1))
      WRITE(IOUT,118) XZ,YD(I),b*Y(1),FMD(I)
      IF(Y(1).LT.YCP) THEN
      IB=I
      GO TO 22
      ENDIF
      XX=XZ
20    XZ=XZ-DELX
22    IF(IB.EQ.1 .AND. FMD(1).GT.FMU(1)) THEN
      WRITE(IOUT,160) H1,H2,Q
160   FORMAT(' Effects extend to entrance so downstream control occurs.'
     &,/,' Change specifications.',/,' H1=',F7.2,' H2=',F7.2,' Q=',F8.2)
      STOP
      ENDIF
      DO 25 I=IB,NP
      IF(FMU(I).LT.FMD(I)) GO TO 26
25    CONTINUE
26    IP=I-1
      FAC=(FMU(IP)-FMD(IP))/(FMD(IP+1)-FMD(IP)-FMU(IP+1)+FMU(IP))
      XX=DELX*(FLOAT(IP-1)+FAC)
      WRITE(IOUT,130) CASE,Q,YC,YU(IP)+FAC*(YU(IP+1)-YU(IP)),YD(IP)+FAC*
     &(YD(IP+1)-YD(IP)),XX
130   FORMAT(' Case ',A3,' Jump occurs within culvert: Q =',F8.2,' Yc ='
     &,F7.2,/,' Depth upst. jump=',F6.2,' Depth downst. jump =',F6.2,
     &' Jump position x=',F7.1)
      STOP
30    XX=(H2-Height)/(SO-SF)
      WRITE(IOUT,150) XX
150   FORMAT(' Case III - Culvert full at downstr. end for a distance of
     &',F8.2)
      IE=NP-XX/DELX-1.9
32    Y(1)=.98*Height
      YD(IE)=Height
      FMD(IE)=b*Y(1)**2/2.+Q2G/(b*Y(1))
      XX=DELX*FLOAT(IE-1)
      XZ=XX-DELX
      H11=-1.
      IB=1
      WRITE(IOUT,115)'S1',XX,Y(1),b*Y(1),FMD(IE)
      CASE='III'
      GO TO 19
40    SF=(FN*Q/(CC*AT*(AT/(2.*(b+Height)))**.6666667))**2
      XX=(H2-Height)/(SO-SF)
      IF(XX.GE.FL) THEN
      WRITE(IOUT,155) (XX-FL)*(SO-SF)+(FKE+1.)*(Q/AT)**2/(2.*G)
155   FORMAT(' Case V - Downstream H2 causes depth at entrance of',F9.2,
     &/,' Flow is downstream controlled.')
      STOP
      ENDIF
      DO 41 I=NP,1,-1
      IF(FMU(I).LT.FMT) GO TO 42
41    CONTINUE
      WRITE(IOUT,160) H1,H2,Q
      STOP
42    IE=I
      IF(IE.EQ.NP) GO TO 30
      X24L=DELX*(FLOAT(IE-1)+(FMT-FMU(IE))/(FMU(IE+1)-FMU(IE)))
      H24L=Height+(SO-SF)*(FL-X24L)
      WRITE(IOUT,180) X24L,FL-X24L,H24L
180   FORMAT(' Start of Case IV at x =',F8.2,' (from end=',F8.2,') Downs
     &tr. H2 required=',F8.2)
      DO 50 I=IE-1,NP
      PHEAD=H2-Height-(SO-SF)*(FL-DELX*FLOAT(I-1))
C      WRITE(IOUT,*) I,PHEAD,PHEAD*AT+FMT,FMU(I)
      IF(PHEAD.LT.0.) GO TO 50
      IF(PHEAD*AT+FMT.GT.FMU(I)) GO TO 50
      WRITE(IOUT,140) DELX*FLOAT(I-1),PHEAD,FMU(I)
140   FORMAT(' Case IV, H. Jump causes pipe flow downstream from x=',F8.
     &2,/,' The pressure head on top of culvert=',F8.2,' Mom=',F10.1)
      STOP
50    CONTINUE
      WRITE(IOUT,170) 
170   FORMAT(' Did not find location where Mu=Mt+AtPh')
      GO TO 32
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/b,Height,So,G,QN,Q2G,SQ2G,H1,H2,YC,IOUT
      YY=Y(1)
      IF(YY.LT. 0.05) YY=.05
      A=b*Y(1)
      P=b+2.*Y(1)
      SoSf=So-QN*((P/A)**.666666667/A)**2
      DY(1)=SoSf/(1.-(SQ2G/Y(1)**3))
      RETURN
      END