C Solves flow in circular channel that has a trapezoidal entrance at the reservoir.
C Equations are: Mannings, Energy at entrance, & Energy between 2 shapes.
      CHARACTER*17 FMT/'(1X,A2,'' ='',F9.3)'/
      CHARACTER*2 CX(12)/'b ','m ','D ','So','n ','Q ','H ','Y1','Y2',
     &'Ke','KL','Dz'/
      CHARACTER C1(12)/'2','2','2','5','3','1','2','2','2','3','3','2'/
      CHARACTER*5 CH(0:1)/'value','guess'/
      REAL F(3),F1(3),D(3,3)
      INTEGER*2 ID(12),INDX(3)
      COMMON X(12),G,G2,Cu
      WRITE(*,*)' Give: g, Hend & Del H'
      READ(*,*) G,H2,DELH
      G2=2.*G
      Cu=1.
      IF(G.GT.15.) Cu=1.486
1     DO 10 I=1,12
      WRITE(*,'(I3,2X,A2)') I,CX(I)
10    ID(I)=0
2     WRITE(*,*)' Give three numbers for 3 unknown variables'
      READ(*,*) I1,I2,I3
      IF(I1.LT.1.OR.I1.GT.12.OR.I2.LT.1.OR.I2.GT.12.OR.I3.LT.1.OR.I3.GT.
     &12) GO TO 2
      ID(I1)=1
      ID(I2)=1
      ID(I3)=1
      DO 20 I=1,12
      WRITE(*,100) CH(ID(I)),CX(I)
100   FORMAT(' Give ',A5,' for ',A2,' = ',\)
      READ(*,*) X(I)
20    CONTINUE
      NUM=(H2-X(7))/DELH+1.5
      DO 70 K=1,NUM
      NCT=0
30    SUM=0.
      CALL FUN(F)
      I1=0
      DO 40 I=1,12
      IF(ID(I).EQ.0) GO TO 40
      XX=X(I)
      I1=I1+1
      X(I)=1.005*X(I)
      CALL FUN(F1)
      DO 35 J=1,3
35    D(J,I1)=(F1(J)-F(J))/(X(I)-XX)
      X(I)=XX
40    CONTINUE
      CALL SOLVEQ(3,1,3,D,F,1,DD,INDX)
      I1=0
      DO 50 I=1,12
      IF(ID(I).EQ.0) GO TO 50
      I1=I1+1
      SUM=SUM+ABS(F(I1))
      X(I)=X(I)-F(I1)
50    CONTINUE
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,' SUM=',SUM
      IF(NCT.LT.30 .AND. SUM.GT.3.E-5) GO TO 30
      IF(K.EQ.1) THEN
      WRITE(*,*)' Solution:'
      DO 60 I=1,12
      FMT(16:16)=C1(I)
      WRITE(*,FMT) CX(I),X(I)
60    CONTINUE
      ENDIF
      FR21=X(6)**2*(X(1)+2.*X(8)*SQRT(X(2)**2+1.))/(G*((X(1)+X(2)*X(8))*
     &X(8))**3)
      BETA=ACOS(1.-2.*X(9)/X(3))
      A2=.25*X(3)**2*(BETA-COS(BETA)*SIN(BETA))
      FR22=X(6)**2*X(3)*BETA/(G*A2**3)
      WRITE(3,200) X(7),X(8),X(9),X(6),FR21,FR22
200   FORMAT(F6.2,2F8.3,F8.1,2F7.2)
70    X(7)=X(7)+DELH
      END
      SUBROUTINE FUN(F)
      REAL F(3)
      COMMON X(12),G,G2,Cu
      BETA=ACOS(1.-2.*X(9)/X(3))
      A2=.25*X(3)**2*(BETA-COS(BETA)*SIN(BETA))
      P2=X(3)*BETA
      A1=(X(1)+X(2)*X(8))*X(8)
      FKe=(1.+X(10))/G2
      FKL=(1.+X(11))/G2
      F(1)=X(5)*X(6)*P2**.6666667-Cu*A2**1.6666667*SQRT(X(4))
      F(2)=X(7)-X(8)-FKE*(X(6)/A1)**2
      F(3)=X(8)+(X(6)/A1)**2/G2-X(9)-FKL*(X(6)/A2)**2-X(12)
      RETURN
      END