C This program handles: First when a gate in instantly partially closed in a
C circular channel, by decreasing the flowrate to a fraction of that under
C uniform conditions and second thereafter the flow rate dQ/dt is given.  
C This 1st portion of the program solves 6 eqs, after it solve the upstream
C uniform flow from the specified Q and downstream velocity Vo2.  The
C 2nd portion solves 11 variables in which theory of Charertistics is used to
C handle the upstream and downstream unsteady flows. For the 1st problem the
C  unknowns are: 1=Y1, 2=Y2, 3=Y3, 4=V3, 5=Wu, and 6=Wd
C For the 2nd problem the unknonws are:
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d,11=wd
C  The flowrates and Froude Numbers are computed and printed.
C In other words this program is like GATETRDQ, except for circular channels.
      PARAMETER (N=200)
      CHARACTER*2 UNK(6)/'Y1','Y2','Y3','V3','Wu','Wd'/
      INTEGER*2 INDX(11)
      REAL F(11),FF(11),D(11,11)
      COMMON RADIUS,RAD2,W(N),X(11),DY,VOW,Yo1,Vo1,G,G2,dQdt,TIME,Yod,
     &Ao1,Ao2,Ao1G,FMON1,Qd,VOWU,VOWD,Qo,XSU,XSD,BETo1,DIA,INIT
      INIT=0
      WRITE(*,*)' Give: g,Dia,Qo,Vo2,IOUT'
      READ(*,*) G,Dia,Qo,Vo2,IOUT
      RADIUS=.5*DIA
      RAD2=RADIUS**2
      SGD=SQRT(G*DIA)
      IOU1=IOUT+1
      IOUM=IOUT-1
      G2=2.*G
      Ao2=Qo/Vo2
      BETA=1.
      NCT=0
1     FE=Ao2-RAD2*(BETA-COS(BETA)*SIN(BETA))
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 2
      FEE=FE
      BETA=BETA+.01
      GO TO 1
2     DIF=FEE/(100.*(FE-FEE))
      BETA=BETA-.01-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT.1.E-5) GO TO 1
      Yo2=RADIUS*(1.-COS(BETA))
      Eo2=Yo2+Vo2**2/G2
      Fro2=Vo2/SQRT(G*DIA*SIN(BETA)/(RAD2*(BETA-COS(BETA)*SIN(BETA))))
      Yo1=2.5*Yo2
      IF(Yo1.LT.RADIUS) Yo1=1.2*RADIUS
      NCT=0
3     BETA=ACOS(1.-Yo1/RADIUS)
      FE=Eo2-Yo1-(Qo/(RAD2*(BETA-COS(BETA)*SIN(BETA))))**2/G2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 4
      FEE=FE
      Yo1=Yo1+.01
      GO TO 3
4     DIF=FEE/(100.*(FE-FEE))
      Yo1=Yo1-.01-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT.1.E-5) GO TO 3
      BETo1=ACOS(1.-Yo1/RADIUS)
      Ao1=RAD2*(BETo1-COS(BETo1)*SIN(BETo1))
      Vo1=Qo/Ao1
      FRo1=Vo1/SQRT(G*DIA*SIN(BETo1)/Ao1)
      WRITE(IOUT,212) Yo1,Vo1,Ao1,Qo,Yo2,Vo2,Ao2
      WRITE(*,212) Yo1,Vo1,Ao1,Qo,Yo2,Vo2,Ao2
212   FORMAT(' Uniform upstream and downstream conditions',/,' Yo1=',
     &F7.3,' Vo1=',F7.3,' Ao1=',F7.2,' Qunif=',F8.2,' Yo2=',F7.3,' Vo2='
     &,F7.3,' Ao2=',F8.2)
      WRITE(*,213) Qo,Yo2,Vo2
213   FORMAT(' Qunif=',F9.2,' Yo2=',F8.3,' Vo2=',F8.3)
      WRITE(*,100) UNK
100   FORMAT(' Give faction of Qunif & guesses for:',5(A3,','),A3)
      READ(*,*) FQo,(X(I),I=1,6)
      Qd=FQo*Qo
      WRITE(IOUT,211) FQo,Qd
211   FORMAT(' Gate to so fraction of flowrate=',F8.3,' so Q=',F9.2 )
      N23=7*N/12
      DY=(Yo1-.01)/FLOAT(N23)
      Ao1G=Ao1/G
      FMON1=RADIUS*(RAD2/1.5*SIN(BETo1)**3-Ao1*COS(BETo1))
      Y=.01
      B1=ACOS(1.-Y/RADIUS)
      WF1=FW(B1) 
      W(1)=0. 
      DO 10 I=2,N
      SUM=0.
      Y=Y+DY
      B2=ACOS(1.-Y/RADIUS)
      DB=(B2-B1)/10.
      DB2=.5*DB
      DO 5 J=1,10
      WF=FW(B1+DB*FLOAT(J))
      SUM=SUM+DB2*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM*SGD
10    B1=B2
      WRITE(IOUT,338) Y
338   FORMAT(' Largest depth for stage variable look-up table=',F9.2)
      WRITE(*,338) Y
      IM=(Yo2-.01)/DY+1.
      FAC=(Yo2-.01-DY*FLOAT(IM-1))/DY
      VOW=Vo2-W(IM)+FAC*(W(IM+1)-W(IM))
      NCT=0
12    SUM=0.
      CALL FUN(F)
      DO 20 J=1,6
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 15 I=1,6
15    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
20    X(J)=XT
      CALL SOLVEQ(6,1,11,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 30 I=1,6
      X(I)=X(I)-F(I)
30    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(X(I),I=1,6)
110   FORMAT(' NCT=',I3,', SUM=',E12.5,/11F9.3)
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 12
      IF(IOUT.NE.6) THEN
      WRITE(IOUT,119)
119   FORMAT(' Solution to conditions immediately after dropping gate')
      WRITE(IOUT,120)(UNK(I),X(I),I=1,6)
      ENDIF
      WRITE(*,120)(UNK(I),X(I),I=1,6)
120   FORMAT(A3,' = ',F10.3)
      Yod=X(2)
      INIT=1
      IM=(X(1)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(1)-.01-DY*FLOAT(IM-1))/DY
      BETA=ACOS(1.-X(1)/RADIUS)
      VOWU=Qd/(RAD2*(BETA-COS(BETA)*SIN(BETA)))-W(IM)+FAC*(W(IM+1)-W(IM)
     &)
      IM=(X(3)-.01)/DY+1.
      FAC=(X(3)-.01-DY*FLOAT(IM-1))/DY
      VOWD=X(4)-W(IM)+FAC*(W(IM+1)-W(IM))
      Qo=Qd
      Yo2=X(3)
      WRITE(IOUT,121) Qo
121   FORMAT(' The flow rate past gate after instant drop, Qo=',F9.3)
      WRITE(*,*)' Give: dQ/dt, Delt & Number of steps'
      READ(*,*) dQdt,DELT,NUM
C New order of unknowns in array X for time simulation when dQ/dt is given      
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d & 11=wd
      X(11)=X(6)
      X(10)=X(4)
      X(9)=X(3)
      BETA=ACOS(1.-X(2)/RADIUS)
      X(8)=Qo/(RAD2*(BETA-COS(BETA)*SIN(BETA)))
      X(7)=X(2)
      X(4)=X(1)
      X(3)=X(5)
      X(6)=X(8)
      BETA=ACOS(1.-X(1)/RADIUS)
      X(5)=Qo/(RAD2*(BETA-COS(BETA)*SIN(BETA)))
      X(2)=X(5)
      XSUo=0.
      XSDo=0.
      WRITE(IOUT,129) dQdt
129   FORMAT(' dQ/dt=',F9.6,/,
     &118('-'),/,'  t     Yu2     Vu2      wu     You     Vou     Yod   
     &  Vod     Yd2     Vd2     Y3d     V3d      wd      Xsu     Xsd'
     &,/,118('-'))
      WRITE(IOU1,128)
128   FORMAT(84('-'),/,'  t    Au2     Qu2     Aou     Qou     Aod  
     &Qod     Ad2     Qd2      A3d     Q3d',/,84('-'))  
      WRITE(IOUT,130) 0,(X(I),I=1,5),X(7),(X(I),I=6,11),XSUo,XSDo
      BET1=ACOS(1.-X(1)/RADIUS)
      Au2=RAD2*(BET1-COS(BET1)*SIN(BET1))
      Qu2=Au2*X(2)
      BET2=ACOS(1.-X(4)/RADIUS)
      Aou=RAD2*(BET2-COS(BET2)*SIN(BET2))
      Qou=Aou*X(5)
      BET3=ACOS(1.-X(7)/RADIUS)
      Aod=RAD2*(BET3-COS(BET3)*SIN(BET3))
      Qod=Aod*X(6)
      Ad2=Aod
      Qd2=Ad2*X(8)
      BET4=ACOS(1.-X(9)/RADIUS)
      A3d=RAD2*(BET4-COS(BET4)*SIN(BET4))
      Q3d=A3d*X(10)
      FRu2=SQRT(Qu2**2*DIA*SIN(BET1)/(G*Au2**3))
      FRou=SQRT(Qou**2*DIA*SIN(BET2)/(G*Aou**3))
      FRod=SQRT(Qod**2*DIA*SIN(BET3)/(G*Aod**3))
      FRd2=SQRT(Qd2**2*DIA*SIN(BET3)/(G*Ad2**3))
      FR3d=SQRT(Q3d**2*DIA*SIN(BET4)/(G*A3d**3))
      FMo1=(X(3)+Vo1)/SQRT(G*Ao1/(DIA*SIN(BETo1)))
      FMu2=(X(3)+X(2))/SQRT(G*Au2/(DIA*SIN(BET1)))
      FMd2=(X(8)-X(11))/SQRT(G*Ad2/(DIA*SIN(BET3)))
      FM3d=(X(10)-X(11))/SQRT(G*A3d/(DIA*SIN(BET4)))
      WRITE(IOU1,131) 0,Au2,Qu2,Aou,Qou,Aod,Qod,Ad2,Qd2,A3d,Q3d
      WRITE(IOUM,331) FRo1,FRo2
331   FORMAT(' Upstream & Downstream Froude No.s for Initial Uniform Flo
     &w',/,' Fro1=',F8.2,' Fro2=',F8.2)
      WRITE(IOUM,131) 0,FRu2,FRou,FRod,FRd2,FR3d,FMo1,FMu2,FMd2,FM3d
      DO 50 K=1,NUM
      TIME=DELT*FLOAT(K)
      Qd=Qo-dQdt*TIME
      NCT=0
52    SUM=0.
      XSU=XSUo+DELT*X(3)
      XSD=XSDo+DELT*X(11)
      CALL FUN(F)
      DO 53 J=1,11
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 55 I=1,11
55    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
53    X(J)=XT
      CALL SOLVEQ(11,1,11,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 56 I=1,11
      X(I)=X(I)-F(I)
56    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
      IF(NCT.LT.30 .AND. SUM.GT.1.E-4) GO TO 52
      XSUo=XSUo+DELT*X(3)
      XSDo=XSDo+DELT*X(11)
      WRITE(IOUT,130) IFIX(TIME),(X(I),I=1,5),Yod,(X(I),I=6,11),
     &XSU,XSD
130   FORMAT(I4,12F8.3,2F9.1)
      BET1=ACOS(1.-X(1)/RADIUS)
      Au2=RAD2*(BET1-COS(BET1)*SIN(BET1))
      Qu2=Au2*X(2)
      BET2=ACOS(1.-X(4)/RADIUS)
      Aou=RAD2*(BET2-COS(BET2)*SIN(BET2))
      Qou=Aou*X(5)
      BET3=ACOS(1.-Yod/RADIUS)
      Aod=RAD2*(BET3-COS(BET3)*SIN(BET3))
      Qod=Aod*X(6)
      BET4=ACOS(1.-X(7)/RADIUS)
      Ad2=RAD2*(BET4-COS(BET4)*SIN(BET4))
      Qd2=Ad2*X(8)
      BET5=ACOS(1.-X(9)/RADIUS)
      A3d=RAD2*(BET5-COS(BET5)*SIN(BET5))
      Q3d=A3d*X(10)
      FRu2=SQRT(Qu2**2*DIA*SIN(BET1)/(G*AU2**3))
      FRou=SQRT(Qou**2*DIA*SIN(BET2)/(G*Aou**3))
      FRod=SQRT(Qod**2*DIA*SIN(BET3)/(G*Aod**3))
      FRd2=SQRT(Qd2**2*DIA*SIN(BET4)/(G*Ad2**3))
      FR3d=SQRT(Q3d**2*DIA*SIN(BET5)/(G*A3d**3))
      FMo1=(X(3)+Vo1)/SQRT(G*Ao1/(DIA*SIN(BETo1)))
      FMu2=(X(3)+X(2))/SQRT(G*Au2/(DIA*SIN(BET1)))
      FMd2=(X(8)-X(11))/SQRT(G*Ad2/(DIA*SIN(BET4)))
      FM3d=(X(10)-X(11))/SQRT(G*A3d/(DIA*SIN(BET5)))
      WRITE(IOUM,131) IFIX(TIME),FRu2,FRou,FRod,FRd2,FR3d,FMo1,FMu2,
     &FMd2,FM3d
      IF(FMu2.GT. .99 .OR.ABS(X(1)-Yo1).LT. .01) ISTOP=1
50    WRITE(IOU1,131) IFIX(TIME),Au2,Qu2,Aou,Qou,Aod,Qod,Ad2,Qd2,A3d,Q3d
131   FORMAT(I4,10F8.2)
      END
      SUBROUTINE FUN(F)
      PARAMETER (N=200)
      REAL F(11)
      COMMON RADIUS,RAD2,W(N),X(11),DY,VOW,Yo1,Vo1,G,G2,dQdt,TIME,Yod,
     &Ao1,Ao2,Ao1G,FMON1,Qd,VOWU,VOWD,Qo,XSU,XSD,BETo1,DIA,INIT
      IF(INIT.GT.0) GO TO 10
C  1=Y1,2=Y2,3=Y3,4=V3,5=Wu,and 6=Wd
      BET1=ACOS(1.-X(1)/RADIUS)
      A1=RAD2*(BET1-COS(BET1)*SIN(BET1))
      V1=Qd/A1
      BET2=ACOS(1.-X(2)/RADIUS)
      A2=RAD2*(BET2-COS(BET2)*SIN(BET2))
      V2=Qd/A2
      BET3=ACOS(1.-X(3)/RADIUS)
      A3=RAD2*(BET3-COS(BET3)*SIN(BET3))
      F(1)=X(1)+V1**2/G2-X(2)-V2**2/G2
      F(2)=(X(5)+Vo1)*Ao1-(X(5)+V1)*A1
      F(3)=FMON1+(X(5)+Vo1)**2*Ao1G-RADIUS*(RAD2/1.5*SIN(BET1)**3-A1*COS
     &(BET1))-(X(5)+V1)**2*A1/G
      F(4)=(X(6)-V2)*A2-(X(6)-X(4))*A3
      F(5)=RADIUS*(RAD2/1.5*SIN(BET2)**3-A2*COS(BET2))+(X(6)-V2)**2*A2/G
     &-RADIUS*(RAD2/1.5*SIN(BET3)**3-A3*COS(BET3))-(X(6)-X(4))**2*A3/G
      IM=(X(3)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(3)-.01-DY*FLOAT(IM-1))/DY
      F(6)=X(4)-(W(IM)+FAC*(W(IM+1)-W(IM)))-VOW
      RETURN
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d,11=wd
10    BET1=ACOS(1.-X(1)/RADIUS)
      Au2=RAD2*(BET1-COS(BET1)*SIN(BET1))
      F(1)=(Vo1+X(3))*Ao1-(X(2)+X(3))*Au2
      F(2)=RADIUS*(RAD2/1.5*SIN(BETo1)**3-Ao1*COS(BETo1))-RADIUS*(RAD2/
     &1.5*SIN(BET1)-Au2*COS(BET1))+((Vo1+X(3))**2*Ao1-(X(2)+X(3))**2*Au2
     &)/G
      IM=(X(1)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(1)-.01-DY*FLOAT(IM-1))/DY
      Wu2=W(IM)+FAC*(W(IM+1)-W(IM))
      IM=(X(4)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(4)-.01-DY*FLOAT(IM-1))/DY
      Wou=W(IM)+FAC*(W(IM+1)-W(IM))
      F(3)=X(2)-X(5)-Wu2+Wou
      BET3=ACOS(1.-X(4)/RADIUS)
      Aou=RAD2*(BET3-COS(BET3)*SIN(BET3))
      F(4)=Aou*X(5)-Qd
      Aod=Qd/X(6)
      NCT=0
30    BETA=ACOS(1.-Yod/RADIUS)
      FE=Aod-RAD2*(BETA-COS(BETA)*SIN(BETA))
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 31
      FEE=FE
      Yod=Yod+.01
      GO TO 30
31    DIF=FEE/(100.*(FE-FEE))
      Yod=Yod-.01-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-5) GO TO 30
      F(5)=X(4)-Yod+(X(5)**2-X(6)**2)/G2
      IM=(X(7)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(7)-.01-DY*FLOAT(IM-1))/DY
      Wd2=W(IM)+FAC*(W(IM+1)-W(IM))
      IM=(Yod-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(Yod-.01-DY*FLOAT(IM-1))/DY
      Wod=W(IM)+FAC*(W(IM+1)-W(IM))
      F(6)=X(8)-X(6)+Wod-Wd2
      BET4=ACOS(1.-X(7)/RADIUS)
      Ad2=RAD2*(BET4-COS(BET4)*SIN(BET4))
      BET5=ACOS(1.-X(9)/RADIUS)
      A3d=RAD2*(BET5-COS(BET5)*SIN(BET5))
      F(7)=(X(8)-X(11))*Ad2-(X(10)-X(11))*A3d
      F(8)=RADIUS*(RAD2/1.5*SIN(BET4)**3-Ad2*COS(BET4))-RADIUS*(RAD2/1.5
     &*SIN(BET5)**3-A3d*COS(BET5))+((X(8)-X(11))**2*Ad2-(X(10)-X(11))**2
     &*A3d)/G
      IM=(X(9)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(9)-.01-DY*FLOAT(IM-1))/DY
      W3d=W(IM)+FAC*(W(IM+1)-W(IM))
      F(9)=X(10)-W3d-VOW
      cd=X(8)/SQRT(G*Ad2/(DIA*SIN(BET4)))
      cu=X(2)/SQRT(G*Au2/(DIA*SIN(BET1)))
      IM=(X(7)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(7)-.01-DY*FLOAT(IM-1))/DY
      Wd2=W(IM)+FAC*(W(IM+1)-W(IM))
      F(10)=TIME-ABS(Qo-Ad2*X(8))/dQdt-XSD/(Wd2-cd-VOWD)      
      F(11)=TIME-ABS(Qo-Au2*X(2))/dQdt-XSU/(Wu2-cu-VOWU)
      END
      FUNCTION FW(BETA)
      SINB=SIN(BETA)
      FW=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END