C Handles problem in which gate is partially and instantly raised so dispersive
C wave occurs upstream in a circular channel. Program GATECI handles problems
C in which gate is lowered.  This program is similar to GATETRU that is designed
C to solve the same 6 unknowns in a trapezoidal channel.
      PARAMETER (N=200)
      CHARACTER*2 UNK(6)/'Y1','V1','V2','Y3','V3',' W'/
      INTEGER*2 INDX(6)
      REAL F(6),FF(6),D(6,6)
      COMMON RADIUS,RAD2,FM3,Y2,W(200),X(6),DY,VOW,Yo1,Vo1,Yo2,Vo2,G,
     &G2,Ao2,Ao2G,A2,FMON2,W2
      WRITE(*,*)' Give: g,Dia,Yo1,Vo1,Yo2,Vo2,Y2'
      READ(*,*) G,DIA,Yo1,Vo1,Yo2,Vo2,Y2
      RADIUS=.5*DIA
      RAD2=RADIUS**2
      WRITE(*,100) UNK
100   FORMAT(' Give guesses for:',5(A3,','),A3)
      READ(*,*) X
      G2=2.*G
      SGD=SQRT(G*DIA)
      DY=(Yo1-.01)/FLOAT(N-1)
      BETA=ACOS(1.-Yo2/RADIUS)
      Ao2=RAD2*(BETA-COS(BETA)*SIN(BETA))
      Ao2G=Ao2/G
      FMON2=RADIUS*(RAD2/1.5*SIN(BETA)**3-Ao2*COS(BETA))
      BETA=ACOS(1.-Y2/RADIUS)
      A2=RAD2*(BETA-COS(BETA)*SIN(BETA))
      Y=.01
      B1=ACOS(1.-Y/RADIUS)
      WF1=FW(B1) 
      W(1)=0. 
      DO 10 I=2,N
      SUM=0.
      Y=Y+DY
      B2=ACOS(1.-Y/RADIUS)
      DB=(B2-B1)/10.
      DB2=.5*DB
      DO 5 J=1,10
      WF=FW(B1+DB*FLOAT(J))
      SUM=SUM+DB2*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM*SGD
10    B1=B2
      VOW=Vo1+W(N)
      IM=(Y2-.01)/DY+1.
      FAC=(Y2-.01-DY*FLOAT(IM-1))/DY
      W2=W(IM)+FAC*(W(IM+1)-W(IM))
      NCT=0
12    SUM=0.
      CALL FUN(F)
      DO 20 J=1,6
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 15 I=1,6
15    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
20    X(J)=XT
      CALL SOLVEQ(6,1,6,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 30 I=1,6
      X(I)=X(I)-F(I)
30    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,', SUM=',E12.5,/6F9.3)
      IF(NCT.LT.30 .AND. SUM.GT.1.5E-4) GO TO 12
      WRITE(*,120)(UNK(I),X(I),I=1,6)
120   FORMAT(A3,' = ',F10.3)
      END
      SUBROUTINE FUN(F)
      REAL F(6)
      COMMON RADIUS,RAD2,FM3,Y2,W(200),X(6),DY,VOW,Yo1,Vo1,Yo2,Vo2,G,
     &G2,Ao2,Ao2G,A2,FMON2,W2
      F(1)=X(1)+X(2)**2/G2-Y2-X(3)**2/G2
      BETA=ACOS(1.-X(1)/RADIUS)
      A1=RAD2*(BETA-COS(BETA)*SIN(BETA))
      BETA=ACOS(1.-X(4)/RADIUS)
      A3=RAD2*(BETA-COS(BETA)*SIN(BETA))
      FM3=RADIUS*(RAD2/1.5*SIN(BETA)**3-A3*COS(BETA))
      F(2)=X(2)*A1-X(3)*A2
      F(3)=ABS(X(6)-X(5))*A3-ABS(X(6)-Vo2)*Ao2
      F(4)=FM3+(X(6)-X(5))**2*A3/G-FMON2-(X(6)-Vo2)**2*Ao2G
      IM=(X(1)-.01)/DY+1.
      IF(IM.LT.1) IM=1
      IF(IM.GT.199) IM=199
      FAC=(X(1)-.01-DY*FLOAT(IM-1))/DY
      F(5)=X(2)+(W(IM)+FAC*(W(IM+1)-W(IM)))-VOW
      IM=(X(4)-.01)/DY+1.
      IF(IM.LT.1) IM=1
      IF(IM.GT.199) IM=199
      FAC=(X(4)-.01-DY*FLOAT(IM-1))/DY
      F(6)=X(3)+W2-X(5)-(W(IM)+FAC*(W(IM+1)-W(IM)))
      RETURN
      END
      FUNCTION FW(BETA)
      SINB=SIN(BETA)
      FW=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END