C Solves the problem of side flow into a triangular gutter, and the outflow
C from a grate at its end.  A flowrate Q =Qin at the beginning of the gutter
C can also occur and all the lateral inflow must exit from the grate.
C  Yl=X(1), Yr=X(2) Ye=X(3)
C The difference in this program and GUTGRAT1.FOR is that this program assume
C the cross-sectional area of the grate consist of a rectangle with a width b 
C  and a side slope with its m given by FMG (which can be different from FM).
C  Program GUTGRAT1 assumes the cross-sectional area at the grate is given by
C  (1/2)mY**2, whereas this program computes this area as A = by+.5mY**2, where 
C the latter m is FMG
C This program modifies GUTGRAT1 so a series of solution is obtained with the 
C   selected variable changed.
      INTEGER*2 INDX(3)
      LOGICAL DONE
      REAL F(3),D(3,3),FFF(3)
      CHARACTER*3 CVAR 
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XX,FMG,HMG,B,DONE,IOUT
      WRITE(*,*)' Give:IO,TOL,ERR,n,So,m,L,Lgrate,g,DX,DXG,Qin,q*,b,m,frac
     &,Cd'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,FLG,G,DX,DXG,Qin,QS,B,FMG,FRAC
     &,CD
      FMO=FM
      QinO=Qin
      QSO=QS
      BO=B
      FMGO=FMG
      CDO=CD
      IOU1=IOUT+1
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      QT=QS*FL+Qin
      DONE=.FALSE.
      DXGH=DXG/2.
      HMG=.5*FMG
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      CD=CD*SQRT(G2)*FRAC*B
      G8=.125*G
      WRITE(*,*)' GIVE guess for:Yl, Yr, Ye'
      READ(*,*) X
      WRITE(*,180)
180   FORMAT(' Select variable to vary, No. of Sol, Delt Var. & 1=Prof.'
     &/,' 1 - Upstream m'/,' 2 - Qin'/,' 3 - q*',/' 4 - b',/' 5 - mg',/
     &' 6 - Cd')
      READ(*,*) IVAR,NV,DELV,IPROF
      DO 50 IJ=1,NV
      IF(IVAR.EQ.1) THEN
      FM=FMO+DELV*FLOAT(IJ-1)
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      XXV=FM
      CVAR=' m '
      ELSEIF(IVAR.EQ.2) THEN
      Qin=QinO+DELV*FLOAT(IJ-1)
      QT=QS*FL+Qin
      XXV=Qin
      CVAR='Qin'
      ELSEIF(IVAR.EQ.3) THEN
      QS=QSO+DELV*FLOAT(IJ-1)
      QT=QS*FL+Qin
      XXV=QS
      CVAR=' q*'
      ELSEIF(IVAR.EQ.4) THEN
      B=BO+DELV*FLOAT(IJ-1)
      CD=CDO*SQRT(G2)*FRAC*B
      XXV=B
      CVAR=' b '
      ELSEIF(IVAR.EQ.5) THEN
      FMG=FMGO+DELV*FLOAT(IJ-1)
      HMG=.5*FMG
      XXV=FMG
      CVAR='mg'
      ELSE
      CD=CDO+DELV*FLOAT(IJ-1)
      XXV=CD
      CD=CD*SQRT(G2)*FRAC*B
      CVAR=' Cd'
      ENDIF
7     NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,3
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,3
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(3,1,3,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,3
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,6F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      Frr=SQRT(QT**2*FM*X(2)/(G*(HM*X(2)**2)**3))
      Frl=SQRT(Qin**2*FM*X(1)/(G*(HM*X(1)**2)**3))
      WRITE(IOU1,120) XXV,X,Frr
120   FORMAT(F8.4,3F8.3,F7.3)
      IF(IPROF.EQ.0) GO TO 50
      WRITE(IOUT,200) CVAR,FM
200   FORMAT(' For upstream triangular gutter with',A3,' =',F8.4)
      WRITE(IOUT,100) Qin,QS,X,Frl,Frr
100   FORMAT(' Qin=',F8.4,', q*=',F8.4,/' Yl=',F7.3,', Yr=',F7.3,', Ye='
     &,F7.3,', (Fr)l=',F7.3,', (Fr)r=',F7.3)
      DONE=.TRUE.
      CALL FUN(F)
      DONE=.FALSE.
50    CONTINUE
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XX,FMG,HMG,B,DONE,IOUT
      HMIN=1.E-6
      IF(DONE) THEN
      A=HM*X(1)**2
      WRITE(IOUT,100) 0.,X(1),Qin,X(1)+(Qin/A)**2/G2,A,Qin/(FM*SQRT(G8*
     & X(1)**5))
      ENDIF
100   FORMAT(/,'       x          Y         Q        E        A         
     & Fr',/,1X,59('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=X(1)
10    XZ=XX+DX
      IF(XZ.GT.FL) XZ=FL
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*XZ+Qin
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT.FL) GO TO 10
      F(1)=X(2)-Y(1)
      H1=.005
      XX=0.
      SQSTAR=0.
      QS1=CD*SQRT(X(2))
      IF(DONE) THEN
      A=HM*X(2)**2
      WRITE(IOUT,120) 0.,X(2),QT,QS1,X(2)+(QT/A)**2/G2,A,QT/(FM*SQRT(G8*
     &X(2)**5))
120   FORMAT(/,'       x          Y         Q        q*        E         
     &A           Fr',/,1X,69('-'),/,F10.1,6F10.3)
      ENDIF
30    XZ=XX+DXG
      IF(XZ.GT.FLG) XZ=FLG
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD*SQRT(Y(1))
      SQSTAR=SQSTAR+DXGH*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QT-SQSTAR
      WRITE(IOUT,130) XZ,Y,Q,QS2,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**
     &5))
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLG) GO TO 30
      F(2)=X(3)-Y(1)
      F(3)=QT-SQSTAR
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XDUM,FMG,HMG,B,DONE,IOUT
      YY=ABS(Y(1))
      A=HM*YY**2
      Q=QS*XX+Qin
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XX,FMG,HMG,B,DONE,IOUT
      YY=Y(1)
      QS2=CD*SQRT(YY)
      A=(B+HMG*YY)*YY
      Q=QT-SQSTAR-.5*(XP-XX)*(QS1+QS2)
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*(B+FMG*YY)/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END