C Solves the problem of side flow into a triangular gutter.  This version 
C modifies GUTTER so that only 2 eqs. are solve for Ys=X(1) and Xs=X(2).  This
C can be done because explicit equations give critical depths for triangular gutters
      INTEGER*2 INDX(2)
      LOGICAL DONE,UP
      REAL F(2),D(2,2),FFF(2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(2),SO,FM,FMS,AOQS,A1QS,A2QS,BOQS,B1QS,QTOTAL,QR,CC,
     &FN,HM,G,G2,G8,FL,DX,GM2,TOL,DONE,UP,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,m,L,g,DX, & coef for q*(ao,a1,a
     &2)'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,G,DX,AOQS,A1QS,A2QS
C  The coefficients for define q*=ao(x**2)+a1(x)+a2
      BOQS=AOQS
      B1QS=A1QS
      AOQS=AOQS/3.
      A1QS=A1QS/2.
      QTOTAL=((AOQS*FL+A1QS)*FL+A2QS)*FL
      WRITE(IOUT,199) FN,SO,FM,FL,G
199   FORMAT(' n=',F8.4,' So=',F10.6,' side slope=',F8.2,' L=',F8.1,
     &' g=',F8.2)
      WRITE(IOUT,200) BOQS,B1QS,A2QS,QTOTAL
200   FORMAT(' q*=',E12.6,'x**2+',E12.6,'x+',E12.6,' Total inflow=',
     &F9.3)
      DONE=.FALSE.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      G8=.125*G
      GM2=G8*FM*FM
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(2)
      QR=((AOQS*X(2)+A1QS)*X(2)+A2QS)*X(2)
      X(1)=.8*((QR**2/GM2)**.2+((QTOTAL-QR)**2/GM2)**.2)
      WRITE(*,*)' Guesses for x',X
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,2
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,2
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(2,1,2,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,2
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,2F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) X
100   FORMAT(' Depth at Q=0, Ys=',F8.3,', Xs=',F8.1)
      QR=((AOQS*X(2)+A1QS)*X(2)+A2QS)*X(2)
      YCL=(QR**2/GM2)**.2
      YCR=((QTOTAL-QR)**2/GM2)**.2
      WRITE(3,101) YCL,YCR
101   FORMAT(' Critical depths: left =',F9.3,', right =',F9.3)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE,UP
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(2),SO,FM,FMS,AOQS,A1QS,A2QS,BOQS,B1QS,QTOTAL,QR,CC,
     &FN,HM,G,G2,G8,FL,DX,GM2,TOL,DONE,UP,IOUT
      QR=((AOQS*X(2)+A1QS)*X(2)+A2QS)*X(2)
      HMIN=.001
      UP=.TRUE.
      YCL=(QR*QR/GM2)**.2
      IF(DONE) THEN
      A=HM*YCL**2
      WRITE(IOUT,100) 0.,YCL,QR,YCL+(QR/A)**2/G2,A,QR/(FM*SQRT(G8*YCL**5
     &)),A2QS
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr
     &    q*',/1X,65('-'),/,F10.1,5F10.3,F8.5)
      H1=.1
      XX=0.
      Y(1)=1.1*YCL
10    XZ=XX+DX
      IF(XZ.GT.X(2)) XZ=X(2)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QR-((AOQS*XZ+A1QS)*XZ+A2QS)*XZ
      QS=(BOQS*XZ+B1QS)*XZ+A2QS
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
     &,QS
110   FORMAT(F10.1,5F10.3,F8.5)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(2)) GO TO 10
      F(1)=X(1)-Y(1)
      H1=-.1
      Q=QTOTAL-((AOQS*X(2)+A1QS)*X(2)+A2QS)*X(2)
      QS=(BOQS*FL+B1QS)*FL+A2QS
      YCR=(Q*Q/GM2)**.2
      IF(DONE) THEN
      A=HM*YCR**2
      WRITE(IOUT,100) FL,YCR,Q,YCR+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*YCR**5)),
     &QS
      ENDIF
      UP=.FALSE.
      XX=FL
      Y(1)=1.1*YCR
20    XZ=XX-DX
      IF(XZ.LT.X(2)) XZ=X(2)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=((AOQS*XZ+A1QS)*XZ+A2QS)*XZ-QR
      QS=(BOQS*XZ+B1QS)*XZ+A2QS
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
     &,QS
      ENDIF
      XX=XZ
      IF(XZ.GT. X(2)) GO TO 20
      F(2)=X(1)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE,UP
      REAL Y(1),DY(1)
      COMMON /TRAS/X(2),SO,FM,FMS,AOQS,A1QS,A2QS,BOQS,B1QS,QTOTAL,QR,CC,
     &FN,HM,G,G2,G8,FL,DX,GM2,TOL,DONE,UP,IOUT
      YABS=ABS(Y(1))
      A=HM*YABS**2
      Q=((AOQS*XX+A1QS)*XX+A2QS)*XX-QR
      SF=FN*Q/CC*(FMS*YABS/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YABS/(G*A**3)
      IF(FR2.GT. .95) FR2=.95
      DY(1)=(SO-SF-2.*Q*((BOQS*XX+B1QS)*XX+A2QS)/(G*A**2))/(1.-FR2)
      RETURN
      END