C This program handles the case of a channel divided into: (1) a main channel
C (2) a left side, and (3) a right side.  n is different in each portion of section
C and can vary linearly between stations. 
C  The difference between this program and GVFNATM is that it uses cubic splines to
C generate the cross-section data table and uses SIMPR to numerically integrate for
C the area and wetted perimeters.
      PARAMETER (N=26,NN=15)
      REAL SE(1),DE(1),XP(1),YP(1,1),WK1(1,13)
      CHARACTER*2 UNIT
      EXTERNAL DEX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRANS/ QN,FN(2,3),SO
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &XMID,XLD,XRD,YLD,YRD,NR,NL,IR,IR1,IL,IL1
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),ALPA(N,2),RKS(N,2),
     &CC,XSTA1,XSTA2,ZSTA1,YY,ZSTA2,PSTA,ASTA,FNA,Q2G,QSTA,IP1,IP2,IOTAB
      WRITE(*,*)' GIVE: UNIT,IOUT,IOTAB,NSTAT,TOL,DELX,YB,Q,XBEG,XEND'
      READ(*,*) UNIT,IOUT,IOTAB,NSTAT,TOL,DELX,YB,Q,XBEG,XEND
      H1=-.1
      HMIN=1.E-4
      CC=1.486
      G=32.2
      IF(UNIT.EQ.'SI' .OR. UNIT.EQ.'si') THEN
      CC=1.
      G=9.81
      ENDIF
      G2=2.*G
      QN=(Q/CC)**2
      Q2G=Q*Q/G2
      XS=XBEG
      CALL CHTABLSP(1,1)
      CALL CHTABLSP(2,2)
      NSTA=2
      SO=(ZSTA2-ZSTA1)/(XSTA1-XSTA2)
      YY=YB
      IP1=N/2
      IP2=N/2
      CALL INTERP(XS,YY,.TRUE.)
      SE(1)=YY+Q2G/ASTA**2
      WRITE(IOUT,15) Q
15    FORMAT(' Solution to Gradually Varied Flow in natural channel with
     &',/,' Q =',F10.2,/,1X,87('-'),/,4X,'X',9X,'Y',7X,'E',
     &'     Per.     Area Velocity  Bot. S.  n-main n-left n-right Qm/Qt
     &',/,1X,87('-'))
      WRITE(IOUT,40) XS,YY,SE(1),PSTA,ASTA,Q/ASTA,SO,(FN(1,I),I=1,3),
     &QSTA
40    FORMAT(1X,F8.0,5F8.2,F10.7,4F7.4)
20    XZ=XS+DELX
      CALL ODESOL(SE,DE,1,XS,XZ,TOL,H1,HMIN,1,XP,YP,WK1,DEX)
      FAX=(XZ-XSTA1)/(XSTA2-XSTA1)
      IF(FAX.GT. .99) FAX=1.
      IF(FAX.LT. .01) FAX=0.
      FNL=(1.-FAX)*FN(1,2)+FAX*FN(2,2)
      FNR=(1.-FAX)*FN(1,3)+FAX*FN(2,3)
      WRITE(IOUT,40) XZ,YY,SE(1),PSTA,ASTA,Q/ASTA,SO,FNA,FNL,FNR,QSTA
      XS=XZ
      IF(XZ.LE.XSTA2 .AND. NSTA.LT.NSTAT) THEN
      DO 30 I=1,N
      Y(I,1)=Y(I,2)
      A(I,1)=A(I,2)
      P(I,1)=P(I,2)
      ALPA(I,1)=ALPA(I,2)
      RKS(I,1)=RKS(I,2)
30    E(I,1)=E(I,2)
      DO 31 I=1,3
31    FN(1,I)=FN(2,I)
      ZSTA1=ZSTA2
      XSTA1=XSTA2
      IP1=IP2
      NSTA=NSTA+1
      CALL CHTABLSP(NSTA,2)
      SO=(ZSTA2-ZSTA1)/(XSTA1-XSTA2)
      ENDIF
      IF(XZ.GT.XEND) GO TO 20
      STOP
      END
      SUBROUTINE DEX(X,SE,EPRIME)
      PARAMETER (N=26)
      REAL SE(1),EPRIME(1)
      COMMON /TRANS/ QN,FN(2,3),SO
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),ALPA(N,2),RKS(N,2),
     &CC,XSTA1,XSTA2,ZSTA1,YY,ZSTA2,PSTA,ASTA,FNA,Q2G,QSTA,IP1,IP2,IOTAB
      CALL INTERP(X,SE(1),.FALSE.)
      SF=QN*(QSTA*FNA*ABS(PSTA/ASTA)**.666666667/ASTA)**2
      EPRIME(1)=SO-SF
      RETURN
      END
      SUBROUTINE CHTABLSP(NOSEC,M)
      PARAMETER (N=26,NN=15)
      EXTERNAL EQUATR, EQUATL,EQUAPR,EQUAPL
      LOGICAL*2 IBOTSC,LINEAR
      REAL X(20),H(20),DD(NN)
      COMMON /TRANS/ QN,FN(2,3),SO
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &XMID,XLD,XRD,YLD,YRD,NR,NL,IR,IR1,IL,IL1
      COMMON/INF/Y(N,2),T(N,2),AR(N,2),P(N,2),E(N,2),ALPA(N,2),RKS(N,2),
     &CC,XSTA1,XSTA2,ZSTA1,YY,ZSTA2,PSTA,ASTA,FNA,Q2G,QSTA,IP1,IP2,IOTAB
      READ(3,*) NSTA,NVALUE,XSTA,(FN(M,I),I=1,3),XLD,XRD,LINEAR
C NSTA-Station No. starting at downstream end with 1, NVALUE-No. of pts to 
C define sec.,  XSTA-x position of station, n-main,n-left,n-right, 
C XLD-x at start of left channel, XRD-x at start of right channel.
      IF(M.EQ.1) THEN
      XSTA1=XSTA
      ELSE
      XSTA2=XSTA
      ENDIF
      IF(NVALUE.GT.20) THEN
      WRITE(*,100)
100   FORMAT(' Program dimension to allow only 20 coordinate pairs')
      STOP
      ENDIF
      IF(IOTAB.GT.0) THEN
      IOTT=IOTAB
      IBOTSC=.FALSE.
      IF(IOTAB.GT.20) THEN
      IOTT=IOTAB-20
      IBOTSC=.TRUE.
      ENDIF
      ENDIF
      IF(NSTA.NE.NOSEC) THEN
      WRITE(*,110) NSTA,NOSEC
110   FORMAT(' Next station with data is',I4,/,' Expecting data for stat
     *ion',I5)
      STOP
      ENDIF
      AL=.001
      AAR=.001
      PL=0.
      PR=0.
      FK2=0.
      FK3=0.
      READ(3,*)(X(I),H(I),I=1,NVALUE)
      ZSTA=H(1)
      IMIN=1
      YMAX=ZSTA
      DO 10 I=2,NVALUE
      IF(H(I).GE.ZSTA) GO TO 5
      ZSTA=H(I)
      IMIN=I
5     IF(H(I).GT.YMAX) YMAX=H(I)
10    CONTINUE
      IF(H(IMIN+1).LT.ZSTA+1.E-5) THEN
      T(1,M)=X(IMIN+1)-X(IMIN)
      XMID=.5*(X(IMIN+1)+X(IMIN))
      P(1,M)=T(1,M)
      IR1=IMIN+1
      ELSE
      T(1,M)=0.
      P(1,M)=0.
      IR1=IMIN
      XMID=X(IMIN)
      ENDIF
      AA=0.
      PP=P(1,M)
      AR(1,M)=0.
      Y(1,M)=0.
      NR=0
      YRD=-1000.
      DO 12 I=IR1,NVALUE
      NR=NR+1
      IF(YRD.LT. -999. .AND. X(I).GE.XRD) THEN
      IF(X(I).EQ.XRD) THEN
      YRD=H(I)
      ELSE
      YRD=H(I)-(XRD-X(I-1))/(X(I)-X(I-1))*(H(I)-H(I-1))
      ENDIF
      ENDIF
      XR(NR)=X(I)
12    YR(NR)=H(I)
      IF(LINEAR) THEN
      DO 13 I=1,NR
13    D2XR(I)=0.
      ELSE
      CALL SPLINESU(NR,YR,XR,D2XR,DD,0)
      ENDIF
      NL=0
      YLD=-1000.
      DO 14 I=IMIN,1,-1
      NL=NL+1
      IF(YLD.LT. -999. .AND. X(I).LE.XLD) THEN
      IF(X(I).EQ.XLD) THEN
      YLD=H(I)
      ELSE
      YLD=H(I)-(X(I-1)-XLD)/(X(I-1)-X(I))*(H(I)-H(I-1))
      ENDIF
      ENDIF
      XL(NL)=X(I)
14    YL(NL)=H(I)
      IF(LINEAR) THEN
      DO 15 I=1,NL
15    D2XL(I)=0.
      ELSE
      CALL SPLINESU(NL,YL,XL,D2XL,DD,0)
      ENDIF
      IR=1
      IR1=2
      IL=1
      IL1=2
      DYY=(YMAX-ZSTA)/FLOAT(N-1)
      Y1=ZSTA
      IF(M.EQ.1) THEN
      ZSTA1=ZSTA
      ELSE
      ZSTA2=ZSTA
      ENDIF
      IF(IBOTSC) WRITE(*,312) NSTA,XSTA,ZSTA,(FN(M,I),I=1,3)
      WRITE(IOTT,312) NSTA,XSTA,ZSTA,(FN(M,I),I=1,3)
312   FORMAT(/,' Station no.=',I4,' x =',F10.1,' Elev. Bot=',
     &F8.2,' n''s=',3F7.4,/,' No.  Depth  Amain   Aleft  Aright      A 
     & Pmain  Pleft Pright     P    Top   S-En.  alpha',/,1X,92('-') )
      AA=0.
      AAR=0.
      AL=0.
      PP=0.
      PR=0.
      PL=0.
      DO 40 I=2,N
      YY=DYY*FLOAT(I-1)+ZSTA
      Y(I,M)=YY-ZSTA
41    IF(YY.LE.YR(IR1) .OR. IR1.EQ.NR) GO TO 42
      IR=IR1
      IR1=IR1+1
      GO TO 41
42    IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 43
      IR1=IR
      IR=IR-1
      GO TO 42
43    DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
44    IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 45
      IL=IL1
      IL1=IL1+1
      GO TO 44
45    IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 46
      IL1=IL
      IL=IL-1
      GO TO 45
46    DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      T(I,M)=XXR-XXL
      IF(YY.LE.YRD) THEN
      CALL SIMPR(EQUATR,Y1,YY,AARR,.1,11)
      ELSE
      AARR=DYY*(XRD-XMID)
      CALL SIMPR(EQUATR,Y1,YY,ARR,.1,11)
      AAR=AAR+ARR
      ENDIF
      AA=AA+AARR
      IF(YY.LE.YLD) THEN
      CALL SIMPR(EQUATL,Y1,YY,AAL,.1,11)
      ELSE
      AAL=DYY*(XMID-XLD)
      CALL SIMPR(EQUATL,Y1,YY,ALL,.1,11)
      AL=AL+ALL
      ENDIF
      AA=AA+AAL
      AT=AA+AAR+AL
      AR(I,M)=AA
      IF(AT.LT.1.E-5) GO TO 35
      VS=Q2G/AR(I,M)**2
      IF(VS.GT. 5.*Y(I,M)) GO TO 35
      E(I,M)=Y(I,M)+VS
      GO TO 36
35    E(I,M)=0.
36    IF(YY.LE.YRD) THEN
      CALL SIMPR(EQUAPR,Y1,YY,DPP,.1,11)
      PP=PP+DPP
      ELSE 
      CALL SIMPR(EQUAPR,Y1,YY,DPR,.1,11)
      PR=PR+ABS(DPR)
      ENDIF
      IF(YY.LE.YLD) THEN
      CALL SIMPR(EQUAPL,Y1,YY,DPP,.1,11)
      PP=PP+DPP
      ELSE
      CALL SIMPR(EQUAPL,Y1,YY,DPL,.1,11)
      PL=PL+ABS(DPL)
      ENDIF
      PT=PP+PR+PL
      P(I,M)=PP
      FK1=CC*AA*ABS(AA/PP)**.6666667/FN(M,1)
      IF(PL.GT. .1) FK2=CC*AL*ABS(AL/PL)**.6666667/FN(M,2)
      IF(PR.GT. .1) FK3=CC*AAR*ABS(AAR/PR)**.6666667/FN(M,3)
      IF(YY.GT.YLD .AND. YY.GT.YRD) THEN
      ALPA(I,M)=AT*AT*(FK1*(FK1/AA)**2+FK2*(FK2/AL)**2+FK3*(FK3/AAR)**2)
     &/(FK1+FK2+FK3)**3
      RKS(I,M)=FK1/(FK1+FK2+FK3)
      ELSE
      ALPA(I,M)=1.
      RKS(I,M)=1.
      ENDIF
      Y1=YY
      IF(IBOTSC) WRITE(*,311)I,Y(I,M),AA,AL,AAR,AT,PP,PL,PR,PT,T(I,M),
     &E(I,M),ALPA(I,M)
40    WRITE(IOTT,311) I,Y(I,M),AA,AL,AAR,AT,PP,PL,PR,PT,T(I,M),E(I,M),
     &ALPA(I,M)
311   FORMAT(I3,F7.3,4F8.2,4F7.2,3F7.3)
      RETURN
      END
      FUNCTION EQUATR(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &XMID,XLD,XRD,YLD,YRD,NR,NL,IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR1) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
      IF(YY.LE.YRD) THEN
      EQUATR=XXR-XMID
      ELSE
      EQUATR=XXR-XRD
      ENDIF
      RETURN
      END
      FUNCTION EQUATL(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &XMID,XLD,XRD,YLD,YRD,NR,NL,IR,IR1,IL,IL1
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      IF(YY.LT.YLD) THEN
      EQUATL=XMID-XXL
      ELSE
      EQUATL=XLD-XXL
      ENDIF
      RETURN
      END
      FUNCTION EQUAPR(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &XMID,XLD,XRD,YLD,YRD,NR,NL,IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR1) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      DX=XR(IR1)-XR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XR(IR)-(3.*B*B-1.)*D2XR(IR1))*DY/6.
      EQUAPR=SQRT(Z**2+1.)
      RETURN
      END
      FUNCTION EQUAPL(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &XMID,XLD,XRD,YLD,YRD,NR,NL,IR,IR1,IL,IL1
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      DX=XL(IL1)-XL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XL(IL)-(3.*B*B-1.)*D2XL(IL1))*DY/6.
      EQUAPL=SQRT(Z**2+1.)
      RETURN
      END
      SUBROUTINE INTERP(X,SE,KNWY)
      PARAMETER (N=26)
      LOGICAL*2 KNWY,TWICE
      COMMON /TRANS/ QN,FN(2,3),SO
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),ALPA(N,2),RKS(N,2),
     &CC,XSTA1,XSTA2,ZSTA1,YY,ZSTA2,PSTA,ASTA,FNA,Q2G,QSTA,IP1,IP2,IOTAB
      NCT=0
      TWICE=.FALSE.
      FAX=(X-XSTA1)/(XSTA2-XSTA1)
      IF(FAX.GT. .99) FAX=1.
      IF(FAX.LT. .01) FAX=0.
      JP1=IP1-1
      JP2=IP2-1
10    IF(IP1.GE.N .OR. Y(IP1,1).GE.YY) GO TO 20
      JP1=IP1
      IP1=IP1+1
      GO TO 10
20    IF(IP1.LT.3 .OR. Y(JP1,1).LE.YY) GO TO 30
      IP1=IP1-1
      JP1=IP1-1
      GO TO 20
30    IF(FAX.LT.1.E-5) GO TO 50
      IF(IP2.GE.N .OR. Y(IP2,2).GE.YY) GO TO 40
      JP2=IP2
      IP2=IP2+1
      GO TO 30
40    IF(IP2.LT.3 .OR. Y(JP2,2).LE.YY) GO TO 50
      IP2=IP2-1
      JP2=IP2-1
      GO TO 40
50    FA1=(YY-Y(JP1,1))/(Y(IP1,1)-Y(JP1,1))
      FA2=(YY-Y(JP2,2))/(Y(IP2,2)-Y(JP2,2))
      ASTA=(1.-FAX)*(A(JP1,1)+FA1*(A(IP1,1)-A(JP1,1)))+FAX*(A(JP2,2)+FA2
     &*(A(IP2,2)-A(JP2,2)))
      PSTA=(1.-FAX)*(P(JP1,1)+FA1*(P(IP1,1)-P(JP1,1)))+FAX*(P(JP2,2)+FA2
     &*(P(IP2,2)-P(JP2,2)))
      QSTA=(1.-FAX)*(RKS(JP1,1)+FA1*(RKS(IP1,1)-RKS(JP1,1)))+FAX*(RKS(
     &JP2,2)+FA2*(RKS(IP2,2)-RKS(JP2,2)))
52    FNA=(1.-FAX)*FN(1,1)+FAX*FN(2,1)
      IF(KNWY) GO TO 70
      F=SE-YY-Q2G/ASTA**2
      IF(TWICE) GO TO 60
      TWICE=.TRUE.
      F1=F
      YY=YY-.01
      GO TO 50
60    DIF=.01*F1/(F1-F)
      NCT=NCT+1
      TWICE=.FALSE.
      YY=YY+.01-DIF
      IF(NCT.LT.10 .AND. ABS(DIF).GT. .00001) GO TO 10
      IF(NCT.EQ.10) WRITE(*,80) DIF,YY,SE,Q2G
80    FORMAT(' Failed to converge, DIF=',E10.4,' YY=',3E10.4)
70    RETURN
      END