C  This program allows n to vary linearly between stations.  Now n is input
C each station and not in the original data just as in program GVFNATN.FOR.
C The difference is that this program using cubic splines to generate the tables
C of cross-sectional data with subroutine CHTABLSP.
      PARAMETER (N=26,NN=15)
      REAL SE(1),DE(1),XP(1),YP(1,1),WK1(1,13)
      CHARACTER*2 UNIT
      LOGICAL*2 LINEAR
      EXTERNAL DEX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRANS/ QN,FN(2),SO
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,FNA,Q2G,LINEAR,IP1,IP2,IOTAB
      WRITE(*,*)' GIVE: UNIT,IOUT,IOTAB,NSTAT,TOL,DELX,YB,Q,XBEG,XEND'
      READ(*,*) UNIT,IOUT,IOTAB,NSTAT,TOL,DELX,YB,Q,XBEG,XEND
      LINEAR=.TRUE.
      H1=-.1
      HMIN=1.E-4
      CC=1.486
      G=32.2
      IF(UNIT.EQ.'SI' .OR. UNIT.EQ.'si') THEN
      CC=1.
      G=9.81
      ENDIF
      G2=2.*G
      QN=(Q/CC)**2
      Q2G=Q*Q/G2
      XS=XBEG
      CALL CHTABLSP(1,1)
      CALL CHTABLSP(2,2)
      NSTA=2
      SO=(ZSTA2-ZSTA1)/(XSTA1-XSTA2)
      YY=YB
      IP1=N/2
      IP2=N/2
      CALL INTERP(XS,YY,.TRUE.)
      SE(1)=YY+Q2G/ASTA**2
      WRITE(IOUT,15) Q
15    FORMAT(' Solution to Gradually Varied Flow in natural channel with
     &',/,' Q =',F10.2,/,1X,78('-'),/,6X,'X',11X,'Y',9X,'E',
     &'   Perimeter      Area  Velocity  Bot. Slope    n',/,1X,78('-'))
      WRITE(IOUT,40) XS,YY,SE(1),PSTA,ASTA,Q/ASTA,SO,FN(1)
40    FORMAT(1X,6F10.2,F10.7,F7.4)
20    XZ=XS+DELX
      CALL ODESOL(SE,DE,1,XS,XZ,TOL,H1,HMIN,1,XP,YP,WK1,DEX)
      WRITE(IOUT,40) XZ,YY,SE(1),PSTA,ASTA,Q/ASTA,SO,FNA
      XS=XZ
      IF(XZ.LE.XSTA2 .AND. NSTA.LT.NSTAT) THEN
      DO 30 I=1,N
      Y(I,1)=Y(I,2)
      A(I,1)=A(I,2)
      P(I,1)=P(I,2)
30    E(I,1)=E(I,2)
      FN(1)=FN(2)
      ZSTA1=ZSTA2
      XSTA1=XSTA2
      IP1=IP2
      NSTA=NSTA+1
      CALL CHTABLSP(NSTA,2)
      SO=(ZSTA2-ZSTA1)/(XSTA1-XSTA2)
      ENDIF
      IF(XZ.GT.XEND) GO TO 20
      STOP
      END
      SUBROUTINE DEX(X,SE,EPRIME)
      PARAMETER (N=26)
      REAL SE(1),EPRIME(1)
      LOGICAL*2 LINEAR
      COMMON /TRANS/ QN,FN(2),SO
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,FNA,Q2G,LINEAR,IP1,IP2,IOTAB
      CALL INTERP(X,SE(1),.FALSE.)
      SF=QN*(FNA*ABS(PSTA/ASTA)**.666666667/ASTA)**2
      EPRIME(1)=SO-SF
      RETURN
      END
      SUBROUTINE CHTABLSP(NOSEC,M)
      PARAMETER (N=26,NN=15)
      EXTERNAL EQUAT, EQUAT1
      LOGICAL*2 IBOTSC
      REAL X(20),Z(20),DD(NN)
      COMMON /TRANS/ QN,FN(2),SO
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
      COMMON /INF/Y(N,2),T(N,2),AR(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,FNA,Q2G,LINEAR,IP1,IP2,IOTAB
      READ(3,*) NSTA,NVALUE,XSTA,FN(M)
      IF(M.EQ.1) THEN
      XSTA1=XSTA
      ELSE
      XSTA2=XSTA
      ENDIF
      IF(NVALUE.GT.20) THEN
      WRITE(*,100)
100   FORMAT(' Program dimension to allow only 20 coordinate pairs')
      STOP
      ENDIF
      IF(NSTA.NE.NOSEC) THEN
      WRITE(*,110) NSTA,NOSEC
110   FORMAT(' Next station with data is',I4,/,' Expecting data for stat
     *ion',I5)
      STOP
      ENDIF
      READ(3,*)(X(I),Z(I),I=1,NVALUE)
      ZSTA=Z(1)
      IMIN=1
      YMAX=ZSTA
      DO 10 I=2,NVALUE
      IF(Z(I).GE.ZSTA) GO TO 5
      ZSTA=Z(I)
      IMIN=I
5     IF(Z(I).GT.YMAX) YMAX=Z(I)
10    CONTINUE
      IF(Z(IMIN+1).LT.ZSTA+1.E-5) THEN
      T(1,M)=X(IMIN+1)-X(IMIN)
      P(1,M)=T(1,M)
      IR1=IMIN+1
      ELSE
      T(1,M)=0.
      P(1,M)=0.
      IR1=IMIN
      ENDIF
      AA=0.
      PP=P(1,M)
      AR(1,M)=0.
      Y(1,M)=0.
      NR=0
      DO 12 I=IR1,NVALUE
      NR=NR+1
      XR(NR)=X(I)
12    YR(NR)=Z(I)
      CALL SPLINESU(NR,YR,XR,D2XR,DD,0)
      NL=0
      DO 14 I=IMIN,1,-1
      NL=NL+1
      XL(NL)=X(I)
14    YL(NL)=Z(I)
      CALL SPLINESU(NL,YL,XL,D2XL,DD,0)
      IR=1
      IR1=2
      IL=1
      IL1=2
      DYY=(YMAX-ZSTA)/FLOAT(N-1)
      Y1=ZSTA
      IF(M.EQ.1) THEN
      ZSTA1=ZSTA
      ELSE
      ZSTA2=ZSTA
      ENDIF
      DO 40 I=2,N
      YY=DYY*FLOAT(I-1)+ZSTA
      Y(I,M)=YY-ZSTA
41    IF(YY.LE.YR(IR1) .OR. IR1.EQ.NR) GO TO 42
      IR=IR1
      IR1=IR1+1
      GO TO 41
42    IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 43
      IR1=IR
      IR=IR-1
      GO TO 42
43    DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
44    IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 45
      IL=IL1
      IL1=IL1+1
      GO TO 44
45    IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 46
      IL1=IL
      IL=IL-1
      GO TO 45
46    DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      T(I,M)=XXR-XXL
      CALL SIMPR(EQUAT,Y1,YY,AA,1.E-4,11)
      AR(I,M)=AR(I-1,M)+AA
      VS=Q2G/AR(I,M)**2
      IF(VS.GT. 5.*Y(I,M)) GO TO 35
      E(I,M)=Y(I,M)+VS
      GO TO 36
35    E(I,M)=0.
36    CALL SIMPR(EQUAT1,Y1,YY,PP,1.E-4,11)
      P(I,M)=P(I-1,M)+PP
40    Y1=YY
      IF(IOTAB.GT.0) THEN
      IOTT=IOTAB
      IBOTSC=.FALSE.
      IF(IOTAB.GT.20) THEN
      IOTT=IOTAB-20
      IBOTSC=.TRUE.
      ENDIF
      IF(IBOTSC) WRITE(*,312) NSTA,XSTA,ZSTA
      WRITE(IOTT,312) NSTA,XSTA,ZSTA
312   FORMAT(/,' Station no.=',I4,' Position, x =',F10.1,' Elev. Bot=',
     &F8.2,/,' No.     Depth      Area Perimeter Top Width S. Energy',/
     &,1X,55('-') )
      DO 310 I=1,N
      IF(IBOTSC) WRITE(*,311) I,Y(I,M),AR(I,M),P(I,M),T(I,M),E(I,M)
310   WRITE(IOTT,311) I,Y(I,M),AR(I,M),P(I,M),T(I,M),E(I,M)
311   FORMAT(I4,5F10.3)
      IF(IOTAB.EQ.6 .OR.IBOTSC) READ(*,*)
      ENDIF
      RETURN
      END
      FUNCTION EQUAT(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR1) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      XXR=A*XR(IR)+B*XR(IR1)+((A*A-1.)*A*D2XR(IR)+(B*B-1.)*B*D2XR(IR1))*
     &DY**2/6.
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      XXL=A*XL(IL)+B*XL(IL1)+((A*A-1.)*A*D2XL(IL)+(B*B-1.)*B*D2XL(IL1))*
     &DY**2/6.
      EQUAT=XXR-XXL
      RETURN
      END
      FUNCTION EQUAT1(YY)
      PARAMETER (NN=15)
      COMMON /TRAF/D2XR(NN),D2XL(NN),XR(NN),XL(NN),YR(NN),YL(NN),
     &NR,NL,IR,IR1,IL,IL1
1     IF(YY.LE.YR(IR1) .OR. IR1.EQ.NR) GO TO 2
      IR=IR1
      IR1=IR1+1
      GO TO 1
2     IF(YY.GE.YR(IR) .OR. IR.EQ.1) GO TO 3
      IR1=IR
      IR=IR-1
      GO TO 2
3     DY=YR(IR1)-YR(IR)
      DX=XR(IR1)-XR(IR)
      A=(YR(IR1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XR(IR)-(3.*B*B-1.)*D2XR(IR1))*DY/6.
      EQUAT1=SQRT(Z**2+1.)
4     IF(YY.LE.YL(IL1) .OR. IL1.EQ.NL) GO TO 5
      IL=IL1
      IL1=IL1+1
      GO TO 4
5     IF(YY.GE.YL(IL) .OR. IL.EQ.1) GO TO 6
      IL1=IL
      IL=IL-1
      GO TO 5
6     DY=YL(IL1)-YL(IL)
      DX=XL(IL1)-XL(IL)
      A=(YL(IL1)-YY)/DY
      B=1.-A
      Z=DX/DY-((3.*A*A-1.)*D2XL(IL)-(3.*B*B-1.)*D2XL(IL1))*DY/6.
      EQUAT1=EQUAT1+SQRT(Z**2+1.)
      RETURN
      END
      SUBROUTINE INTERP(X,SE,KNWY)
      PARAMETER (N=26)
      LOGICAL*2 LINEAR,KNWY,TWICE
      COMMON /TRANS/ QN,FN(2),SO
      COMMON /INF/Y(N,2),T(N,2),A(N,2),P(N,2),E(N,2),XSTA1,XSTA2,ZSTA1,
     &YY,ZSTA2,PSTA,ASTA,FNA,Q2G,LINEAR,IP1,IP2,IOTAB
      NCT=0
      TWICE=.FALSE.
      FAX=(X-XSTA1)/(XSTA2-XSTA1)
      IF(FAX.GT. .99) FAX=1.
      IF(FAX.LT. .01) FAX=0.
      JP1=IP1-1
      JP2=IP2-1
10    IF(IP1.GE.N .OR. Y(IP1,1).GE.YY) GO TO 20
      JP1=IP1
      IP1=IP1+1
      GO TO 10
20    IF(IP1.LT.3 .OR. Y(JP1,1).LE.YY) GO TO 30
      IP1=IP1-1
      JP1=IP1-1
      GO TO 20
30    IF(FAX.LT.1.E-5) GO TO 50
      IF(IP2.GE.N .OR. Y(IP2,2).GE.YY) GO TO 40
      JP2=IP2
      IP2=IP2+1
      GO TO 30
40    IF(IP2.LT.3 .OR. Y(JP2,2).LE.YY) GO TO 50
      IP2=IP2-1
      JP2=IP2-1
      GO TO 40
50    FA1=(YY-Y(JP1,1))/(Y(IP1,1)-Y(JP1,1))
      FA2=(YY-Y(JP2,2))/(Y(IP2,2)-Y(JP2,2))
      ASTA=(1.-FAX)*(A(JP1,1)+FA1*(A(IP1,1)-A(JP1,1)))+FAX*(A(JP2,2)+FA2
     &*(A(IP2,2)-A(JP2,2)))
      PSTA=(1.-FAX)*(P(JP1,1)+FA1*(P(IP1,1)-P(JP1,1)))+FAX*(P(JP2,2)+FA2
     &*(P(IP2,2)-P(JP2,2)))
      FNA=(1.-FAX)*FN(1)+FAX*FN(2)
      IF(KNWY) GO TO 70
      F=SE-YY-Q2G/ASTA**2
      IF(TWICE) GO TO 60
      TWICE=.TRUE.
      F1=F
      YY=YY-.01
      GO TO 50
60    DIF=.01*F1/(F1-F)
      NCT=NCT+1
      TWICE=.FALSE.
      YY=YY+.01-DIF
      IF(NCT.LT.10 .AND. ABS(DIF).GT. .00001) GO TO 10
      IF(NCT.EQ.10) WRITE(*,80) DIF,YY,SE,Q2G
80    FORMAT(' Failed to converge, DIF=',E10.4,' YY=',3E10.4)
70    RETURN
      END