C This program uses c rather than Y  as a variable to solve.  The solution method
C is the Hartree method.  This program is restricted to rectangular channels.
C Using c, rather than Y, is relatively  straight forward since along C+
C char. dx/dt=V+c with d(V+2c)/dt=g(So-Sf) and along C- char. dx/dt=V-c with
C d(V-2c)/dt=g(So-Sf)
      COMMON V(51),C(51),VK(51),CK(51),Va(8),F(8),F1(8),D(8,8),Z(8),DTG2
     &,DELTDX,CN,DX,DT2,SO,B,G,DV,DELT,H,FEK,VaN,N,II,IOUT,LINEAR,ITYPE
      REAL GIVTIM(40),GIVDWS(40),KE
      WRITE(*,*)' Give input and output units: IN & IOUT'
      READ(*,*) IN,IOUT
      READ(IN,*) NT,N,LINEAR,DELT,NPRT,Q,FN,SO,B,G,FL,H,KE
C READ initial depths, which are later converted to celerities
      READ(IN,*) (CK(I),I=N,1,-1)
      READ(IN,*) ITYPE,MGIV,(GIVTIM(I),GIVDWS(I),I=1,MGIV)
C  ITYPE=1 then Y(N)-given; ITYPE=2 then V(N)-given; ITYPE=3 then Q(N)-given
C Unknowns: Va(1)=V, Va(2)=c, Va(3)=XL, Va(4)=XR, Va(5)=VL, Va(6)=VR, 
C   Va(7)=cL, Va(8)=cR.
C For upstream BC Va(1)=V, Va(2)=c, Va(3)=XR, Va(4)=VR, Va(5)=cR
C For downstream BC Va(1)=V, Va(2)=c, Va(3)=XL, Va(4)=VL, Va(5)=cL
      DT2=DELT/2.
      DTG2=G*DELT
      DX=FL/FLOAT(N-1)
      DELTDX=DELT/DX
      FEK=(KE+1.)/(2.*G)
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      DO 5 I=1,N
      VK(I)=Q/(B*CK(I))
      C(I)=SQRT(G*CK(I))
5     V(I)=VK(I)
      WRITE(IOUT,100) 0,0.
      WRITE(IOUT,101) (CK(I),I=1,N)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(Q,I=1,N)
      WRITE(IOUT,101)(C(I),I=1,N)
      DO 6 I=1,N
6     CK(I)=C(I)
      IGIV=2
      DO 50 K=1,NT
      TIME=DELT*FLOAT(K)
10    IF(GIVTIM(IGIV).GE.TIME .OR. IGIV.EQ.MGIV) GO TO 20
      IGIV=IGIV+1
      GO TO 10
20    IG=IGIV-1
      VaN=GIVDWS(IG)+(TIME-GIVTIM(IG))/(GIVTIM(IGIV)-GIVTIM(IG))*
     &(GIVDWS(IGIV)-GIVDWS(IG))
      CALL SOLVE
      IF(MOD(K,NPRT).EQ.0) THEN
      WRITE(IOUT,100) K,TIME,VaN
100   FORMAT(/,' K=',I3,', Depth, Velocity, Flowrate & 	Celerity for Tim
     &e=',F8.1,' sec.  (Given=',F8.2,')')
      WRITE(IOUT,101) (C(I)**2/G,I=1,N)
101   FORMAT(1X,16F7.2)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*B*C(I)**2/G,I=1,N)
102   FORMAT(1X,16F7.1)
      WRITE(IOUT,101)(C(I),I=1,N)
      ENDIF
      DO 40 I=1,N
      YA=V(I)
      V(I)=2.*YA-VK(I)
      VK(I)=YA
      YA=C(I)
      C(I)=2.*YA-CK(I)
40    CK(I)=YA
50    CONTINUE
      END
      SUBROUTINE SOLVE
      COMMON V(51),C(51),VK(51),CK(51),Va(8),F(8),F1(8),D(8,8),Z(8),DTG2
     &,DELTDX,CN,DX,DT2,SO,B,G,DV,DELT,H,FEK,VaN,N,II,IOUT,LINEAR,ITYPE
      DO 50 I=1,N
      II=I
      IP=I+1
      IM=I-1
      NCT=0
      Va(1)=V(I)
      Va(2)=C(I)
C  Va(3) IS (XL-Xi-1)/Dx, or  XL=X(I-1)+Dx*Va(3)
C  Va(4) IS (XR-Xi)/Dx, or  XR=X(I)+Dx*Va(4)
      IF(I.EQ.1) THEN
      NEQ=5
      Va(3)=(C(1)-V(1))*DELTDX
      Va(4)=V(1)+Va(3)*(V(2)-V(1))
      Va(5)=C(1)+Va(3)*(C(2)-C(1))
      ELSE IF(I.EQ.N) THEN
      NEQ=5
      Va(3)=1.-(V(N)+C(N))*DELTDX
      Va(4)=V(N-1)+(1.-Va(3))*(V(N)-V(N-1))
      Va(5)=C(N-1)+(1.-Va(3))*(C(N)-C(N-1))
      ELSE
      NEQ=8
      IF(I.EQ.2) THEN
      Va(3)=1.-(V(2)+C(I))*DELTDX
      Va(4)=(C(I)-V(2))*DELTDX
      ENDIF
      Va(5)=VK(IM)+Va(3)*(VK(I)-VK(IM))
      Va(7)=CK(IM)+Va(3)*(CK(I)-CK(IM))
      Va(6)=VK(I)+Va(4)*(VK(IP)-VK(I))
      Va(8)=CK(I)+Va(4)*(CK(IP)-CK(I))
      ENDIF
15    CALL FUNCT(0)
      DO 20 J=1,NEQ
20    F1(J)=F(J)
      DO 22 J=1,NEQ
      CALL FUNCT(J)
      DO 22 J1=1,NEQ
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQ-1
      DO 30 M=NEQ,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQ
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQ
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(M)=Va(M)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQ
32    SUM=SUM+Z(J)*D(M1,J)
      IF(ABS(D(M1,M1)).LT.1.E-10) THEN
      Z(M1)=0.
      ELSE
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      ENDIF
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
      NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .00001) GO TO 15
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',I,DIF
      V(I)=Va(1)
50    C(I)=Va(2)
      RETURN
      END
      SUBROUTINE FUNCT(J)
      PARAMETER (EX=.66666667)
      COMMON V(51),C(51),VK(51),CK(51),Va(8),F(8),F1(8),D(8,8),Z(8),DTG2
     &,DELTDX,CN,DX,DT2,SO,B,G,DV,DELT,H,FEK,VaN,N,I,IOUT,LINEAR,ITYPE
      IM=I-1
      IP=I+1
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      IF(ABS(DV).LT. 1.E-5) DV=SIGN(1.E-5,DV)
      Va(J)=Va(J)+DV
      ENDIF
      YY=Va(2)**2/G
      SF=(CN*Va(1)*((B+2.*YY)/(B*YY))**EX)**2
      IF(I.EQ.1) THEN
C Upstream BC H=Y+(1+Ke)V**2/(2g)
      YR=Va(5)**2/G
      SFR=(CN*Va(4)*((B+2.*YR)/(B*YR))**EX)**2
      F(1)=DT2*(Va(2)-Va(1)+Va(5)-Va(4))-DX*Va(3)
      F(2)=Va(1)-Va(4)+2.*(Va(5)-Va(2))-DTG2*(SO-.5*(SF+SFR))
      F(3)=H-YY-FEK*Va(1)**2
      IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(1)-Va(3)*(VK(2)-VK(1))
      F(5)=Va(5)-CK(1)-Va(3)*(CK(2)-CK(1))
      ELSE
      F(4)=Va(4)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     & VK(3)-VK(2)))
      F(5)=Va(5)-CK(1)-.5*Va(3)*((3.-Va(3))*(CK(2)-CK(1))+(Va(3)-1.)*(
     & CK(3)-CK(2)))
      ENDIF
      ELSE IF(I.EQ.N) THEN
C Downstream BC 
      YL=Va(5)**2/G
      SFL=(CN*Va(4)*((B+2.*YL)/(B*YL))**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+Va(2)+Va(4)+Va(5))
      F(2)=Va(1)-Va(4)+2.*(Va(2)-Va(5))-DTG2*(SO-.5*(SF+SFL))
      IF(ITYPE-2) 1,2,3
1     F(3)=Va(2)**2/G-VaN
      GO TO 4
2     F(3)=Va(1)-VaN
      GO TO 4
3     F(3)=VaN-Va(2)**2*Va(1)/G
4     IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(5)=Va(5)-CK(IM)-Va(3)*(CK(I)-CK(IM))
      ELSE
      F(4)=Va(4)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(5)=Va(5)-CK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(CK(IM)-CK(I-2))+Va(3
     &)*(CK(I)-CK(IM)))
      ENDIF
      ELSE
C Regular points
      YL=Va(7)**2/G
      SFL=(CN*Va(5)*((B+2.*YL)/(B*YL))**EX)**2
      YR=Va(8)**2/G
      SFR=(CN*Va(6)*((B+2.*YR)/(B*YR))**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+Va(2)+Va(5)+Va(7))
      F(2)=Va(1)-Va(5)+2.*(Va(2)-Va(7))-DTG2*(SO-.5*(SF+SFL))
      F(3)=DT2*(Va(2)-Va(1)+Va(8)-Va(6))-DX*Va(4)
      F(4)=Va(1)-Va(6)+2.*(Va(8)-Va(2))-DTG2*(SO-.5*(SF+SFR))
      IF(LINEAR.EQ.1) THEN
      F(5)=Va(5)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(7)=Va(7)-CK(IM)-Va(3)*(CK(I)-CK(IM))
      ELSE
      IF(I.EQ.2) THEN
      F(5)=Va(5)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     &VK(3)-VK(2)))
      F(7)=Va(7)-CK(1)-.5*Va(3)*((3.-Va(3))*(CK(2)-CK(1))+(Va(3)-1.)*(
     &CK(3)-CK(2)))
      ELSE
      F(5)=Va(5)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(7)=Va(7)-CK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(CK(IM)-CK(I-2))+Va(3
     &)*(CK(I)-CK(IM)))
      ENDIF
      ENDIF
      IF(LINEAR.EQ.1) THEN
      F(6)=Va(6)-VK(I)-Va(4)*(VK(IP)-VK(I))
      F(8)=Va(8)-CK(I)-Va(4)*(CK(IP)-CK(I))
      ELSE
      IF(IP.EQ.N) THEN
      F(6)=Va(6)-VK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(VK(I)-VK(IM))+Va(4)*
     &(VK(N)-VK(I)))
      F(8)=Va(8)-CK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(CK(I)-CK(IM))+Va(4)*
     &(CK(N)-CK(I)))
      ELSE
      F(6)=Va(6)-VK(I)-.5*Va(4)*((3.-Va(4))*(VK(IP)-VK(I))+(Va(4)-1.)*(
     &VK(I+2)-VK(IP)))
      F(8)=Va(8)-CK(I)-.5*Va(4)*((3.-Va(4))*(CK(IP)-CK(I))+(Va(4)-1.)*(
     &CK(I+2)-CK(IP)))
      ENDIF
      ENDIF
      ENDIF
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END