C  This program uses the "Iterative Solution Technique that starts assuming that
C  points L & R can be determined using slopes of char. at point (i,k).
C  Its subroutine SOLVE is that listed in the book.
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),FMS,DTG2,FM2,CN,DX,DT2,SO,
     &GBS,B,FM,G,DELT,H,FEK,VaN,N,IOUT,ITYPE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      REAL GIVTIM(40),GIVDWS(40),KE
      WRITE(*,*)' Give input and output units: IN & IOUT'
      READ(*,*) IN,IOUT
      READ(IN,*) NT,N,DELT,Q,FN,SO,B,FM,G,FL,H,KE
      READ(IN,*) (YK(I),I=N,1,-1)
C      READ(IN,*) (YK(I),I=1,N)
      READ(IN,*) ITYPE,MGIV,(GIVTIM(I),GIVDWS(I),I=1,MGIV)
C  ITYPE=1 then Y(N)-given; ITYPE=2 then V(N)-given; ITYPE=3 then Q(N)-given
C Unknowns: Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=XR, Va(5)=VL, Va(6)=VR, 
C   Va(7)=YL, Va(8)=YR.
C For upstream BC Va(1)=V, Va(2)=Y, Va(3)=XR, Va(4)=VR, Va(5)=YR
C For downstream BC Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=VL, Va(5)=YL
      IF(FM.GT.0.) THEN
      GBS=SQRT(G*B/FM)
      ELSE
      GBS=1.
      ENDIF
      DT2=DELT/2.
      DTG2=G*DELT
      DX=FL/FLOAT(N-1)
      FEK=(KE+1.)/(2.*G)
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      ITAB=100
      IF(FM.GT. 0.) CALL STAGE
      DO 5 I=1,N
      Y(I)=YK(I)
      VK(I)=Q/((B+FM*Y(I))*Y(I))
5     V(I)=VK(I)
      WRITE(IOUT,100) 0,0.,GIVDWS(1)
      WRITE(IOUT,101) (Y(I),I=1,N)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(Q,I=1,N)
      C=SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2)))
      Va(3)=1.-(V(2)+C)*DELT/DX
      Va(4)=(C-V(2))*DELT/DX
      IGIV=2
      DO 50 K=1,NT
      TIME=DELT*FLOAT(K)
10    IF(GIVTIM(IGIV).GE.TIME .OR. IGIV.EQ.MGIV) GO TO 20
      IGIV=IGIV+1
      GO TO 10
20    IG=IGIV-1
      VaN=GIVDWS(IG)+(TIME-GIVTIM(IG))/(GIVTIM(IGIV)-GIVTIM(IG))*
     &(GIVDWS(IGIV)-GIVDWS(IG))
      CALL SOLVE
      WRITE(IOUT,100) K,TIME,VaN
100   FORMAT(/,' K=',I3,', Depth, Velocity & Flowrate for Time=',F8.1,
     &' sec.',' Given=',F8.3)
      WRITE(IOUT,101) (Y(I),I=1,N)
101   FORMAT(1X,16F7.2)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*(B+FM*Y(I))*Y(I),I=1,N)
102   FORMAT(1X,16F7.1)
      DO 40 I=1,N
      YA=V(I)
      V(I)=2.*YA-VK(I)
      VK(I)=YA
      YA=Y(I)
      Y(I)=2.*YA-YK(I)
40    YK(I)=YA
50    CONTINUE
      END
      SUBROUTINE SOLVE
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),FMS,DTG2,FM2,CN,DX,DT2,SO,
     &GBS,B,FM,G,DELT,H,FEK,VaN,N,IOUT,ITYPE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      AMB=DELT/DX
      AMB2=AMB*AMB
      Va(1)=VK(1)
      Va(2)=YK(1)
      DO 50 I=1,N
      ITER=0
      IP=I+1
      IM=I-1
      XI=DX*FLOAT(I)
      XIM=XI-DX
      XIP=XI+DX
      C=SQRT(G*(B+FM*Y(I))*Y(I)/(B+FM2*Y(I)))
1     IF(I.NE.1) THEN
      IF(ITER.EQ.0) Va(3)=XI-DELT*(VK(I)+C)
      Va(5)=VK(IM)+(Va(3)-XIM)/DX*(VK(I)-VK(IM))
      IF(ITER.EQ.0) THEN
      CIM=SQRT(G*(B+FM*Y(IM))*Y(IM)/(B+FM2*Y(IM)))
      CL=CIM+(Va(3)-XIM)/DX*(C-CIM)
      ENDIF
      Va(7)=CL*CL/G
      IF(FM.GT.0.) THEN
      BB=Va(7)-.5*B/FM
      Va(7)=BB+SQRT(BB*BB+B*Va(7)/FM)
      ENDIF
      IF(ITER.EQ.0) SFL=(CN*Va(5)*((B+FMS*Va(7))/((B+FM*Va(7))*Va(7)))
     &**.66666667)**2
      R1=Va(5)+WSTAGE(Va(7))+DTG2*(SO-SFL)
      ENDIF
      IF(I.NE.N) THEN
      IF(ITER.EQ.0) Va(4)=XI-DELT*(VK(I)-C)
      VA(6)=VK(IP)+(XIP-VA(4))/DX*(VK(I)-VK(IP))
      IF(ITER.EQ.0) THEN
      CIP=SQRT(G*(B+FM*Y(IP))*Y(IP)/(B+FM2*Y(IP)))
      CR=CIP+(XIP-Va(4))/DX*(C-CIP)
      ENDIF
      Va(8)=CR*CR/G
      IF(FM.GT.0.) THEN
      BB=Va(8)-.5*B/FM
      Va(8)=BB+SQRT(BB*BB+B*Va(8)/FM)
      ENDIF
      IF(ITER.EQ.0) SFR=(CN*Va(6)*((B+FMS*Va(8))/((B+FM*Va(8))*Va(8)))
     &**.66666667)**2
      R2=Va(6)-WSTAGE(Va(8))+DTG2*(SO-SFR)
      IF(I.NE.1) Va(1)=.5*(Va(5)+Va(6))+DTG2*(SO-.5*(SFL+SFR))
      ENDIF
      IF(I.EQ.1) THEN
C  UPSTREAM B.C.
      NCT=0
2     IF(ITER.GT.0) THEN
      SF=(CN*Va(1)*((B+FMS*Va(2))/AR)**.66666667)**2
      R2=Va(6)-WSTAGE(Va(8))+DTG2*(SO-.5*(SFR1+SF))
      ENDIF
      Va(1)=R2+WSTAGE(Va(2))
      F1=H-Va(2)-FEK*Va(1)**2
      DV=.005*Va(2)
      F11=H-Va(2)-DV-FEK*(R2+WSTAGE(Va(2)+DV))**2
      DIF=DV*F1/(F11-F1)
      Va(2)=Va(2)-DIF
      NCT=NCT+1
      IF(NCT.LT.20 .AND. ABS(DIF).GT. .000001) GO TO 2
      ELSE IF(I.EQ.N) THEN
C DOWNSTREAM B.C.
      IF(ITYPE.EQ.1) THEN
      Va(1)=R1-WSTAGE(VaN)
      Va(2)=VaN
      ELSE IF(ITYPE.EQ.2) THEN
      WK1=R1-VaN
      IF(FM.GT.0.) THEN
      Va(2)=B*YSTAGE(WK1/GBS)/FM
      ELSE
      Va(2)=(.5*WK1)**2/G
      ENDIF
      Va(1)=VaN
      ELSE
      NCT=0
4     F1=VaN/((B+FM*Va(2))*Va(2))+WSTAGE(Va(2))-R1
      DV=.005*Va(2)
      VA2=Va(2)+DV
      F11=VaN/((B+FM*VA2)*VA2)+WSTAGE(VA2)-R1      
      DIF=DV*F1/(F11-F1)
      Va(2)=Va(2)-DIF
      NCT=NCT+1
      IF(NCT.LT.20 .AND. ABS(DIF).GT. .000001) GO TO 4
      Va(1)=R1-WSTAGE(Va(2))
      ENDIF
      ELSE
C REGULAR POINTS
      Va(1)=.5*(R1+R2)
      WK1=.5*(R1-R2)
      IF(FM.GT.0.) THEN
      Va(2)=B*YSTAGE(WK1/GBS)/FM
      ELSE
      Va(2)=(.5*WK1)**2/G
      ENDIF      
      ENDIF
C Uses average of v's * c's to evaluate x at L & R and repeats computations
      ITER=ITER+1
      IF(ITER.EQ.1) THEN
      AR=(B+FM*Va(2))*Va(2)
      C=SQRT(G*AR/(B+FM2*Va(2)))
      SF=(CN*Va(1)*((B+FMS*Va(2))/AR)**.66666667)**2
      IF(I.NE.1) THEN
      CL=SQRT(G*(B+FM*Va(7))*Va(7)/(B+FM2*Va(7)))
      Va(3)=XI-DT2*(Va(1)+Va(5)+C+CL)
      SFL=.5*(SF+SFL)
      ENDIF
      IF(I.NE.N) THEN
      CR=SQRT(G*(B+FM*Va(8))*Va(8)/(B+FM2*Va(8)))
      Va(4)=XI-DT2*(Va(1)+Va(6)-C-CR)
      IF(I.EQ.1) SFR1=SFR
      SFR=.5*(SF+SFR)
      ENDIF
      GO TO 1
      ENDIF
      V(I)=Va(1)
50    Y(I)=Va(2)
      RETURN
      END
      FUNCTION YSTAGE(WK1)
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      IF(ITAB.LT.399) THEN
      IT1=ITAB+1
      ELSE
      IT1=399
      ITAB=398
      ENDIF
      IF(WK1.LT.W(IT1)) THEN
 10   IF(WK1.LT.W(ITAB)) THEN
      ITAB=ITAB-1
      IF(ITAB.GT.1) GO TO 10
      ENDIF
      IT1=ITAB+1
      ELSE
20    IF(WK1.GT. W(IT1)) THEN
      IT1=IT1+1
      IF(IT1.LT.399) GO TO 20
      ENDIF
      ITAB=IT1-1
      ENDIF
      YSTAGE=YST(ITAB)+(WK1-W(ITAB))/(W(IT1)-W(ITAB))*(YST(IT1)-
     &YST(ITAB))
      RETURN
      END
      FUNCTION WSTAGE(YY)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),FMS,DTG2,FM2,CN,DX,DT2,SO,
     &GBS,B,FM,G,DELT,H,FEK,VaN,N,IOUT,ITYPE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      IF(FM.LT.1.E-5) THEN
      WSTAGE=2.*SQRT(G*YY)
      ELSE
      YYY=FM*YY/B
      IF(ITAB.LT.2) ITAB=2
      IF(ITAB.LT.399) THEN
      I1=ITAB+1
      ELSE
      ITAB=398
      I1=399
      ENDIF
      IF(YYY.LT.YST(I1)) THEN
 10   IF(YYY.LT.YST(ITAB)) THEN
      ITAB=ITAB-1
      IF(ITAB.GT.1) GO TO 10
      ENDIF
      I1=ITAB+1
      ELSE
20    IF(YYY.GT. YST(I1)) THEN
      I1=I1+1
      IF(I1.LT.399) GO TO 20
      ENDIF
      ITAB=I1-1
      ENDIF
      WSTAGE=GBS*(W(ITAB)+(YYY-YST(ITAB))/(YST(I1)-YST(ITAB))*(W(I1)-
     &W(ITAB)))
      ENDIF
      RETURN
      END
      SUBROUTINE STAGE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
      DY=.005
      DY1=DY/10.
      DYH=DY1/2.
      N=(2.-.01)/DY+1
      YST(1)=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      YP=YST(I-1)+DY1*FLOAT(J)
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
5     RC=RC1
      YST(I)=YP
10    W(I)=W(I-1)+SUM
      RETURN
      END