C This program modifies HARTREE to allow for a submerged gate with a constant
C energy E1 upstream from it. Three additional equations are used at the upstream
C end of the channel: (1) special momentum, (2) special energy, & (3) energy
C from rectangular to trapezoidal channel (replaces H-Y-Q**2/(2g)).  B2 is with
C of upstream rect. channel.
C 7 eqs. are solved for the upstream boundary condition, with Y (submerged depth
C downstream from gate)=Va(6), Y3 (depth downstream in rect. ch.)=Va(7) added to
C those in HARTEE and listed below. The depth of jet below the gate is Y2=CcYg, 
C and this depth is what is specified as a function of time, i.e. the gates setting
C is changed in time.
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),GBS,
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,E1,Y2,FEK,VaN,N,II
     &,IOUT,LINEAR,ITYPE,YSUB,Y3,B2
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      REAL GIVTIM(40),GIVDWS(40),GY2TIM(20),GY2UP(20)
      WRITE(*,*)' Give input and output units: IN & IOUT'
      READ(*,*) IN,IOUT
      READ(IN,*) NT,N,LINEAR,DELT,NPRT,Q,FN,SO,B,FM,G,FL,B2,Y2
      READ(IN,*) (YK(I),I=N,1,-1)
C      READ(IN,*) (YK(I),I=1,N)
      READ(IN,*) ITYPE,MGIV,(GIVTIM(I),GIVDWS(I),I=1,MGIV)
      READ(IN,*) MY2GIV,(GY2TIM(I),GY2UP(I),I=1,MY2GIV)
C  ITYPE=1 then Y(N)-given; ITYPE=2 then V(N)-given; ITYPE=3 then Q(N)-given
C Unknowns: Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=XR, Va(5)=VL, Va(6)=VR, 
C   Va(7)=YL, Va(8)=YR.
C For upstream BC Va(1)=V, Va(2)=Y, Va(3)=XR, Va(4)=VR, Va(5)=YR
C For downstream BC Va(1)=V, Va(2)=Y, Va(3)=XL, Va(4)=VL, Va(5)=YL
      GBS=SQRT(G*B/FM)
      DT2=DELT/2.
      DTG2=G*DELT
      DX=FL/FLOAT(N-1)
      DELTDX=DELT/DX
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      FEK=.5/G
      QS=(Q/B2)**2/G
      QS2=QS/2.
      EU=YK(1)+(Q/((B+FM*YK(1))*YK(1)))**2/(2.*G)
      Y3=.95*YK(1)
      NCT=0
1     FF=EU-Y3-QS2/Y3**2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 2
      Y3=Y3+.005
      F11=FF
      GO TO 1
2     DIF=.005*F11/(FF-F11)
      Y3=Y3-.005-DIF
      IF(ABS(DIF).GT.1.E-6 .AND.NCT.LT.30) GO TO 1
      YSUB=SQRT(2.*(QS/Y3-QS/Y2)+Y3*Y3)
      E1=YSUB+QS2/Y2**2
      WRITE(IOUT,210) YSUB,E1,Y2,EU
      WRITE(*,210) YSUB,E1,Y2,EU
210   FORMAT(' Initial submerge depth=',F7.3,' Upstream Energy=',F7.3,
     &/,' Gate jet depth=',F7.3,' Eu=',F7.3)
      ITAB=100
      IF(FM.GT. 0.) CALL STAGE
      DO 5 I=1,N
      Y(I)=YK(I)
      VK(I)=Q/((B+FM*Y(I))*Y(I))
5     V(I)=VK(I)
      WRITE(IOUT,100) 0,0.,GIVDWS(1),Y2,YSUB,Y3
      WRITE(IOUT,101) (Y(I),I=1,N)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(Q,I=1,N)
      IGIV=2
      IY2GIV=2
      WRITE(*,*)' Give frequency of plot data'
      READ(*,*) NPRNT
      DO 50 K=1,NT
      TIME=DELT*FLOAT(K)
10    IF(GIVTIM(IGIV).GE.TIME .OR. IGIV.EQ.MGIV) GO TO 20
      IGIV=IGIV+1
      GO TO 10
20    IG=IGIV-1
      VaN=GIVDWS(IG)+(TIME-GIVTIM(IG))/(GIVTIM(IGIV)-GIVTIM(IG))*
     &(GIVDWS(IGIV)-GIVDWS(IG))
11    IF(GY2TIM(IY2GIV).GE.TIME .OR. IY2GIV.EQ.MY2GIV) GO TO 21
      IY2GIV=IY2GIV+1
      GO TO 11
21    IY2G=IY2GIV-1
      Y2=GY2UP(IY2G)+(TIME-GY2TIM(IY2G))/(GY2TIM(IY2GIV)-GY2TIM(IY2G))*
     &(GY2UP(IY2GIV)-GY2UP(IY2G))
      CALL SOLVE
      IF(MOD(K,NPRT).EQ.0) THEN
      WRITE(IOUT,100) K,TIME,VaN,Y2,YSUB,Y3
100   FORMAT(/,' K=',I3,', Depth, Velocity & Flowrate for Time=',F8.1,
     &' sec. (Given=',F7.3,')',/,' Y2=',F7.3,' Ysub=',F7.3,' Y3=',F7.3)
      WRITE(IOUT,101) (Y(I),I=1,N)
101   FORMAT(1X,16F7.2)
      WRITE(IOUT,101)(V(I),I=1,N)
      WRITE(IOUT,102)(V(I)*(B+FM*Y(I))*Y(I),I=1,N)
102   FORMAT(1X,16F7.1)
      ENDIF
      IF(MOD(K,NPRNT).EQ.0) write(4,*)' '
      DO 40 I=1,N
      YA=V(I)
      IF(MOD(K,NPRNT).EQ.0) write(4,333) dx*float(i-1),Y(I),YA,
     &V(I)*(B+FM*Y(I))*Y(I)
333   format(f6.1,2f8.3,f9.2)
      V(I)=2.*YA-VK(I)
      VK(I)=YA
      YA=Y(I)
      Y(I)=2.*YA-YK(I)
40    YK(I)=YA
50    CONTINUE
      END
      SUBROUTINE SOLVE
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),GBS,
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,E1,Y2,FEK,VaN,N,II
     &,IOUT,LINEAR,ITYPE,YSUB,Y3,B2
      DO 50 I=1,N
      II=I
      IP=I+1
      IM=I-1
      NCT=0
      Va(1)=V(I)
      Va(2)=Y(I)
C  Va(3) IS (XL-Xi-1)/Dx, or  XL=X(I-1)+Dx*Va(3)
C  Va(4) IS (XR-Xi)/Dx, or  XR=X(I)+Dx*Va(4)
      IF(I.EQ.1) THEN
      NEQ=7
      Va(3)=(SQRT(G*(B+FM*Y(1))*Y(1)/(B+FM2*Y(1)))-V(1))*DELTDX
      Va(4)=V(1)+Va(3)*(V(2)-V(1))
      Va(5)=Y(1)+Va(3)*(Y(2)-Y(1))
      Va(6)=YSUB
      Va(7)=Y3
      ELSE IF(I.EQ.N) THEN
      NEQ=5
      Va(3)=1.-(V(N)+SQRT(G*(B+FM*Y(N))*Y(N)/(B+FM2*Y(N))))*DELTDX
      Va(4)=V(N-1)+(1.-Va(3))*(V(N)-V(N-1))
      Va(5)=Y(N-1)+(1.-Va(3))*(Y(N)-Y(N-1))
      ELSE
      NEQ=8
      IF(I.EQ.2) THEN
      Va(3)=1.-(V(2)+SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2))))*DELTDX
      Va(4)=(SQRT(G*(B+FM*Y(2))*Y(2)/(B+FM2*Y(2)))-V(2))*DELTDX
      ENDIF
      Va(5)=VK(IM)+Va(3)*(VK(I)-VK(IM))
      Va(7)=YK(IM)+Va(3)*(YK(I)-YK(IM))
      Va(6)=VK(I)+Va(4)*(VK(IP)-VK(I))
      Va(8)=YK(I)+Va(4)*(YK(IP)-YK(I))
      ENDIF
15    CALL FUNCT(0)
      DO 20 J=1,NEQ
20    F1(J)=F(J)
      DO 22 J=1,NEQ
      CALL FUNCT(J)
      DO 22 J1=1,NEQ
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQ-1
      DO 30 M=NEQ,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQ
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQ
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(M)=Va(M)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQ
32    SUM=SUM+Z(J)*D(M1,J)
      IF(ABS(D(M1,M1)).LT.1.E-10) THEN
      Z(M1)=0.
      ELSE
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      ENDIF
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
      NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .00001) GO TO 15
      IF(NCT.EQ.20) WRITE(*,*)' Failed to converge',I,DIF
      IF(I.EQ.1) THEN
      YSUM=Va(6)
      Y3=Va(7)
      ENDIF
      V(I)=Va(1)
50    Y(I)=Va(2)
      RETURN
      END
      SUBROUTINE FUNCT(J)
      PARAMETER (EX=.66666667)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),GBS,
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,E1,Y2,FEK,VaN,N,I
     &,IOUT,LINEAR,ITYPE,YSUB,Y3,B2
      IM=I-1
      IP=I+1
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      IF(ABS(DV).LT. 1.E-5) DV=SIGN(1.E-5,DV)
      Va(J)=Va(J)+DV
      ENDIF
      A=(B+FM*Va(2))*Va(2)
      C=SQRT(G*A/(B+FM2*Va(2)))
      SF=(CN*Va(1)*((B+FMS*Va(2))/A)**EX)**2
      IF(I.EQ.1) THEN
C Upstream BC, Jet depth Y2 downstream from gate changes with E1 (ups)=Constant
      AR=(B+FM*Va(5))*Va(5)
      CR=SQRT(G*AR/(B+FM2*Va(5)))
      SFR=(CN*Va(4)*((B+FMS*Va(5))/AR)**EX)**2
      F(1)=DT2*(C-Va(1)+CR-Va(4))-DX*Va(3)
      F(2)=Va(1)-WSTAGE(Va(2))-Va(4)+WSTAGE(Va(5))-DTG2*(SO-.5*(SF+SFR))
      F(3)=Va(2)+FEK*(Va(1)**2-(A*Va(1)/(B2*Va(7)))**2)-Va(7)
      QS=(A*Va(1)/B2)**2/G
      F(4)=QS/Y2+.5*Va(6)**2-QS/Va(7)-.5*Va(7)**2
      F(5)=E1-Va(6)-.5*QS/Y2**2
      IF(LINEAR.EQ.1) THEN
      F(6)=Va(4)-VK(1)-Va(3)*(VK(2)-VK(1))
      F(7)=Va(5)-YK(1)-Va(3)*(YK(2)-YK(1))
      ELSE
      F(6)=Va(4)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     & VK(3)-VK(2)))
      F(7)=Va(5)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     & YK(3)-YK(2)))
      ENDIF
      ELSE IF(I.EQ.N) THEN
C Downstream BC 
      AL=(B+FM*Va(5))*Va(5)
      CL=SQRT(G*AL/(B+FM2*Va(5)))
      SFL=(CN*Va(4)*((B+FMS*Va(5))/AL)**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(4)+CL)
      F(2)=Va(1)+WSTAGE(Va(2))-Va(4)-WSTAGE(Va(5))-DTG2*(SO-.5*(SF+SFL))
      IF(ITYPE-2) 1,2,3
1     F(3)=Va(2)-VaN
      GO TO 4
2     F(3)=Va(1)-VaN
      GO TO 4
3     F(3)=VaN-A*Va(1)
4     IF(LINEAR.EQ.1) THEN
      F(4)=Va(4)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(5)=Va(5)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      F(4)=Va(4)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(5)=Va(5)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ELSE
C Regular points
      AL=(B+FM*Va(7))*Va(7)
      CL=SQRT(G*AL/(B+FM2*Va(7)))
      SFL=(CN*Va(5)*((B+FMS*Va(7))/AL)**EX)**2
      AR=(B+FM*Va(8))*Va(8)
      CR=SQRT(G*AR/(B+FM2*Va(8)))
      SFR=(CN*Va(6)*((B+FMS*Va(8))/AR)**EX)**2
      F(1)=DX*(1.-Va(3))-DT2*(Va(1)+C+Va(5)+CL)
      WS=WSTAGE(Va(2))
      F(2)=Va(1)+WS-Va(5)-WSTAGE(Va(7))-DTG2*(SO-.5*(SF+SFL))
      F(3)=DT2*(C-Va(1)+CR-Va(6))-DX*Va(4)
      F(4)=Va(1)-WS-Va(6)+WSTAGE(Va(8))-DTG2*(SO-.5*(SF+SFR))
      IF(LINEAR.EQ.1) THEN
      F(5)=Va(5)-VK(IM)-Va(3)*(VK(I)-VK(IM))
      F(7)=Va(7)-YK(IM)-Va(3)*(YK(I)-YK(IM))
      ELSE
      IF(I.EQ.2) THEN
      F(5)=Va(5)-VK(1)-.5*Va(3)*((3.-Va(3))*(VK(2)-VK(1))+(Va(3)-1.)*(
     &VK(3)-VK(2)))
      F(7)=Va(7)-YK(1)-.5*Va(3)*((3.-Va(3))*(YK(2)-YK(1))+(Va(3)-1.)*(
     &YK(3)-YK(2)))
      ELSE
      F(5)=Va(5)-VK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(VK(IM)-VK(I-2))+Va(3
     &)*(VK(I)-VK(IM)))
      F(7)=Va(7)-YK(I-2)-.5*(Va(3)+1.)*((2.-Va(3))*(YK(IM)-YK(I-2))+Va(3
     &)*(YK(I)-YK(IM)))
      ENDIF
      ENDIF
      IF(LINEAR.EQ.1) THEN
      F(6)=Va(6)-VK(I)-Va(4)*(VK(IP)-VK(I))
      F(8)=Va(8)-YK(I)-Va(4)*(YK(IP)-YK(I))
      ELSE
      IF(IP.EQ.N) THEN
      F(6)=Va(6)-VK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(VK(I)-VK(IM))+Va(4)*
     &(VK(N)-VK(I)))
      F(8)=Va(8)-YK(IM)-.5*(Va(4)+1.)*((2.-Va(4))*(YK(I)-YK(IM))+Va(4)*
     &(YK(N)-YK(I)))
      ELSE
      F(6)=Va(6)-VK(I)-.5*Va(4)*((3.-Va(4))*(VK(IP)-VK(I))+(Va(4)-1.)*(
     &VK(I+2)-VK(IP)))
      F(8)=Va(8)-YK(I)-.5*Va(4)*((3.-Va(4))*(YK(IP)-YK(I))+(Va(4)-1.)*(
     &YK(I+2)-YK(IP)))
      ENDIF
      ENDIF
      ENDIF
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END
      FUNCTION WSTAGE(YY)
      COMMON V(51),Y(51),VK(51),YK(51),Va(8),F(8),F1(8),D(8,8),Z(8),GBS,
     &DELTDX,FMS,DTG2,FM2,CN,DX,DT2,SO,B,FM,G,DV,DELT,E1,Y2,FEK,VaN,N,II
     &,IOUT,LINEAR,ITYPE,YSUB,Y3,B2
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      IF(FM.LT.1.E-5) THEN
      WSTAGE=2.*SQRT(G*YY)
      ELSE
      YYY=FM*YY/B
      IF(ITAB.LT.398) THEN
      I1=ITAB+1
      ELSE
      ITAB=398
      I1=399
      ENDIF
      IF(YYY.LT.YST(I1)) THEN
 10   IF(YYY.LT.YST(ITAB)) THEN
      ITAB=ITAB-1
      IF(ITAB.GT.1) GO TO 10
      ENDIF
      I1=ITAB+1
      ELSE
20    IF(YYY.GT. YST(I1)) THEN
      I1=I1+1
      IF(I1.LT.400) GO TO 20
      ENDIF
      ITAB=I1-1
      ENDIF
      WSTAGE=GBS*(W(ITAB)+(YYY-YST(ITAB))/(YST(I1)-YST(ITAB))*(W(I1)-W(
     &ITAB)))
      ENDIF
      RETURN
      END
      SUBROUTINE STAGE
      COMMON /CSTAGE/ YST(400),W(400),ITAB
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
      DY=.005
      DY1=DY/10.
      DYH=DY1/2.
      N=(2.-.01)/DY+1
      YST(1)=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      YP=YST(I-1)+DY1*FLOAT(J)
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
5     RC=RC1
      YST(I)=YP
10    W(I)=W(I-1)+SUM
      RETURN
      END