C This program is a modification of IMPLICNE to allow 2 gates at its downstream
C end.  To accomplish this change both Y and Q are unknown at the end of the channel
C and two additional unknowns are added the flow rates past each of the gates, i.e.
C  Q1 and Q2.  The additional 3 equations are: (1) Energy from end to supercritical
C flow downstream of gate #1 (2) Energy to downstream of gate #2, and 
C continuity Qn = Q1 + Q2
      COMMON /SOLVNE/ A(124,6),V(124),FB(124)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),YGAT1(0:200),YGAT
     &2(0:200),DXG,G,G2,DELX,GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,
     &EK,UQ,ERR,NT,NX,NXM,NX2,IOUT,IYOUT,IFREQ,Q1,Q2,B1,B2
      DATA ONE/-1./
      READ(2,*) IOUT,IFREQ,NFORW,NX,NT,DELT,DELX,G,IYOUT,UQ,EK,ERR
      G2=2.*G
      CMAN=1.
      IF(G.GT.30.) CMAN=1.486
      DEL2=2.*DELX
      DXT=DELX/DELT
      GDELX=DELX*G2
      DXDT2=2.*DXT
      DXDT4=4.*DXT
      EK=(1.+EK)/G2
      DXG=G*DELX
      RDT=1./DELT
      NXM=NX-1
      NX2=NX-2
      DO 10 I=1,NX
      Q(I)=ONE
      B(I)=ONE
      FM(I)=ONE
      FN(I)=ONE
10    SO(I)=ONE
      READ(2,*) (Q(I),I=1,NX)
      READ(2,*) (B(I),I=1,NX)
      READ(2,*) (FM(I),I=1,NX)
      READ(2,*) (FN(I),I=1,NX)
      READ(2,*) (SO(I),I=1,NX)
C Reads in Contract & Loss Coef., widths of both gates and flows past them
      READ(2,*) CC,FKL,B1,B2,Q1,Q2
      B1=(1.+FKL)/(G2*B1**2)
      B2=(1.+FKL)/(G2*B2**2)
      DO 20 I=2,NX
      IM=I-1
      IF(Q(I).EQ.ONE) Q(I)=Q(IM)
      IF(B(I).EQ.ONE) B(I)=B(IM)
      IF(FM(I).EQ.ONE) FM(I)=FM(IM)
      IF(FN(I).EQ.ONE) FN(I)=FN(IM)
      IF(SO(I).EQ.ONE) SO(I)=SO(IM)
20    SMS(I)=2.*SQRT(FM(I)**2+1.)
      DO 21 I=2,NXM
21    SQ(I)=Q(I+1)-Q(I-1)
      SMS(1)=2.*SQRT(FM(1)**2+1.)
      SQ(1)=2.*(Q(2)-Q(1))
      SQ(NX)=2.*(Q(NX)-Q(NXM))
      IF(NFORW.EQ.1) THEN
      READ(2,*)(Y(I),I=1,NX)
      ELSE
      READ(2,*)(Y(I),I=NX,1,-1)
      ENDIF
      DO 30 I=0,NT
      YGAT1(I)=ONE
30    YGAT2(I)=ONE
      READ(2,*)(YGAT1(I),I=0,NT)
      READ(2,*)(YGAT2(I),I=0,NT)
      DO 40 I=2,NT
      IF(YGAT1(I).LT.0.) YGAT1(I)=2.*YGAT1(I-1)-YGAT1(I-2)
      IF(YGAT2(I).LT.0.) YGAT2(I)=2.*YGAT2(I-1)-YGAT2(I-2)
40    CONTINUE
      DO 41 I=0,NT
      YGAT1(I)=CC*YGAT1(I)
41    YGAT2(I)=CC*YGAT2(I)
      H=Y(1)+EK*(Q(1)/((B(1)+FM(1)*Y(1))*Y(1)))**2
      CALL IMPLNE
      END
      SUBROUTINE IMPLNE
      COMMON /SOLVNE/ A(124,6),V(124),FB(124)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),YGAT1(0:200),YGAT
     &2(0:200),DXG,G,G2,DELX,GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,
     &EK,UQ,ERR,NT,NX,NXM,NX2,IOUT,IYOUT,IFREQ,Q1,Q2,B1,B2
      DXDTT=DXDT4
      KNEXT=0
      DO 50 K=1,NT
      YBG1=B1/YGAT1(K)**2
      YBG2=B2/YGAT2(K)**2
      SQB1=SQ(1)
      SQBN=SQ(NX)
      DXDT4=DXDTT
      DO 10 I=1,NX
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
      TB(I)=TOP(I)
      SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PP(I)/AA(I))**1.3333333)
      YB(I)=Y(I)
      IF(I.EQ.1) THEN
      FB(1)=0.
      FB(2)=Q(2)-Q(1)
      ELSE IF(I.EQ.NX) THEN
      FB(2*NX-1)=.75*Q(NX)-Q(NXM)+.25*Q(NX2)
      ELSE
      FB(2*I-1)=FUN(I)
      FB(2*I)=Q(I+1)-Q(I-1)-SQ(I)
      ENDIF
10    CONTINUE
      IF(K.EQ.1) WRITE(IOUT,100) 0,0.,Q1,YGAT1(0),Q2,YGAT2(0),(I,Y(I),
     &Q(I),AA(I),V1(I),PP(I),TOP(I),SF(I),I=1,NX)
C  READ IN q* FOR THIS TIME STEP (No. of values,pair of (position & q*)
      IF(IYOUT.GT.0 .AND. K.GE.KNEXT) THEN
      READ(2,*) NSQ,(II,SQ(II),I=1,NSQ)
      READ(2,*,END=12) KNEXT
      GO TO 14
12    KNEXT=NT+10
      ENDIF
14    NCT=0
15    V(1)=H-Y(1)-EK*V1(1)**2
      V(2)=DXT*(TB(1)+TOP(1))*(Y(1)-YB(1))
      A(1,3)=2.*EK*V1(1)**2*TOP(1)/AA(1)-1.
      A(1,4)=-2.*EK*V1(1)/AA(1)
      A(1,5)=0.
      A(1,6)=0.
      YY=Y(1)
      Y(1)=1.005*Y(1)
      A(2,3)=(DXT*(TB(1)+B(1)+2.*FM(1)*Y(1))*(Y(1)-YB(1))-V(2))/
     &(Y(1)-YY)
      Y(1)=YY
      V(2)=V(2)+Q(2)-Q(1)-.5*(SQB1+SQ(1))+FB(2)
      A(2,4)=-1.
      A(2,5)=0.
      A(2,6)=1.
      II=1
      DXDT4=-DXDTT
C  Define equations & Jacobian element for regular points
      DO 20 I=2,NXM
      II=II+2
      IP=II+1
      V(II)=FUN(I)
      V(IP)=DXDT2*(TB(I)+TOP(I))*(Y(I)-YB(I))
      A(II,5)=TOP(I)*(G*AA(I)/TOP(I)-V1(I)**2)
      A(II,1)=-A(II,5)
      A(II,6)=2.*V1(I)
      A(II,2)=-A(II,6)
      YY=Y(I)
      AAT=AA(I)
      V1T=V1(I)
      SFT=SF(I)
      PPT=PP(I)
      TOPT=TOP(I)
      Y(I)=1.005*Y(I)
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
      SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PP(I)/AA(I))**1.3333333)
      A(II,3)=(FUN(I)-V(II))/(Y(I)-YY)
      A(IP,3)=(DXDT2*(TB(I)+TOP(I))*(Y(I)-YB(I))-V(IP))/(Y(I)-YY)
      Y(I)=YY
      AA(I)=AAT
      PP(I)=PPT
      TOP(I)=TOPT
      YY=Q(I)
      Q(I)=1.005*Q(I)
      V1(I)=Q(I)/AAT
      SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PPT/AAT)**1.3333333)
      A(II,4)=(FUN(I)-V(II))/(Q(I)-YY)
      Q(I)=YY
      V1(I)=V1T
      SF(I)=SFT
      V(II)=V(II)+FB(II)
      V(IP)=V(IP)+Q(I+1)-Q(I-1)-SQ(I)+FB(IP)
      A(IP,1)=0.
      A(IP,2)=-1.
      A(IP,4)=0.
      A(IP,5)=0.
20    A(IP,6)=1.
C Add equations & Jacobian elements for 2 gates, i.e. 2 energy & cont. eqs
C 1st eq. is continuity with 2nd order Newton backward interpolation eq.
      IP=IP+1
      A(IP,1)=0.
      A(IP,2)=-1.
      V(IP)=DXT*(TOP(NX)+TB(NX))*(Y(NX)-YB(NX))
      YY=Y(NX)
      TOPT=TOP(NX)
      Y(NX)=1.005*Y(NX)
      TOP(NX)=B(NX)+2.*FM(NX)*Y(NX)
      A(IP,3)=(DXT*(TOP(NX)+TB(NX))*(Y(NX)-YB(NX))-V(IP))/(Y(NX)-YY)
      A(IP,4)=.75
      A(IP,5)=0.
      A(IP,6)=0.
      V(IP)=V(IP)+FB(IP)+.25*Q(NX2)-Q(NXM)+.75*Q(NX)
      Y(NX)=YY
      TOP(NX)=TOPT
C  Additional 3 equations for flow past 2 gates
      IP=IP+1
      V(IP)=Q(NX)-Q1-Q2
      A(IP,1)=0.
      A(IP,2)=1.
      A(IP,3)=-1.
      A(IP,4)=-1.
      IP=IP+1
      ANX=(B(NX)+FM(NX)*Y(NX))*Y(NX)
      ANX2=G2*ANX**2
      V(IP)=Y(NX)+Q(NX)**2/ANX2-YGAT1(K)-YBG1*Q1**2
      A(IP,1)=1.-2.*Q(NX)**2*(B(NX)+2.*FM(NX)*Y(NX))/(ANX*ANX2)
      A(IP,2)=2.*Q(NX)/ANX2
      A(IP,3)=-2.*YBG1*Q1
      IP=IP+1
      V(IP)=Y(NX)+Q(NX)**2/ANX2-YGAT2(K)-YBG2*Q2**2
      A(IP,1)=A(IP-1,1)
      A(IP,2)=A(IP-1,2)
      A(IP,3)=0.
      A(IP,4)=-2.*YBG2*Q2
      CALL BAND(IP)
      SUM=0.
      DO 30 I=1,NX
      Y(I)=Y(I)-V(2*I-1)
      SUM=SUM+ABS(V(2*I-1))
      Q(I)=Q(I)-V(2*I)
      SUM=SUM+ABS(V(2*I))
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
30    SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PP(I)/AA(I))**1.3333333)
      Q1=Q1-V(IP-1)
      Q2=Q2-V(IP)
      NCT=NCT+1
      IF(NCT.LT. 30 .AND. SUM.GT.ERR) GO TO 15
      IF(NCT.EQ.30) THEN
      WRITE(*,330) K,SUM
330   FORMAT(' Step=',I4,' Residual=',E12.6)
      READ(*,*)
      ENDIF
      IF(MOD(K,IFREQ).EQ.0) WRITE(IOUT,100) K,DELT*FLOAT(K),Q1,YGAT1(K),
     &Q2,YGAT2(K),(I,Y(I),Q(I),AA(I),V1(I),PP(I),TOP(I),SF(I),I=1,NX)
50    CONTINUE
100   FORMAT(/' Solution at K=',I4,' Time=',F8.1,/,1X,' Q past gate#1=',
     &F8.2,' Yg1=',F7.2' Q past gate#2=',F8.2,' Yg2=',F7.2,/,1X,' Posit.
     & Depth  Flowrate      Area  Velocity Perimeter Top Width  Slope, S
     &f',/,1X,76('-'),/,(I4,6F10.3,F10.6))
      END
      FUNCTION FUN(I)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),YGAT1(0:200),YGAT
     &2(0:200),DXG,G,G2,DELX,GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,
     &EK,UQ,ERR,NT,NX,NXM,NX2,IOUT,IYOUT,IFREQ,Q1,Q2,B1,B2
      IF(I.EQ.NX) THEN
      YAV=(Y(I)+Y(I-1))/2.
      DA=(B(I)-B(I-1)+(FM(I)-FM(I-1))*YAV)*YAV/DELX
      ELSE
      DA=(B(I+1)-B(I-1)+(FM(I+1)-FM(I-1))*Y(I))*Y(I)/DEL2
      ENDIF
      IF(IYOUT.EQ.0) THEN
      FQ=0.
      ELSE IF(IYOUT.EQ.1) THEN
      FQ=(V1(I)-UQ)*SQ(I)/DEL2/(G*AA(I))+(B(I)/2.+FM(I)*Y(I)/3.)*(Y(I)/
     &AA(I))**2*(AA(I)-AA(I-1))/DELX
      ELSE
      FQ=V1(I)*SQ(I)/DEL2/(G2*AA(I))
      ENDIF
      FUN=GDELX*(SF(I)-SO(I)+FQ)*AA(I)-V1(I)*SQ(I)-DXDT4*Q(I)-DA*
     &V1(I)**2
      FUN=FUN+2.*V1(I)*(Q(I+1)-Q(I-1))+(G*AA(I)-TOP(I)*V1(I)**2)
     &*(Y(I+1)-Y(I-1))
      RETURN
      END
      SUBROUTINE BAND(N)
      COMMON /SOLVNE/ A(124,6),V(124),FB(124)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),YGAT1(0:200),YGAT
     &2(0:200),DXG,G,G2,DELX,GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,
     &EK,UQ,ERR,NT,NX,NXM,NX2,IOUT,IYOUT,IFREQ,Q1,Q2,B1,B2
      NM=N-4
      N3=N-3
      FAC=.25/A(NM,2)
      A(N3,1)=-FAC*A(NM,3)
      A(N3,3)=A(N3,3)-FAC*A(NM,5)
      A(N3,4)=A(N3,4)-FAC*A(NM,6)
      V(N3)=V(N3)-FAC*V(NM)
      DO 35 K=1,2
      DO 30 I=4-K,N3
      IM=I-1
      IF(MOD(I,2).EQ.0) THEN
      K2=0
      K3=K+1
      K4=K3
      K6=6
      KK=K+2
      ELSE
      K3=K
      K6=4
      KK=K+1
      K4=K+2
      K2=2
      ENDIF
      IF(I.EQ.NM) K6=5
      IF(I.EQ.N3) K3=K
      IF(I.EQ.2) K6=4
      FAC=A(I,K3)/A(IM,K4)
      V(I)=V(I)-FAC*V(IM)
      DO 30 J=KK,K6
30    A(I,J)=A(I,J)-FAC*A(IM,J+K2)
      IF(K.EQ.1) THEN
      NMP=N-1
      A(N,3)=-A(NMP,3)
      V(N)=V(N)-V(NMP)
      ELSE
      FAC=A(NMP,1)/A(N-3,3)
      A(NMP,2)=A(NMP,2)-FAC*A(N-3,4)
      V(NMP)=V(NMP)-FAC*V(N-3)
      FAC=A(NMP,2)/A(N-2,2)
      A(NMP,3)=A(NMP,3)-FAC*A(N-2,3)
      V(NMP)=V(NMP)-FAC*V(N-2)
      FAC=A(N,3)/A(NMP,3)
      A(N,4)=A(N,4)-FAC*A(NMP,4)
      V(N)=V(N)-FAC*V(NMP)
      ENDIF
35    CONTINUE
      I=NMP
      V(N)=V(N)/A(N,4)
      V(I)=(V(I)-V(N)*A(I,4))/A(I,3)
      I=I-1
      V(I)=(V(I)-V(NMP)*A(I,3)-V(N)*A(I,4))/A(I,2)
      I=I-1
      V(I)=(V(I)-V(N-2)*A(I,4))/A(I,3)
40    I=I-1
      V(I)=(V(I)-V(I+1)*A(I,5)-V(I+2)*A(I,6))/A(I,4)
      I=I-1
      V(I)=(V(I)-V(I+1)*A(I,4)-V(I+2)*A(I,5)-V(I+3)*A(I,6))/A(I,3)
      IF(I.GT.2) GO TO 40
      RETURN
      END