C The comments below are the same as in IMPLICIU.  This program also allows
C    a stage-discharge relationship to be given both upstream and downstream.
C  This program is a modification of Program IMPLICIC with the capability added
C to specify the depth, or flow rate at the upstream end as well as having H=Constant
C Depth or Flowrate may be specified as a function of time at the downstream end.
C  The difference in this program and IMPLICUY is that the "Alternative Boundary 
C  Condition equations are used that are based on the Characteristic-Differential
C Equation, i.e. the four b's & a's and f5 & f4 are used as the BC-equation.
C The program uses the "Direct Implicit Finite Differencing Method", i.e. it
C solves the linear algebra problem.
      LOGICAL LDBC,LUBC
      COMMON /SOLV/ A(162,6),V(162)
      COMMON Y(81),AA(81),Q(81),PP(81),TOP(81),V1(81),SQ(81),B(81)
     &,FM(81),SO(81),FN(81),SMS(81),SF(81),QGIV(0:100),DXG,G,G2,DELX,
     &DEL2,DELT,DXT,RDT,H,CMAN,NT,NX,NXM,IOUT,NTBETW,IDBC,IUBC,NDBC,
     &KDBC,NUBC,KUBC,NODED,NODEU,LDBC,LUBC,UGIV(0:100)
      DATA ONE/-1./
      LDBC=.FALSE.
      LUBC=.FALSE.
C  IDBC= 1 then depth is given at end of channel, IDBC=2 Q(N) is given
C  IDBC= 3 THEN A Stage-discharge relationship given downstream
C  IUBC=1 Then depth is given at upstream end, IUBC=2 THEN Q(1) is given, and
C  if IUBC=0 then H=Constant head of reservoir
C  IUBC= 3 THEN A Stage-discharge relationship given upstream
      READ(2,*) IOUT,NFORW,NX,NT,NTBETW,DELT,DELX,G,IDBC,IUBC
      DELT=DELT/FLOAT(NTBETW)
      G2=2.*G
      CMAN=1.
      IF(G.GT.30.) CMAN=1.486
      DEL2=2.*DELX
      DXT=DELX/DELT
      DXG=G*DELX
      RDT=1./DELT
      NXM=NX-1
      DO 10 I=1,NX
      Q(I)=ONE
      B(I)=ONE
      FM(I)=ONE
      FN(I)=ONE
10    SO(I)=ONE
      READ(2,*) (Q(I),I=1,NX)
      READ(2,*) (B(I),I=1,NX)
      READ(2,*) (FM(I),I=1,NX)
      READ(2,*) (FN(I),I=1,NX)
      READ(2,*) (SO(I),I=1,NX)
      DO 20 I=2,NX
      IM=I-1
      IF(Q(I).EQ.ONE) Q(I)=Q(IM)
      IF(B(I).EQ.ONE) B(I)=B(IM)
      IF(FM(I).EQ.ONE) FM(I)=FM(IM)
      IF(FN(I).EQ.ONE) FN(I)=FN(IM)
      IF(SO(I).EQ.ONE) SO(I)=SO(IM)
      SQ(I)=Q(I)-Q(IM)
20    SMS(I)=1.33333333*SQRT(FM(I)**2+1.)
      SMS(1)=1.33333333*SQRT(FM(1)**2+1.)
      IF(NFORW.EQ.1) THEN
      READ(2,*)(Y(I),I=1,NX)
      ELSE
      READ(2,*)(Y(I),I=NX,1,-1)
      ENDIF
      IF(IDBC.LT.3) THEN
      DO 30 I=1,NT
30    QGIV(I)=ONE
      READ(2,*)(QGIV(I),I=0,NT)
      IF(IDBC.EQ.1) THEN
      IF(ABS(Y(NX)-QGIV(0)).GT. .1) THEN
      WRITE(*,101) Y(NX),QGIV(0)
101   FORMAT(' Depth',F8.2,' at end must be same as 1st Y at t=0',F8.2)
      STOP
      ENDIF
      ELSE
      IF(ABS(Q(NX)-QGIV(0)).GT. .1) THEN
      WRITE(*,100) Q(NX),QGIV(0)
100   FORMAT(' Flowrate',F8.2,' at end must be same as 1st Q at t=0',
     &F8.2)
      STOP
      ENDIF
      ENDIF
      DO 40 I=3,NT
      IF(QGIV(I).EQ.ONE) QGIV(I)=2.*QGIV(I-1)-QGIV(I-2)
40    CONTINUE
      ELSE
C NODED is the node number that controls the stage-disch. rel. at the end of the
C If NODED is given as negative, then relation is Q versus E (specific energy)
C channel.  It may be the last node NX, or any other node.
      READ(2,*) NODED,NDBC,(QGIV(2*I-1),QGIV(2*I),I=1,NDBC)
      KDBC=NDBC/2
      IF(NODED.LT.0) THEN
      NODED=IABS(NODED)
      LDBC=.TRUE.
      ENDIF
      ENDIF
      IF(IUBC.GT.0) THEN
      IF(IUBC.LT.3) THEN
      DO 31 I=1,NT
31    UGIV(I)=ONE
      READ(2,*)(UGIV(I),I=0,NT)
      DO 41 I=3,NT
      IF(UGIV(I).EQ.ONE) UGIV(I)=2.*UGIV(I-1)-UGIV(I-2)
41    CONTINUE
      ELSE
C NODEU is the node number that controls the stage-disch. rel. at the beg of the
C If NODEU is given as negative, then relation is Q versus E (specific energy)
C channel.  It may be the last node 1, or any other node.
      READ(2,*) NODEU,NUBC,(UGIV(2*I-1),UGIV(2*I),I=1,NUBC)
      KUBC=NUBC/2
      IF(NODEU.LT.0) THEN
      NODEU=IABS(NODEU)
      LUBC=.TRUE.
      ENDIF
      ENDIF
      ENDIF
      H=Y(1)+(Q(1)/((B(1)+FM(1)*Y(1))*Y(1)))**2/G2
      CALL IMPLIC
      END
      SUBROUTINE IMPLIC
      LOGICAL LDBC,LUBC
      COMMON /SOLV/ A(162,6),V(162)
      COMMON Y(81),AA(81),Q(81),PP(81),TOP(81),V1(81),SQ(81),B(81)
     &,FM(81),SO(81),FN(81),SMS(81),SF(81),QGIV(0:100),DXG,G,G2,DELX,
     &DEL2,DELT,DXT,RDT,H,CMAN,NT,NX,NXM,IOUT,NTBETW,IDBC,IUBC,NDBC,
     &KDBC,NUBC,KUBC,NODED,NODEU,LDBC,LUBC,UGIV(0:100)
      IDX=DELX+.5
      TIME=0.
      K=0
110   K=K+1
      IF(IDBC.LT.3) THEN
      QGIV1=QGIV(K-1)
      DQGIV=(QGIV(K)-QGIV1)/FLOAT(NTBETW)
      ELSE
      IF(LDBC) THEN
      YNODE=Y(NODED)+(Q(NODED)/AA(NODED))**2/G2
      ELSE
      YNODE=Y(NODED)
      ENDIF
2     IF(QGIV(2*KDBC+1).GE.YNODE .OR. KDBC.EQ.NDBC) GO TO 3
      WRITE(*,*) LDBC,KDBC,NDBC,NODED,YNODE,QGIV(2*KDBC+1)
      GO TO 2
3     IF(QGIV(2*KDBC-1).LE.YNODE .OR. KDBC.EQ.1) GO TO 4
      KDBC=KDBC-1
      GO TO 3
4     C1D=(QGIV(2*KDBC+2)-QGIV(2*KDBC))/(QGIV(2*KDBC+1)-QGIV(2*KDBC-1))
      COD=C1D*QGIV(2*KDBC-1)-QGIV(2*KDBC)
      ENDIF
      IF(IUBC.GT.0) THEN
      IF(IUBC.LT.3) THEN
      UGIV1=UGIV(K-1)
      DUGIV=(UGIV(K)-UGIV1)/FLOAT(NTBETW)
      ELSE
      IF(LUBC) THEN
      YNODE=Y(NODEU)+(Q(NODEU)/AA(NODEU))**2/G2
      ELSE
      YNODE=Y(NODEU)
      ENDIF
5     IF(UGIV(2*KUBC+1).GE.YNODE .OR. KUBC.EQ.NUBC) GO TO 6
      KUBC=KUBC+1
      GO TO 5
6     IF(UGIV(2*KUBC-1).LE.YNODE .OR. KUBC.EQ.1) GO TO 7
      KUBC=KUBC-1
      GO TO 6
7     C1U=(UGIV(2*KUBC+2)-UGIV(2*KUBC))/(UGIV(2*KUBC+1)-UGIV(2*KUBC-1))
      COU=C1U*UGIV(2*KUBC-1)-UGIV(2*KUBC)
      ENDIF
      ENDIF
      DO 290 K10=1,NTBETW
      QGIVI=QGIV1+DQGIV
      IF(IUBC.GT.0) UGIVI=UGIV1+DUGIV
      DO 120 I=1,NX
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+1.5*SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
120   SF(I)=(FN(I)*Q(I)/(CMAN*AA(I)))**2*(PP(I)/AA(I))**1.33333333
      IF(K10.NE.1) GO TO 145
      WRITE(IOUT,130) TIME
      IF(IOUT.NE.6) WRITE(*,130) TIME
130   FORMAT(' Solution for time =',F10.2,/1X,69('-'),/'   x    DEPTH VE
     &LOCITY EL_SLOPE PERIM. FLOWRATE  AREA   TOP_W.     E',/1X,69('-'))
      DO 135 I=1,NX
      IF(IOUT.NE.6) WRITE(*,140) IDX*(I-1),Y(I),V1(I),SF(I),PP(I),Q(I),
     &AA(I),TOP(I)
135   WRITE(IOUT,140) IDX*(I-1),Y(I),V1(I),SF(I),PP(I),Q(I),AA(I),TOP(I)
     &,Y(I)+V1(I)**2/G2
140   FORMAT(I6,2F8.3,F8.5,5F8.3)
145   IF(K.GT.NT) STOP
      TIME=TIME+DELT
      I=1
C  Setting up equations
270   DO 280 II=2,NXM
      I=I+2
      IP=I+1
      C2=G*AA(II)/TOP(II)
      FYP=TOP(II)*(C2-V1(II)**2)/DEL2
      FQP=V1(II)/DELX
      A(I,1)=-FYP
      A(I,2)=-FQP
      A(IP,1)=0.
      A(IP,2)=-.5
      SC64=G2*SF(II)
      FY=SC64*(SMS(II)*AA(II)/PP(II)-1.6666667*TOP(II))
      A(I,3)=FY
      A(I,4)=RDT+SC64*AA(II)/Q(II)
      A(I,5)=FYP
      A(I,6)=FQP
      A(IP,3)=TOP(II)*DXT
      A(IP,4)=0.
      A(IP,5)=0.
      A(IP,6)=.5
      DL=V1(II)*SQ(II)/(DXG*AA(II))
      IF(SQ(II) .LT. 0.) DL=.5*DL
      SOD=SO(II)-DL
      V(I)=Q(II)/DELT+Y(II)*(FY+V1(II)**2*(B(II+1)-B(II-1)+Y(II)*(FM(II+
     *1)-FM(II-1)))/DEL2)+G*(AA(II)*(SOD+SF(II)))+V1(II)*SQ(II)/DELX
280   V(IP)=A(IP,3)*Y(II)+SQ(II)
C  Upstream Boundary Conditions
      IF(IUBC.EQ.0) THEN
      C1=Q(1)/G/(AA(1)*(2.*(H-Y(1))*TOP(1)-AA(1)))
      V(1)=Y(1)-C1*Q(1)
      A(1,4)=1.
      A(1,5)=-C1
      A(1,6)=0.
      A(2,3)=DELX*RDT*TOP(1)
      A(2,4)=-.5
      A(2,5)=0.
      A(2,6)=.5
      V(2)=A(2,3)*Y(1)+.5*(Q(1)-Q(2))
      ELSE
C  If either Y(t) or Q(t) is given 1st row in A (& V) are not used.
      C=SQRT(G*AA(1)/TOP(1))
      VC=(V1(1)-C)/DELX
      CV=C+V1(1)
      SMMS=G2*(1.666667*TOP(1)-SMS(1)*AA(1)/PP(1))*SF(1)
      A(2,1)=-TOP(1)*CV*(RDT-VC)-SMMS
      A(2,2)=RDT+G2*AA(1)*SF(1)/Q(1)-VC
      A(2,3)=-TOP(1)*VC*CV
      A(2,4)=VC
      V(2)=RDT*(Q(1)-TOP(1)*CV*Y(1))-SMMS*Y(1)+G*AA(1)*SO(1)+G*AA(1)*
     &SF(1)
      IF(IUBC.EQ.1) THEN
C Upstream Boundary Condition,  Y(t) = known
      V(2)=V(2)-A(2,1)*UGIVI
      A(2,1)=A(2,2)
      A(2,2)=A(2,3)
      A(2,3)=A(2,4)
      A(2,4)=0.
      V(3)=V(3)-A(3,1)*UGIVI
      Y(1)=UGIVI
      ELSEIF(IUBC.EQ.2) THEN
C Upstream Boundary Condition, Q(t) = known
      V(2)=V(2)-A(2,2)*UGIVI
      A(2,2)=A(2,3)
      A(2,3)=A(2,4)
      A(2,4)=0.
      V(3)=V(3)-A(3,2)*UGIVI
      V(4)=V(4)+.5*UGIVI
      Q(1)=UGIVI
      ELSE
C  Stage-discharge upstream BC
      V(1)=COU
      A(1,3)=C1U
      A(1,4)=-1.
      A(1,5)=0.
      A(1,6)=0.
      ENDIF
      ENDIF
C  Downstream Boundary Conditions
      IP=IP+1
      C2=G*AA(NX)/TOP(NX)
      C=SQRT(C2)
      VC=(V1(NX)+C)/DELX
      CV=C-V1(NX)
      A(IP,1)=-VC*CV*TOP(NX)
      A(IP,2)=-VC
      SMMS=1.6666667*TOP(NX)-SMS(NX)*AA(NX)/PP(NX)
      A(IP,3)=TOP(NX)*CV*(RDT+VC)-G2*SF(NX)*SMMS
      A(IP,4)=RDT+VC+G2*AA(NX)*SF(NX)/Q(NX)
      V(IP)=RDT*(Q(NX)+TOP(NX)*CV*Y(NX))+C2*TOP(NX)*SO(NX)+G*AA(NX)*SF(
     &NX)-G2*SF(NX)*SMMS*Y(NX)
      IF(IDBC.EQ.1) THEN
C  Downstream Boundary Condition, Y(t) = known
      V(IP)=V(IP)-A(IP,3)*QGIVI
      A(IP,3)=A(IP,4)
      A(IP,4)=0.
      IMM=IP-2
      V(IMM)=V(IMM)-A(IMM,5)*QGIVI
      A(IMM,5)=A(IMM,6)
      A(IP-1,5)=.5
      Y(NX)=QGIVI
      ELSEIF(IDBC.EQ.2) THEN
C  Downstream Boundary Condition,  Q(t) = known
      V(IP)=V(IP)-A(IP,4)*QGIVI
      A(IP,4)=0.
      V(IP-1)=V(IP-1)-A(IP-1,6)*QGIVI
      V(IP-2)=V(IP-2)-A(IP-2,6)*QGIVI
      Q(NX)=QGIVI
      ELSE
C Stage-discharge downstream BC
      IP=IP+1
      V(IP)=COD
      A(IP,1)=0.
      A(IP,2)=0.
      A(IP,3)=C1D
      A(IP,4)=-1.
      A(IP,5)=0.
      A(IP,6)=0.
      ENDIF
C  Solving Equations
      CALL BAND(IP)
290   QGIV1=QGIVI
      GO TO 110
      END
      SUBROUTINE BAND(N)
      LOGICAL LDBC,LUBC
      COMMON /SOLV/ A(162,6),V(162)
      COMMON Y(81),AA(81),Q(81),PP(81),TOP(81),V1(81),SQ(81),B(81)
     &,FM(81),SO(81),FN(81),SMS(81),SF(81),QGIV(0:100),DXG,G,G2,DELX,
     &DEL2,DELT,DXT,RDT,H,CMAN,NT,NX,NXM,IOUT,NTBETW,IDBC,IUBC,NDBC,
     &KDBC,NUBC,KUBC,NODED,NODEU,LDBC,LUBC,UGIV(0:100)
      IF(IUBC.EQ.0) THEN
C  H=Constant or Stage-Discharge for Upstream BC
      FAC=A(3,1)/A(2,3)
      A(3,2)=A(3,2)-FAC*A(2,4)
      A(3,4)=A(3,4)-FAC*A(2,6)
      V(3)=V(3)-FAC*V(2)
      II4=4
      ELSEIF(IUBC.EQ.1) THEN
C   Y(t) = Given for Upstream BC
      FAC=A(4,2)/A(3,2)
      V(4)=V(4)-FAC*V(3)
      DO 1 J=3,6
1     A(4,J)=A(4,J)-FAC*A(3,J)
      FAC=A(3,2)/A(2,1)
      V(3)=V(3)-FAC*V(2)
      A(3,3)=A(3,3)-FAC*A(2,2)
      A(3,4)=A(3,4)-FAC*A(2,3)
      II4=5
      ELSEIF(IUBC.EQ.2) THEN
C   Q(t) = Given for Upstream BC
      FAC=A(3,1)/A(2,1)
      V(3)=V(3)-FAC*V(2)
      A(3,3)=A(3,3)-FAC*A(2,2)
      A(3,4)=A(3,4)-FAC*A(2,3)
      II4=5
      ELSE
      FAC=A(3,1)/A(2,1)
      DO 3 J=2,4
3     A(3,J)=A(3,J)-FAC*A(2,J)
      V(3)=V(3)-FAC*V(2)
      FAC=A(2,1)/A(1,3)
      A(2,2)=A(2,2)-FAC*A(1,4)
      V(2)=V(2)-FAC*V(1)
      II4=4
      ENDIF
      DO 40 K=0,1
      DO 30 I=II4,N
      IM=I-1
      IF(MOD(I,2).EQ.0) THEN
      KK=K+2
      KM=KK
      K6=6
      ELSE
      KK=K+1
      KM=K+3
      K6=4
      ENDIF
      FAC=A(I,KK)/A(IM,KM)
      V(I)=V(I)-FAC*V(IM)
      DO 30 J=KK+1,K6
30    A(I,J)=A(I,J)-FAC*A(IM,KM-KK+J)
      IF(K.EQ.1) GO TO 40
      IF(IUBC.EQ.0) THEN
      FAC=A(2,3)/A(1,4)
      A(2,4)=A(2,4)-FAC*A(1,5)
      V(2)=V(2)-FAC*V(1)
      FAC=A(3,2)/A(2,4)
      A(3,4)=A(3,4)-FAC*A(2,6)
      V(3)=V(3)-FAC*V(2)
      ELSEIF(IUBC.LT.3) THEN
      FAC=A(4,3)/A(3,3)
      V(4)=V(4)-FAC*V(3)
      DO 2 J=4,6
2     A(4,J)=A(4,J)-FAC*A(3,J)
      ELSE
      FAC=A(3,2)/A(2,2)
      V(3)=V(3)-FAC*V(2)
      A(3,3)=A(3,3)-FAC*A(2,3)
      A(3,4)=A(3,4)-FAC*A(2,4)
      ENDIF
40    CONTINUE
      I=NXM
      IN=N-1
      IF(IDBC.EQ.1) THEN
      Q(NX)=V(N)/A(N,3)
      Q(I)=(V(IN)-Q(NX)*A(IN,5))/A(IN,4)
      IN=IN-1
      Y(I)=(V(IN)-Q(I)*A(IN,4)-A(IN,5)*Q(NX))/A(IN,3)
      ELSEIF(IDBC.EQ.2) THEN
      Y(NX)=V(N)/A(N,3)
      Q(I)=(V(IN)-Y(NX)*A(IN,5))/A(IN,4)
      IN=IN-1
      Y(I)=(V(IN)-Q(I)*A(IN,4)-A(IN,5)*Y(NX))/A(IN,3)
      ELSE
      Q(NX)=V(N)/A(N,4)
      Y(NX)=(V(IN)-Q(NX)*A(IN,4))/A(IN,3)
      I=I-1
      ENDIF
50    IP=I
      I=I-1
      IN=IN-1
      Q(I)=(V(IN)-Y(IP)*A(IN,5)-Q(IP)*A(IN,6))/A(IN,4)
      IN=IN-1
      Y(I)=(V(IN)-Q(I)*A(IN,4)-Y(IP)*A(IN,5)-Q(IP)*A(IN,6))/A(IN,3)
      IF(I.GT.2) GO TO 50
      IF(IUBC.EQ.0) THEN
      Q(1)=(V(2)-A(2,6)*Q(2))/A(2,4)
      Y(1)=(V(1)-A(1,5)*Q(1))/A(1,4)
      ELSE IF(IUBC.EQ.1) THEN
      Q(1)=(V(2)-A(2,2)*Y(2)-A(2,3)*Q(2))/A(2,1)
      ELSEIF(IUBC.EQ.2) THEN
      Y(1)=(V(2)-A(2,2)*Y(2)-A(2,3)*Q(2))/A(2,1)
      ELSE
      Q(1)=(V(2)-A(2,3)*Y(2)-A(2,4)*Q(2))/A(2,2)
      Y(1)=(V(1)-A(1,4)*Q(1))/A(1,3)
      ENDIF
      RETURN
      END