C This program is a modification of IMPLICNE that determines the maximum flow
C that can be taken from the end of the channel, but solving the critical
C flow equation as the downstream boundary condition.  This program doesnot
C include the critical flow equation as part of the system of equations being 
C solved, but rather takes the value of Y from this solution and solve the
C flowrate from Q =sqrt{gA**3/T}.  Thus the convergence may not be quadratic.
      COMMON /SOLVNE/ A(124,6),V(124),FB(124)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),DXG,G,G2,DELX,
     &GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,EK,UQ,ERR,NT,NX,NXM,
     &NX2,IOUT,IYOUT,IFREQ
      DATA ONE/-1./
      READ(2,*) IOUT,IFREQ,NFORW,NX,NT,DELT,DELX,G,IYOUT,UQ,EK,ERR
      G2=2.*G
      CMAN=1.
      IF(G.GT.30.) CMAN=1.486
      DEL2=2.*DELX
      DXT=DELX/DELT
      GDELX=DELX*G2
      DXDT2=2.*DXT
      DXDT4=4.*DXT
      EK=(1.+EK)/G2
      DXG=G*DELX
      RDT=1./DELT
      NXM=NX-1
      NX2=NX-2
      DO 10 I=1,NX
      Q(I)=ONE
      B(I)=ONE
      FM(I)=ONE
      FN(I)=ONE
10    SO(I)=ONE
      READ(2,*) (Q(I),I=1,NX)
      READ(2,*) (B(I),I=1,NX)
      READ(2,*) (FM(I),I=1,NX)
      READ(2,*) (FN(I),I=1,NX)
      READ(2,*) (SO(I),I=1,NX)
      DO 20 I=2,NX
      IM=I-1
      IF(Q(I).EQ.ONE) Q(I)=Q(IM)
      IF(B(I).EQ.ONE) B(I)=B(IM)
      IF(FM(I).EQ.ONE) FM(I)=FM(IM)
      IF(FN(I).EQ.ONE) FN(I)=FN(IM)
      IF(SO(I).EQ.ONE) SO(I)=SO(IM)
20    SMS(I)=2.*SQRT(FM(I)**2+1.)
      DO 21 I=2,NXM
21    SQ(I)=Q(I+1)-Q(I-1)
      SMS(1)=2.*SQRT(FM(1)**2+1.)
      SQ(1)=2.*(Q(2)-Q(1))
      SQ(NX)=2.*(Q(NX)-Q(NXM))
      IF(NFORW.EQ.1) THEN
      READ(2,*)(Y(I),I=1,NX)
      ELSE
      READ(2,*)(Y(I),I=NX,1,-1)
      ENDIF
      H=Y(1)+EK*(Q(1)/((B(1)+FM(1)*Y(1))*Y(1)))**2
      CALL IMPLNE
      END
      SUBROUTINE IMPLNE
      COMMON /SOLVNE/ A(124,6),V(124),FB(124)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),DXG,G,G2,DELX,
     &GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,EK,UQ,ERR,NT,NX,NXM,
     &NX2,IOUT,IYOUT,IFREQ
      DXDTT=DXDT4
      KNEXT=0
      DO 50 K=1,NT
      SQB1=SQ(1)
      SQBN=SQ(NX)
      DXDT4=DXDTT
      DO 10 I=1,NX
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
      TB(I)=TOP(I)
      SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PP(I)/AA(I))**1.3333333)
      YB(I)=Y(I)
      IF(I.EQ.1) THEN
      FB(1)=0.
      FB(2)=Q(2)-Q(1)
      ELSE IF(I.EQ.NX) THEN
      FB(2*NX-1)=.75*Q(NX)-Q(NXM)+.25*Q(NX2)
      ELSE
      FB(2*I-1)=FUN(I)
      FB(2*I)=Q(I+1)-Q(I-1)-SQ(I)
      ENDIF
10    CONTINUE
      IF(K.EQ.1) WRITE(IOUT,100) 0,0.,(I,Y(I),Q(I),AA(I),V1(I),PP(I),
     &TOP(I),SF(I),I=1,NX)
C  READ IN q* FOR THIS TIME STEP (No. of values,pair of (position & q*)
      IF(IYOUT.GT.0 .AND. K.GE.KNEXT) THEN
      READ(2,*) NSQ,(II,SQ(II),I=1,NSQ)
      READ(2,*,END=12) KNEXT
      GO TO 14
12    KNEXT=NT+10
      ENDIF
C  guess for critical depth
      Y(NX)=.75*Y(NX)
      Q(NX)=SQRT(G*((B(NX)+FM(NX)*Y(NX))*Y(NX))**3/(B(NX)+2.*FM(NX)*Y(NX
     &)))
14    NCT=0
15    V(1)=H-Y(1)-EK*V1(1)**2
      V(2)=DXT*(TB(1)+TOP(1))*(Y(1)-YB(1))
      A(1,3)=2.*EK*V1(1)**2*TOP(1)/AA(1)-1.
      A(1,4)=-2.*EK*V1(1)/AA(1)
      A(1,5)=0.
      A(1,6)=0.
      YY=Y(1)
      Y(1)=1.005*Y(1)
      A(2,3)=(DXT*(TB(1)+B(1)+2.*FM(1)*Y(1))*(Y(1)-YB(1))-V(2))/
     &(Y(1)-YY)
      Y(1)=YY
      V(2)=V(2)+Q(2)-Q(1)-.5*(SQB1+SQ(1))+FB(2)
      A(2,4)=-1.
      A(2,5)=0.
      A(2,6)=1.
      II=1
      DXDT4=-DXDTT
      DO 20 I=2,NXM
      II=II+2
      IP=II+1
      V(II)=FUN(I)
      V(IP)=DXDT2*(TB(I)+TOP(I))*(Y(I)-YB(I))
      A(II,5)=TOP(I)*(G*AA(I)/TOP(I)-V1(I)**2)
      A(II,1)=-A(II,5)
      A(II,6)=2.*V1(I)
      A(II,2)=-A(II,6)
      YY=Y(I)
      AAT=AA(I)
      V1T=V1(I)
      SFT=SF(I)
      PPT=PP(I)
      TOPT=TOP(I)
      Y(I)=1.005*Y(I)
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
      SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PP(I)/AA(I))**1.3333333)
      A(II,3)=(FUN(I)-V(II))/(Y(I)-YY)
      A(IP,3)=(DXDT2*(TB(I)+TOP(I))*(Y(I)-YB(I))-V(IP))/(Y(I)-YY)
      Y(I)=YY
      AA(I)=AAT
      PP(I)=PPT
      TOP(I)=TOPT
      YY=Q(I)
      Q(I)=1.005*Q(I)
      V1(I)=Q(I)/AAT
      SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PPT/AAT)**1.3333333)
      A(II,4)=(FUN(I)-V(II))/(Q(I)-YY)
      Q(I)=YY
      V1(I)=V1T
      SF(I)=SFT
      V(II)=V(II)+FB(II)
      V(IP)=V(IP)+Q(I+1)-Q(I-1)-SQ(I)+FB(IP)
      A(IP,1)=0.
      A(IP,2)=-1.
      A(IP,4)=0.
      A(IP,5)=0.
20    A(IP,6)=1.
      IP=IP+1
      A(IP,1)=0.
      A(IP,2)=-1.
      V(IP)=DXT*(TOP(NX)+TB(NX))*(Y(NX)-YB(NX))
      YY=Y(NX)
      TOPT=TOP(NX)
      Y(NX)=1.005*Y(NX)
      TOP(NX)=B(NX)+2.*FM(NX)*Y(NX)
      A(IP,3)=(DXT*(TOP(NX)+TB(NX))*(Y(NX)-YB(NX))-V(IP))/(Y(NX)-YY)
      A(IP,4)=.75
      A(IP,5)=0.
      A(IP,6)=0.
      V(IP)=V(IP)+FB(IP)+.25*Q(NX2)-Q(NXM)+.75*Q(NX)
      Y(NX)=YY
      TOP(NX)=TOPT
C Critical flow equation at downstream end of channel
      Q(NX)=SQRT(G*((B(NX)+FM(NX)*Y(NX))*Y(NX))**3/(B(NX)+2.*FM(NX)*Y(NX
     &)))
      CALL BAND(IP)
      SUM=0.
      DO 30 I=1,NX
      Y(I)=Y(I)-V(2*I-1)
      SUM=SUM+ABS(V(2*I-1))
      Q(I)=Q(I)-V(2*I)
      SUM=SUM+ABS(V(2*I))
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
30    SF(I)=V1(I)*ABS(V1(I)*(FN(I)/CMAN)**2*(PP(I)/AA(I))**1.3333333)
      NCT=NCT+1
      IF(NCT.LT. 30 .AND. SUM.GT.ERR) GO TO 15
      IF(NCT.EQ.30) THEN
      WRITE(*,330) K,SUM
330   FORMAT(' Step=',I4,' Residual=',E12.6)
      READ(*,*)
      ENDIF
      IF(MOD(K,IFREQ).EQ.0) WRITE(IOUT,100) K,DELT*FLOAT(K),(I,Y(I),Q(I)
     &,AA(I),V1(I),PP(I),TOP(I),SF(I),I=1,NX)
50    CONTINUE
100   FORMAT(/' Solution at K=',I4,' Time=',F8.1,/,1X,' Posit. Depth  Fl
     &owrate      Area  Velocity Perimeter Top Width  Slope, Sf',/,1X,
     &76('-'),/,(I4,6F10.3,F10.6))
      END
      FUNCTION FUN(I)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),DXG,G,G2,DELX,
     &GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,EK,UQ,ERR,NT,NX,NXM,
     &NX2,IOUT,IYOUT,IFREQ
      IF(I.EQ.NX) THEN
      YAV=(Y(I)+Y(I-1))/2.
      DA=(B(I)-B(I-1)+(FM(I)-FM(I-1))*YAV)*YAV/DELX
      ELSE
      DA=(B(I+1)-B(I-1)+(FM(I+1)-FM(I-1))*Y(I))*Y(I)/DEL2
      ENDIF
      IF(IYOUT.EQ.0) THEN
      FQ=0.
      ELSE IF(IYOUT.EQ.1) THEN
      FQ=(V1(I)-UQ)*SQ(I)/DEL2/(G*AA(I))+(B(I)/2.+FM(I)*Y(I)/3.)*(Y(I)/
     &AA(I))**2*(AA(I)-AA(I-1))/DELX
      ELSE
      FQ=V1(I)*SQ(I)/DEL2/(G2*AA(I))
      ENDIF
      FUN=GDELX*(SF(I)-SO(I)+FQ)*AA(I)-V1(I)*SQ(I)-DXDT4*Q(I)-DA*
     &V1(I)**2
      FUN=FUN+2.*V1(I)*(Q(I+1)-Q(I-1))+(G*AA(I)-TOP(I)*V1(I)**2)
     &*(Y(I+1)-Y(I-1))
      RETURN
      END
      SUBROUTINE BAND(N)
      COMMON /SOLVNE/ A(124,6),V(124),FB(124)
      COMMON Y(61),YB(61),AA(61),Q(61),PP(61),TOP(61),TB(61),V1(61),
     &SQ(61),B(61),FM(61),SO(61),FN(61),SMS(61),SF(61),DXG,G,G2,DELX,
     &GDELX,DXDT2,DXDT4,DEL2,DELT,DXT,RDT,H,CMAN,EK,UQ,ERR,NT,NX,NXM,
     &NX2,IOUT,IYOUT,IFREQ
      NM=N-1
      FAC=.25/A(NM,2)
      A(N,1)=-FAC*A(NM,3)
      A(N,3)=A(N,3)-FAC*A(NM,5)
      V(N)=V(N)-FAC*V(NM)
      DO 30 K=1,2
      DO 30 I=4-K,N
      IM=I-1
      IF(MOD(I,2).EQ.0) THEN
      K2=0
      K3=K+1
      K4=K3
      K6=6
      KK=K+2
      ELSE
      K3=K
      K6=4
      KK=K+1
      K4=K+2
      K2=2
      ENDIF
      IF(I.EQ.NM) K6=5
      IF(I.EQ.N) K6=3
      IF(I.EQ.2) K6=4
      FAC=A(I,K3)/A(IM,K4)
      V(I)=V(I)-FAC*V(IM)
      DO 30 J=KK,K6
30    A(I,J)=A(I,J)-FAC*A(IM,J+K2)
      I=NM
      V(N)=V(N)/A(N,3)
      V(I)=(V(I)-V(N)*A(I,5))/A(I,4)
      I=I-1
      V(I)=(V(I)-V(I+1)*A(I,4)-V(I+2)*A(I,5))/A(I,3)
40    I=I-1
      V(I)=(V(I)-V(I+1)*A(I,5)-V(I+2)*A(I,6))/A(I,4)
      I=I-1
      V(I)=(V(I)-V(I+1)*A(I,4)-V(I+2)*A(I,5)-V(I+3)*A(I,6))/A(I,3)
      IF(I.GT.2) GO TO 40
      RETURN
      END