C  Same as IMPLICLA except depth may be given at downstream end as B.C. as well
C as the flow rate.  
C This program is the same as IMPLICLA with the exception that rather than
C evaluating dY/dQ from H=Y+(Q/A)**2/(2g) it is evaluated from the given stage-
C discharge relationship.
      COMMON /SOLV/ A(102,6),V(102)
      COMMON /STAGE/ YSTAGE(10),QSTAGE(10),ISTAGE,NSTAGE
      COMMON Y(51),AA(51),Q(51),PP(51),TOP(51),V1(51),SQ(51),B(51)
     &,FM(51),SO(51),FN(51),SMS(51),SF(51),QGIV(0:100),DXG,G,G2,DELX,
     &DEL2,DELT,DXT,RDT,H,CMAN,NT,NX,NXM,IOUT,NTBETW,IDBC
      DATA ONE/-1./
C  IDBC= 1 then depth is given at end of channel, IDBC=2 Q(N) is given
      READ(2,*) IOUT,NFORW,NX,NT,NTBETW,DELT,DELX,G,IDBC
      DELT=DELT/FLOAT(NTBETW)
      G2=2.*G
      CMAN=1.
      IF(G.GT.30.) CMAN=1.486
      DEL2=2.*DELX
      DXT=DELX/DELT
      DXG=G*DELX
      RDT=1./DELT
      NXM=NX-1
      DO 10 I=1,NX
      Q(I)=ONE
      B(I)=ONE
      FM(I)=ONE
      FN(I)=ONE
10    SO(I)=ONE
      READ(2,*) (Q(I),I=1,NX)
      READ(2,*) (B(I),I=1,NX)
      READ(2,*) (FM(I),I=1,NX)
      READ(2,*) (FN(I),I=1,NX)
      READ(2,*) (SO(I),I=1,NX)
      DO 20 I=2,NX
      IM=I-1
      IF(Q(I).EQ.ONE) Q(I)=Q(IM)
      IF(B(I).EQ.ONE) B(I)=B(IM)
      IF(FM(I).EQ.ONE) FM(I)=FM(IM)
      IF(FN(I).EQ.ONE) FN(I)=FN(IM)
      IF(SO(I).EQ.ONE) SO(I)=SO(IM)
      SQ(I)=Q(I)-Q(IM)
20    SMS(I)=1.33333333*SQRT(FM(I)**2+1.)
      SMS(1)=1.33333333*SQRT(FM(1)**2+1.)
      IF(NFORW.EQ.1) THEN
      READ(2,*)(Y(I),I=1,NX)
      ELSE
      READ(2,*)(Y(I),I=NX,1,-1)
      ENDIF
      DO 30 I=1,NT
30    QGIV(I)=ONE
      READ(2,*)(QGIV(I),I=0,NT)
      IF(IDBC.EQ.1) THEN
      IF(ABS(Y(NX)-QGIV(0)).GT. .1) THEN
      WRITE(*,101) Y(NX),QGIV(0)
101   FORMAT(' Depth',F8.2,' at end must be same as 1st Y at t=0',F8.2)
      STOP
      ENDIF
      ELSE
      IF(ABS(Q(NX)-QGIV(0)).GT. .1) THEN
      WRITE(*,100) Q(NX),QGIV(0)
100   FORMAT(' Flowrate',F8.2,' at end must be same as 1st Q at t=0',
     &F8.2)
      STOP
      ENDIF
      ENDIF
      DO 40 I=3,NT
      IF(QGIV(I).EQ.ONE) QGIV(I)=2.*QGIV(I-1)-QGIV(I-2)
40    CONTINUE
C Reads in stage-discharge relationship. Y are given in increasing order.
      READ(2,*) NSTAGE,(YSTAGE(I),QSTAGE(I),I=1,NSTAGE)
      ISTAGE=NSTAGE/2
      CALL IMPLIC
      END
      SUBROUTINE IMPLIC
      COMMON /SOLV/ A(102,6),V(102)
      COMMON /STAGE/ YSTAGE(10),QSTAGE(10),ISTAGE,NSTAGE
      COMMON Y(51),AA(51),Q(51),PP(51),TOP(51),V1(51),SQ(51),B(51)
     &,FM(51),SO(51),FN(51),SMS(51),SF(51),QGIV(0:100),DXG,G,G2,DELX,
     &DEL2,DELT,DXT,RDT,H,CMAN,NT,NX,NXM,IOUT,NTBETW,IDBC
      TIME=0.
      K=0
110   K=K+1
      QGIV1=QGIV(K-1)
      DQGIV=(QGIV(K)-QGIV1)/FLOAT(NTBETW)
      DO 290 K10=1,NTBETW
      QGIVI=QGIV1+DQGIV
      DO 120 I=1,NX
      AA(I)=(B(I)+FM(I)*Y(I))*Y(I)
      V1(I)=Q(I)/AA(I)
      PP(I)=B(I)+1.5*SMS(I)*Y(I)
      TOP(I)=B(I)+2.*FM(I)*Y(I)
120   SF(I)=(FN(I)*Q(I)/(CMAN*AA(I)))**2*(PP(I)/AA(I))**1.33333333
      IF(K10.NE.1) GO TO 145
      WRITE(IOUT,130) TIME
      IF(IOUT.NE.6) WRITE(*,130) TIME
130   FORMAT(' Solution for time =',F10.2,/,1X,60('-'),/,'    DEPTH VELO
     &CITY EL_SLOPE  PERIM.  FLOWRATE  AREA   TOP_W.',/,1X,60('-'))
      DO 135 I=1,NX
      IF(IOUT.NE.6) WRITE(*,140) I,Y(I),V1(I),SF(I),PP(I),Q(I),AA(I),
     &TOP(I)
135   WRITE(IOUT,140) I,Y(I),V1(I),SF(I),PP(I),Q(I),AA(I),TOP(I)
140   FORMAT(I3,2F8.3,F8.5,4F8.3)
145   IF(K.GT.NT) STOP
      TIME=TIME+DELT
      I=1
C  Setting up equations
270   DO 280 II=2,NXM
      I=I+2
      IP=I+1
      C2=G*AA(II)/TOP(II)
      FYP=TOP(II)*(C2-V1(II)**2)/DEL2
      FQP=V1(II)/DELX
      A(I,1)=-FYP
      A(I,2)=-FQP
      A(IP,1)=0.
      A(IP,2)=-.5
      SC64=G2*SF(II)
      FY=SC64*(SMS(II)*AA(II)/PP(II)-1.6666667*TOP(II))
      A(I,3)=FY
      A(I,4)=RDT+SC64*AA(II)/Q(II)
      A(I,5)=FYP
      A(I,6)=FQP
      A(IP,3)=TOP(II)*DXT
      A(IP,4)=0.
      A(IP,5)=0.
      A(IP,6)=.5
      DL=V1(II)*SQ(II)/(DXG*AA(II))
      IF(SQ(II) .LT. 0.) DL=.5*DL
      SOD=SO(II)-DL
      V(I)=Q(II)/DELT+Y(II)*(FY+V1(II)**2*(B(II+1)-B(II-1)+Y(II)*(FM(II+
     *1)-FM(II-1)))/DEL2)+G*(AA(II)*(SOD+SF(II)))+V1(II)*SQ(II)/DELX
280   V(IP)=A(IP,3)*Y(II)+SQ(II)
C  Upstream Boundary Condition
282   IF(Y(1).GE.YSTAGE(ISTAGE) .OR. ISTAGE.EQ.NSTAGE) GO TO 284
      ISTAGE=ISTAGE+1
      GO TO 282
284   IF(ISTAGE.LT.3 .OR. YSTAGE(ISTAGE-1).GE.Y(1)) GO TO 286
      ISTAGE=ISTAGE-1
      GO TO 284
286   C1=(Y(ISTAGE)-Y(ISTAGE-1))/(QSTAGE(ISTAGE)-QSTAGE(ISTAGE-1))
      V(1)=Y(1)-C1*Q(1)
      A(1,4)=1.
      A(1,5)=-C1
      A(1,6)=0.
      A(2,3)=DELX*RDT*TOP(1)
      A(2,4)=-.5
      A(2,5)=0.
      A(2,6)=.5
      V(2)=A(2,3)*Y(1)+.5*(Q(1)-Q(2))
      IP=IP+1
      IF(IDBC.EQ.2) THEN
C  Downstream Boundary Condition,  Q(t) = known
      V(IP)=DELX*(SQ(NX)+RDT*TOP(NX)*Y(NX))-1.5*QGIV1
      V(IP-1)=V(IP-1)-A(IP-1,6)*QGIVI
      V(IP-2)=V(IP-2)-A(IP-2,6)*QGIVI
      A(IP,2)=-2.
      A(IP,3)=DELX*RDT*TOP(NX)
      Q(NX)=QGIVI
      ELSE
C  Downstream Boundary Condition, Y(t) = known
      V(IP)=DELX*(SQ(NX)-RDT*TOP(NX)*(QGIVI-Y(NX)))
      IMM=IP-2
      V(IMM)=V(IMM)-A(IMM,5)*QGIVI
      A(IMM,5)=A(IMM,6)
      A(IP-1,5)=.5
      A(IP,2)=-2.
      A(IP,3)=1.5
      Y(NX)=QGIVI
      ENDIF
C  Solving Equations
      CALL BAND(IP)
290   QGIV1=QGIVI
      GO TO 110
      END
      SUBROUTINE BAND(N)
      COMMON /SOLV/ A(102,6),V(102)
      COMMON Y(51),AA(51),Q(51),PP(51),TOP(51),V1(51),SQ(51),B(51)
     &,FM(51),SO(51),FN(51),SMS(51),SF(51),QGIV(0:100),DXG,G,G2,DELX,
     &DEL2,DELT,DXT,RDT,H,CMAN,NT,NX,NXM,IOUT,NTBETW,IDBC
      FAC=.5/A(N-1,2)
      A(N,1)=-FAC*A(N-1,3)
      A(N,3)=A(N,3)-FAC*A(N-1,5)
      V(N)=V(N)-FAC*V(N-1)
      FAC=A(3,1)/A(2,3)
      A(3,2)=A(3,2)-FAC*A(2,4)
      A(3,4)=A(3,4)-FAC*A(2,6)
      V(3)=V(3)-FAC*V(2)
      DO 40 K=0,1
      DO 30 I=4,N
      IM=I-1
      IF(MOD(I,2).EQ.0) THEN
      KK=K+2
      KM=KK
      K6=6
      ELSE
      KK=K+1
      KM=K+3
      K6=4
      ENDIF
      FAC=A(I,KK)/A(IM,KM)
      V(I)=V(I)-FAC*V(IM)
      DO 30 J=KK+1,K6
30    A(I,J)=A(I,J)-FAC*A(IM,KM-KK+J)
      IF(K.EQ.1) GO TO 40
      FAC=A(2,3)/A(1,4)
      A(2,4)=A(2,4)-FAC*A(1,5)
      V(2)=V(2)-FAC*V(1)
      FAC=A(3,2)/A(2,4)
      A(3,4)=A(3,4)-FAC*A(2,6)
      V(3)=V(3)-FAC*V(2)
40    CONTINUE
      I=NXM
      IN=N-1
      IF(IDBC.EQ.1) THEN
      Q(NX)=V(N)/A(N,3)
      Q(I)=(V(IN)-Q(NX)*A(IN,5))/A(IN,4)
      IN=IN-1
      Y(I)=(V(IN)-Q(I)*A(IN,4)-A(IN,5)*Q(NX))/A(IN,3)
      ELSE
      Y(NX)=V(N)/A(N,3)
      Q(I)=(V(IN)-Y(NX)*A(IN,5))/A(IN,4)
      IN=IN-1
      Y(I)=(V(IN)-Q(I)*A(IN,4)-A(IN,5)*Y(NX))/A(IN,3)
      ENDIF
50    IP=I
      I=I-1
      IN=IN-1
      Q(I)=(V(IN)-Y(IP)*A(IN,5)-Q(IP)*A(IN,6))/A(IN,4)
      IN=IN-1
      Y(I)=(V(IN)-Q(I)*A(IN,4)-Y(IP)*A(IN,5)-Q(IP)*A(IN,6))/A(IN,3)
      IF(I.GT.2) GO TO 50
      Q(1)=(V(2)-A(2,6)*Q(2))/A(2,4)
      Y(1)=(V(1)-A(1,5)*Q(1))/A(1,4)
      RETURN
      END