C Solves the problem of side flow into a triangular gutter with a flat bottom and
C a rise on the slope side of z, i.e. A = bY +m(Y-z)**2/2.  This version 
C modifies RGUTTER so that only 1 eq. is solved for Xs=X(2).  This can be done
C by calling on the function subroutine that solve Yc, whenever it is needed, and
C solving as the only equation the lateral inflow ODE.
      LOGICAL DONE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/Xs,SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,b,m,z,L,g,DX,q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B,FM,Z,FL,G,DX,QS
      DONE=.FALSE.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      ZM=Z*(SQRT(FM*FM+1.)-1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      G3=3.*G
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) Xs
      GM2=.125*G*FM*FM
      YCL=CRITY(QS*Xs,((QS*Xs)**2/GM2)**.2)
      YCR=CRITY(QS*(FL-Xs),((QS*(FL-Xs))**2/GM2)**.2)
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DXX=.005*Xs
      Xs=Xs+DXX
      CALL FUN(FFF)
      DIF=DXX*F/(FFF-F)
      Xs=Xs-DIF-DXX
      NCT=NCT+1
      WRITE(*,110) NCT,DIF,Xs
110   FORMAT(' NCT=',I3,' SUM=',E12.6,', Xs=',F10.3)
      IF(NCT.LT.30 .AND. ABS(DIF).GT. ERR) GO TO 8
      WRITE(3,100) Xs
100   FORMAT(' Position where flow separates, Xs=',F9.2)
      WRITE(3,101) CRITY(QS*Xs,YCL),CRITY(QS*(FL-Xs),YCR)
101   FORMAT(' Critical depths: left =',F9.3,', right =',F9.3)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/Xs,SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      HMIN=.00001
      Q=-QS*Xs
      YCL=CRITY(Q,YCL)
      YCR=CRITY(QS*(FL-Xs),YCR)
      IF(DONE) THEN
      A=B*YCL+HM*(YCL-Z)**2
      T=B+FM*ABS(YCL-Z)
      WRITE(IOUT,100) 0.,YCL,Q,YCL+(Q/A)**2/G2,A,ABS(Q)*SQRT(T/(G*A**3))
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr'
     &,/,1X,57('-'),/,F10.1,5F10.3)
      H1=.05
      XX=0.
      Y(1)=1.1*YCL
10    XZ=XX+DX
      IF(XZ.GT.FL) XZ=FL
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=B*Y(1)+HM*(Y(1)-Z)**2
      T=B+FM*ABS(Y(1)-Z)
      Q=QS*(XZ-Xs)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,ABS(Q)*SQRT(T/(G*A**3))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. FL) GO TO 10
      F=1.1*YCR-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/Xs,SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      A=B*Y(1)+HM*(Y(1)-Z)**2
      Q=QS*(XX-Xs)
      SF=FN*Q/CC*ABS((B+FMS*Y(1)-ZM)/A)**.66666667/A
      SF=SF*ABS(SF)
      OFR2=1.-Q*Q*(B+FM*ABS(Y(1)-Z))/(G*A**3)
      IF(ABS(OFR2).LT. .05) OFR2=.1
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/OFR2
      RETURN
      END
      FUNCTION CRITY(Q,YY)
      LOGICAL DONE
      COMMON /TRAS/Xs,SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      Y=YY
      Q2=Q*Q
      M=0
1     A=B*Y+HM*(Y-Z)**2
      T=B+FM*(Y-Z)
      DIF=(Q2*T-G*A**3)/(Q2*FM-G3*A**2*T)
      Y=ABS(Y-DIF)
      M=M+1
      IF(M.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 1
      IF(M.EQ.30) WRITE(*,*)' CRITY did not converge',DIF
      CRITY=Y
      RETURN
      END