C Solves the problem of side flow into a triangular gutter with a flat bottom and
C a rise on the slope side of z, i.e. A = bY +m(Y-z)**2/2.  This version 
C modifies RGUTTER so that only 2 eqs. are solve for Ys=X(1) and Xs=X(2).  This
C can be done by calling on the function subroutine that solve Yc, whenever it is needed
      LOGICAL DONE
      REAL F(2),D(2),FFF(2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(2),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,b,m,z,L,g,DX,q*'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B,FM,Z,FL,G,DX,QS
      DONE=.FALSE.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      ZM=Z*(SQRT(FM*FM+1.)-1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      G3=3.*G
      WRITE(*,*)' GIVE guess for Position Xs'
      READ(*,*) X(2)
      GM2=.125*G*FM*FM
      YCL=CRITY(QS*X(2),((QS*X(2))**2/GM2)**.2)
      YCR=CRITY(QS*(FL-X(2)),((QS*(FL-X(2)))**2/GM2)**.2)
      X(1)=YCL+YCR
      WRITE(*,*)' Guesses for x',X
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DXX=.005*X(2)
      X(2)=X(2)+DXX
      CALL FUN(FFF)
      DO 9 I=1,2
9     D(I)=(FFF(I)-F(I))/DXX
      X(2)=X(2)-DXX
C Solve 2 linear eqs. accounting for fact that 1st column contains 1's
      D(2)=D(2)-D(1)
      F(2)=F(2)-F(1)
      ZZ=F(2)/D(2)
      SUM=ABS(ZZ)
      X(2)=X(2)-ZZ
      ZZ=F(1)-Z*D(2)
      SUM=SUM+ABS(ZZ)
      X(1)=X(1)-ZZ
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,2F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(3,100) X
100   FORMAT(' Depth at Q=0, Ys=',F8.3,', Xs=',F8.1)
      WRITE(3,101) CRITY(QS*X(2),YCL),CRITY(QS*(FL-X(2)),YCR)
101   FORMAT(' Critical depths: left =',F9.3,', right =',F9.3)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(2)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(2),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      HMIN=.00001
      Q=QS*X(2)
      YCL=CRITY(Q,YCL)
      IF(DONE) THEN
      A=B*YCL+HM*(YCL-Z)**2
      T=B+FM*(YCL-Z)
      WRITE(IOUT,100) 0.,YCL,Q,YCL+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
      ENDIF
100   FORMAT('       x          Y         Q        E        A        Fr'
     &,/,1X,57('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=1.1*YCL
10    XZ=XX+DX
      IF(XZ.GT.X(2)) XZ=X(2)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=B*Y(1)+HM*(Y(1)-Z)**2
      T=B+FM*(Y(1)-Z)
      Q=QS*(X(2)-XZ)
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT. X(2)) GO TO 10
      F(1)=X(1)-Y(1)
      H1=-.1
      Q=QS*(FL-X(2))
      YCR=CRITY(Q,YCR)
      IF(DONE) THEN
      A=B*YCR+HM*(YCR-Z)**2
      T=B+FM*(YCR-Z)
      WRITE(IOUT,100) FL,YCR,Q,YCR+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
      ENDIF
      XX=FL
      Y(1)=1.1*YCR
20    XZ=XX-DX
      IF(XZ.LT.X(2)) XZ=X(2)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=B*Y(1)+HM*(Y(1)-Z)**2
      T=B+FM*(Y(1)-Z)
      Q=QS*(XZ-X(2))
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q*SQRT(T/(G*A**3))
      ENDIF
      XX=XZ
      IF(XZ.GT. X(2)) GO TO 20
      F(2)=X(1)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(2),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      A=B*Y(1)+HM*(Y(1)-Z)**2
      Q=QS*(XX-X(2))
      SF=FN*Q/CC*ABS((B+FMS*Y(1)-ZM)/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*(B+FM*ABS(Y(1)-Z))/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END
      FUNCTION CRITY(Q,YY)
      LOGICAL DONE
      COMMON /TRAS/X(2),SO,FM,FMS,QS,CC,FN,HM,G,G2,G3,B,Z,ZM,FL,DX,TOL,
     &YCL,YCR,DONE,IOUT
      Y=YY
      Q2=Q*Q
      M=0
1     A=B*Y+HM*(Y-Z)**2
      T=B+FM*(Y-Z)
      DIF=(Q2*T-G*A**3)/(Q2*FM-G3*A**2*T)
      Y=ABS(Y-DIF)
      M=M+1
      IF(M.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 1
      IF(M.EQ.30) WRITE(*,*)' CRITY did not converge',DIF
      CRITY=Y
      RETURN
      END