C Solves problem of flow into a mild (or Horiz.) channel from a reservoir,
C and discharges into a downstream reservoir.  Q is specified, and the bottom
C width b is solve along with the depth Y.
      EXTERNAL DYX
      REAL F(2),D(2,2),X(2),KE1,KE,TOL,ERR,HMIN,Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/Q,FM,H1,H2,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,Q2GS,X,
     &HMIN,W(1,13),XP(1),YP(1,1)
      EQUIVALENCE (B,X(1)),(Y1,X(2))
      TOL=1.E-6
      HMIN=.001
      ERR=.0001
      WRITE(*,*)' GIVE:IOUT,FN,SO,Q,FM,H1,H2,FL,g,KE,DELX'
      READ(*,*) IOUT,FN,SO,Q,FM,H1,H2,FL,G,KE,DELX
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      Q2G=Q*Q/G
      Q2GS=Q2G/2.
      QN=(FN*Q/CC)**2
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: b,Y1'
      READ(*,*) X
      NCT=0
1     DO 10 I=1,2
      F(I)=FUN(I)
      DO 10 J=1,2
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      F(2)=F(2)-FAC*F(1)
      DIF=F(2)/D(2,2)
      SUM=ABS(DIF)
      Y1=Y1-DIF
      DIF=(F(1)-DIF*D(1,2))/D(1,1)
      SUM=SUM+ABS(DIF)
      B=B-DIF
      NCT=NCT+1
      WRITE(*,*) ' NCT=',NCT,SUM,X
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' b =',F10.3,' Y1 =',F10.3)
      XE=FL
      HH=-.01
      Y(1)=H2
      A=(X(1)+FM*H2)*H2
      V=Q/A
      WRITE(IOUT,105)
105   FORMAT('    x      Y        V         E      M',/,1X,41('-'))
      WRITE(IOUT,110) XE,H2,V,H2+V**2/G2,H2**2*(.5*X(1)+FM*H2/3.)+Q2G/A
110   FORMAT(F8.1,3F8.3,F8.2)
      Y(1)=H2
20    XB=XE-DELX
      IF(XB.LT.0.) XB=0.
      CALL ODESOL(Y,DY,1,XE,XB,TOL,HH,HMIN,1,XP,YP,W,DYX)
      A=(X(1)+FM*Y(1))*Y(1)
      V=Q/A
      WRITE(IOUT,110) XB,Y(1),V,Y(1)+V**2/G2,Y(1)**2*(.5*X(1)+FM*Y(1)/3.
     &)+Q2G/A
      XE=XB
      IF(XB.GT.0.) GO TO 20
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(2),KE1,Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/Q,FM,H1,H2,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,Q2GS,X,
     &HMIN,W(1,13),XP(1),YP(1,1)
      IF(II.EQ.1) THEN
      FUN=H1-X(2)-KE1*Q2GS/((X(1)+FM*X(2))*X(2))**2
      ELSE
      HH=-.05
      XX=FL
      XZ=0.
      Y(1)=H2
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,HH,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KE1,X(2)
      COMMON /TRAS/Q,FM,H1,H2,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,Q2GS,X,
     &HMIN,W(1,13),XP(1),YP(1,1)
      P=X(1)+2.*SQRT(FM*FM+1.)*Y(1)
      A=(X(1)+FM*Y(1))*Y(1)
      SF=QN*((P/A)**.666666667/A)**2
      T=X(1)+2.*FM*Y(1)
      DY(1)=(SO-SF)/(1.-Q2G*T/A**3)
      RETURN
      END