C Solves problem of flow into a mild channel from a reservoir to a 
C reservoir a position L downstream from the first reservoir.  The difference
C between this program and SOLPR19.FOR is that Chezy's equation is used.
      REAL F(2),D(2,2),X(2),KE1,KE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,G,G2,KE1,FL,TOL,e,C,SO,Q2G,X,HDOWN,HUPS
     &,SQG,QV4,SG
      EQUIVALENCE (Q,X(1)),(Y1,X(2))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,e,VIS,SO,B1,FM1,H1,N1,DH1,H2,N2,DH2,
     &L,g,KE'
      READ(*,*) IOUT,TOL,ERR,e,VIS,SO,B1,FM1,H1,N1,DH1,H2,N2,DH2,FL,G,KE
      e=e/12.
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      C=SQG*ALOG10(e/(((B1+FM1*H2)*H2)/(B1+2.*SQRT(FM1*FM1+1.)*H2)))
      G2=2.*G
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1'
      READ(*,*) X
      QV4=4.*X(1)/VIS
      DO 20 KK1=1,N1
      HUPS=H1+FLOAT(KK1-1)*DH1
      DO 20 KK2=1,N2
      HDOWN=H2+FLOAT(KK2-1)*DH2
      NCT=0
1     DO 10 I=1,2
      F(I)=FUN(I)
      DO 10 J=1,2
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      F(2)=F(2)-FAC*F(1)
      DIF1=F(2)/D(2,2)
      Y1=Y1-DIF1
      DIF=(F(1)-DIF1*D(1,2))/D(1,1)
      Q=Q-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      NCT=NCT+1
      WRITE(*,130) NCT,SUM,HUPS,HDOWN,X
130   FORMAT(I5,E14.5,4F10.2)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
20    WRITE(IOUT,100) HUPS,HDOWN,X
100   FORMAT(' H1 =',F10.2,' H2 =',F10.2,' Q =',F10.2,' Y1 =',F10.2)
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(2),W(1,13),KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,G,G2,KE1,FL,TOL,e,C,SO,Q2G,X,HDOWN,HUPS
     &,SQG,QV4,SG
      H11=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G2
      GO TO (1,2),II
1     FUN=HUPS-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      RETURN
2     Y(1)=HDOWN
      XX=FL
      XZ=0.
      Q2G=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KE1,X(2)
      COMMON /TRAS/B1,FM1,B2,G,G2,KE1,FL,TOL,e,C,SO,Q2G,X,HDOWN,HUPS
     &,SQG,QV4,SG
      EQUIVALENCE (Q,X(1)),(Y1,X(2))
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      P=B1+2.*SQRT(FM1*FM1+1.)*YY
      A=(B1+FM1*YY)*YY
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QV4/P))
      IF(ABS(C-C1).GT. 1.E-4) GO TO 1
      SF=(Q/(C*A))**2/Rh
      T=B1+2.*FM1*YY
      DY(1)=(SO-SF)/(1.-Q2G*T/A**3)
      RETURN
      END