C Solves problem of lateral outflow from grates in the bottom of a mild channel.
C The flow is assumed to be subcritical at beginning of grates and downstream
C channel is mild and contains normal depth.  Unknowns: Qd (downstream flowrate),
C  Y1 (depth at beginning of grates), & Yod (normal depth downstream channel.
      LOGICAL DONE
      REAL F(3),D(3,3),X(3),FFF(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XX,X,FFF,IPRNT,DONE,IOUT
      EQUIVALENCE (Qd,X(1)),(Y1,X(2)),(Yo2,X(3))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,Qu,FN,SO,B1,FM1,B2,FM2,L,W,Cd,g,PRNT
     &'
      READ(*,*) IOUT,TOL,ERR,Qu,FN,SO,B1,FM1,B2,FM2,FL,W,Cd,G,IPRNT
      DONE=.FALSE.
      FMSQ=2.*SQRT(FM2*FM2+1.)
      DB=(B1-B2)/FL
      DM=(FM1-FM2)/FL
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      CS=CC*SQRT(SO)
      G2=2.*G
      CDG=Cd*W*SQRT(G2)
      WRITE(*,*)' GIVE guess for: Qd,Y1,Yo2'
      READ(*,*) X
      NCT=0
1     CALL FUN
      DO 8 I=1,3
8     F(I)=FFF(I)
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN
      DO 9 I=1,3
9     D(I,J)=(FFF(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(3,1)/D(1,1)
      D(3,2)=D(3,2)-FAC*D(1,2)
      D(3,3)=D(3,3)-FAC*D(1,3)
      F(3)=F(3)-FAC*F(1)
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      D(2,3)=D(2,3)-FAC*D(1,3)
      F(2)=F(2)-FAC*F(1)
      FAC=D(3,2)/D(2,2)
      D(3,3)=D(3,3)-FAC*D(2,3)
      F(3)=F(3)-FAC*F(2)
      DIF1=F(3)/D(3,3)
      Yo2=Yo2-DIF1
      DIF=(F(2)-DIF1*D(2,3))/D(2,2)
      Y1=Y1-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      DIF=(F(1)-D(1,2)*DIF-D(1,3)*DIF1)/D(1,1)
      SUM=SUM+ABS(DIF)
      Qd=Qd-DIF
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.5,3F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      DONE=.TRUE.
      CALL FUN
      WRITE(IOUT,100) X
100   FORMAT(' Qd =',F10.2,' Y1 =',F10.3,' Yo2 =',F10.3)
      END
      SUBROUTINE FUN
      LOGICAL DONE
      EXTERNAL DYX
      REAL X(3),WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XX,X,F,IPRNT,DONE,IOUT
      H1=-.05
      HMIN=.001
      F(1)=FN*X(1)*(B2+FMSQ*X(3))**.666666667-CS*((B2+FM2*X(3))*X(3))**
     &1.6666667
      Y(1)=X(3)
      XX=FL
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
100   FORMAT('     x       Y    acc. q*  av. q*           X1        X2',
     &/,1X,57('-'))
      ENDIF  
      SQSTAR=0.
      IF(Y(1).LT.W) THEN
      QSTAR1=0.
      ELSE
      QSTAR1=CDG*SQRT(Y(1))
      ENDIF
4     XZ=XX-1.
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(Y(1).LT.W) THEN
      QSTAR2=0.
      ELSE
      QSTAR2=CDG*SQRT(Y(1))
      ENDIF
      SQSTAR=SQSTAR+(XX-XZ)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. XZ.LT. .001) THEN    
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ
110   FORMAT(F8.2,F8.3,2F8.3,'  betw.',F8.2,' &',F8.2)
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.GT. .001) GO TO 4
      F(2)=X(2)-Y(1)
      F(3)=Qu-X(1)-SQSTAR
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(3),F(3)
      LOGICAL DONE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XXB,X,F,IPRNT,DONE,IOUT
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      B=B1+DB*XX
      FM=FM1+DM*XX
      P=B+2.*SQRT(FM*FM+1.)*YY
      A=(B+FM*YY)*YY
      IF(YY.LT.W) THEN
      QSTAR=0.
      ELSE
      QSTAR=CDG*SQRT(YY)
      ENDIF
      QQ=X(1)+SQSTAR+ABS(XXB-XX)*(QSTAR+QSTAR1)/2.
      SF=(FN*QQ/CC*(P/A)**.666666667/A)**2
      T=B+2.*FM*YY
      A3=A**3
      QQS=QQ*QQ
      DY(1)=(SO-SF+QQ*QSTAR/(G*A*A)+QQS/(G*A3)*(DB+YY*DM)*YY)/
     &(1.-QQS*T/G/A3)
      RETURN
      END
