C Solves problem of flow into a mild circular channel from a reservoir to a 
C reservoir a position L downstream from the first reservoir.  Series of solutions
C can be obtained by setting N1 & N2 larger than 1.
      EXTERNAL DYX
      LOGICAL*2 PROFIL
      REAL F(2),D(2,2),X(2),KE1,KE,W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/DI,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,HDOWN,HUPS,DI2
      EQUIVALENCE (Q,X(1)),(Y1,X(2))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,n,So,Dia,H1,N1,DH1,H2,N2,DH2,L,g,KE,
     &PROFIL(.T. or .F.)'
      READ(*,*) IOUT,TOL,ERR,FN,SO,DI,H1,N1,DH1,H2,N2,DH2,FL,G,KE,PROFIL
      DI2=.25*DI*DI
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1'
      READ(*,*) X
      DO 20 KK1=1,N1
      HUPS=H1+FLOAT(KK1-1)*DH1
      DO 20 KK2=1,N2
      HDOWN=H2+FLOAT(KK2-1)*DH2
      NCT=0
1     DO 10 I=1,2
      F(I)=FUN(I)
      DO 10 J=1,2
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      F(2)=F(2)-FAC*F(1)
      DIF1=F(2)/D(2,2)
      Y1=Y1-DIF1
      DIF=(F(1)-DIF1*D(1,2))/D(1,1)
      Q=Q-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      NCT=NCT+1
      WRITE(*,101) NCT,SUM,HUPS,HDOWN,X
101   FORMAT(I5,E14.5,4F10.2)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,100) HUPS,HDOWN,X
100   FORMAT(' H1 =',F10.2,' H2 =',F10.2,' Q =',F10.3,' Y1 =',F10.3)
      IF(.NOT.PROFIL) GO TO 20
      WRITE(*,120)
120   FORMAT(' Give no. of stations')
      READ(*,*) NSTATI
      IF(NSTATI.GT.0) THEN
      H11=-.01
      HMIN=1.E-5
      WRITE(IOUT,130) FL,H2
      DELLX=FL/(NSTATI-1)
      Y(1)=H2
      DO 44 I=1,NSTATI-1
      XZ=FL-DELLX*FLOAT(I)
      XX=XZ+DELLX
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
44    WRITE(IOUT,130) XZ,Y
130   FORMAT(2F12.3)
      ENDIF
20    CONTINUE
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(2),W(1,13),KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/DI,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,HDOWN,HUPS,DI2
      H11=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G2
      GO TO (1,2),II
1     COSB=1.-2.*X(2)/DI
      BETA=ACOS(COSB)
      FUN=HUPS-X(2)-KE1*Q2G/(DI2*(BETA-COSB*SIN(BETA)))**2
      RETURN
2     Y(1)=HDOWN
      XX=FL
      XZ=0.
      QN=(FN*X(1)/CC)**2
      Q2G=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KE1,X(2)
      COMMON /TRAS/DI,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,HDOWN,HUPS,DI2
      EQUIVALENCE (Q,X(1)),(Y1,X(2))
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      COSB=1.-2.*YY/DI
      BETA=ACOS(COSB)
      P=DI*BETA
      A=DI2*(BETA-COSB*SIN(BETA))
      SF=QN*((P/A)**.666666667/A)**2
      T=DI*SIN(BETA)
      DY(1)=(SO-SF)/(1.-Q2G*T/A**3)
      RETURN
      END

