C Solves problem of flow into a mild channel from a reservoir that has a 
C steep rectangular channel at a position L downstream from the reservoir.
      REAL F(3),D(3,3),X(3),KE1,KE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,H,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,
     &X1,DB,DFM,DX1,DX2,NPRINT,NPRT,IOUT,FLX1
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B1,FM1,B2,H,L,X1,g,KE,DX1,DX2'
      READ(*,*)IOUT,TOL,ERR,FN,SO,B1,FM1,B2,H,FL,X1,G,KE,DX1,DX2
      FLX1=FL-X1
      NPRINT=0
      NPRT=0
      IDONE=0
      IF(IOUT.EQ.6) NPRINT=1
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Y1,Y2'
      READ(*,*) X
      DB=B2-B1
      DFM=0.-FM1
      NCT=0
1     IF(NPRINT.GT.0) WRITE(IOUT,105) FL,X(3)
105   FORMAT(F10.1,F10.3)
      DO 10 I=1,3
      IF(NPRINT.GT.0) NPRT=1
      F(I)=FUN(I)
      NPRT=0
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(3,1)/D(1,1)
      D(3,2)=D(3,2)-FAC*D(1,2)
      D(3,3)=D(3,3)-FAC*D(1,3)
      F(3)=F(3)-FAC*F(1)
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      D(2,3)=D(2,3)-FAC*D(1,3)
      F(2)=F(2)-FAC*F(1)
      FAC=D(3,2)/D(2,2)
      D(3,3)=D(3,3)-FAC*D(2,3)
      F(3)=F(3)-FAC*F(2)
      DIF1=F(3)/D(3,3)
      Y2=Y2-DIF1
      DIF=(F(2)-DIF1*D(2,3))/D(2,2)
      Y1=Y1-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      DIF=(F(1)-D(1,2)*DIF-D(1,3)*DIF1)/D(1,1)
      SUM=SUM+ABS(DIF)
      Q=Q-DIF
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I5,E12.5,3F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      IF(NPRINT.EQ.0) THEN
      WRITE(IOUT,120) FL,((X(1)/B2)**2/G)**.3333333
120   FORMAT(F10.1,F10.3)
      NPRT=1
      F(3)=FUN(3)
      ENDIF
      WRITE(IOUT,100) X
100   FORMAT(' Q =',F10.2,' Y1 =',F10.3,' Y2 =',F10.3)
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(3),W(1,13),KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,H,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,
     &X1,DB,DFM,DX1,DX2,NPRINT,NPRT,IOUT,FLX1
      H1=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G2
      GO TO (1,2,3),II
1     FUN=X(3)-1.05*((X(1)/B2)**2/G)**.333333333
      RETURN
2     FUN=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      RETURN
3     Y(1)=X(3)
      XX=FL
      XZ=XX-DX2
      QN=(FN*X(1)/CC)**2
      Q2G=X(1)*X(1)/G
10    CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      IF(NPRT.GT.0) WRITE(IOUT,120) XZ,Y
120   FORMAT(F10.1,F10.3)
      XX=XZ
      IF(XX.LT. .001) GO TO 30
      IF(XX.LE.X1) THEN
      XZ=XZ-DX1
      ELSE
      XZ=XZ-DX2
      ENDIF
      GO TO 10
30    FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KE1,X(3)
      COMMON /TRAS/B1,FM1,B2,H,G,G2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,
     &X1,DB,DFM,DX1,DX2,NPRINT,NPRT,IOUT,FLX1
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3))
      IF(XX.GT.X1) THEN
      XXX=(XX-X1)/FLX1
      B=B1+DB*XXX
      FM=FM1+DFM*XXX
      DAX=(DB+DFM*Y(1))*Y(1)/FLX1
      ELSE
      B=B1
      FM=FM1
      DAX=0.
      ENDIF
10    P=B+2.*SQRT(FM*FM+1.)*Y(1)
      A=(B+FM*Y(1))*Y(1)
      SF=QN*((P/A)**.6666667/A)**2
      QA3=Q2G/A**3
      DY(1)=(SO-SF+QA3*DAX)/(1.-QA3*(B+2.*FM*Y(1)))
      RETURN
      END