C  Solves submerged flow by gate downstream from reservoir.
      LOGICAL*2 SUBMER
      INTEGER*2 INDX(6)
      REAL F(6),D(6,6),X(6),KL2,KE1
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,SO1,FN1,B2,B3,FM3,SO3,FN3,H,G,G2,KL2,KE1,FL,
     &SFM3,SFM1,Q2G,TOL,Y2,CC,QN,X,SUBMER
      EQUIVALENCE (Q,X(1)),(Ybeg,X(2)),(Y1T,X(3)),(Y1R,X(4)),(Y3,X(5)),
     &(Y,X(6))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,B1,m1,So1,n1,B2,B3,m3,So3,n3,Y2,H,L,
     &g,KL,KE,SUBMER'
      READ(*,*) IOUT,TOL,ERR,B1,FM1,SO1,FN1,B2,B3,FM3,SO3,FN3,Y2,H,FL,G,
     &KL2,KE1,SUBMER
      SFM3=SQRT(1.+FM3*FM3)
      SFM1=SQRT(1.+FM1*FM1)
      IF(SUBMER) THEN
      N=6
      ELSE
      N=5
      ENDIF
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KL2=1.+KL2
      KE1=1.+KE1
      WRITE(*,*)' GIVE guess for: Q,Ybeg,Y1t,Y1r,Y3,Y'
      READ(*,*) X
2     NCT=0
1     DO 10 I=1,N
      F(I)=FUN(I)
      DO 10 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(N,6,D,F,1,DD,INDX)
      SUM=0.
      DO 20 I=1,N
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM
      WRITE(*,*) (X(I),I=1,N)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      IF(.NOT.SUBMER) THEN
22    FF=FMOM(6)
      XX=Y
      Y=.998*Y
      DIF=(XX-Y)*FF/(FF-FMOM(6))
      Y=XX-DIF
      IF(ABS(DIF).GT. .00001) GO TO 22
      ENDIF    
      WRITE(IOUT,100) Y2,X
100   FORMAT(F8.2,F10.2,5F8.3)
      IF(Y.LT.Y2 .AND. .NOT.SUBMER) THEN
      SUBMER=.TRUE.
      N=6
      ELSE IF(Y.LT.Y2 .AND. SUBMER) THEN
      SUBMER=.FALSE.
      N=5
      ENDIF
      WRITE(*,110) Y2,X,SUBMER
110   FORMAT(F10.3,F10.2,5F8.3,L8,/,' Give new y2 ')
      READ(*,*) Y2
      IF(Y2.GT. 0.) GO TO 2
      END
      FUNCTION FMOM(K)
      LOGICAL*2 SUBMER
      REAL X(6),KL2,KE1
      COMMON /TRAS/B1,FM1,SO1,FN1,B2,B3,FM3,SO3,FN3,H,G,G2,KL2,KE1,FL,
     &SFM3,SFM1,Q2G,TOL,Y2,CC,QN,X,SUBMER
      FMOM=B3*X(6)**2/2.+FM3*X(6)**3/3.-B3*X(5)**2/2.-FM3*X(5)**3/3.
     &+X(1)**2/G*(1./((B3+FM3*X(6))*X(6))-1./((B3+FM3*X(5))*X(5)))
      RETURN
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      LOGICAL*2 SUBMER
      REAL X(6),W(1,13),KL2,KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,SO1,FN1,B2,B3,FM3,SO3,FN3,H,G,G2,KL2,KE1,FL,
     &SFM3,SFM1,Q2G,TOL,Y2,CC,QN,X,SUBMER
      H1=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G2
      IF(SUBMER) THEN
      GO TO (1,2,3,4,5,6),II
      ELSE
      GO TO (1,2,3,7,6),II
      ENDIF
1     AA=(B3+FM3*X(5))*X(5)
      FUN=FN3*X(1)-CC*AA*(AA/(B3+2.*X(5)*SFM3))**.6666667*SQRT(SO3)
      RETURN
2     FUN=H-X(2)-KE1*Q2G/((B1+FM1*X(2))*X(2))**2
      RETURN
3     FUN=X(3)+Q2G/((B1+FM1*X(3))*X(3))**2-X(4)-Q2G/(B2*X(4))**2
      RETURN
4     FUN=X(4)+Q2G/(B2*X(4))**2-X(6)-Q2G/(B2*Y2)**2
      RETURN
5     FUN=.5*(B2*X(6)**2-B2*X(5)**2)+2.*(Q2G/(B2*Y2)-Q2G/(B2*X(5)))
      RETURN
7     FUN=X(4)+Q2G/(B2*X(4))**2-Y2-Q2G/(Y2*B2)**2
      RETURN
6     Y(1)=X(3)
      XX=FL
      XZ=0.
      IND=1
      QN=(FN1*X(1)/CC)**2
      Q2G=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KL2,KE1,X(6)
      LOGICAL*2 SUBMER
      COMMON /TRAS/B1,FM1,SO1,FN1,B2,B3,FM3,SO3,FN3,H,G,G2,KL2,KE1,FL,
     &SFM3,SFM1,Q2G,TOL,Y2,CC,QN,X,SUBMER
      YY=ABS(Y(1))
      A=(B1+FM1*YY)*YY
      SF=QN*(((B1+2.*YY*SFM1)/A)**.666666667/A)**2
      DY(1)=(SO1-SF)/(1.-Q2G*(B1+2.*FM1*YY)/A**3)
      RETURN
      END