C  Solves submerged flow by gate downstream from reservoir and at end of channel
C  a free overfall occurs.
      INTEGER*2 INDX(6)
      REAL F(5),D(5,5),X(5),KE1
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,SO,FN,H,G,G2,FL1,FL2,Q2G,TOL,Y3,CC,QN,KE1,X
      EQUIVALENCE (Q,X(1)),(Y1,X(2)),(Y2,X(3)),(Y,X(4)),(Y4,X(5))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,B,So,n,Y3,H,L1,L2,g,KE'
      READ(*,*) IOUT,TOL,ERR,B,SO,FN,Y3,H,FL1,FL2,G,KE1
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KE1=1.+KE1
      WRITE(*,*)' GIVE guess for: Q,Y1,Y2,Y,Y4'
      READ(*,*) (X(I),I=1,5)
      Yc=((Q/B)**2/G)**.33333333
2     NCT=0
1     DO 10 I=1,5
      F(I)=FUN(I)
      DO 10 J=1,5
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(5,5,D,F,1,DD,INDX)
      SUM=0.
      DO 20 I=1,5
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,100) NCT,SUM,X
100   FORMAT(' NCT=',I3,' SUM=',E10.4,/,5F8.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,110) X,((X(1)/B)**2/G)**.3333333,Y3
110   FORMAT(' Solution:',/' Q=',F10.2,/' Y1=',F8.3,/,' Y2=',F8.3,/
     &' Y=',F8.3,/' Y4=',F8.3,/' Yc=',F8.3,/' Gate depth=',F8.3)
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(5),W(1,13),KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,SO,FN,H,G,G2,FL1,FL2,Q2G,TOL,Y3,CC,QN,KE1,X
      Q2G=X(1)*X(1)/G2
      GO TO (1,2,3,4,5),II
1     FUN=H-X(2)-KE1*Q2G/(B*X(2))**2
      RETURN
2     FUN=X(3)+Q2G/(B*X(3))**2-X(4)-Q2G/(B*Y3)**2
      RETURN
3     FUN=.5*(X(4)**2-X(5)**2)+2./(B*B)*(Q2G/Y3-Q2G/X(5))
      RETURN
4     Y(1)=X(3)
      XX=FL1
      XZ=0.
      GO TO 7
5     Y(1)=((X(1)/B)**2/G)**.3333333+.1
      XX=FL2
      XZ=0.
7     QN=(FN*X(1)/CC)**2
      H1=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      IF(II.EQ.4) THEN
      FUN=X(2)-Y(1)
      ELSE
      FUN=X(5)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KE1,X(5)
      COMMON /TRAS/B,SO,FN,H,G,G2,FL1,FL2,Q2G,TOL,Y3,CC,QN,KE1,X
      YY=ABS(Y(1))
      A=B*YY
      SF=QN*(((B+2.*YY)/A)**.666666667/A)**2
      FRS=Q2G*B/A**3
      IF(FRS.GT. 1.) FRS=.9
      DY(1)=(SO-SF)/(1.-FRS)
      RETURN
      END