C Solves for critical position in a steep channel with lateral inflow
C A pipe at the beginning discharges water into a reservoir.
C  This program solves the GVF upstream and downstream of the critical 
C position whereas SOLGVINF does not. DY1 & DY2 are increment above and
C below critical depth to start these profiles.
      PARAMETER (N=5)
      INTEGER*2 INDX(N)
      EXTERNAL DYX
      REAL X(N),W(1,13),Y(1),DY(1),XP(1),YP(1,1),F(N),F1(N),D(N,N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/Bo,FMo,Db,Dm,G,G2,FL,TOL,FN,SO,Cu,Dp,Ap,FLp,E,WS,El,
     &qs,Uq,CC,X
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,Bo,FMo,Db,Dm,L,g,D,Lp,e,WS,El,
     &qs,Uq'
      READ(*,*)IOUT,TOL,ERR,FN,SO,Bo,FMo,Db,Dm,FL,g,Dp,FLp,e,WS,El,qs,Uq
      Ap=.78539816*Dp*Dp
      IF(G.GT.30.) THEN
      CC=7.34347283*1.41E-5
      Cu=1.486
      ELSE
      Cu=1.
      CC=7.34347283*1.31E-6
      ENDIF
      G2=2.*G
      WRITE(*,*)' GIVE guess for: xc,Yc,Q,Qp,Yo'
      READ(*,*) X
      NCT=0
1     CALL FUN(F)
      DO 10 I=1,N
      DX=.005*X(I)
      X(I)=X(I)+DX
      CALL FUN(F1)
      DO 9 J=1,N
9     D(J,I)=(F1(J)-F(J))/DX
10    X(I)=X(I)-DX
      CALL SOLVEQ(N,1,N,D,F,1,DD,INDX)
      WRITE(*,*)' NCT',NCT,F
      DIF=0.
      DO 20 I=1,N
      DIF=DIF+ABS(F(I))
20    X(I)=X(I)-F(I)
      WRITE(*,*)' DIF & X=',DIF,X
      NCT=NCT+1
      IF(NCT.LT.30 .AND. DIF.GT. ERR) GO TO 1
      WRITE(IOUT,100) X
100   FORMAT(' xc =',F10.2,' Yc=',F10.2,' Q =',F10.2,' Pipe Q =',F10.3,
     &' Yo =',F10.3)
      IF(X(1).GT.FL) STOP
      WRITE(*,*)' Give DY1 & DY2'
      READ(*,*) DY1,DY2
      H1=-.05
      HMIN=1.e-10
      NST=X(1)/10.
      B=Bo+Db*X(1)
      FM=Fmo+Dm*X(1)
      AR=(B+FM*X(2))*X(2)
      FR=SQRT(X(3)**2*(B+2.*FM*X(2))/(G*AR**3))
      WRITE(IOUT,110) X(1),X(2),X(3),X(2)+(X(3)/AR)**2/G2,FR,B,FM
110   FORMAT(7F10.3)
      IF(10.*FLOAT(NST).GT.X(1)-2.) NST=NST-1
      Y(1)=X(2)+DY1
      XX1=X(1)-1.
      XX=10.*FLOAT(NST)
30    IF(XX.LT.0.) XX=0.
      CALL ODESOL(Y,DY,1,XX1,XX,TOL,H1,HMIN,1,XP,YP,W,DYX)
      B=Bo+Db*XX
      FM=Fmo+Dm*XX
      AR=(B+FM*Y(1))*Y(1)
      QQ=XX*qs-X(4)
      FR=SQRT(ABS(QQ**2*(B+2.*FM*Y(1))/(G*AR**3)))
      WRITE(IOUT,110) XX,Y(1),QQ,Y(1)+(QQ/AR)**2/G2,FR,B,FM
      IF(XX.LT.1.E-5) GO TO 31
      XX1=XX
      XX=XX-10.
      GO TO 30
31    WRITE(IOUT,*)
      Y(1)=X(2)-DY2
      H1=.05
      XX1=X(1)+1.
      XX=10.*FLOAT(NST+1)
40    IF(XX.GT.FL) XX=FL
      CALL ODESOL(Y,DY,1,XX1,XX,TOL,H1,HMIN,1,XP,YP,W,DYX)
      B=Bo+Db*XX
      FM=Fmo+Dm*XX
      AR=(B+FM*Y(1))*Y(1)
      QQ=XX*qs-X(4)
      FR=SQRT(QQ**2*(B+2.*FM*Y(1))/(G*AR**3))
      WRITE(IOUT,110) XX,Y(1),QQ,Y(1)+(QQ/AR)**2/G2,FR,B,FM
      IF(XX+1.E-5.GT.FL) STOP
      XX1=XX
      XX=XX+10.
      GO TO 40
      END
      SUBROUTINE FUN(F)
      PARAMETER (N=5)
      EXTERNAL DYX
      REAL X(N),W(1,13),Y(1),DY(1),XP(1),YP(1,1),F(N)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/Bo,FMo,Db,Dm,G,G2,FL,TOL,FN,SO,Cu,Dp,Ap,FLp,E,WS,El,
     &qs,Uq,CC,X
      H1=-.05
      HMIN=.001
      YY=X(2)
      B=Bo+Db*X(1)
      FM=FMo+Dm*X(1)
      A=(B+FM*YY)*YY
      DAx=YY*Db+YY*YY*Dm
      Sf=(FN*X(3)*(B+2.*YY*SQRT(FM*FM+1.))**.666667/A**1.6666667/Cu)**2
      Fq=(X(3)/A-Uq)*qs/(g*A)+(.5*B+FM*YY)*(YY/A)**2*DAx
      F(1)=SO-Sf+X(3)**2/(G*A**3)*DAx-X(3)*qs/(G*A**2)-Fq
      F(2)=FR(X(4))*FLp/Dp*(X(4)/Ap)**2/G2-El+WS-X(5)
      F(3)=qs*X(1)-X(3)-X(4)
      F(4)=X(3)**2*(B+2.*FM*YY)/(G*A**3)-1.
C3     Y(1)=1.05*X(2)
C      XX1=X(1)-2.
C      DXX=XX1/20.
C      DO 10 I=1,20
C      XX=XX1-DXX
C      CALL ODESOL(Y,DY,1,XX1,XX,TOL,H1,HMIN,1,XP,YP,W,DYX)
C10    XX1=XX
3     Y(1)=X(2)+.35
      CALL ODESOL(Y,DY,1,X(1)-10.,0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      F(5)=X(5)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/Bo,FMo,Db,Dm,G,G2,FL,TOL,FN,SO,Cu,Dp,Ap,FLp,E,WS,El,
     &qs,Uq,CC,X(5)
      YY=ABS(Y(1))
      B=Bo+Db*XX
      FM=FMo+Dm*XX
      A=(B+FM*YY)*YY
      Q=XX*qs-X(4)
      QA=ABS(Q)
      A3=A**3
      Q2=QA*QA
      SF=Q*((FN/Cu/A)**2*QA*((B+2.*SQRT(FM*FM+1.)*YY)/A)**1.3333333)
      T=B+2.*FM*YY
      DAx=YY*(Db+YY*Dm)
      Fq=(QA/A-Uq)*qs/(g*A)+(.5*B+FM*YY/3.)*(YY/A)**2*DAx
      FR2=1.-Q2*T/(G*A3)
      IF(ABS(FR2).LT. 0.05) FR2=.05*FR2/ABS(FR2)
      DY(1)=(SO-SF+Q2/(G*A3)*DAx-QA*qs/(G*A**2)-Fq)/FR2
C      DY(1)=(SO-SF+Q2/(G*A3)*DAx-QA*qs/(G*A**2)-Fq)/(1.-Q2*T/(G*A3))
      RETURN
      END
      FUNCTION FR(Q)
      COMMON /TRAS/Bo,FMo,Db,Dm,G,G2,FL,TOL,FN,SO,Cu,Dp,Ap,FLp,E,WS,El,
     &qs,Uq,CC,X(5)
      F1=8.
10    F2=F1
      F1=1.14-2.*ALOG10(E/Dp+CC*Dp*F2/Q)
      IF(ABS(F1-F2).GT. 1.E-6) GO TO 10
      FR=1./F1/F1
      RETURN
      END