C Solves problem of lateral outflow from bottom of a mild channel, as orifice flow.
C The flow is assumed to be critical at beginning of outflow and downstream
C channel is mild and contains normal depth.  A jump occurs.
C Unknowns: X(1) = Qu (flow rate in Upstream channel); X(2) = Yj1 (upstream jump);
C X(3) = Yj2 (downstream jump), X(4) =Yc (Critical depth at beginning of outflow);
C X(5) = x (position of jump).
C This Program modifies SOLORIF so that the upstream flow rate is given, not Qd, and 
C the upstream critical depth replaces the downstream normal depth as an unknown.
C W is fraction of bottom that is open.
      LOGICAL DONE,UPST
      INTEGER*2 INDX(5)
      REAL F(5),D(5,5),X(5),FFF(5)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qd,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XX,X,FFF,Yod,IPRNT,DONE,UPST,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,Qd,FN,SO,B1,FM1,B2,FM2,L,W,Cd,g,PRNT
     &,PRNTM'
      READ(*,*) IOUT,TOL,ERR,Qd,FN,SO,B1,FM1,B2,FM2,FL,W,Cd,G,IPRNT,
     &IPRMOR
      DONE=.FALSE.
      FMSQ=2.*SQRT(FM2*FM2+1.)
      DB=(B1-B2)/FL
      DM=(FM1-FM2)/FL
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      CS=CC*SQRT(SO)
      G2=2.*G
      CDG=W*Cd*SQRT(G2)
      WRITE(*,*)' GIVE guess for: Qu,Yj1,Yj2,Yc,x'
      READ(*,*) X
C  Solve for normal depth in downstream channel
      NCT=0
      Yod=1.1*X(3)
5     FF=FN*Qd*(B2+FMSQ*Yod)**.6666667-CS*((B2+FM2*Yod)*Yod)**1.6666667
      NCT=NCT+1
      IF(MOD(NCT,2).NE.0) THEN
      FF1=FF
      YY=Yod
      Yod=1.005*Yod
      GO TO 5
      ENDIF
      DIF=(Yod-YY)*FF1/(FF-FF1)
      Yod=YY-DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. NCT.LT.30) GO TO 5
      WRITE(IOUT,150) Yod,Qd
150   FORMAT(' Normal Depth in Downstream Channel=',F8.3,'  Q=',F8.2)
      FMSQ=2.*FM1
      NCT=0
      IF(IPRMOR.GT.1) DONE=.TRUE.
1     CALL FUN
      DO 8 I=1,5
8     F(I)=FFF(I)
      DO 10 J=1,5
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN
      DO 9 I=1,5
9     D(I,J)=(FFF(I)-F(I))/DX
10    X(J)=X(J)-DX
      IF(IPRMOR.GT.0) THEN
      DO 11 I=1,5
11    WRITE(*,333)(D(I,J),J=1,5),F(I)
333   FORMAT(6F10.3)
      ENDIF
      CALL SOLVEQ(5,1,5,D,F,1,DD,INDX)
      IF(IPRMOR.GT.0) WRITE(*,334) (F(I),I=1,5)
334   FORMAT(' sol',6F10.3)
      NCT=NCT+1
      DIF=0.
      DO 19 I=1,5
19    DIF=DIF+ABS(F(I))
      WRITE(*,*) NCT,DIF,' Give factor; IF 0 then x'
      READ(*,*) DX
      IF(DX.LT.1.E-6) THEN
      WRITE(*,*)' Give Qu,Yj1,Yj2,Yc & x'
      READ(*,*) X
      GO TO 21
      ENDIF
      DO 20 I=1,5
20    X(I)=X(I)-DX*F(I)
21    WRITE(*,110) NCT,DIF,X
110   FORMAT(' NCT=',I3,' DIF=',E12.5,/,5F10.3)
      IF(NCT.LT.30 .AND. DIF.GT. ERR) GO TO 1
      DONE=.TRUE.
      CALL FUN
      WRITE(IOUT,100) X
100   FORMAT(' Qu =',F10.2,' Yj1 =',F10.3,' Yj2 =',F10.3,' Yc =',F10.3,
     &' x =',F10.2)
      END
      SUBROUTINE FUN
      LOGICAL DONE,UPST
      EXTERNAL DYX
      REAL X(5),WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(5)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qd,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XX,X,F,Yod,IPRNT,DONE,UPST,IOUT
      F(1)=(X(1)**2*(B1+FMSQ*X(4)))/(G*((B1+FM1*X(4))*X(4))**3)-1.
      IF(X(5).LT.0.) THEN
      SQSTAU=0.
      GO TO 3
      ENDIF
      H1=.02
      HMIN=.000001
      Y(1)=.98*X(4)
      XX=0.
      UPST=.FALSE.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
100   FORMAT('     x       Y    acc. q*  av. q*           X1        X2
     &      Q     Fr',/,1X,75('-'))
      WRITE(IOUT,110) XX,X(4),CDG*B1*SQRT(Y(1)),0.,0.,1.,X(1),SQRT((X(1)
     &**2*(B1+FMSQ*X(4)))/(G*((B1+FM1*X(4))*X(4))**3))
      ENDIF  
      SQSTAR=0.
      QSTAR1=CDG*B1*SQRT(Y(1))
2     XZ=XX+1.
      IF(XZ.GT.X(5)) XZ=X(5)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      QSTAR2=CDG*(B1+DB*XZ)*SQRT(Y(1))
      SQSTAR=SQSTAR+(XZ-XX)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-X(5)).LT. .001) THEN
      QQ=X(1)-SQSTAR
      B=B1+DB*XZ
      FM=FM1+DM*XZ
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ,SQRT(
     &(QQ**2*(B+2.*FM*Y(1)))/(G*((B+FM*Y(1))*Y(1))**3))
110   FORMAT(F8.2,F8.3,2F8.3,'  betw.',F8.2,' &',F8.2,2F10.2)
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.LT. X(5)-.001) GO TO 2
      SQSTAU=SQSTAR
      F(2)=X(2)-Y(1)
3     H1=-.1
      HMIN=.000001
      Y(1)=Yod
      IF(X(5).GT.FL) GO TO 8
      XX=FL
      UPST=.TRUE.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
      WRITE(IOUT,110) FL,Yod,CDG*B2*SQRT(Yod),CDG*SQRT(Yod),FL,FL-1.,Qd,
     &SQRT((Qd**2*(B2+2.*FM2*Yod))/(G*((B2+FM*Yod)*Yod)**3))
      ENDIF  
      SQSTAR=0.
      QSTAR1=CDG*B2*SQRT(Y(1))
4     XZ=XX-1.
      IF(XZ.LT.X(5)) XZ=X(5)
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      QSTAR2=CDG*(B1+DB*XZ)*SQRT(Y(1))
      SQSTAR=SQSTAR+(XX-XZ)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-X(5)).LT. .001) THEN    
      QQ=Qd+SQSTAR
      B=B1+DB*XZ
      FM=FM1+DM*XZ
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ,SQRT(
     &(QQ**2*(B+2.*FM*Y(1)))/(G*((B+FM*Y(1))*Y(1))**3))
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.GT. X(5)+.001 .AND. XZ.GT. 0.) GO TO 4
      SQSTAD=SQSTAR
8     F(3)=X(3)-Y(1)
      B=B1+DB*X(5)
      FM=FM1+DM*X(5)
      FMM1=(B/2.+X(2)*FM/3.)*X(2)**2+(X(1)-SQSTAU)**2/G/((B+X(2)*FM)*X(2
     &))
      FMM2=(B/2.+X(3)*FM/3.)*X(3)**2+(Qd+SQSTAD)**2/G/((B+X(3)*FM)*X(3))
      F(4)=FMM1-FMM2
      F(5)=X(1)-Qd-SQSTAU-SQSTAD
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(5),F(5)
      LOGICAL DONE,UPST
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qd,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XXB,X,F,Yod,IPRNT,DONE,UPST,IOUT
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      B=B1+DB*XX
      FM=FM1+DM*XX
      P=B+2.*SQRT(FM*FM+1.)*YY
      A=(B+FM*YY)*YY
      IF(YY.LT.W) THEN
      QSTAR=0.
      ELSE
      QSTAR=CDG*B*SQRT(YY)
      ENDIF
      IF(UPST) THEN
      QQ=Qd+SQSTAR+ABS(XXB-XX)*(QSTAR+QSTAR1)/2.
      ELSE
      QQ=X(1)-SQSTAR-ABS(XX-XXB)*(QSTAR+QSTAR1)/2.
      ENDIF
      SF=(FN*QQ/CC*(P/A)**.666666667/A)**2
      T=B+2.*FM*YY
      A3=A**3
      QQS=QQ*QQ
      FR1=1.-QQS*T/G/A3
      IF(ABS(FR1) .LT. .01) THEN
      DY(1)=0.
      ELSE
      DY(1)=(SO-SF+QQ*QSTAR/(G*A*A)+QQS/(G*A3)*(DB+YY*DM)*YY)/FR1
      ENDIF
      RETURN
      END
