C Solves problem of lateral outflow from bottom of a mild channel, as orifice flow.
C The flow is assumed to be critical at beginning of outflow and remains supercritical
C  through the length of lateral outflow, with a hydraulic jump occuring in the
C  downstream channel.  The downstream flow rate Qd is specified.
C Three unknowns are: Qu, Yc and Y2 (at end of lateral outflow length.)
C  X(1)=Qu, X(2)=Yc & X(3)=Y2
C See Programs SOLORIF(Qu given) & SOLORIFD(Qd given) as other orifice outflow cases.
      LOGICAL DONE,UPST
      INTEGER*2 INDX(3)
      REAL F(3),D(3,3),X(3),FFF(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qd,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XX,X,FFF,IPRNT,DONE,UPST,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,Qd,FN,SO,B1,FM1,B2,FM2,L,W,Cd,g,PRNT
     &'
      READ(*,*) IOUT,TOL,ERR,Qd,FN,SO,B1,FM1,B2,FM2,FL,W,Cd,G,IPRNT
      DONE=.FALSE.
      FMSQ=2.*FM1
      DB=(B1-B2)/FL
      DM=(FM1-FM2)/FL
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      CS=CC*SQRT(SO)
      G2=2.*G
      CDG=W*Cd*SQRT(G2)
      WRITE(*,*)' GIVE guess for: Qu,Yc,Y2'
      READ(*,*) X
      NCT=0
1     CALL FUN
      DO 8 I=1,3
8     F(I)=FFF(I)
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN
      DO 9 I=1,3
9     D(I,J)=(FFF(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(3,1,3,D,F,1,DD,INDX)
      NCT=NCT+1
      DIF=0.
      DO 20 I=1,3
      DIF=DIF+ABS(F(I))
20    X(I)=X(I)-F(I)
      WRITE(*,110) NCT,DIF,X
110   FORMAT(' NCT=',I3,' DIF=',E12.5,/,3F10.3)
      IF(NCT.LT.30 .AND. DIF.GT. ERR) GO TO 1
      DONE=.TRUE.
      CALL FUN
      WRITE(IOUT,100) X
100   FORMAT(' Qu =',F10.2,' Yc =',F10.3,' Y2 =',F10.3)
      END
      SUBROUTINE FUN
      LOGICAL DONE,UPST
      EXTERNAL DYX
      REAL X(3),WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qd,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XX,X,F,IPRNT,DONE,UPST,IOUT
      F(1)=(X(1)**2*(B1+FMSQ*X(2)))/(G*((B1+FM1*X(2))*X(2))**3)-1.
      H1=.05
      HMIN=.00001
      Y(1)=.95*X(2)
      XX=0.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
100   FORMAT('     x       Y    acc. q*  av. q*           X1        X2
     &      Q        Fr     b      m',/,1X,90('-'))
      WRITE(IOUT,110) XX,X(2),CDG*B1*SQRT(Y(1)),0.,0.,1.,X(1),SQRT((X(1)
     &**2*(B1+FMSQ*X(2)))/(G*((B1+FM1*X(2))*X(2))**3)),B1,FM1
      ENDIF  
      SQSTAR=0.
      QSTAR1=CDG*B1*SQRT(Y(1))
2     XZ=XX+1.
      IF(XZ.GT.FL) XZ=FL
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      QSTAR2=CDG*(B1+DB*XZ)*SQRT(Y(1))
      SQSTAR=SQSTAR+(XZ-XX)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-FL).LT. .001) THEN
      QQ=X(1)-SQSTAR
      B=B1+DB*XZ
      FM=FM1+DM*XZ
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ,SQRT(
     &(QQ**2*(B+2.*FM*Y(1)))/(G*((B+FM*Y(1))*Y(1))**3)),B,FM
110   FORMAT(F8.2,F8.3,F8.2,F8.3,'  betw.',F8.2,' &',F8.2,2F10.2,F7.3,
     &F6.3)
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.LT. FL-.001) GO TO 2
      F(2)=X(3)-Y(1)
      F(3)=X(1)-SQSTAR-Qd
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(3),F(3)
      LOGICAL DONE,UPST
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qd,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,
     &W,SQSTAR,QSTAR1,DB,DM,XXB,X,F,IPRNT,DONE,UPST,IOUT
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      B=B1+DB*XX
      FM=FM1+DM*XX
      P=B+2.*SQRT(FM*FM+1.)*YY
      A=(B+FM*YY)*YY
      IF(YY.LT.W) THEN
      QSTAR=0.
      ELSE
      QSTAR=CDG*B*SQRT(YY)
      ENDIF
      QQ=X(1)-SQSTAR-ABS(XXB-XX)*(QSTAR+QSTAR1)/2.
      SF=(FN*QQ/CC*(P/A)**.666666667/A)**2
      T=B+2.*FM*YY
      A3=A**3
      QQS=QQ*QQ
      FR1=1.-QQS*T/G/A3
      IF(ABS(FR1) .LT. .01) THEN
      DY(1)=0.
      ELSE
      DY(1)=(SO-SF+QQ*QSTAR/(G*A*A)+QQS/(G*A3)*(DB+YY*DM)*YY)/FR1
      ENDIF
      RETURN
      END