C Solves problem of flow from a gate to a hydraulic jump and then a known
C depth at the downstream end of the channel, i.e. this may be a free overfall.
      REAL F(3),D(3,3),X(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,FM,FL,TOL,FN,SO,CC,QN,Q2G,X,X1,DXX,B2,FM2,FM3,
     &FMS,YB,YE,NPRINT,NPRT,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B,FM,L,g,Q,YB,YE,DX'
      READ(*,*)IOUT,TOL,ERR,FN,SO,B,FM,FL,G,Q,YB,YE,DXX
      NPRINT=0
      NPRT=0
      IF(IOUT.EQ.6) NPRINT=1
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      WRITE(*,*)' GIVE guess for: x,Y1,Y2'
      READ(*,*) X
      B2=.5*B
      FM3=FM/3.
      Q2G=Q*Q/G
      FM2=2.*FM
      QN=(FN*Q/CC)**2
      FMS=2.*SQRT(FM*FM+1.)
      NCT=0
1     DO 10 I=1,3
      IF(NPRINT.GT.0) NPRT=1
      F(I)=FUN(I)
      WRITE(*,*) I,F(I)
      NPRT=0
      DO 10 J=1,3
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      FAC=D(3,1)/D(1,1)
      D(3,2)=D(3,2)-FAC*D(1,2)
      D(3,3)=D(3,3)-FAC*D(1,3)
      F(3)=F(3)-FAC*F(1)
      FAC=D(2,1)/D(1,1)
      D(2,2)=D(2,2)-FAC*D(1,2)
      D(2,3)=D(2,3)-FAC*D(1,3)
      F(2)=F(2)-FAC*F(1)
      FAC=D(3,2)/D(2,2)
      D(3,3)=D(3,3)-FAC*D(2,3)
      F(3)=F(3)-FAC*F(2)
      DIF1=F(3)/D(3,3)
      X(3)=X(3)-DIF1
      DIF=(F(2)-DIF1*D(2,3))/D(2,2)
      X(2)=X(2)-DIF
      SUM=ABS(DIF1)+ABS(DIF)
      DIF=(F(1)-D(1,2)*DIF-D(1,3)*DIF1)/D(1,1)
      SUM=SUM+ABS(DIF)
      X(1)=X(1)-DIF
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I5,E12.5,3F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      IF(NPRINT.EQ.0) THEN
      NPRT=1
      WRITE(IOUT,120) 0.,YB
120   FORMAT(F10.1,F10.3)
      F(1)=FUN(1)
      WRITE(IOUT,120) FL,YE
      F(2)=FUN(2)
      ENDIF
      WRITE(IOUT,100) X
100   FORMAT(' x =',F10.2,' Y1 =',F10.3,' Y2 =',F10.3)
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      REAL X(3),W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,FM,FL,TOL,FN,SO,CC,QN,Q2G,X,X1,DXX,B2,FM2,FM3,
     &FMS,YB,YE,NPRINT,NPRT,IOUT
      H1=-.05
      HMIN=.001
      IF(II.EQ.3) THEN
      FUN=B2*(X(2)**2-X(3)**2)+FM3*(X(2)**3-X(3)**3)+Q2G*(1./((B+FM*X(2)
     &)*X(2))-1./((B+FM*X(3))*X(3)))
      ELSE
      IF(II.EQ.1) THEN
      XX=0.
      XZ=XX+DXX
      Y(1)=YB
      ELSE
      XX=FL
      XZ=XX-DXX
      Y(1)=YE
      ENDIF
10    CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      IF(NPRT.GT.0) WRITE(IOUT,120) XZ,Y
120   FORMAT(F10.1,F10.3)
      XX=XZ
      IF(II.EQ.1) THEN
      IF(XZ.GE.X(1)) THEN
      FUN=X(2)-Y(1)
      RETURN
      ENDIF
      XZ=XZ+DXX
      IF(XZ.GT.X(1)) XZ=X(1)
      ELSE
      IF(XZ.LE.X(1)) THEN
      FUN=X(3)-Y(1)
      RETURN
      ENDIF
      XZ=XZ-DXX
      IF(XZ.LT. X(1)) XZ=X(1)
      ENDIF
      GO TO 10
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(3)
      COMMON /TRAS/B,FM,FL,TOL,FN,SO,CC,QN,Q2G,X,X1,DXX,B2,FM2,FM3,
     &FMS,YB,YE,NPRINT,NPRT,IOUT
10    P=B+FMS*Y(1)
      A=(B+FM*Y(1))*Y(1)
      DY(1)=(SO-QN*((P/A)**.6666667/A)**2)/(1.-Q2G*(B+FM2*Y(1))/A**3)
      RETURN
      END