C  Program to solve Depth through inlet structure
      PARAMETER (N=3)
      EXTERNAL DYX
      CHARACTER*2 UNK(N)/' Q','Yo','Yb'/
      REAL F(N),F1(N),D(N,N),X(N),Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,BB,FM,FN,BN,So,FL,G,G2,TOL,CC,QN,X,QG,DB,DM,F2,H,SB
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,H,b,bb,m,n,nb,So,Sob,L,g,Q,Yo,Yb'
      READ(*,*) IOUT,TOL,ERR,H,B,BB,FM,FN,BN,So,SB,FL,G,X
C H=Res. head; b=bot. w. of downstr. ch.; bb=bot w. of beg. of inlet structure
C m=side slope of downstr. ch.; n=for downstr. ch.; nb=n for inlet structure
C So=slope of downstr. ch.; Sob=bot. slope of inlet (beg.); L=length of inlet st.
C g=ac. of gravity;Q=guess for;Yo=guess for uniform depth;Yb=guess for Y at beg.
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      NCT=0
      DB=(BB-B)/FL
      DM=FM/FL
      F2=2.*SQRT(FM*FM+1.)
1     CALL FUN(F)
      DO 10 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(F1)
      DO 5 I=1,N
5     D(I,J)=(F1(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(N,1,N,D,F,1,DD,INDX)
      SUM=0.
      DO 15 I=1,N
      X(I)=X(I)-F(I)
15    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I2,' SUM=',E12.5,4F10.4)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      WRITE(IOUT,*)' Solution:'
      DO 20 I=1,N
20    WRITE(IOUT,100) UNK(I),X(I)
100   FORMAT(1X,A2,' =',F10.3)
      QG=X(1)**2/G
      QN=(BN*X(1)/CC)**2
      Y(1)=X(2)
      XX1=FL
      WRITE(IOUT,120) FL,Y(1),Y(1)+QG/(2.*((B+FM*Y(1))*Y(1))**2),B,FM
      DO 30 I=1,10
      XX=(1.-.1*FLOAT(I))*FL
      CALL ODESOL(Y,DY,1,XX1,XX,TOL,H1,HMIN,1,XP,YP,W,DYX)
      BX=BB-DB*XX
      FMX=DM*XX
      P=BX+2.*SQRT(FMX*FMX+1.)*Y(1)
      A=(BX+FMX*Y(1))*Y(1)
      WRITE(IOUT,120) XX,Y(1),Y(1)+QG/(2.*A**2),BX,FMX,A,P
120   FORMAT(7F10.3)
30    XX1=XX
      END
      SUBROUTINE FUN(F)
      EXTERNAL DYX
      REAL X(3),F(3),W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B,BB,FM,FN,BN,So,FL,G,G2,TOL,CC,QN,X,QG,DB,DM,F2,H,SB
      H1=-.1
      HMIN=.00001
      QG=X(1)**2/G
      QN=(BN*X(1)/CC)**2
      Y(1)=X(2)
      CALL ODESOL(Y,DY,1,FL,0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      F(3)=X(3)-Y(1)
      F(1)=FN*X(1)*(B+X(2)*F2)**.6666667-CC*SQRT(So)*((B+FM*X(2))*X(2))
     &**1.66666667
      F(2)=H-X(3)-(X(1)/(BB*X(3)))**2/G2
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(3)
      COMMON /TRAS/B,BB,FM,FN,BN,So,FL,G,G2,TOL,CC,QN,X,QG,DB,DM,F2,H,SB
      BX=BB-DB*XX
      FMX=DM*XX
      P=BX+2.*SQRT(FMX*FMX+1.)*Y(1)
      A=(BX+FMX*Y(1))*Y(1)
      DA=((DM*Y(1)-DB)*Y(1))/A**3
      DY(1)=(SB-QN*((P/A)**.6666667/A)**2+QG*DA)/(1.-QG*(BX+2.*FMX*Y(1))
     &/A**3)
      RETURN
      END