C Solves problem of lateral outflow from a side weir in a mild channel.
C The flow is assumed to be subcritical at beginning of side weir and downstream
C channel is mild and contains: 1-gate, 2-critical flow, 3- reser, or 4- normal
C depth.  Unknowns: Qd (downstream flowrate), Y1 (depth at beginning of side weir),
C Y21 (depth at beg. of channel 2) & Y22 (depth at end of channel 2)
      LOGICAL DONE
      INTEGER*2 INDX(4)
      REAL F(4),D(4,4),X(4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XX,X,IPRNT,DONE,IOUT,Ygd,FL2,ITBC
      EQUIVALENCE (Qd,X(1)),(Y1,X(2)),(Y21,X(3)),(Y22,X(4))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,Qu,FN,SO,B1,FM1,B2,FM2,L,W,Cd,g,PRNT
     &,Ygd,FL2,ICTL'
      READ(*,*) IOUT,TOL,ERR,Qu,FN,SO,B1,FM1,B2,FM2,FL,W,Cd,G,IPRNT,Ygd,
     &FL2,ICTL
      DONE=.FALSE.
      FMSQ=2.*SQRT(FM2*FM2+1.)
      DB=(B1-B2)/FL
      DM=(FM1-FM2)/FL
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      CS=CC*SQRT(SO)
      G2=2.*G
      CDG=Cd*SQRT(G2)
      WRITE(*,*)' GIVE guess for: Qd,Y1,Y21,Y22'
      READ(*,*) X
      NCT=0
1     CALL FUN(F)
      DO 10 J=1,4
      DX=.005*X(J)
      X(J)=X(J)+DX
      CALL FUN(FFF)
      DO 9 I=1,4
9     D(I,J)=(FFF(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,4
20    SUM=SUM+ABS(F(I))
      WRITE(*,*)' Give Mult. factor  SUM=',SUM,' F=',F
      READ(*,*) FAC
      DO 21 I=1,4
      IF(I.EQ.1) THEN
      X(I)=X(I)-.5*(1.+FAC)*F(I)
      ELSE
      X(I)=X(I)-FAC*F(I)
      ENDIF
21    CONTINUE
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,4F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      DONE=.TRUE.
      CALL FUN(F)
      WRITE(IOUT,100) X
100   FORMAT(' Qd =',F10.2,' Y1 =',F10.3,' Y21 =',F10.3,' Y22 =',F10.3)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX,DYXD
      REAL X(4),WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XX,X,IPRNT,DONE,IOUT,Ygd,FL2,ITBC
      H1=-.05
      HMIN=.00001
      GO TO(1,2,3,4) ITBC
1     F(1)=X(4)-(X(1)/((B2+FM2*X(4))*X(4)))**2/G2-Ygd-(X(1)/((B2+FM2*Ygd
     &)*Ygd))**2/G2
      GO TO 5
2     F(1)=X(1)**2*(B2+2.*FM2*X(4))-(G*((B2+FM2*X(4))*X(4))**3)
      GO TO 5
3     F(1)=X(4)-Ygd
      GO TO 5
4     F(1)=FN*X(1)*(B2+FMSQ*X(3))**.666666667-CS*((B2+FM2*X(3))*X(3))**
     &1.6666667
5     Y(1)=X(3)
      XX=FL
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
100   FORMAT('     x       Y    acc. q*  av. q*           X1        X2',
     &/,1X,57('-'))
      ENDIF  
      SQSTAR=0.
      IF(Y(1).LT.W) THEN
      QSTAR1=0.
      ELSE
      QSTAR1=CDG*(Y(1)-W)**1.5
      ENDIF
10    XZ=XX-1.
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(Y(1).LT.W) THEN
      QSTAR2=0.
      ELSE
      QSTAR2=CDG*(Y(1)-W)**1.5
      ENDIF
      SQSTAR=SQSTAR+(XX-XZ)*(QSTAR1+QSTAR2)/2.
      QSTAR1=QSTAR2
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. XZ.LT. .001) THEN    
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ
110   FORMAT(F8.2,F8.3,2F8.3,'  betw.',F8.2,' &',F8.2)
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      XX=XZ
      IF(XZ.GT. .001) GO TO 10
      F(2)=X(2)-Y(1)
      F(3)=Qu-X(1)-SQSTAR
      IF(ITBC.EQ.4) THEN
      F(4)=X(3)-X(4)
      ELSE
      Y(1)=X(4)
      IF(ITBC.EQ.2) Y(1)=1.1*Y(1)
      CALL ODESOL(Y,DY,1,FL2,0.,TOL,H1,HMIN,1,XP,YP,WW,DYXD)
      F(4)=X(3)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(4)
      LOGICAL DONE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XXB,X,IPRNT,DONE,IOUT,Ygd,FL2,ITBC
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      B=B1+DB*XX
      FM=FM1+DM*XX
      P=B+2.*SQRT(FM*FM+1.)*YY
      A=(B+FM*YY)*YY
      IF(YY.LT.W) THEN
      QSTAR=0.
      ELSE
      QSTAR=CDG*(YY-W)**1.5
      ENDIF
      QQ=X(1)+SQSTAR+ABS(XXB-XX)*(QSTAR+QSTAR1)/2.
      SF=(FN*QQ/CC*(P/A)**.666666667/A)**2
      T=B+2.*FM*YY
      A3=A**3
      QQS=QQ*QQ
      DY(1)=(SO-SF+QQ*QSTAR/(G*A*A)+QQS/(G*A3)*(DB+YY*DM)*YY)/
     &(1.-QQS*T/G/A3)
      RETURN
      END
      SUBROUTINE DYXD(XX,Y,DY)
      REAL Y(1),DY(1),X(4)
      LOGICAL DONE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,FL,TOL,FN,SO,CC,FMSQ,CS,CDG,W,
     &SQSTAR,QSTAR1,DB,DM,XXB,X,IPRNT,DONE,IOUT,Ygd,FL2,ITBC
      A=(B2+FM2*Y(1))*Y(1)
      SF=(FN*X(1)*((B2+FMSQ*Y(1))/A)**.666667/A)**2
      DY(1)=(SO-SF)/(1.-X(1)**2*(B2+2.*FM2*Y(1))/(G*A**3))
      RETURN
      END