C Channel system is supplied by a submerged gate at the upstream reservoir.
C At this upstream gate there are 4 rather than the usual 5 equations.
C  (Unknowns here are: V(1,1)=1 or V(2,1)=H, Y,Y3,Yd)
C With the upstream gate there are an equal number of gates and channels
C Notice different order of variables in V(*,I) than in SUBMESER
      COMMON NGOOD,NBAD,KMAX,KCOUNT,DXSAVE
      COMMON/TRAS/V(5,10),YG(10),BG(10),B(11),FM(11),FN(11),FL(11),
     &So(11),FKE,TOL,QN,HMIN,H1,SOC,BC,FMC,FMS,FM2,Q2G,Y1,YE,G,Cu,
     &G2,NGATE,IBCE,NEQ,IUNQ
      REAL FF(57),F(57),DJ(57,57)
      INTEGER*2 INDX(57)
C  If IUNQ=0, then Q is unknown; if IUNQ=1 then H is unknown.
      READ(2,*) NGATE,IBCE,G,Q,H,FKE,YE,TOL,IUNQ,WT
C For each gate V(1,I)=Yu, V(2,I)=Y1, V(3,I)=Y, V(4,I)=Y3, V(5,I)=Yd
C IBCE=1 (Long downstream channel so YE is uniform depth & V(5,NGATE)=YE
C IBCE=2 (Downstream reservoir with w.s. elevation = YE (specified))
C IBCE=3 (Critical depth at end of channel NGATE, YE = Critical depth)
C YG are heights of gates above bottom, Y2 is obtained by multiplying a Cc
C for submerged gate from by YG.
      READ(2,*)(YG(I),BG(I),I=1,NGATE)
      READ(2,*)(B(I),FM(I),FN(I),FL(I),So(I),I=1,NGATE)
C  Guesses depths Y1,Y,Y3 for each gate
      DO 10 I=1,NGATE
      READ(2,*) V(2,I),V(3,I),V(4,I)
      V(5,I)=1.005*V(4,I)
10    V(1,I)=1.005*V(2,I)
      V(1,1)=Q
      V(2,1)=H
      IF(G.LT.25.) THEN
      Cu=1
      ELSE
      Cu=1.486
      ENDIF
      G2=2.*G
      Q2G=Q*Q/G2
      FKE=1.+FKE
      H1=-.05
      HMIN=.0005
      NEQ=5*NGATE-1
      IF(IBCE.EQ.3) NEQ=NEQ+1
      NCT=0
20    SUM=0.
      CALL FUNCT(F)
      JJ=2
      DO 42 I=1,NGATE
      DO 40 J=JJ,5
      JI=J
      IF(I.EQ.1 .AND. J.EQ.2) JI=IUNQ+1
      IJ=5*(I-1)+J-1
      XX=V(JI,I)
      V(JI,I)=1.005*XX
      CALL FUNCT(FF)
      DO 30 K=1,NEQ
30    DJ(K,IJ)=(FF(K)-F(K))/(V(JI,I)-XX)
40    V(JI,I)=XX
42    JJ=1
      IF(IBCE.GT.2) THEN
      XX=YE
      YE=1.005*YE
      CALL FUNCT(FF)
      DO 55 K=1,NEQ
55    DJ(K,NEQ)=(FF(K)-F(K))/(YE-XX)
      YE=XX
      ENDIF
      CALL SOLVEQ(NEQ,1,57,DJ,F,1,DD,INDX)
      JJ=2
      DO 62 I=1,NGATE
      DO 60 J=JJ,5
      JI=J
      IF(I.EQ.1 .AND. J.EQ.2) JI=IUNQ+1
      IJ=5*(I-1)+J-1
      V(JI,I)=V(JI,I)-WT*F(IJ)
60    SUM=SUM+ABS(F(IJ))
62    JJ=1
      IF(IBCE.EQ.3) THEN
      YE=YE-F(NEQ)
      SUM=SUM+ABS(F(NEQ))
      ENDIF
      NCT=NCT+1 
      WRITE(*,200) NCT,SUM,((V(J,I),J=1,5),I=1,NGATE)
200   FORMAT(' NCT=',I4,' SUM=',E12.3,/(10F8.3))
      IF(WT.LT.1.) THEN
      WRITE(*,*)' Current Weight factor=',WT,' Give new one'
      READ(*,*) WT
      ENDIF
      IF(NCT.LT.40 .AND. SUM.GT. 1.E-4) GO TO 20
      DO 70 I=1,NGATE
70    WRITE(3,100) I,(V(J,I),J=1,5)
100   FORMAT(I4,5F8.3)
      END
      SUBROUTINE FUNCT(F)
      REAL F(57)
      COMMON NGOOD,NBAD,KMAX,KCOUNT,DXSAVE
      COMMON/TRAS/V(5,10),YG(10),BG(10),B(11),FM(11),FN(11),FL(11),
     &So(11),FKE,TOL,QN,HMIN,H1,SOC,BC,FMC,FMS,FM2,Q2G,Y1,YE,G,Cu,
     &G2,NGATE,IBCE,NEQ,IUNQ
      REAL Y(1),DY(1),W(1,13),XP(1),YP(1,1)
      EXTERNAL DYX
      DO 10 I=1,NGATE
      IF(I.EQ.1 .AND. IUNQ.EQ.0) Q2G=V(1,1)**2/G2
      BC=B(I)
      FMC=FM(I)
      FM2=2.*FM(I)
      FMS=2.*SQRT(FM(I)**2+1.)
      SOC=So(I)
      QS1=Q2G/BG(I)**2
      QMG=2.*QS1
      QN=(FN(I)*V(1,1)/Cu)**2
      Y2=(.59+.022*YG(I)/V(2,I))*YG(I)
      IF(I.EQ.1) THEN
      H11=V(2,1)
      IG=-1
      ELSE
      IG=5*(I-1)-1
      H11=V(2,I)+QS1/V(2,I)**2
      F(IG+1)=V(1,I)+Q2G/((BC+FMC*V(1,I))*V(1,I))**2-H11
      ENDIF
      F(IG+2)=H11-V(3,I)-QS1/Y2**2
      F(IG+3)=.5*(V(3,I)**2-V(4,I)**2)+QMG/Y2-QMG/V(4,I)
      F(IG+4)=V(4,I)+QS1/V(4,I)**2-V(5,I)-Q2G/((B(I)+FM(I)*V(5,I))*V(5,I
     &))**2
      IF(I.EQ.NGATE) GO TO 10
      Y(1)=V(1,I+1)
      CALL ODESOL(Y,DY,1,FL(I),0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      F(IG+5)=V(5,I)-Y(1)
10    CONTINUE
      IF(IBCE.EQ.1) THEN
      F(NEQ)=FN(NGATE)*V(5,1)*(B(NGATE)+2.*V(5,NGATE)*SQRT(FM(NGATE)**2+
     &1.))**.66666667-Cu*((B(NGATE)+FM(NGATE)*V(5,NGATE))*V(5,NGATE))**
     &1.666667*SQRT(So(NGATE))
      ELSE
      Y(1)=YE
      IF(IBCE.EQ.3) F(NEQ-1)=.5*Q2G*(B(NGATE)+2.*FM(NGATE)*YE)-G*((B(
     &NGATE)+FM(NGATE)*YE)*YE)**3
      BC=B(NGATE)
      FMC=FM(NGATE)
      FM2=2.*FM(NGATE)
      FMS=2.*SQRT(FM(NGATE)**2+1.)
      SOC=So(NGATE)
      QN=(FN(NGATE)*V(1,1)/Cu)**2
      CALL ODESOL(Y,DY,1,FL(NGATE),0.,TOL,H1,HMIN,1,XP,YP,W,DYX)
      F(NEQ)=V(5,NGATE)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(X,Y,DY)
      REAL Y(1),DY(1)
      COMMON/TRAS/V(5,10),YG(10),BG(10),B(11),FM(11),FN(11),FL(11),
     &So(11),FKE,TOL,QN,HMIN,H1,SOC,BC,FMC,FMS,FM2,Q2G,Y1,YE,G,Cu,
     &G2,NGATE,IBCE,NEQ,IUNQ
      P=BC+FMS*Y(1)
      A=(BC+FMC*Y(1))*Y(1)
      SF=QN*((P/A)**.6666667/A)**2
      DY(1)=(SOC-SF)/(1.-2.*Q2G*(BC+FM2*Y(1))/A**3)
      RETURN
      END