C  Designed to handle trapezoidal channels using stage variable w.
C  Allows for the specific energy at downstream end to be specified
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV
     &,ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM,G2
      REAL XI(15),YI(15)
      INTEGER*2 IBOT(0:31)
      LOGICAL*2 LOWBOU
      DATA IN,IOUT/2,3/
      READ(IN,*) N,NPTS,Q,FN,SO,B,FM,G,FL,EK1,H
      READ(IN,*)(XI(I),YI(I),I=N,1,-1)
      READ(IN,*) ITYPE,MGIV,(GIVTIM(I),GIVDWS(I),I=1,MGIV)
      G2=2.*G
      IGIV=MGIV/2
      NPTM=NPTS-1
      CN=FN
      IF(G.GT.30.) CN=CN/1.486
      FM2=2.*FM
      FMS=2.*SQRT(FM*FM+1.)
      SO2=2.*SO
      EK1=(1.+EK1)/(2.*G)
      GBM=SQRT(G*B/FM)
      DELX=FL/FLOAT(N-1)
      CALL STAGE
      II=1
      J=1
      NT=0
      IBOT(0)=1
      DO 10 I=N,1,-1
      A=(B+FM*YI(I))*YI(I)
      X(J)=XI(I)
      Y(J)=YI(I)
      V(J)=Q/A
      C(J)=SQRT(G*A/(B+FM2*YI(I)))
      W(J)=GBM*FNTERP(FM*Y(J)/B)
      T(J)=0.
      SF(J)=(CN*V(J)*((B+FMS*YI(I))/A)**.66666667)**2
      J=J+II
      IF(J.GT. NPTS) THEN  
      NT=N-I
      JBOT=IBOT(NT)
      GO TO 30
      ENDIF
      IBOT(N+1-I)=J
10    II=II+2
      II=II-2
      JBOT=IBOT(N-1)
      DELT=(XI(N)-XI(N-1))/(V(1)+C(1))
      DO 20 I=N+1,30
      IBOT(I)=IBOT(I-1)+II
      NT=I
      IF(IBOT(I).GT.NPTS) GO TO 30
20    CONTINUE
30    IF(NT.GT. 30) THEN
      WRITE(*,*)' Exceeded dim. of IBOT'
      STOP
      ENDIF
      IBOT(NT)=NPTS+1
      LOWBOU=.TRUE.
      III=0
      DO 50 I=1,NT
      II1=IBOT(I)
      IIP=II1+1
      II2=IBOT(I+1)-1
      IF(II2.GT.NPTM) THEN
      II2=NPTS+1
      LOWBOU=.FALSE.
      ENDIF
      IF(II1.GT.JBOT) THEN
      CALL BOUNDY(IBOT(I-1)+1,II1)
      QQ=V(II1)*(B+FM*Y(II1))*Y(II1)
      WRITE(*,109) II1,X(II1),T(II1),Y(II1),V(II1),QQ,C(II1),W(II1),
     &SF(II1)
      III=2
      ENDIF
      DO 40 J=IIP,II2-1
      CALL REGUL(J-1,IBOT(I-1)+J-IIP+III,J)
      QQ=V(J)*(B+FM*Y(J))*Y(J)
40    WRITE(*,109) J,X(J),T(J),Y(J),V(J),QQ,C(J),W(J),SF(J)
      IF(II2.GT.NPTS) GO TO 55
      IF(LOWBOU) CALL BOUNDY(II2-1,II2)
      QQ=V(II2)*(B+FM*Y(II2))*Y(II2)
      WRITE(*,109) II2,X(II2),T(II2),Y(II2),V(II2),QQ,C(II2),W(II2),
     &SF(II2)
50    CONTINUE
55    WRITE(IOUT,100)
100   FORMAT(' Pt.',6X,'x',8X,'t',6X,'Y',6X,'V',6X,'E',8X,'Q',8X,'c',8X,
     &'w',7X,'Sf',/,1X,79('-'))
      DO 60 I=1,NPTS
      QQ=V(I)*(B+FM*Y(I))*Y(I)
      E=V(I)**2/G2+Y(I)
60    WRITE(IOUT,110) I,X(I),T(I),Y(I),V(I),E,QQ,C(I),W(I),SF(I)
      IF(IOUT.NE.6.OR.IOUT.NE.0) CLOSE(IOUT)
110   FORMAT(I4,2F9.1,3F7.3,3F9.3,F9.6)
109   FORMAT(I4,7F9.3,F9.6)
      STOP
      END
      SUBROUTINE REGUL(IL,IR,I)
      PARAMETER (NEQS=5)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV
     &,ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM,G2
      NCT=0
      XX=DELX*(C(IL)+V(IL))/C(IL)/2.
      Va(1)=X(IL)+XX
      Va(2)=.5*(T(IL)+T(IR))+XX/(C(IL)+V(IL))
      Va(3)=.5*(C(IL)+C(IR))
      Va(4)=.5*(V(IL)+V(IR))
      Va(5)=.5*(Y(IL)+Y(IR))
15    CALL FUNCT(0,IL,IR,DV)
      DO 20 J=1,NEQS
20    F1(J)=F(J)
      DO 22 J=1,NEQS
      CALL FUNCT(J,IL,IR,DV)
      DO 22 J1=1,NEQS
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQS-1
      DO 30 M=NEQS,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQS
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQS
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(NEQS)=Va(NEQS)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQS
32    SUM=SUM+Z(J)*D(M1,J)
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
72    NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .0001) GO TO 15
      IF(NCT.EQ.20) WRITE(*,211) I,DIF,Va
211   FORMAT(' Not converge-pt',I4,E10.3,5F10.3)
      X(I)=Va(1)
      T(I)=Va(2)
      C(I)=Va(3)
      V(I)=Va(4)
      Y(I)=Va(5)
      W(I)=GBM*FNTERP(FM*Va(5)/B)
      SF(I)=(CN*Va(4)*((B+FMS*Va(5))/((B+FM*Va(5))*Va(5)))**.6666667)**2
      RETURN
      END
      SUBROUTINE FUNCT(J,IL,IR,DV)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV
     &,ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM,G2
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      Va(J)=Va(J)+DV
      ENDIF
      AM=(B+FM*Va(5))*Va(5)
      F(1)=Va(1)-X(IL)-.5*(Va(2)-T(IL))*(Va(4)+Va(3)+V(IL)+C(IL))
      SFM=(CN*Va(4)*((B+FMS*Va(5))/AM)**.66666667)**2
      F(2)=Va(4)+GBM*FNTERP(FM*Va(5)/B)-V(IL)-W(IL)-.5*(Va(2)-T(IL)
     &)*(G*(SO2-SFM-SF(IL)))
      F(3)=Va(1)-X(IR)-.5*(Va(2)-T(IR))*(Va(4)-Va(3)+V(IR)-C(IR))
      F(4)=AM/(B+FM2*Va(5))-Va(3)**2/G
      F(5)=Va(4)-GBM*FNTERP(FM*Va(5)/B)-V(IR)+W(IR)-.5*(Va(2)-T(IR)
     &)*(G*(SO2-SFM-SF(IR)))
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END
      FUNCTION FNTERP(YP)
      COMMON /CSTAGE/ W(400)
      FI=200.*(YP-.01)+1.
      II=FI
      FNTERP=W(II)+(FI-FLOAT(II))*(W(II+1)-W(II))
      RETURN
      END
      SUBROUTINE STAGE
      COMMON /CSTAGE/ W(400)
      FC(YP)=SQRT((1.+2.*YP)/(YP+YP*YP))
      DY=.005
      DY1=DY/10.
      DYH=DY1/2.
      N=(2.-.01)/DY+2
      YP=.01
      RC=FC(.01)
      W(1)=.138
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      YP=YP+DY1
      RC1=FC(YP)
      SUM=SUM+DYH*(RC+RC1)
5     RC=RC1
10    W(I)=W(I-1)+SUM
      RETURN
      END
      SUBROUTINE BOUNDY(II,I)
      PARAMETER (NEQS=3)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV
     &,ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM,G2
      LOGICAL*2 UPSTRB
      IF(II.EQ.I-1) THEN
      UPSTRB=.FALSE.
      ELSE
      UPSTRB=.TRUE.
      ENDIF
      NCT=0
      Va(1)=T(II)+DELT
      Va(2)=V(II)
      Va(3)=Y(II)
15    IF(UPSTRB) THEN
      CALL FUNUPS(0,II,DV)
      ELSE
      CALL FUNDNS(0,II,DV)
      ENDIF
      DO 20 J=1,NEQS
20    F1(J)=F(J)
      DO 22 J=1,NEQS
      IF(UPSTRB) THEN
      CALL FUNUPS(J,II,DV)
      ELSE
      CALL FUNDNS(J,II,DV)
      ENDIF
      DO 22 J1=1,NEQS
22    D(J1,J)=(F(J1)-F1(J1))/DV
      DO 30 L=1,NEQS-1
      DO 30 M=NEQS,L+1,-1
      IF(ABS(D(M,L)).LT. 1.E-15) GO TO 30
      FAC=D(M,L)/D(L,L)
      F1(M)=F1(M)-FAC*F1(L)
      DO 28 J=L+1,NEQS
28    D(M,J)=D(M,J)-FAC*D(L,J)
30    CONTINUE
      M=NEQS
      Z(M)=F1(M)/D(M,M)
      DIF=ABS(Z(M))
      Va(NEQS)=Va(NEQS)-Z(M)
31    M1=M-1
      SUM=0.
      DO 32 J=M,NEQS
32    SUM=SUM+Z(J)*D(M1,J)
      Z(M1)=(F1(M1)-SUM)/D(M1,M1)
      M=M1
      Va(M)=Va(M)-Z(M)
      DIF=DIF+ABS(Z(M))
      IF(M.GT.1) GO TO 31
      NCT=NCT+1
      IF(NCT.LT.20 .AND. DIF.GT. .0001) GO TO 15
      IF(NCT.EQ.20) WRITE(*,211) I,DIF,(Va(J),J=1,NEQS)
211   FORMAT(' Not converge-BOUNDARY',I4,E10.3,5F10.3)
      IF(UPSTRB) THEN
      X(I)=0.
      ELSE
      X(I)=FL
      ENDIF
      T(I)=Va(1)
      V(I)=Va(2)
      Y(I)=Va(3)
      C(I)=SQRT(G*(B+FM*Y(I))*Y(I)/(B+FM2*Y(I)))
      W(I)=GBM*FNTERP(FM*Y(I)/B)
      SF(I)=(CN*V(I)*((B+FMS*Y(I))/((B+FM*Y(I))*Y(I)))**.6666667)**2
      RETURN
      END
      SUBROUTINE FUNUPS(J,IR,DV)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV
     &,ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM,G2
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      Va(J)=Va(J)+DV
      ENDIF
      AM=(B+FM*Va(3))*Va(3)
      CB=SQRT(G*AM/(B+FM2*Va(3)))
      F(1)=X(IR)+.5*(Va(1)-T(IR))*(Va(2)-CB+V(IR)-C(IR))
      SFM=(CN*Va(2)*((B+FMS*Va(3))/AM)**.66666667)**2
      F(2)=Va(2)-GBM*FNTERP(FM*Va(3)/B)-V(IR)+W(IR)-.5*(Va(1)-T(IR))*(G*
     &(SO2-SFM-SF(IR)))
      F(3)=H-Va(3)-EK1*Va(2)**2
      IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END
      SUBROUTINE FUNDNS(J,IL,DV)
      COMMON X(200),T(200),V(200),W(200),Y(200),C(200),SF(200),Z(5),Va(5
     &),F(5),F1(5),D(5,5),FMS,FM2,CN,FN,Q,SO2,B,FM,G,FL,H,EK1,IGIV,MGIV
     &,ITYPE,GIVDWS(10),GIVTIM(10),DELT,DELX,GBM,G2
      IF(J.GT.0) THEN
      DV=.001*Va(J)
      Va(J)=Va(J)+DV
      ENDIF
      AM=(B+FM*Va(3))*Va(3)
      CB=SQRT(G*AM/(B+FM2*Va(3)))
      F(1)=FL-X(IL)-.5*(Va(1)-T(IL))*(Va(2)+CB+V(IL)+C(IL))
      SFM=(CN*Va(2)*((B+FMS*Va(3))/AM)**.66666667)**2
      F(2)=Va(2)+GBM*FNTERP(FM*Va(3)/B)-V(IL)-W(IL)-.5*(Va(1)-T(IL))*(G*
     &(SO2-SFM-SF(IL)))
10    IF(Va(1).LE.GIVTIM(IGIV) .OR. IGIV.EQ.MGIV) GO TO 20
      IGIV=IGIV+1
      GO TO 10
20    IF(Va(1).GE.GIVTIM(IGIV-1) .OR. IGIV.EQ.2) GO TO 30
      IGIV=IGIV-1
      GO TO 20
30    GIVB=(Va(1)-GIVTIM(IGIV-1))/(GIVTIM(IGIV)-GIVTIM(IGIV-1))*(GIVDWS(
     &IGIV)-GIVDWS(IGIV-1))+GIVDWS(IGIV-1)
      GO TO (40,50,60,65),ITYPE
40    F(3)=Va(3)-GIVB
      GO TO 70
50    F(3)=Va(2)-GIVB
      GO TO 70
60    F(3)=Va(2)*AM-GIVB
      GO TO 70
65    F(3)=Va(3)+Va(2)**2/G2-GIVB
70    IF(J.GT.0) Va(J)=Va(J)-DV
      RETURN
      END