C Numerically solve ODE with N & M of Varied-Flow-Function evaluated within
C  subroutine SLOPE corresponding to any given Y.
C This program is a modified version of VARFUNY1.FOR that uses Chezy's eq.
      REAL Y(1),YTT(1)
      EXTERNAL EQUAT
      COMMON YO,YC,EN,EM,SO,Q,e,SQG,SQG32,FNQ,C,B,FM,G,SM
      WRITE(*,*) 'Give the kinematic viscosity'
      READ(*,*) VISC
      WRITE(*,*)' IOUT,N,X1,X2,Y1,e,So,b,m,Q,g' ! N=No. of steps
      READ(*,*) IOUT,N,X1,X2,Y1,e,SO,B,FM,Q,G
      SM=2.*SQRT(FM*FM+1.)
      FM2=2.*FM
      SS=SQRT(SO)
      DELX=(X2-X1)/FLOAT(N)
      DXS=.1*DELX
      C=100.
      IF(G.LT.20.) C=70.
      SQG=.884/SQRT(G)
      SQG32=-SQRT(32.*G)
      FNQ=4.*Q/VISC
      YO=(.01*Q/(1.5*B)/SS)**.6
10    A=(B+FM*YO)*YO
      P=B+SM*YO
      Rh=A/P
      Re=FNQ/P
1     C1=C
      C=SQG32*ALOG10(e*P/(12.*A)+SQG*C1/Re)
      IF(ABS(C-C1).GT. .0001) GO TO 1
      F=C*SS*A*SQRT(Rh)-Q
      DF=C*SS*(1.5*SQRT(Rh)*(b+FM2*YO)-.5*Rh**1.5*SM)
      YO=YO-F/DF
      IF(ABS(F/DF).GT. .000001) GO TO 10
      YC=((Q/(1.5*B))**2/G)**.333333333
20    A=(B+FM*YC)*YC
      T=B+2.*FM*YC
      F=Q*Q*T-G*A**3
      DF=2.*Q*Q*FM-3.*G*T*A*A
      YC=YC-F/DF
      IF(ABS(F/DF).GT. .000001) GO TO 20
      WRITE(IOUT,100) YO,YC
100   FORMAT(' Yo=',F10.3,'  Yc=',F10.3,/,1X,58('-')/5X,'Pos., x  Depth,
     &Y    S. Energy,E  Momentum,M      C',/1X,58('-'))
      A=(B+FM*Y1)*Y1
      WRITE(IOUT,110) X1,Y1,Y1+(Q/A)**2/(2.*G),(.5*B+FM*Y1/3.)*Y1*Y1+Q*Q
     &/G/A,C
      Y(1)=Y1
      DO 40 I=1,N
      XB=X1+DELX*FLOAT(I-1)
      XE=XB+DELX
      CALL RUKUST(1,DXS,XB,XE,1.E-5,Y,YTT)
      Y1=Y(1)
      A=(B+FM*Y1)*Y1
40    WRITE(IOUT,110) XE,Y1,Y1+(Q/A)**2/(2.*G),(.5*B+FM*Y1/3.)*Y1*Y1+Q*Q
     &/G/A,C
110   FORMAT(F12.2,3F12.3,F10.2)
      END
      SUBROUTINE SLOPE(X,Y,DYX)
      REAL Y(1),DYX(1)
      COMMON YO,YC,EN,EM,SO,Q,e,SQG,SQG32,FNQ,C,B,FM,G,SM
      A=(B+FM*Y(1))*Y(1)
      P=B+SM*Y(1)
      Rh=A/P
      Re=FNQ/P
1     C1=C
      C=SQG32*ALOG10(e*P/(12.*A)+SQG*C1/Re)
      IF(ABS(C-C1).GT. .0001) GO TO 1
      SF=(Q/(C*A))**2*Rh
      EN=ALOG(SF/SO)/ALOG(YO/Y(1))
      EM=ALOG(Q*Q*(B+2.*FM*Y(1))/(G*A**3))/ALOG(YC/Y(1))
      DYX(1)=SO*(1.-(YO/Y(1))**EN)/(1.-(YC/Y(1))**EM)
      RETURN
      END