C  Uses an explicit method to solve a moving wave upstream from a gate (DCW)
C This program is similar to WAVEMOV.FOR with the exception that Chezy's eq.
C is used rather than Mannings eq.
      LOGICAL NFS
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,C,e,QN,FMS,
     &FM2,Q,A1,V1,HCA1,K,Ye,DIST,VISC,SG,SQG
      REAL X(4),F(4),F1(4),D(4,4),Yo(15),YSTOR(16),Y(1),DY(1),XP(1),
     &YP(1,1),W(1,13)
      INTEGER*2 INDX(4)
      EQUIVALENCE (v,X(1)),(Y2,X(2)),(Qe,X(4))
      WRITE(*,*)' Give kinematic viscosity'
      READ(*,*) VISC
      WRITE(*,*)' For initial condition give: g,H,Ke,Cc,Yg,L,e,b,m,So, G
     &uess for Q,Y1,Y2'
      H11=-.5
      HMIN=1.E-5
      TOL=1.E-5
      READ(*,*) G,H,FKe,Cc,Yg,FL,e,B,FM,So,Q,Y2,X(3)
      FKe=FKe+1.
      X(1)=Q
      FMS=2.*SQRT(FM*FM+1.)
      FM2=2.*FM
      Yd=Cc*Yg
      G2=2.*G
      Ad=((b+FM*Yd)*Yd)**2*G2
      Ad1=Ad
      e=e/12.
      SG=SQRT(G)
      SQG=-SQRT(32.*G)
      C=SQG*ALOG10(e/(((B+FM*Y2)*Y2)/(B+FMS*Y2)))
C  Q=X(1); Yb (upstream)=X(2); Ye (downstream)= X(3)
      NCT=0
10    SUM=0.
      QN=4.*X(1)/VISC
      CALL FUN1(F,X)
      DO 12 I=1,3
      XX=X(I)
      X(I)=1.005*X(I)
      IF(I.EQ.1) QN=4.*X(1)/VISC
      CALL FUN1(F1,X)
      DO 11 J=1,3
11    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
12    X(I)=XX
      QN=4.*X(1)/VISC
      CALL SOLVEQ(3,1,4,D,F,1,DD,INDX)
      DO 14 I=1,3
      X(I)=X(I)-F(I)
14    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      IF(SUM.GT.5.E-5 .AND. NCT.LT.20) GO TO 10
      WRITE(3,130)(X(I),I=1,3)
130   FORMAT(' Steady-State Q=',F8.1,',  Y1=',F8.3,',  Ye=',F8.3)
      QN=4.*X(1)/VISC
      Ye=X(3)
      Y(1)=X(3)
      Yo(15)=X(3)
      Q1=X(1)
      DL=FL/14.
      XX=FL
      NFS=.TRUE.
      DO 16 I=14,1,-1
      XX1=XX-DL
      CALL ODESOLF(Y,DY,1,XX,XX1,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      NFS=.FALSE.
      XX=XX1
16    Yo(I)=Y(1)
      WRITE(3,100) (DL*FLOAT(I-1),Yo(I),I=15,1,-1)
100   FORMAT(' Initial Condition (x,Y)',/,8(F8.0,F8.3),/,7(F8.0,F8.3))
      WRITE(*,*)' Give:No. time steps,Dt,New Yg'
      READ(*,*) NT,DT,Yg
C  v=X(1); Y2=X(2); Ye=X(3); Q2=X(4)
      Yd=Cc*Yg
      Ad=((B+FM*Yd)*Yd)**2*G2
      X(4)=Q1*SQRT(Ad/Ad1)
      X(3)=1.2*Yo(15)
      X(2)=.95*X(3)
      X(1)=1.2*SQRT(G*(B+FM*X(3))*X(3)/(B+FM2*X(3)))
      DIST=FL-.1
      H11=-.5
      WRITE(3,111)
111   FORMAT(/,'   Time    x        v       Y2      Ye     Q        Y1  
     &    V1     C',/,1X,70('-'))
      DO 50 K=1,NT
      M=IFIX(DIST/DL)+2
      IF(M.LT.2) THEN
      Y1=Yo(1)
      ELSE
      FAC=(DIST-FLOAT(M-2)*DL)/DL
      Y1=Yo(M-1)+FAC*(Yo(M)-Yo(M-1))
      ENDIF
      A1=(B+FM*Y1)*Y1
      HCA1=(.5*B+FM*Y1/3.)*Y1**2
      V1=Q1/A1
      IF(K.EQ.1) DIST=FL
      NCT=0
20    SUM=0.
      Q=X(4)
      IF(K.EQ.1) Ye=X(3)
      CALL FUN2(F,X)
      DO 22 I=1,4
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN2(F1,X)
      DO 21 J=1,4
21    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
22    X(I)=XX
      CALL SOLVEQ(4,1,4,D,F,1,DD,INDX)
      DO 24 I=1,4
      X(I)=X(I)-F(I)
24    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM
      IF(SUM.GT.5.E-5 .AND. NCT.LT.20) GO TO 20
      WRITE(3,110) IFIX(DT*FLOAT(K-1)),DIST,X,Y1,V1,C
110   FORMAT(I7,F8.1,3F8.3,F8.2,2F8.3,F8.2)
      IF(K.EQ.1) GO TO 40
      NFS=.FALSE.
      Y(1)=X(3)
      XX=FL
      J=0
30    J=J+1
      XX1=XX-DL
      IF(XX1.LT.DIST) XX1=DIST
      NFS=.TRUE.
      CALL ODESOLF(Y,DY,1,XX,XX1,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      YSTOR(J)=Y(1)
      XX=XX1
      NFS=.FALSE.
      IF(XX1.GT.DIST) GO TO 30
      WRITE(4,120) IFIX(DT*FLOAT(K-1)),(DL*FLOAT(15-I),YSTOR(I),I=1,J)
120   FORMAT(I6,8(F8.0,F8.3),/,7(F8.0,F8.3))
40    DIST=DIST-DT*X(1)
      IF(DIST.LT.0.) STOP
50    CONTINUE
      END
      SUBROUTINE FUN1(F,X)
      REAL Y(1),DY(1),XP(1),YP(1,1),W(1,13),X(4),F(4)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,C,e,QN,FMS,
     &FM2,Q,A1,V1,HCA1,K,Ye,DIST,VISC,SG,SQG
      A=(B+FM*X(3))*X(3)
      F(1)=X(3)+(X(1)/A)**2/G2-Yd-X(1)**2/Ad
      F(2)=H-X(2)-FKe*(X(1)/((B+FM*X(2))*X(2)))**2/G2
      Y(1)=X(3)
      CALL ODESOLF(Y,DY,1,FL,0.,TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE FUN2(F,X)
      REAL Y(1),DY(1),XP(1),YP(1,1),W(1,13),X(4),F(4)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,C,e,QN,FMS,
     &FM2,Q,A1,V1,HCA1,K,Ye,DIST,VISC,SG,SQG
      A=(B+FM*X(2))*X(2)
      F(1)=(X(1)+V1)*A1-(X(1)+X(4)/A)*A
      F(2)=HCA1+(X(1)+V1)**2*A1/G-(.5*B+FM*X(2)/3.)*X(2)**2-(X(1)+X(4)/A
     &)**2*A/G
      AE=(B+FM*X(3))*X(3)
      F(3)=X(3)+(X(4)/AE)**2/G2-Yd-X(4)**2/Ad
      IF(K.EQ.1) THEN
      F(4)=X(3)-Ye
      ELSE
      Y(1)=X(3)
      CALL ODESOLF(Y,DY,1,FL,DIST,TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(4)=X(2)-Y(1)
      ENDIF
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,C,e,QN,FMS,
     &FM2,Q,A1,V1,HCA1,K,Ye,DIST,VISC,SG,SQG
      A=(B+FM*Y(1))*Y(1)
      P=B+FMS*Y(1)
      Rh=A/P
1     C1=C
      C=SQG*ALOG10(e/Rh+.884*C/(SG*QN/P))
      IF(ABS(C-C1).GT. 1.E-3) GO TO 1
      SF=(Q/(C*A))**2/Rh
      DY(1)=(SO-SF)/(1.-Q**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
      END