C  Uses an Implicit method to solve a moving wave upstream from a gate (DCW)
C  Free overfall at end of channel
      LOGICAL NFS
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,CUN,FMS,FM2
     &,A1,Q1,V1,HCA1,WV1,XPOS,Yo(15),DL,DT5,X(5)
      REAL F(5),F1(5),D(5,5),YSTOR(16),Y(1),DY(1),XP(1),
     &YP(1,1),W(1,13)
      INTEGER*2 INDX(5)
      EQUIVALENCE (v,X(1)),(Y2,X(2)),(Qe,X(4))
      WRITE(*,*)' For initial condition give: g,H,Ke,L,n,b,m,So, Guess f
     &or Q,Y1,Y2'
      H11=-.05
      HMIN=1.E-5
      TOL=1.E-5
      READ(*,*) G,H,FKe,FL,FN,B,FM,So,X(1),X(2),X(3)
      FKe=FKe+1.
      FMS=2.*SQRT(FM*FM+1.)
      FM2=2.*FM
      G2=2.*G
      Cu=1.486
      IF(G.LT.20.) Cu=1.
      CUN=FN/Cu
C  Q=X(1); Yb (upstream)=X(2); Ye (downstream)= X(3)
      NCT=0
10    SUM=0.
      CALL FUN1(F)
      DO 12 I=1,3
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN1(F1)
      DO 11 J=1,3
11    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
12    X(I)=XX
      CALL SOLVEQ(3,1,5,D,F,1,DD,INDX)
      DO 14 I=1,3
      X(I)=X(I)-F(I)
14    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' 1ST NCT=',NCT,SUM
      IF(SUM.GT.5.E-5 .AND. NCT.LT.20) GO TO 10
      WRITE(3,130)(X(I),I=1,3)
130   FORMAT(' Steady-State Q=',F8.1,',  Y1=',F8.3,',  Ye=',F8.3)
      Y(1)=X(3)+.1
      D11=-.05
      Yo(15)=X(3)
      Q1=X(1)
      DL=FL/14.
      XX=FL
      NFS=.TRUE.
      DO 15 I=14,1,-1
      XX1=XX-DL
      CALL ODESOLF(Y,DY,1,XX,XX1,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      NFS=.FALSE.
      XX=XX1
15    Yo(I)=Y(1)
      WRITE(3,100) (DL*FLOAT(I-1),Yo(I),I=15,1,-1)
100   FORMAT(' Initial Condition (x,Y)',/,8(F8.0,F8.3),/,7(F8.0,F8.3))
      HCA1=(.5*B+FM*X(3)/3.)*X(3)**2
      A1=(B+FM*X(3))*X(3)
      V1=X(1)/A1
      WRITE(*,*)' Give:No. time steps,Dt,New Yg, Cc & GUESS for v,Y2,V2'
      READ(*,*) NT,DT,Yg,Cc,(X(I),I=1,3)
      DT5=.5*DT
C At gate variables: v=X(1), Y2=X(2),  V2=X(3)
      Yd=Cc*Yg
      Ad=((B+FM*Yd)*Yd)**2*G2
      NCT=0
16    SUM=0.
      CALL FUN0(F)
      DO 18 I=1,3
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN0(F1)
      DO 17 J=1,3
17    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
18    X(I)=XX
      CALL SOLVEQ(3,1,5,D,F,1,DD,INDX)
      DO 19 I=1,3
      X(I)=X(I)-F(I)
19    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' 2ND NCT=',NCT,SUM,(X(I),I=1,3)
      IF(SUM.GT.5.E-5 .AND. NCT.LT.20) GO TO 16
      WRITE(3,140)(X(I),I=1,3)
140   FORMAT(' Wave at gate, v=',F9.3,', Y2=',F8.3,',  V2=',F8.3)
      WV1=X(1)
C  v=X(1); Y2=X(2); Ye=X(3); Q2=X(4); Position x of wave=X(5)
      WRITE(3,111)
111   FORMAT(/,'   Time    v       Y2      Ye     Q        x       Y1  
     &    V1',/,1X,62('-'))
      X(4)=X(3)*((B+FM*X(2))*X(2))
      WRITE(3,110) 0,WV1,X(2),X(2),X(4),FL,Yo(15),V1
      X(3)=X(2)
      XPOS=FL
      X(5)=XPOS-WV1*DT
      H11=-.5
      DO 50 K=1,NT
      NCT=0
20    SUM=0.
      CALL FUN2(F)
      DO 22 I=1,5
      XX=X(I)
      X(I)=1.005*X(I)
      CALL FUN2(F1)
      DO 21 J=1,5
21    D(J,I)=(F1(J)-F(J))/(X(I)-XX)
22    X(I)=XX
      CALL SOLVEQ(5,1,5,D,F,1,DD,INDX)
      DO 24 I=1,5
      X(I)=X(I)-F(I)
24    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM
      IF(SUM.GT.1.E-4 .AND. NCT.LT.20) GO TO 20
      M=IFIX(X(5)/DL)+2
      IF(M.LT.2) THEN
      Y1=Yo(1)
      ELSE
      FAC=(X(5)-FLOAT(M-2)*DL)/DL
      Y1=Yo(M-1)+FAC*(Yo(M)-Yo(M-1))
      ENDIF
      V1=Q1/((B+FM*Y1)*Y1)
      WRITE(3,110) IFIX(DT*FLOAT(K)),X,Y1,V1
110   FORMAT(I7,4F8.3,F8.1,2F8.3)
      IF(K.EQ.1) GO TO 40
      NFS=.TRUE.
      Y(1)=X(3)
      XX=FL
      J=0
      H11=-.05
30    J=J+1
      XX1=XX-DL
      IF(XX1.LT.X(5)) XX1=X(5)
      NFS=.TRUE.
      CALL ODESOLF(Y,DY,1,XX,XX1,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      YSTOR(J)=Y(1)
      XX=XX1
      NFS=.FALSE.
      IF(XX1.GT.X(5)) GO TO 30
      WRITE(4,120) IFIX(DT*FLOAT(K-1)),(DL*FLOAT(15-I),YSTOR(I),I=1,J)
120   FORMAT(I6,8(F8.0,F8.3),/,7(F8.0,F8.3))
40    XPOS=X(5)
      WV1=X(1)
      X(5)=X(5)-DT*X(1)
      IF(X(5).LT.0.) STOP
50    CONTINUE
      END
      SUBROUTINE FUN1(F)
      REAL Y(1),DY(1),XP(1),YP(1,1),W(1,13),F(5)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,CUN,FMS,FM2
     &,A1,Q1,V1,HCA1,WV1,XPOS,Yo(15),DL,DT5,X(5)
      A=(B+FM*X(3))*X(3)
C Free overfall at end of channel
      F(1)=X(1)**2*(B+FM2*X(3))-G*A**3
      F(2)=H-X(2)-FKe*(X(1)/((B+FM*X(2))*X(2)))**2/G2
      Y(1)=X(3)+.1
      H11=-.05
      CALL ODESOLF(Y,DY,1,FL,0.,TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(3)=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE FUN2(F)
      REAL Y(1),DY(1),XP(1),YP(1,1),W(1,13),F(5)
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,CUN,FMS,FM2
     &,A1,Q1,V1,HCA1,WV1,XPOS,Yo(15),DL,DT5,X(5)
      A=(B+FM*X(2))*X(2)
      M=IFIX(X(5)/DL)+2
      IF(M.GT.15) M=15
      IF(M.LT.2) THEN
      Y1=Yo(1)
      ELSE
      FAC=(X(5)-FLOAT(M-2)*DL)/DL
      Y1=Yo(M-1)+FAC*(Yo(M)-Yo(M-1))
      ENDIF
      A1=(B+FM*Y1)*Y1
      HCA1=(.5*B+FM*Y1/3.)*Y1**2
      V1=Q1/A1
      F(1)=(X(1)+V1)*A1-(X(1)+X(4)/A)*A
      F(2)=HCA1+(X(1)+V1)**2*A1/G-(.5*B+FM*X(2)/3.)*X(2)**2-(X(1)+X(4)/A
     &)**2*A/G
      AE=(B+FM*X(3))*X(3)
      F(3)=X(3)+(X(4)/AE)**2/G2-Yd-X(4)**2/Ad
      Y(1)=X(3)+.1
      H11=-.05
      CALL ODESOLF(Y,DY,1,FL,X(5),TOL,H11,HMIN,1,XP,YP,W,DYX,.TRUE.)
      F(4)=X(2)-Y(1)
      F(5)=XPOS-DT5*(X(1)+WV1)-X(5)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,CUN,FMS,FM2
     &,A1,Q1,V1,HCA1,WV1,XPOS,Yo(15),DL,DT5,X(5)
      A=(B+FM*Y(1))*Y(1)
      SF=(X(1)*CUN*((B+FMS*Y(1))/A)**.6666667/A)**2
      DY(1)=(SO-SF)/(1.-X(1)**2*(B+FM2*Y(1))/(G*A**3))
      RETURN
      END
      SUBROUTINE FUN0(F)
      REAL F(5)
      COMMON /TRAS/ H,FKe,Yd,Ad,G,G2,FL,B,FM,SO,TOL,H11,HMIN,CUN,FMS,FM2
     &,A1,Q1,V1,HCA1,WV1,XPOS,Yo(15),DL,DT5,X(5)
      A=(B+FM*X(2))*X(2)
      F(1)=(X(1)+V1)*A1-(X(1)+X(3))*A
      F(2)=HCA1+(X(1)+V1)**2*A1/G-(.5*B+FM*X(2)/3.)*X(2)**2-(X(1)+X(3))
     &**2*A/G
      F(3)=X(2)+X(3)**2/G2-Yd-(X(3)*A)**2/Ad
      RETURN
      END