C Solves problem of lateral outflow from either a side weir or a grate in channel bottom.
C The flow is assumed to be critical at beginning and that there is zero flow at end.
C  The channel may be trapezoidal, or 1/2 a triangle (i.e. vertical sided grate)
C  Unknowns: Yju (depth upstream from jump), Yjd (depth downstream from jump),
C  Y2 (depth at end of outflow channel), & x (position of Hyd. Jump)
C  X(1) = Y2; X(2) = Yju(upstream jump); X(3) = Yjd(downstream jump); X(4) = x(position of jump)
C  Should the position x become negative during the iterative solution process, 
C  then the user will be prompted whether the problem should be solved in which 
C  subcritical flow occurs throughout the outflow section.  Then the depth is no
C  longer critical at the beginning of the outflow section, and the two unknowns
C  are Y1=X(2) and Y2=X(1) and the two eqs. are the GVF and continuity.
      LOGICAL*2 DONE,UPST,ISUBC
      INTEGER*2 INDX(4)
      REAL F(4),D(4,4),X(4),FFF(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,CDG,DX,Yc,W,
     &SQSTAR,QSTAR1,DB,DM,XX,X,FFF,IPRNT,DONE,UPST,IOUT,ITYPE,ISUBC
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,Qu,FN,SO,B1,FM1,B2,FM2,L,g,DX'
      READ(*,*) IOUT,TOL,ERR,Qu,FN,SO,B1,FM1,B2,FM2,FL,G,DX
      WRITE(*,*)' PRNT,PRNTM,ITYPE(1=weir,2=grate,3=grate with b given),
     &ISUBC'
      ISUBC=.FALSE.
      READ(*,*) IPRNT,IPRMOR,ITYPE,I4
      IF(I4.GT.0) THEN
      ISUBC=.TRUE.
      I4=2
      ELSE      
      I4=4
      ENDIF
      QuS=Qu**2/G
      IF(ITYPE.EQ.1) THEN
      WRITE(*,*)' Give: W (height weir) & Cd'
      READ(*,*) W,Cd
      ELSE
      WRITE(*,*)' Give: fraction open & Cd'
      READ(*,*) FRAC, Cd
      ENDIF
      DONE=.FALSE.
      DB=(B1-B2)/FL
      DM=(FM1-FM2)/FL
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      IF(ITYPE.EQ. 1) THEN
      CDG=.6666667*Cd*SQRT(G2)
      ELSE IF(ITYPE.EQ.2) THEN
      CDG=FRAC*Cd*SQRT(G2)
      ELSE
C  if ITYPE > 2 then the discharge from the grate is assumed to be from
C   the width of BB (i.e. this allows another width of discharge to be given.
      WRITE(*,*)' Give width of discharge from grate'
      READ(*,*) BB
      CDG=FRAC*BB*Cd*SQRT(G2)
      ENDIF
      IF(ISUBC) THEN
      WRITE(*,*)' GIVE guesses for: Y2 & Y1'
      READ(*,*) X(1),X(2)
      ELSE
      WRITE(*,*)' GIVE guesses for: Y2,Yju,Yjd & x'
      READ(*,*) X
      ENDIF
      Yc=.8*X(1)
      NCT=0
30    IF(ITYPE.EQ.1) THEN
      A=(B1+FM1*Yc)*Yc
      T=B1+2.*FM1*Yc
      ELSE
      A=(B1+.5*FM1*Yc)*Yc
      T=B1+FM1*Yc
      ENDIF
      FC=QuS*T-A**3
      NCT=NCT+1
      IF(MOD(NCT,2).NE.0) THEN
      FFC=FC
      DYC=.01*Yc
      Yc=Yc+DYC
      GO TO 30
      ENDIF
      DIF=DYC*FFC/(FC-FFC)
      Yc=Yc-DYC-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-6) GO TO 30
      WRITE(*,*)' Critical depth at beginning =',Yc
      NCT=0
      IF(IPRMOR.GT.1) DONE=.TRUE.
1     CALL FUN
      DO 8 I=1,I4
8     F(I)=FFF(I)
      DO 10 J=1,I4
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN
      DO 9 I=1,I4
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      IF(IPRMOR.GT.0) THEN
      DO 11 I=1,I4
11    WRITE(*,333)(D(I,J),J=1,I4),F(I)
333   FORMAT(6F10.3)
      ENDIF
      CALL SOLVEQ(I4,1,4,D,F,1,DD,INDX)
      IF(IPRMOR.GT.0) WRITE(*,334) (F(I),I=1,I4)
334   FORMAT(' sol',4F10.4)
      NCT=NCT+1
      DIF=0.
      DO 19 I=1,I4
19    DIF=DIF+ABS(F(I))
      WRITE(*,*) NCT,DIF,' Give factor; IF 0 then x'
      READ(*,*) DXX
      IF(ABS(DXX).LT.1.E-6) THEN
      WRITE(*,*)' Give Y2,Yju,Yjd & x'
      READ(*,*) X
      ENDIF
      DO 20 I=1,I4
20    X(I)=X(I)-DXX*F(I)
      WRITE(*,110) NCT,DIF,X
110   FORMAT(' NCT=',I3,' DIF=',E12.5,/,4F10.3)
      IF(X(4).LT. 0.) THEN
      WRITE(*,*)' Position has become negative, or only subcritical flow
     & is occurring.'
      WRITE(*,*)' Should this case case be solve? Give 1 otherwise 0'
      READ(*,*) J
      IF(J.GT.0) THEN
      ISUBC=.TRUE.
      I4=2
      ENDIF
      ENDIF
      IF(NCT.LT.30 .AND. DIF.GT. ERR) GO TO 1
      IF(ISUBC) THEN
      WRITE(IOUT,101) Qu,Yc,X(2),X(1)
101   FORMAT(' Qu =',F9.2,', Yc =',F8.3,', Y1 =',F8.2,', Y2 =',F8.2)
      ELSE
      WRITE(IOUT,100) Qu,Yc,X
100   FORMAT(' Qu =',F9.2,', Yc =',F8.3,/,', Y2 =',F8.2,', Yju=',F8.3,
     &', Yjd =',F8.3,', x =',F10.2)
      ENDIF
      DONE=.TRUE.
      CALL FUN
      END
      SUBROUTINE FUN
      LOGICAL*2 DONE,UPST,ISUBC
      EXTERNAL DYX
      REAL X(4),WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(4)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,CDG,DX,Yc,W,
     &SQSTAR,QSTAR1,DB,DM,XX,X,F,IPRNT,DONE,UPST,IOUT,ITYPE,ISUBC
      HMIN=.00001
      IF(ISUBC) GO TO 3
      H1=.05
      Y(1)=.95*Yc
      XX=0.
      UPST=.FALSE.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
100   FORMAT('     x       Y    acc. q*  av. q*           X1        X2
     &      Q',/,1X,67('-'))
      ENDIF  
      SQSTAR=0.
      IF(ITYPE.EQ.1) THEN
      IF(Y(1).LT.W) THEN
      QSTAR1=0.
      ELSE
      QSTAR1=CDG*(Y(1)-W)**1.5
      ENDIF
      ELSE IF(ITYPE.EQ.2) THEN
      QSTAR1=CDG*B1*SQRT(Y(1))
      ELSE
      QSTAR1=CDG*SQRT(Y(1))
      ENDIF
2     XZ=XX+DX
      IF(XZ.GT.X(4)) XZ=X(4)
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(ITYPE.EQ.1) THEN
      IF(Y(1).LT.W) THEN
      QSTAR2=0.
      ELSE
      QSTAR2=CDG*(Y(1)-W)**1.5
      ENDIF
      ELSE IF(ITYPE.EQ.2) THEN
      QSTAR2=CDG*(B1+DB*XZ)*SQRT(Y(1))
      ELSE
      QSTAR2=CDG*SQRT(Y(1))
      ENDIF
      SQSTAR=SQSTAR+(XZ-XX)*(QSTAR1+QSTAR2)/2.
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-X(4)).LT. .001) THEN
      QQ=Qu-SQSTAR
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ
110   FORMAT(F8.2,F8.3,2F8.3,'  betw.',F8.2,' &',F8.2,F10.2)
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      QSTAR1=QSTAR2
      XX=XZ
      IF(XZ.LT. X(4)-.0001) GO TO 2
      SQSTAU=SQSTAR
      F(1)=X(2)-Y(1)
3     H1=-.05
      Y(1)=X(1)
      IF(X(4).GT.FL) GO TO 8
      XX=FL
      UPST=.TRUE.
      IF(DONE) THEN
      QSTARA=0.
      NPRT=0
      XX1=XX
      WRITE(IOUT,100)
      ENDIF  
      SQSTAR=0.
      IF(ITYPE.EQ.1) THEN
      IF(Y(1).LT.W) THEN
      QSTAR1=0.
      ELSE
      QSTAR1=CDG*(Y(1)-W)**1.5
      ENDIF
      ELSE IF(ITYPE.EQ.2) THEN
      QSTAR1=CDG*(B1+DB*XX)*SQRT(Y(1))
      ELSE
      QSTAR1=CDG*SQRT(Y(1))
      ENDIF
4     XZ=XX-DX
      IF(XZ.LT.X(4)) XZ=X(4)
      IF(XZ.LT.0.) XZ=0.
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(ITYPE.EQ.1) THEN
      IF(Y(1).LT.W) THEN
      QSTAR2=0.
      ELSE
      QSTAR2=CDG*(Y(1)-W)**1.5
      ENDIF
      ELSE IF(ITYPE.EQ.2) THEN
      QSTAR2=CDG*(B1+DB*XZ)*SQRT(Y(1))
      ELSE
      QSTAR2=CDG*SQRT(Y(1))
      ENDIF
      SQSTAR=SQSTAR+(XX-XZ)*(QSTAR1+QSTAR2)/2.
      IF(DONE) THEN
      QSTARA=QSTARA+(QSTAR1+QSTAR2)/2.
      NPRT=NPRT+1
      IF(MOD(NPRT,IPRNT).EQ.0 .OR. ABS(XZ-X(4)).LT. .0001) THEN    
      QQ=SQSTAR
      WRITE(IOUT,110) XZ,Y(1),SQSTAR,QSTARA/FLOAT(IPRNT),XX1,XZ,QQ
      QSTARA=0.
      XX1=XZ
      ENDIF
      ENDIF
      QSTAR1=QSTAR2
      XX=XZ
      IF(XZ.GT. X(4)+.0001 .AND. XZ.GT. 0.) GO TO 4
      SQSTAD=SQSTAR
8     IF(ISUBC) THEN
      F(1)=X(2)-Y(1)
      F(2)=Qu-SQSTAD
      RETURN
      ELSE
      F(2)=X(3)-Y(1)
      ENDIF
      B=B1+DB*X(4)
      FM=FM1+DM*X(4)
      IF(ITYPE.EQ.1) THEN
      FMM1=(B/2.+X(2)*FM/3.)*X(2)**2+(Qu-SQSTAU)**2/G/((B+X(2)*FM)*X(2))
      FMM2=(B/2.+X(3)*FM/3.)*X(3)**2+(Qu-SQSTAU)**2/G/((B+X(3)*FM)*X(3))
      ELSE
      FMM1=(B/2.+X(2)*FM/6.)*X(2)**2+(Qu-SQSTAU)**2/G/((B+X(2)*FM/2.)*
     &X(2))
      FMM2=(B/2.+X(3)*FM/6.)*X(3)**2+(Qu-SQSTAU)**2/G/((B+X(3)*FM/2.)*
     &X(3))
      ENDIF
      F(3)=FMM1-FMM2
      F(4)=Qu-SQSTAU-SQSTAD
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),X(4),F(4)
      LOGICAL*2 DONE,UPST,ISUBC
      COMMON /TRAS/B1,FM1,B2,FM2,G,G2,Qu,Y1,FL,TOL,FN,SO,CC,CDG,DX,Yc,W,
     &SQSTAR,QSTAR1,DB,DM,XXB,X,F,IPRNT,DONE,UPST,IOUT,ITYPE,ISUBC
      YY=Y(1)
      IF(YY.LT. .01) YY=.01
      B=B1+DB*XX
      FM=FM1+DM*XX
      IF(ITYPE.EQ.1) THEN
      P=B+2.*SQRT(FM*FM+1.)*YY
      A=(B+FM*YY)*YY
      T=B+2.*FM*YY
      IF(YY.LT.W) THEN
      QSTAR=0.
      ELSE
      QSTAR=CDG*(YY-W)**1.5
      ENDIF
      ELSE
      P=B+SQRT(FM*FM+1.)*YY
      A=(B+.5*FM*YY)*YY
      T=B+FM*YY
      IF(ITYPE.EQ.2) THEN
      QSTAR=CDG*B*SQRT(YY)
      ELSE
      QSTAR=CDG*SQRT(YY)
      ENDIF
      ENDIF
      IF(UPST) THEN
      QQ=SQSTAR+ABS(XXB-XX)*(QSTAR+QSTAR1)/2.
      ELSE
      QQ=Qu-SQSTAR-ABS(XX-XXB)*(QSTAR+QSTAR1)/2.
      ENDIF
      SF=(FN*QQ/CC*(P/A)**.666666667/A)**2
      A3=A**3
      QQS=QQ*QQ
      FR1=1.-QQS*T/G/A3
      IF(ABS(FR1) .LT. .01) THEN
      DY(1)=0.
      ELSE
      DY(1)=(SO-SF+QQ*QSTAR/(G*A*A)+QQS/(G*A3)*(DB+YY*DM)*YY)/FR1
      ENDIF
      RETURN
      END