C PROGRAM IS DESIGNED ONLY FOR DISPERSIVE WAVES IN WHICH THE DEPTH DECREASES
C  i.e.  values of the stage f. w generated only up to Yo
C  This program handles a circular channel, YTIMEX a trapezoidal channel
      PARAMETER (N=200)
      REAL W(N),X(20) 
      WRITE(6,*)' Give:Yo,(1 & Vo or 2 & Qo),D,dQ/dt,Tstart,Tend,Dt,g,',
     &'IOUT,Stations'
      READ(5,*) YO,I,QO,D,DQT,TST,TE,DT,G,IOUT,NSTA
      RADIUS=.5*D
      RAD2=RADIUS**2
      BETAO=ACOS(1.-YO/RADIUS)
      AO=RAD2*(BETAO-COS(BETAO)*SIN(BETAO))
      SGD=SQRT(G*D)
      IF(I.EQ.1) THEN
      VO=QO
      QO=QO*AO
      ELSE
      VO=QO/AO
      ENDIF
      CO=SQRT(G*AO/(D*SIN(BETAO)))
      Fro=ABS(VO)/CO
      DXDTO=VO+CO
      IF(NSTA.LT.1) GO TO 1 
      WRITE(6,*)' Give x distances for',NSTA 
      READ(5,*)(X(I),I=1,NSTA) 
1     DY=(YO-.01)/FLOAT(N-1) 
      Y=.01
      B1=ACOS(1.-Y/RADIUS)
      WF1=FW(B1) 
      W(1)=0. 
      DO 10 I=2,N
      SUM=0.
      Y=Y+DY
      B2=ACOS(1.-Y/RADIUS)
      DB=(B2-B1)/10.
      DB2=.5*DB
      DO 5 J=1,10
      WF=FW(B1+DB*FLOAT(J))
      SUM=SUM+DB2*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM*SGD
10    B1=B2
      VOW=VO-W(N)
      IF(VO.GT. 0.) GO TO 14
      DO 12 I=N,1,-1
      Y=.01+FLOAT(I-1)*DY
      BETA=ACOS(1.-Y/RADIUS)
      F=W(I)+SQRT(G*RAD2*(BETA-COS(BETA)*SIN(BETA))/(D*SIN(BETA)))+VOW
      IF(F.LT. 0.) THEN
      YY=Y+DY
      BET=ACOS(1.-YY/RADIUS)
      F1=W(I+1)+SQRT(G*RAD2*(BET-COS(BET)*SIN(BET))/(D*SIN(BET)))+VOW
      FAC=F/(F1-F)
      YMIN=Y-FAC*DY
      VMAX=W(I)+FAC*(W(I+1)-W(I))+VOW
      BETA=ACOS(1.-YMIN/RADIUS)
      QMAX=VMAX*RAD2*(BETA-COS(BETA)*SIN(BETA))
      WRITE(IOUT,150) YMIN,VMAX,QMAX
150   FORMAT(' Limiting Ymin=',F8.3,' Vmax=',F8.3,' & Qmax=',F9.1)
      IMIN=I
      GO TO 14
      ENDIF
12    CONTINUE
14    WRITE(IOUT,110) 0.
      IM=N-1
      NT=(TE-TST)/DT+1.99
      F=AO-QO/(W(N-1)+VOW)
      WRITE(IOUT,100) 0,QO,YO,VO,BETAO,AO,Fro,CO,DXDTO
      DO 40 I=2,NT
      T=TST+DT*FLOAT(I-1)
      IT=T+.99
      Q=QO+DQT*T
20    F1=F
      Y=.01+FLOAT(IM-1)*DY
      BETA=ACOS(1.-Y/RADIUS)
      F=RAD2*(BETA-COS(BETA)*SIN(BETA))-Q/(W(IM)+VOW)
      IF(VO.GT.0.) THEN
      IF(F.LE.0.) GO TO 30 
      ELSE
      IF(F.GE.0.) GO TO 30
      ENDIF
      IM=IM-1
      IF(IM.GT.IMIN) GO TO 20
      WRITE(IOUT,130) IT
130   FORMAT(' Solution not possible for time',I6,' and beyond')
      GO TO 42
30    FAC=ABS(F/(F-F1))
      YY=Y+FAC*DY
      V=W(IM)+FAC*(W(IM+1)-W(IM))+VOW
31    COSB=1.-YY/RADIUS
      BETA=ACOS(COSB)
      AA=RAD2*(BETA-COSB*SIN(BETA))
      C=SQRT(G*AA/(D*SIN(BETA)))
      Fr=ABS(V)/C
      DXDT=V+C
      WRITE(IOUT,100) IT,Q,YY,V,BETA,AA,Fr,C,DXDT
      IF(DXDT.LT. .05) THEN
      WRITE(IOUT,120)
      WRITE(*,120)
      GO TO 42
      ENDIF
40    CONTINUE
100   FORMAT(I8,F8.1,4F8.3,F7.3,F8.3,F8.4)
110   FORMAT('Position x =',F8.0,/,71('-'),/,' Time(s)',5X,'Q',7X,'Y',
     &7X,'V',5X,'Beta',7X,'A',5X,'Fr',7X,'c   dx/dt',/,1X,71('-'))
42    BETA=ACOS(1.-YO/RADIUS)
      DXO=VO+SQRT(G*(RAD2*(BETA-COS(BETA)*SIN(BETA))/(D*SIN(BETA))))
      DO 60 K=1,NSTA
      IM=N
      WRITE(IOUT,*)
      WRITE(IOUT,110) X(K)
      F=X(K)/DXO-TST
      DO 60 I=1,NT
      T=TST+DT*FLOAT(I-1)
      IT=T+.99
      IF(T*DXO.LE.X(K)) THEN
      WRITE(IOUT,100) IT,QO,YO,VO,BETAO,AO,Fro,CO,DXDTO
      ELSE
45    F1=F 
      V=W(IM)+VOW
      Y=.01+FLOAT(IM-1)*DY
      BETA=ACOS(1.-Y/RADIUS)
      A=RAD2*(BETA-COS(BETA)*SIN(BETA))
      Q=V*A
      F=ABS(QO-Q)/ABS(DQT)+X(K)/(V+SQRT(G*A/(D*SIN(BETA))))-T
      IF(F.GT.0.) GO TO 48
      IM=IM-1
      IF(IM.GT.IMIN) GO TO 45
      WRITE(IOUT,130) IT
      STOP
48    FAC=F/(F1-F)
      YY=Y-FAC*DY
      V=W(IM)-FAC*(W(IM+1)-W(IM))+VOW
      BETA=ACOS(1.-YY/RADIUS)
      Q=V*RAD2*(BETA-COS(BETA)*SIN(BETA))
      AA=RAD2*(BETA-COS(BETA)*SIN(BETA))
      C=SQRT(G*AA/(D*SIN(BETA)))
      Fr=ABS(V)/C
      DXDT=V+C
      WRITE(IOUT,100) IT,Q,YY,V,BETA,AA,Fr,C,DXDT
      IF(DXDT.LT. .05) THEN
      WRITE(IOUT,120)
120   FORMAT(' Characteristic has become vertical')
      STOP
      ENDIF
      ENDIF 
60    CONTINUE
      END
      FUNCTION FW(BETA)
      SINB=SIN(BETA)
      FW=SINB/SQRT(BETA/SINB-COS(BETA))
      RETURN
      END
      