C PROGRAM IS DESIGNED ONLY FOR DISPERSIVE WAVES IN WHICH THE DEPTH DECREASES
C  i.e.  values of the stage f. w generated only up to Yo
C  It differs from YTIMEX in that the stage function w is numerically integrated
C  using Simpson's rule whenever needed.  This program differs from YTIMEXI in
C  that the numerical integration is not repeated from .01 to Y in utilizing the
C  Newton method, but rather from the current Y to the new Y until the value of
C the function equals zero.
      EXTERNAL FW
      REAL X[ALLOCATABLE](:)
      COMMON B,FM,FM2,G
      WRITE(6,*)' Give:Yo,Qo,b,m,dQ/dt,Tstart,Tend,Dt,g,IOUT,Stations' 
      READ(5,*) YO,QO,B,FM,DQT,TST,TE,DT,G,IOUT,NSTA 
      FM2=2.*FM
      IF(NSTA.LT.1) GO TO 1 
      WRITE(6,*)' Give x distances for',NSTA 
      ALLOCATE(X(NSTA))
      READ(5,*)(X(I),I=1,NSTA) 
1     DY=(YO-.01)/199.
      CALL SIMPR(FW,.01,YO,Wo,1.E-5,50)
      WW=Wo
      YY=YO
      AO=(B+FM*YO)*YO
      VO=QO/AO 
      VOW=VO-Wo
      CO=SQRT(G*AO/(B+FM2*YO))
      WRITE(IOUT,110) 0.
      WRITE(IOUT,100) 0,QO,YO,VO,Wo,CO
      NT=(TE-TST)/DT+.99 
      DO 40 I=1,NT 
      T=TST+DT*FLOAT(I) 
      IT=T+.99 
      Q=QO+DQT*T 
      M=0
      Y1=YY
      W1=WW
      YY=.98*YY
20    CALL SIMPR(FW,Y1,YY,DW,1.E-5,10)
      WW=W1+DW 
      F=(B+FM*YY)*YY-Q/(WW+VOW) 
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 22
      Y2=YY
      FF=F
      Y1=YY
      W1=WW
      YY=1.005*YY
      GO TO 20
22    DIF=(YY-Y2)*FF/(F-FF)
      Y1=YY
      W1=WW
      YY=Y2-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 20
      CALL SIMPR(FW,Y1,YY,DW,1.E-5,10)
      WW=W1+DW
      C=SQRT(G*(B+FM*YY)*YY/(B+FM2*YY))
40    WRITE(IOUT,100) IT,Q,YY,WW+VOW,WW,C
100   FORMAT(I8,F8.1,4F8.3) 
110   FORMAT(/,' At position x=',F8.0,/' Time(s)',5X,'Q',7X,'Y',7X,'V'
     *,7X,'w',7X,'c'/,1X,48('-')) 
      DXO=VO+SQRT(G*(((B+FM*YO)*YO)/(B+FM2*YO))) 
      DO 60 K=1,NSTA 
      YY=YO
      WW=Wo
      WRITE(IOUT,110) X(K) 
      WRITE(IOUT,100) 0,QO,YO,VO,Wo,CO
      DO 60 I=1,NT 
      T=TST+DT*FLOAT(I) 
      IT=T+.99 
      IF(T*DXO.LE.X(K)) THEN 
      WRITE(IOUT,100) IT,QO,YO,VO,Wo,CO
      ELSE 
      M=0
      Y1=YY
      W1=WW
      YY=.99*YY
55    CALL SIMPR(FW,Y1,YY,DW,1.E-5,10)
      WW=W1+DW 
      V=WW+VOW 
      A=(B+FM*YY)*YY
      Q=V*A 
      F=(Q-QO)/DQT+X(K)/(V+SQRT(G*A/(B+FM2*YY)))-T
      M=M+1
      IF(MOD(M,2).EQ. 0) GO TO 58
      Y2=YY
      FF=F
      Y1=YY
      W1=WW
      YY=1.005*YY
      GO TO 55
58    DIF=(YY-Y2)*FF/(F-FF)
      Y1=YY
      W1=WW
      YY=Y2-DIF
      IF(ABS(DIF).GT. 1.E-5 .AND. M.LT.30) GO TO 55
      CALL SIMPR(FW,Y1,YY,DW,1.E-5,10)
      WW=W1+DW
      V=WW+VOW
      A=(B+FM*YY)*YY 
      Q=V*A
      C=SQRT(G*A/(B+FM2*YY))
      WRITE(IOUT,100) IT,Q,YY,V,WW,C
      ENDIF 
60    CONTINUE 
      STOP 
      END
      FUNCTION FW(Y)
      COMMON B,FM,FM2,G
      FW=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y))
      RETURN
      END