% This script carries out the solution of dx/dY as needed for Example No.1
% in Appendix C.  It calls on the ODE solver ode45 for each new increment
% of DELY as does the Fortran program APPC1.  Rather than call on ode45 for
% each new increment of DELY one can ask ode45 to provide the solution over
% all of the Y's.  This approach is used in the script APPEC1a.m
% Also note that since the evaluation of dx/dY does not involve x, the
% solution can be obtain by numerical integration.  The Fortran program
% APPEC1A.FOR call on SIMPR to numerically integration dx/dY for each 
% increment of Y.
disp('Give the following input values');
DELY=input('DELY = '); XB=input('XB = '); Q=input('Q = '); FN=input('n =');
SO=input('So ='); B=input('b =');FM=input('m = ');YBEG=input('beg Y =');
YEND=input('end Y ='); Cu=input('Cu =');  FNQ=FN*Q/Cu;
if Cu==1.
    g=9.81;
else
    g=32.2;
end
Q2=Q^2/g; 
fid=input('Should output be written to file? (2=yes,1=no)');
if fid>1 
    FILN=input('Give name of this file');
    fid=fopen(FILN,'w');
end
X(1)=XB;
Y=YBEG; 
fprintf('      Y         x\n');
fprintf(fid,'%10.3f %10.3f\n',Y,XB);
ICONT=1;
YO=Y;  II=0;
while ICONT==1
    II=II+1;
    YZ=YO+DELY*II;
    [yy,xx]=ode45(@acxprime,[Y YZ],[X(1)]',[],B,FM,FN,SO,Q2,FNQ);
    Y=YO+DELY*II;
    nn=size(xx);
    X(1)=xx(nn(1));
    fprintf(fid,'%10.3f %10.3f\n',Y,X(1));
    if DELY<0
        if Y <= YEND
            ICONT=0;
        end
    else
        if Y>= YEND
            ICONT=0;
        end
    end
end