% This script is designed to solve Example No. 1 in Appendix C.  Instead of
% call on ode45 for each new step DELY as does script APPEC1.m it utilizes
% the fact that ode45 will accept a vector of the values for which the 
% independent variable, Y, is to have a corresponding value of the
% dependent variable X.  Thus in this script the vector of depths is
% obtained and passed to ode45.  See script APPEC1.m in which ode45 is
% called for each new increment in the depth.
disp('Give the following input values');
DELY=input('DELY = '); XB=input('XB = '); Q=input('Q = '); FN=input('n =');
SO=input('So ='); B=input('b =');FM=input('m = ');YBEG=input('beg Y =');
YEND=input('end Y ='); Cu=input('Cu =');  FNQ=FN*Q/Cu;
if Cu==1.
    g=9.81;
else
    g=32.2;
end
Q2=Q^2/g;
Y=YBEG:DELY:YEND;
fid=input('Should output be written to file? (2=yes,1=no) ');
if fid>1 
    FILN=input('Give name of this file');
    fid=fopen(FILN,'w');
end
[yy,xx]=ode45(@acxprime,Y,[XB]',[],B,FM,FN,SO,Q2,FNQ);
    n=size(yy);
    fprintf(fid,'        Y         X\n');
      for j=1:n
        fprintf(fid,'%10.3f %10.f\n',yy(j),xx(j));
      end
