% This script is designed to solve Example No. 2 in Appendix C, and is
% very similiar to the Fortran Program APPEC2.  It utilizes the MATLAB
% built-in function quad to solve the 2 first order ordinary differential
% equations.  The Fortran program uses ODESOL to accomplish this task.
disp('Give input variables ');
P1=input('P1 ');P2=input('P2 ');T2=input('T2 ');X(1)=input('X(1)=x ');
FL2=input('FL2 ');NT=input('NT ');DELT=input('DELT ');
ANOZ=input('ANOZ ');E=input('E ');D=input('D ');
P1=P1+14.7; P2=P2+14.7; T2=T2+460.0; D12=D/12.0; ED=E/D;
D5=0.5/D; DXBETW=DELT; SF=6.0; FL=X(1)+FL2; A=0.785398*D12^2; 
RHOO=144.*P2/(1715.*T2); P20=P2; TM=RHOO*A*FL; X(2)=0.0; T20=T2; 
TIME=0.0; 
for I=1:NT 
   TIME1=DELT*I; 
   if P2 > 27.84 
      PS=.528*P2; TS=.833*T2;
   else
      PS=14.7; TS=T2*(14.7/P2)^.2857; 
   end
   RHOS=.083965*PS/TS; T2=T20*(P2/P20)^.2857; 
   X(2)=sqrt(12005.*(1.-TS/T2)); G=ANOZ*X(2)*RHOS; 
   TM=TM-G*DELT*X(2); H12=2.3077*(P1-P2); 
   if X(2)== 0. 
      RE95=.1;
   else
      RE95=1.122E-4/(D12*X(2));
   end
   [xx,tt]=ode45(@slopeappec2,[TIME TIME1],[X]',[],SF,ED,RE95,H12,D5);
   nn=size(xx); X(1)=xx(nn(1));
   TIME=TIME1; FL2=FL-X(1); RHO=TM/(A*FL2); T2=T20*(RHO/RHOO)^0.4; 
   P2=P20*(T2/T20)^3.5;
   fprintf(1,'%8.1f %8.2f %8.2f %7.5f %8.3f %8.2f %8.2f %8.6f %8.2f %8.2f\n',...
       TIME,X(1),X(2),RHO,TM,PS-14.7,TS-460.,G,T2-460.,P2-14.7);
end