%This script solves the Example No. 3 in Appendix C, similiar to the
% Fortran Program APPEC3.FOR and the C Program CHANRE2.C.
% It uses the MATLAB built in function ode45 to solve the
% differential equation dY/dx=(So-Sf)/(1-Fr2) as does script
% APPEC3.m with the exception that ode45 is activated only
% once, rather than for each new increment of delta x.  Thus
% this script does not allow it user to specify on what increment
% of x the solution is obtained on.  The number of entries in
% the solution is now determined by the vectors output by ode45.
% Another difference with CHANRE2.C is that it determines whether
% SI or ES units are used by the value of the accel. of gravity
% g, whereas this script makes this determination from Cu.
disp('Give the following input values');
 YB=input('YB = '); Q=input('Q = '); FN=input('n =');
SO=input('So ='); B=input('b =');FM=input('m = ');XBEG=input('beg x =');
XEND=input('end x ='); Cu=input('Cu =');  FNQ=FN*Q/Cu;
if Cu==1.
    g=9.81;
else
    g=32.2;
end
Q2=Q^2/g; 
fid=input('Should output be written to file? (2=yes,1=no)');
if fid>1 
    FILN=input('Give name of this file ');
    fid=fopen(FILN,'w');
end
Y(1)=YB; 
fprintf(fid,'      x          Y         Area    Momentum\n');
    [xx,yy]=ode45(@ayprime,[XBEG XEND],[Y]',[],B,FM,FN,SO,Q2,FNQ);
    nn=size(xx);
    for i=1:nn(1)
        A=(B+FM*yy(i))*yy(i); FMOM=(B/2+FM*yy(i)/3)*yy(i)^2+Q2/A;
        fprintf(fid,'%10.3f %10.3f %10.2f %10.2f\n',xx(i),yy(i),A,FMOM);
    end

