function Z=INVERM(A,N);
% Performs the Gaussian elimination in expanded matrix and
% provides the solution in the returned vector.
% A is an N by 2N+1 matrix that contains the coefficient matrix
% in the first N column, and the known vector {b} in the N+1 column
% for the linear algebra problem [A]{z}={b}, e.g. this algebraic
% [A] consists of the first N column of the input matrix A
N1=N+1; N2=N+2; M=2*N+1;
for I=1:N 
  for J=N2:M
     A(I,J)=0.;
  end
  A(I,I+N1)=1.;
end
for I=1:N-1 
  DIAG=A(I,I);
  A(I,I)=1.;
  for J=I+1:M
     A(I,J)=A(I,J)/DIAG; 
  end
  for K=I+1:N 
    FAC=A(K,I);
    A(K,I)=0.;
    for J=I+1:M
        A(K,J)=A(K,J)-FAC*A(I,J);
     end
   end 
end
DIAG=A(N,N); 
A(N,N)=1.; 
for J=N1:M
  A(N,J)=A(N,J)/DIAG;
end
for I=N:-1:2 
  for K=I-1:-1:1 
     FAC=A(K,I);
     A(K,I)=0.;
     for J=N1:M
       A(K,J)=A(K,J)-FAC*A(I,J);
     end
  end
end
for I=1:N 
  for J=1:N 
    A(I,J)=A(I,J+N1);
  end
end
for I=1:N
    Z(I)=A(I,N1);
end