% This script accomplishes the solution of MANNING'S eq. in a circular channel
% as does the PASCAL program Manning_Circular channel that is listed in
% Appendix B, and it also allow a solution in a Trapezoidal channel.
% Thus is capabilities are more in line with the Fortran programs
% MANNING.FOR and MANN_TC.FOR
UN='nQSYbmnQSYD';  Cu=1.; I1=1;I2=6; IT1=0; MAX=15; ERR=1e-5;
IT=input('Give:1=trap.,2=cir. for channel type ');
KU=input('Give:1=ES or 2=SI units ');
if KU==1
    Cu=1.486;
end
if IT==2
    I1=7; I2=11; IT1=6;
end
disp('Give the number for the unknown:');
j=0; 
for i=I1:I2
    j=j+1;
    disp([UN(i) ' = ' num2str(j)]);
 end
 IU=input(' Number = ');       
 disp('Give value to known variables and guess for unknown');
 j=0;
 for i=I1:I2
     j=j+1;
     if j ~= IU
     X(j)=input([UN(i) ' = ']);
     end
 end
 if IU<4
     if IT==1
         A=(X(5)+X(6)*X(4))*X(4);
         P=X(5)+2*sqrt(X(6)^2+1)*X(4);
     else
         cosb=1-2*X(4)/X(5); beta=acos(cosb);
         A=X(5)^2/4*(beta-cosb*sin(beta));
         P=beta*X(5);
     end
     if IU==1
         X(1)=Cu/X(2)*A*(A/P)^0.66666667*sqrt(X(3));
     elseif IU==2
         X(2)=Cu/X(1)*A*(A/P)^0.66666667*sqrt(X(3));
     else
         X(3)=(X(1)*X(2)*(P/A)^0.66666667/Cu/A)^2;
     end
 else
     X(IU)=input([' Provide guess for unknown ' UN(IU+IT1) ' = ']);    
    m=0;  DX=.01*X(IU);
    DIF=1.;
% Uses the Newton Method if unknown makes equation implicit
while (abs(DIF)>ERR) & (m<MAX)
    ISECOND=0;
    while ISECOND<2
    if IT==1
         A=(X(5)+X(6)*X(4))*X(4);
         P=X(5)+2*sqrt(X(6)^2+1)*X(4);
     else
         cosb=1-2*X(4)/X(5); beta=acos(cosb);
         A=X(5)^2/4*(beta-cosb*sin(beta));
         P=beta*X(5);
    end
     FF=X(1)*X(2)*P^0.66666667-Cu*A^1.66666667*sqrt(X(3));
     ISECOND=ISECOND+1;
     if ISECOND==1
         F1=FF;
         X(IU)=X(IU)+DX;
     else
         X(IU)=X(IU)-DX;
         DIF=DX*F1/(FF-F1);
         m=m+1;
         X(IU)=X(IU)-DIF;
     end
    end
end
if m>=MAX
     disp(['Failed to converge DIF= ' num2str(DIF)]);
 end
 end
 disp(['Unknown ' UN(IU+IT1) ' = ' num2str(X(IU))]);
j=0; 
for i=I1:I2
    j=j+1;
    disp([UN(i) ' = ' num2str(X(j))]);
 end    