% This program implements the NEWTON method in solving 3 eqs.
% It accomplishes the same tasks as the Fortran Program NEWEQS
% given in Appendix B. To solve a different system of three equations
% the 3 statements that evaluation F(1),F(2) & F(3) are changed.
% And if more or fewer equations are to be solved change N
N=3;N1=N+1;N2=N+2;N21=2*N+1;X=zeros(N:1);F=zeros(N:1);D=zeros(N,N21);
DX=.001; MAX=15; ERR=1e-4;g=32.2; g2=2*g;
V1=input('Give the following variables: V1= '); Y1=input('Y1= ');
Y3=input('Y3= ');X(1)=input('Y2=X(1)= ');X(2)=input('V2=X(2)= ');
X(3)=input('v=X(3)= ');  M=0; DIF=1;
while (DIF>ERR) & (M<MAX)
NT=0;
while NT<=N
  F(1)=X(1)+X(2)^2/g2-Y3-(X(1)*X(2))^2/(g2*Y3*Y3); 
  F(2)=(X(3)+V1)*Y1-(X(3)+X(2))*X(1); 
  F(3)=.5*(Y1*Y1-X(1)*X(1))-((V1+X(3))*Y1)^2/g*(1./X(1)-1./Y1);
   if (NT==0)
    for i=1:N
      D(i,N1)=F(i);
    end
  else
    for i=1:N 
      D(i,NT)=(D(i,N1)-F(i))/DX;
    end
  end
   if NT>0
     X(NT)=X(NT)+DX; 
   end
  NT=NT+1;
  if NT<=N
     X(NT)=X(NT)-DX;
  end
end
X(N)=X(N)+DX;
% Performs the Gaussian elimination in expanded matrix that is
% carried out in the Fortran Subroutine INVERM
for I=1:N 
  for J=N2:N21
     D(I,J)=0.;
  end
  D(I,I+N1)=1.;
end
for I=1:N-1 
  DIAG=D(I,I);
  D(I,I)=1.;
  for J=I+1:N21
     D(I,J)=D(I,J)/DIAG; 
  end
  for K=I+1:N 
    FAC=D(K,I);
    D(K,I)=0.;
    for J=I+1:N21
        D(K,J)=D(K,J)-FAC*D(I,J);
     end
   end 
end
DIAG=D(N,N); 
D(N,N)=1.; 
for J=N1:N21
  D(N,J)=D(N,J)/DIAG;
end
for I=N:-1:2 
  for K=I-1:-1:1 
     FAC=D(K,I);
     D(K,I)=0.;
     for J=N1:N21
       D(K,J)=D(K,J)-FAC*D(I,J);
     end
  end
end
for I=1:N 
  for J=1:N 
    D(I,J)=D(I,J+N1);
  end
end
% end of Gaussian Elimination
DIF=0.;
for I=1:N 
   DIF=DIF+abs(D(I,N1));
   X(I)=X(I)-D(I,N1);
end
M=M+1;
end
fprintf(1,' Solution is:\n',X');
for I=1:N
    fprintf(1,'X(%1d)=  %10.3f\n',I,X(I));
end