%This script solves Example Problem 3 in Appendix B, as does
%apbep3.m.  The differences is that herein the solution of the
% ODE is obtained using the Runge Kutta method which is implemented
% in the function ruku4a, rather than utilizing the MATLAB built
% in ODE solver ode45.  One can increase the accuracy of this
% numerical solution of the ODE by increasing the number of 
% delta x increments by changing the variable num.
wide=2.5074826; num=20;
delx=wide/num;  XB=0; delxh=delx/2;
X=0:delx:wide; Y(1)=0.;
slope=inline('x+y/2','x','y');
for i=2:num+1
Y(i)=ruku4a(slope,X(i),delx,Y(i-1));
end
disp('Solution of ODE dy/dx=x+y/2');
for i=1:num+1
    fprintf(1,'%10.3f %10.3f\n',X(i),Y(i));
end
% integrates using Simpsons rule
area=0; delx3=delx/3; depth1=5+0.7071068*X(1)-Y(1);
for i=2:2:num
    depth2=5+0.7071068*X(i)-Y(i);
    depth3=5+0.7071068*X(i+1)-Y(i+1);
    area=area+delx3*(depth1+4*depth2+depth3);
    depth1=depth3;
end
disp(['Simpson rule Area = ' num2str(area)]);