%This script solves Example Problem 4 in Appendix B. Runge
% Kutta method is implemented in the function ruku4a to solve
% the ODE. One can increase the accuracy of this
% numerical solution of the ODE by increasing the number of 
% delta x increments by changing the variable num.
wide=2.0; num=30; sin45=sin(pi/2);sxy=wide/sin45;
delx=wide/num;  delxh=delx/2;
X=0:delx:wide; Y(1)=0.;
slope=inline('x+y/2','x','y');
icont=1; i=1
while icont>0
    i=i+1;
    Y(i)=ruku4a(slope,X(i),delx,Y(i-1));
    if X(i)+Y(i) > sxy
        icont=0;
    end
end
disp('Solution of ODE dy/dx=x+y/2 in rotated axes');
for i=1:num+1
    fprintf(1,'%10.3f %10.3f\n',X(i),Y(i));
end
% integrates using Simpsons rule
area=0; delx3=delx/3; depth1=5+sin45*(X(1)-Y(1));
for i=2:2:num
    depth2=5+0.7071068*X(i)-Y(i);
    depth3=5+0.7071068*X(i+1)-Y(i+1);
    area=area+delx3*(depth1+4*depth2+depth3);
    depth1=depth3;
end
disp(['Simpson rule Area = ' num2str(area) ' Force = ' ...
    num2str(9.806*area)]);
% Now compute first moments of areas using Simpson's rule
xarea=0;  xdepth1=X(1)*(5+sin45*X(1)-X(1));
for i=2:2:num
    xdepth2=X(i)*(5+sin45*X(i)-Y(i));
    xdepth3=X(i+1)*(5+sin45*X(i+1)-X(i+1));
    xarea=xarea+delx3*(xdepth1+4*xdepth2+xdepth3);
    xdepth1=xdepth3;
end
disp(['1st moments of Area = ' num2str(xarea)]);
disp(['Centroid Xc = ' num2str(xarea/area)]);
