% This script solves problem such #11 in "Problem: (For you to work) that
% are given in Appendix A.  In other words is solve for one of the following
% variables: A, D, or Y given the other two. The following shows the MATLAB
% command window in which 3 problems are solve, on for A, one for D and one
% for Y.
%appendixAhwk11
%A = 1 
%D = 2 
%Y = 3 
% Give the number for the unknown;1
% Give value to known variables
%D = 12
%Y = 7
%unknown A =    68.4929
%P = 37.6991, T =  0.0000, Rh =  1.4667
%appendixAhwk11
%A = 1 
%D = 2 
%Y = 3 
% Give the number for the unknown;2
% Give value to known variables
%A = 70
%Y = 5
%Provide guess for D = 12
%unknown D =    25.0693
%P = 78.7574, T =  0.0000, Rh =  0.4814
%appendixAhwk11
%A = 1 
%D = 2 
%Y = 3 
% Give the number for the unknown;3
% Give value to known variables
%A = 65
%D = 15
%Provide guess for Y = 7
%unknown Y =     5.9313
%P = 47.1239, T =  0.0000, Rh =  0.9595
var='ADY'; u=zeros(3,1);
 % The vector u represent the variables as follows:
 % u(1) = A (area)
 % u(2) = D (diameter)
 % u(3) = Y (depth)
for i=1:3
    disp([var(i) ' = ' num2str(i) ' ']);
end
ic=input(' Give the number for the unknown;');
disp(' Give value to known variables');
for i=1:3
    if i ~= ic
    u(i)=input([var(i) ' = ']);
    end
end
option=optimset('display','off');
if ic>1
    u(ic)=input(['Provide guess for ' var(ic) ' = ']);
    A=u(1); D=u(2); Y=u(3);
end
switch ic
    case 1
        beta=acos(1-2*u(3)/u(2));
        u(1)=u(2)^2/4*(beta-cos(beta)*sin(beta));
    case 2
        feq=inline('D^2/4*(acos(1-2*Y/D)-(1-2*Y/D)*sin(acos(1-2*Y/D)))-A','D','Y','A');
        u(2)=fsolve(feq,D,option,Y,A);
    case 3
        feq=inline('D^2/4*(acos(1-2*Y/D)-(1-2*Y/D)*sin(acos(1-2*Y/D)))-A','Y','D','A');
        u(3)=fsolve(feq,Y,option,D,A);      
end
fprintf(1,'unknown %c = % 10.4f\n',var(ic),u(ic));
beta=acos(1-2*u(2)/u(3));
P=u(2)*beta; T=u(2)*sin(beta); Rh=u(1)/P;
fprintf(1,'P =%8.4f, T =%8.4f, Rh =%8.4f\n',P,T,Rh);