% This script fills in the missing values in the table of #17, but using
%MATLAB built-in "spline" to interpolate the cross-section data obtained
% by executing script GEONAT.  The output matrix from GOENAT has been
% copied in the cross_sect, and this table used for interpolation.  The
% interpolated missing values of the table as obtained from this script
% are as follows:
% T1 = 25.7266, P1 = 27.9019, A1 =  60.3007
% Y2 =  2.9645, P2 = 24.9493, A2 =  36.4585
% Y3 =  3.9387, T3 = 25.7606, A3 =  61.0475
% Y4 =  5.2704, T4 = 33.1277, P4 =  35.9307
cross_sect=[      0.30       1.56       0.23       1.67
      0.60       3.62       1.01       3.82
      0.90       6.17       2.48       6.45
      1.20       9.22       4.79       9.58
      1.50      12.76       8.08      13.20
      1.80      16.34      12.45      16.87
      2.10      18.90      17.73      19.52
      2.40      21.05      23.73      21.78
      2.70      22.78      30.30      23.63
      3.00      24.10      37.33      25.09
      3.30      25.01      44.70      26.18
      3.60      25.55      52.28      27.01
      3.90      25.70      60.04      27.86
      4.20      27.16      67.97      29.47
      4.50      28.63      76.33      31.10
      4.80      30.11      85.15      32.75
      5.10      31.94      94.45      34.69
      5.40      34.08     104.36      36.92
      5.70      36.39     114.93      39.30
      6.00      38.87     126.21      41.85]
  T1=spline(cross_sect(:,1),cross_sect(:,2),3.91)
  P1=spline(cross_sect(:,1),cross_sect(:,4),3.91)
  A1=spline(cross_sect(:,1),cross_sect(:,3),3.91)
  Y2=spline(cross_sect(:,2),cross_sect(:,1),24.0)
  P2=spline(cross_sect(:,2),cross_sect(:,4),24.0)
  A2=spline(cross_sect(:,2),cross_sect(:,3),24.0)
  Y3=spline(cross_sect(:,4),cross_sect(:,1),28.0)
  T3=spline(cross_sect(:,4),cross_sect(:,2),28.0)
  A3=spline(cross_sect(:,4),cross_sect(:,3),28.0)
  Y4=spline(cross_sect(:,3),cross_sect(:,1),100.0)
  T4=spline(cross_sect(:,3),cross_sect(:,2),100.0)
  P4=spline(cross_sect(:,3),cross_sect(:,4),100.0)
  