% This script solves projectile problems such as Example No. 2 at the 
%end of Appendix C.  It is similar to the PROJECTILE program in Fortran
% and C that are given at the end of this appendix.  This program uses
% the MATLAB built-in ODE solver ode45, and it produces the same results
% as given from the programs listed there.  Note that ode45 returns a
% matrix with 4 columns for xx (the for variables being solved) and
% it determined the number of rows in this matrix. 
% The last row of this matrix is printed as the solution.
% The solution process is terminated when y=xx(n,3)
% becomes less than zero, i.e. the projectile has hit the ground, just
% as do the programs given at the end of Appendix C.
W=input('Give Projectile Weight ');
K=input('Give the drag coef. ');
g=input('Accel of gravity = ');
V=input('Its initial velocity = ');
angle=input(' It angle at lift off = ');
delt=input(' Time incremetn, delt = ');
gkw=g*K/W; x(1)=0.0; x(3)=0; x(2)=V*cos(angle*pi/180);
x(4)=V*sin(angle*pi/180); t1=0;  icont=1;
if g<20
    fprintf(' t(sec)      x(m)     Vx(m/s)      y(m)    Vy(m/s)   V(m/s)\n');
else
    fprintf(' t(sec)     x(ft)    Vx(ft/s)     y(ft)   Vy(ft/s)    V(ft/s)\n');
end
while icont>0
   t2=t1+delt;    
   [tt,xx]=ode45(@dxprojectile,[0 t2],[x]',[],g,gkw);
   nn=size(tt); n=nn(1);
   Vel=sqrt(xx(n,2)^2+xx(n,4)^2);
   fprintf('%6.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n',tt(n),xx(n,1),...
        xx(n,2),xx(n,3),xx(n,4),Vel);
    if xx(n,3)<0
        icont=0;
    end
    t1=t2;
end

