% This script solves projectile problems such as Example No. 2 at the 
% end of Appendix C.  It is similar to the PJECTILE program in Fortran
% and C that are given at the end of this appendix.  It uses the Runge-
% Kutta method as described and it produces the same results as given 
% from the programs listed there. The .m file rukust implements
% this method, and its script comes from converting the programs RUKUST.FOR,
% which are listed in the text into MATLAB syntax.
% The solution process is terminated when y(3), which is the vert. distance,
% becomes less than zero, i.e. the projectile has hit the ground, just
% as do the programs given at the end of Appendix C.
% Script projectile.m solves this same problem but it calls on the built-in
% ODE solver ode45.  Becauase of the global declaration in this script
% which transfers variables g and gkw to the function dxprojectilg, this
% latter function is different than dxprojectile which is used by
% projectile.
global g gkw
W=input('Give Projectile Weight ');
K=input('Give the drag coef. ');
g=input('Accel of gravity = ');
V=input('Its initial velocity = ');
angle=input('It angle at lift off = ');
delt=input('Time incremetn, delt = ');
gkw=g*K/W; x=[0 V*cos(angle*pi/180) 0 V*sin(angle*pi/180)];
t1=0; ndeg=4; dts=.2*delt; icont=1; error=2.e-4;
if g<20
    fprintf(' t(sec)      x(m)     Vx(m/s)      y(m)    Vy(m/s)   V(m/s)\n');
else
    fprintf(' t(sec)     x(ft)    Vx(ft/s)     y(ft)   Vy(ft/s)    V(ft/s)\n');
end
while icont==1
   t2=t1+delt; 
      xx=rukust(@dxprojectilg,ndeg,dts,t1,t2,error,x);
      Vel=sqrt(xx(2)^2+xx(4)^2);
   fprintf('%6.2f %10.2f %10.2f %10.2f %10.2f %10.2f\n',t2,xx(1),...
        xx(2),xx(3),xx(4),Vel);
    if xx(3)<=10
        icont=0;
    end
    t1=t2;
    for i=1:ndeg
       x(i)=xx(i);
    end
end

