%This script provides an example that utilizes function splinesu.  It is
%designed to input N pairs of X Y values, and provided a table of x y 
%values in which x has NOUT evenly spaced values, and y is the corresponding
%interpolated values.
%Below the command windown dialog is given to use this program to
%interpolate the data given in Appendix B just before the listing of the
%Fortran subroutine SPLINESU.
%>>splineeven
%Give number of pairs of input data 6
%point-1 X value= 0
%point-1 Y value= 0
%point-2 X value= 5
%point-2 Y value= 2
%point-3 X value= 9
%point-3 Y value= 9
%point-4 X value= 14
%point-4 Y value= 15
%point-5 X value= 18
%point-5 Y value= 17
%point-6 X value= 22
%point-6 Y value= 19
%Give number of evently spaced output values 21
%    0.0000     0.0000
%    1.1000     0.6338
%    2.2000     1.2085
%    3.3000     1.6649
%    4.4000     1.9438
%    5.5000     3.0924
%    6.6000     5.2894
%    7.7000     7.1836
%    8.8000     8.7517
%    9.9000    10.5826
%   11.0000    12.2061
%   12.1000    13.5005
%   13.2000    14.4790
%   14.3000    15.2890
%   15.4000    16.1600
%   16.5000    16.7281
%   17.6000    16.9852
%   18.7000    17.5370
%   19.8000    18.1722
%   20.9000    18.6304
%   22.0000    19.0000
N=input('Give number of pairs of input data ');
X=zeros(N,1); Y=zeros(N,1);
for i=1:N
    X(i)=input(['point-' num2str(i) ' X value= ']);
    Y(i)=input(['point-' num2str(i) ' Y value= ']);
end
d2y=splinesu(X,Y,N,0);
NOUT=input('Give number of evently spaced output values ');
xx=linspace(X(1),X(N),NOUT);
I1=1;  I2=2;
for i=1:NOUT
    while (xx(i)>X(I2)) & (I2<N)
        I1=I2; I2=I2+1;
    end
    while (xx(i)<X(I1)) & (I1>1)
        I2=I1; I1=I1-1;
    end
    DX=X(I2)-X(I1); A=(X(I2)-xx(i))/DX; B=1-A;
    yy(i)=A*Y(I1)+B*Y(I2)+((A*A-1)*A*d2y(I1)+((B*B-1)*B*d2y(I2)))*DX^2/6;
    fprintf(1,'%10.4f %10.4f\n',xx(i),yy(i));
end
    