%This script handles problem such as Problem 5 in Chapter 1 by performing
%two numerical integrations; first the dimensionless velocities across the
%natural channel, and second the depth times the velocity to get the
%differenial flowrate per unit width.  To accomplish this task two
%functions are called: "velocity" for the first intetration, and "flowrate"
%for the second integration.  Simpson's rule as in simpr is used to carry
%out the numerical integrations.  The input data to solve Problem 5 is in
%the file EXPRB5_1.DAT, and when giving this name at the prompt it must be
%enclosed in single brackets ' '.
global I1 I2 NP NX YP VP X Y VS D2VP D2VS D2Y
FILN=input('Give file name containing input data ');
fid=fopen(FILN);
ypvp=fscanf(fid,'%f');
fclose(fid);
NP=ypvp(1);
for i=1:NP
    YP(i)=ypvp(2*i); VP(i)=ypvp(2*i+1);
end
ii=2*NP+2;
NX=ypvp(ii);
for i=1:NX
    X(i)=ypvp(3*i+ii-2);Y(i)=ypvp(3*i+ii-1);VS(i)=ypvp(3*i+ii);
end
D2VP=splinesu(YP,VP,NP,0);
D2Y=splinesu(X,Y,NX,0);
D2VS=splinesu(X,VS,NX,0);
I1=1; I2=2;
qPRIM=simpr('velocity',0,1,1.e-5,15);
fprintf(1,'Integral of dimensionless velocity profile=%10.4f\n',qPRIM);
I1=1; I2=2;
DQ=simpr('flowrate',0,X(NX),1.e-5,15);
fprintf(1,'Flowrate, Q =%10.4f\n',DQ);