% This script solves Example Problem 12 in Chapter 1 by using
% the MATLAN built-in numerical integrater "quad".  The information
% about the velocity profile is placed in the vectors Y and V. The
% coefficients for the 2nd degree polynomial are determined by
% using \ division of the coefficient matrix into the known vector
% and finally alpha is determined by integrating the velocity 
% profile cubed.  When you execute this script the results in the
% text will be verified.
Y=[.1 2.1 2.6]; V=[2.3 2.45 2.35];
C=V(1)*log(Y(1))
coefm=[(Y').^2 Y' ones(3,1)];
coef=coefm\V'
q1=C*quad(inline('1./log(y)','y'),0.00001,0.1)
q2=quad(inline('2.2694+(0.317-0.11.*y).*y','y'),.1,2.6)
q=q1+q2
aq1=C^3*quad(inline('1./log(y).^3','y'),0.00001,0.1)
aq2=quad(inline('(2.2694+(0.317-0.11.*y).*y).^3','y'),.1,2.6)
aq=aq1+aq2
V=q/Y(3)
alpha=aq/(q*V^2)