% This script solves Example Problem 9 from Chapter 1, in that it
% uses the MATLAB built in function spline to interpolate the
% dimensionless data from the two tables giving the dimensionless
% upstream and downstream velocity distributions, and then uses
% the MATLAB built in trapz to carry out the integrations.  When
% you run this script you will see the dimensionless upstream unit 
% flow rate is 1.000, and the dimensionless downstream unit flow
% rate is 0.9974 (also very close to unity).  The upstream 
% alpha is 1.2549, and the downstream alpha=1.0529.  The momentum
% correction coefficients beta are also computed as:
% beta upstream =1.1008, beta downstream =1.0217.
Q=48.2; Y=6; b=10; A=b*Y
yY=[0 .07143 .2143 .3571 .5357 .7143 .8571 1];
vV=[0 .3529 .8235 1.0353 1.1764 1.2823 1.2235 1.0823];
y=linspace(0,1,30); 
v=spline(yY,vV,y);
qQ=trapz(y,v)
V=Q/A
alpha=trapz(y,v.^3)
dyY=[0 .0357 .0714 .1429 .3571 .7143 1];
dvV=[0 .5743 .8614 .9763 1.0452 1.0567 1.0452];
dv=spline(dyY,dvV,y);
dqQ=trapz(y,dv)
dalpha=trapz(y,dv.^3)
beta=trapz(y,v.^2)
dbeta=trapz(y,dv.^2)