% This script is designed to solve the problem of any number of downstream
% channels branching from one uptstream channel, and therefore does the
% same tasks as the BRANCHCH programs listed in the text after Example 
% Problem 18 in Chapter # 2.  A gate may exist in any of these downstream
% channels.  When a gate does exist the program still ask for its n and So
% even though these valves are not used.  Rather than transferring the
% large number of variables through the fsolve list of parameters, they 
% are transfered to the function fbranchch, which evaluated the equations,
% by the global declaration.
global b m n So Dz KL N type g2 Cu ngate igat yg areag
g=input('Give g = ');  g2=2*g;  
if g<20
    Cu=1;
else
    Cu=1.486;
end
N=input('Give number of channels ');
type(1)=input('For Channel # 1 type is:(0=trap.,1=cir.) ')>0;
if type(1)
    b(1)=input('D1 = ');
else
    b(1)=input('b1 = '); m(1)=input('m1 = ');
end
n(1)=input('H= '); KL(1)=input('KL = ');
for i=2:N
    type(i)=input(['For Channel #' num2str(i) ' give 0=trap,1=cir. '])>0;
    if type(i)
        b(i)=input(['D' num2str(i) ' = ']);
    else
        b(i)=input(['b' num2str(i) ' = ']); m(i)=input(['m' num2str(i) ' = ']); 
    end
    n(i)=input(['n' num2str(i) ' = ']);
    So(i)=input(['So' num2str(i) ' = ']);
    Dz(i)=input(['Dz' num2str(i) ' = ']);
    KL(i)=input(['KL' num2str(i) ' = ']);
end
ngate=input('Give number of gates = '); 
if ngate>0
    disp('Numbers must be consecutive');
    for i=1:ngate
        igat(i)=input(['Channel No. containing gate # ' num2str(i) ' = ']);
        Cc=input('This gates contraction coef. = ');
        yg(i)=input('Its heigth above channel bottom = ')*Cc;
        if type(igat(i))
            beta=acos(1-2*yg(i)/b(igat(i)));
            areag(i)=b(igat(i))^2/4*(beta-cos(beta)*sin(beta));
        else
            areag(i)=(b(igat(i))+m(igat(i))*yg(i))*yg(i);
        end
    end
end
    igat(ngate+1)=100;
disp('Provide initial guesses')
for i=1:N
    qy(2*i-1)=input(['Q' num2str(i) ' = ']);
    qy(2*i)=input(['Y' num2str(i) ' = ']);
end
  option=optimset('display','off','TolX',1.e-4);
SQY=fsolve('fbranchch',qy,option);
fmt='%8.1f %8.3f'; head='    Q1       Y1 ';
for i=2:N
    fmt=[fmt ' %8.1f %8.3f'];head=[head '       Q' num2str(i) '       Y' num2str(i)];
end
fmt=[fmt '\n)']; head=[head '\n'];
fprintf(head);
fprintf(fmt,SQY);