% This script solve the Chezy Equation and the Chezy C equation
% It differs from "chezy.m" or "chezy1.m" in that only the Chezy's equation
% is solved with the MATLAB built-in function fsolve, rather than the two
% equations (Chezy's & Chezys C eqs.) simultaneously.  Since the Chezys C
% equation converges very rapidly with a Gauss-Seidel iteration, i.e.
% computing the new C on the left of the equal sign from a guess on the
% right of the equal sign, this equation is iteratively solved in this main
% script.  Thus the function "fxhezy2.m" only solve the Chezy equation.
% Since fsolve requires that the first argument of the function by the
% unknown, it is passed, but then immediately assigned again to the
% position in X that contains the unknown, e.g. X(IU)=xx; as the 1st
% statement.  The dialog in the command window to solve Homework Problem 1
% in Chapter 2 follows:
%>>chezy2
%Give:1=trap.,2=cir. for channel type 2
%Give:1=ES or 2=SI units 2
%Give k. viscosity 1.519e-6
%Give the number for the unknown:
%e = 1
%Q = 2
%S = 3
%Y = 4
%D = 5
% Number = 2
%Give value to known variables and guess for unknown
%e = .0003
%Q = 2.5
%S = .0004
%Y = 1.3
%D = 2
%Unknown Q = 2.4741, C = 75.3837
%e = 0.0003
%Q = 2.4741
%S = 0.0004
%Y = 1.3
%D = 2

UNT='eQSYbme'; UNC='eQSYD';
IT=input('Give:1=trap.,2=cir. for channel type ');
KU=input('Give:1=ES or 2=SI units ');  C=70;  g=9.81;
vis=input('Give k. viscosity ');
if KU==1, C=130;  g=32.2; end;
if IT==1
  UN=UNT; I2=6;
else
    UN=UNC; I2=5;
end
disp('Give the number for the unknown:');
for i=1:I2
     disp([UN(i) ' = ' num2str(i)]);
 end
 IU=input(' Number = ');
  disp('Give value to known variables and guess for unknown');
 for i=1:I2, X(i)=input([UN(i) ' = ']); end;
 s32g=sqrt(32*g); g884=0.221*vis/sqrt(g); XU=X(IU);  C1=1.2*C;
 opt=optimset('display','off');
 while (abs(C1-C)+abs(XU-X(IU)))>1.e-4
    XU=X(IU); C1=C; 
    if IT==1
        A=(X(5)+X(6)*X(4))*X(4);
        P=X(5)+2*sqrt(X(6)^2+1)*X(4);
    else
        cosb=1-2*X(4)/X(5); beta=acos(cosb);
        A=X(5)^2/4*(beta-cosb*sin(beta));
        P=beta*X(5);
    end
     C=-s32g*log10(X(1)*P/(12.*A)+g884*C1*P/X(2));
     X(IU)=fsolve('fchezy2',X(IU),opt,C,X,IT,IU);
 end
  disp(['Unknown ' UN(IU) ' = ' num2str(X(IU)) ', C = ' num2str(C)]);
  for i=1:I2
       disp([UN(i) ' = ' num2str(X(i))]);
  end  
