%Solves Critical and Specific Energy for Y & Q by substituting the Critical
%Flow equation into the Energy equation and first solving for Y and
%thereafter Q.  The dialog in the command window for solving two problems,
%the first using a trapezoidal channel, and second using a circular channel 
%follows:
%>>e_cr1
%Give g 32.2
%Give type of channel (0=trap, 1=cir.) 0
%Give: b,m,H,Ke enclosed in [ ] [10 1.5 5 .12]
%Solution: Y =    3.531, Q =     496.41
%>>e_cr1
%Give g 9.81
%Give type of channel (0=trap, 1=cir.) 1
%Give: D,H,Ke enclose in [ ] [4 3 .15]
%Solution: Y =    2.061, Q =      26.13

g=input('Give g ');  itype=input('Give type of channel (0=trap, 1=cir.) ');
if itype
    var=input('Give: D,H,Ke enclose in [ ] '); D=var(1);H=var(2);Ke=var(3);
    b=D; m=1;
else
    var=input('Give: b,m,H,Ke enclosed in [ ] ');b=var(1);m=var(2);H=var(3);Ke=var(4);
    D=b;
end
C=.5*(1+Ke); Y=.7*H;  opt=optimset('display','off');
Y=fsolve('fe_cr1',Y,opt,b,m,H,D,C,itype);
AT=areap(Y,b,m,D,itype);  Q=sqrt(g*AT(1)^3/AT(2));
fprintf('Solution: Y = %8.3f, Q = %10.2f\n',Y,Q);
    