% This script solve the energy equation.  You can either have E computed,
% or specify E and solve for Y.  Both a trapezoidal and a circular channel
% are accommodated.  The dialog in the command window for 3 problems
% follows:
%>>energy
%Give 0 to compute E, or 1 to solve for Y 0
%Give 0 for trap., or 1 for circle 0
%Give accel. gravity, g 32.2
%Give:Q,b,m & Y in [ ] [300 10 1 4]
%Specific Energy =    4.4456
%
%>>energy
%Give 0 to compute E, or 1 to solve for Y 1
%Give 0 for trap., or 1 for circle 1
%Give accel. gravity, g 9.81
%Give:Q,E,D, & guess for Y in [ ] [40 4 6 3.8]
%Depth =    3.7664

%>>energy
%Give 0 to compute E, or 1 to solve for Y 1
%Give 0 for trap., or 1 for circle 0
%Give accel. gravity, g 9.81
%Give:Q,E,b,m & guess for Y in [ ] [40 5 10 1 4.8]
%Depth =    4.9854

ipb=input('Give 0 to compute E, or 1 to solve for Y ');
itype=input('Give 0 for trap., or 1 for circle ');
g=input('Give accel. gravity, g ');  g2=2*g;
opt=optimset('display','off');
if ipb
    if itype
        var=input('Give:Q,E,D, & guess for Y in [ ] ');
        Q2g=var(1)^2/g2; E=var(2);D=var(3);Y=var(4);
        Y=fsolve('fenergyc',Y,opt,Q2g,D,E);
    else
        var=input('Give:Q,E,b,m & guess for Y in [ ] ');
        Q2g=var(1)^2/g2; E=var(2); b=var(3); m=var(4); Y=var(5);
        Y=fsolve('fenergyt',Y,opt,Q2g,b,m,E);
    end
    fprintf('Depth =%10.4f\n',Y);
else
    if itype
        var=input('Give:Q,D & Y in [ ] ');Q=var(1);D=var(2);Y=var(3);
        cosb=1-2*Y/D; A=.25*D^2*(beta-sin(beta)*cosb);
    else
        var=input('Give:Q,b,m & Y in [ ] ');
        Q=var(1);b=var(2);m=var(3);Y=var(4); A=(b+m*Y)*Y;
    end
    E=Y+(Q/A)^2/g2;
    fprintf('Specific Energy =%10.4f\n',E);
end
        
        