%This script is designed to solve the energy equation between two adjacent 
%points along either a trapezoidal or circular channel.  Any of the
%variable may be selected as the unknown, with the other variables given.
%The flowrates may be different at the two sections, even though generally
%they would be specified equal. The function fenertwo is used to define the
%equation that is being solved.
cx='Q1Q2KLdzY1Y2b1m1b2m2';
%trap:1=Q1,2=Q2,3=KL,4=dz,5=Y1,6=Y2,7=b1,8=m1,9=b2,10=m2
%circular:1=Q1,2=Q2,4=KL,4=dz,5=Y1,6=Y2,7=D1,8=D2
g2=2*input('Give g = '); itype=input('Give type of channel (0=trap,1=cir) ');
disp('Give number of the unknown'); N=19;  j=0;
if itype
    cx(13)='D';cx(15:16)='D2';cx(17:20)=[]; N=15;
end
for i=1:2:N
    j=j+1; fprintf('%3.0f    %2s\n',j,cx(i:i+1));
end
nuk=input(' '); disp('Give value to variables'); j=0; nnk=0;
if nuk<3, nnk=input('Should both flows be computed? (0=no,1=yes) '); end;
for i=1:2:N
    j=j+1;
    if j==nuk
        var(j)=input([cx(i:i+1) '(guess) = ']);
    else
        var(j)=input([cx(i:i+1) '(known) = ']);
    end
end
opt=optimset('display','off');
if (nuk>5) | (nuk==3) | (nuk==4)
    if itype
        cosb=1-2*var(5)/var(7); beta=acos(cosb);
        A=.25*var(7)^2*(beta-sin(beta)*cosb);
    else
        A=(var(7)+var(8)*var(5))*var(5);
    end
    E=var(5)+(var(1)/A)^2/g2; 
 else
    if itype
        cosb=1-2*var(6)/var(8); beta=acos(cosb);
        A=.25*var(8)^2*(beta-sin(beta)*cosb);
    else
        A=(var(9)+var(10)*var(6))*var(6);
    end
    E=var(6)+(1+var(3))*(var(2)/A)^2/g2+var(4);
end
  unk=var(nuk);
unk=fsolve('fenertwo',unk,opt,itype,nuk,nnk,g2,E,var);
j=0; if nnk,var(1)=unk;var(2)=unk; else var(nuk)=unk; end;
if itype
   cosb=1-2*var(5)/var(7); beta=acos(cosb);
   A=.25*var(7)^2*(beta-sin(beta)*cosb); T=var(7)*sin(beta);
else
   A=(var(7)+var(8)*var(5))*var(5); T=var(7)+2*var(8)*var(5);
end
E1=var(5)+(var(1)/A)^2/g2; Fr1=sqrt(var(1)^2*T/(g2/2*A^3)); 
if itype
    cosb=1-2*var(6)/var(8); beta=acos(cosb); T=var(8)*sin(beta);
    A=.25*var(8)^2*(beta-sin(beta)*cosb);
else
    A=(var(9)+var(10)*var(6))*var(6); T=var(9)+2*var(10)*var(6);
end
E2=var(6)+(var(2)/A)^2/g2; Fr2=sqrt(var(2)^2*T/(g2/2*A^3));
   
fprintf('Specific energy E1 =%9.4f,  E2 =%9.4f, E =%9.4f\n',E1,E2,E);
fprintf('Froude Numbers Fr1 =%9.4f,  Fr2 =%9.4f\n',Fr1,Fr2);
for i=1:2:N
    j=j+1;
    if j==nuk
        fprintf('%3.0f %2s (unknown) = %10.4f\n',j,cx(i:i+1),var(j));
    else
        fprintf('%3.0f %2s (known)   = %10.4f\n',j,cx(i:i+1),var(j));
    end
end

    
    