% This script solves Example Problem 18 in Chapter 2 by utilizing the 
% MATLAB built in function fsolve.  The variables to define the problem are
% global, and are given for this problem within the script.
% The initialization of the 8 unknown variables is provided by the vector
% init and its values are also given within this script.
% You might read in both the global variables and the initial guesses to
% make the script more general to handly 4 channel problems like this one.
% Also the global variables might be passed to fsolve as parameters.
global H KL g Cu b1 m1 b2 m2 n2 So2 b3 m3 n3 So3 b4 m4 n4 So4 Y3d
H=5; KL=.2; g=32.2; b1=15; m1=2; b2=8; m2=1; n2=.013; So2=.0008;
b3=5; m3=1; n3=.013; So3=.0008; b4=5; m4=1; n4=.013; So4=.0008; Cc=.6;
if g<20
    Cu=1;
else
    Cu=1.486;
end
init=[545 4.5 315 4.2 0. 5. 230 4.3];
fprintf('   Yg      Q1       Y1       Q2       Y2       Q3       Y3       Q4       Y4\n');
option=optimset('display','off');
II=0:18; II(1)=.1;
for i=II
    Yg=0.1*i;  Y3d=Cc*Yg;
    SQY=fsolve('fep18ch2',init,option);
    fprintf('%6.2f %8.1f %8.3f %8.1f %8.3f %8.1f %8.3f %8.1f %8.3f\n',Yg,...
        SQY(1),SQY(2),SQY(3),SQY(4),SQY(5),SQY(6),SQY(7),SQY(8));
    init=SQY;
end
