% This script solves Mannings Eq. in a circular channel for the depth
% Y.  Notice it does the using fsolve and uses inline to provide the
% Mannings equation to fsolve without using an additional line to
% compute the angle beta, i.e. Mannings eq. is contained in 1 line.
Q=input('Q = ');D=input('D = ');n=input('n = ');Sf=input('Sf = ');
Cu=input('Cu = '); Y=input('Y (guess) = ');
o=optimset('display','off');
YM=inline('n*Q-Cu*(D^2/4*(acos(1-2*Y/D)-(1-2*Y/D)*sin(acos(1-2*Y/D))))^1.666667/(D*acos(1-2*Y/D))^0.6666667*sqrt(Sf)','Y','Q','D','n','Sf','Cu');
Y=fsolve(YM,Y,o,Q,D,n,Sf,Cu)