% This script is designed to solve Example Problem 13 in Chapter 3,
% and similar problems by calling on the MATLAB built-in function
% fsolve.  Here 9 equations are being solved for the unknown indicated
% in the first statements in the function fep13ch3, that supplies
% the equations to fsolve as they are driven toward equaling zero.
% As suggested by a comment you might also have this script solve
% Y1 and Sf1, rather than inputting their values. The dialog to
% solve Problem 13 is given below along with the solution.
%>>ep13ch3
%Give the following:
%g = 32.2
%Pipe dia. 5
%Bottom slope 1 .0482
%Bottom slope 2 .01
%Dia. of discharge pipe 1.5
%Length pipe 2 500
%Length of disch. pipe 1200
%Pipes e (inch) .0045
%Weir height 4
%Discharge coef. .6
%Length weir 50.6
%Dif. elev. 103
%Pres. head 90
%Incoming flow rate = 600
%Sf1 = .0336853
%Y1 = 3.962
%Solution:
%Q2=  577.62
%Qp=22.37948
%x= 394.252
%d=   6.150
%Sf2= 0.03109 
%H= 2.330
%z=   11.87
%f= 0.01157
%fp= 0.01499
global D So1 So2 Dp L2 Lw Zw Cd Lp Dz phead Q1 e Sf1 Y1 vis Ap At g g2
disp('Give the following:');
g=input('g = '); D=input('Pipe dia. '); g2=2*g;
So1=input('Bottom slope 1 '); So2=input('Bottom slope 2 ');
Dp=input('Dia. of discharge pipe ');L2=input('Length pipe 2 ');
Lp=input('Length of disch. pipe ');e=input('Pipes e (inch) ')/12;
Zw=input('Weir height ');Cd=input('Discharge coef. ');Lw=input('Length weir ');
Dz=input('Dif. elev. '); phead=input('Pres. head ');
Q1=input('Incoming flow rate = '); vis=1.41e-5;
Sf1=input('Sf1 = '); Y1=input('Y1 = '); 
% In place of the last line of input Sf1 & Y1 the Manning's Eq.
% can be solved and then the Darcy-Weisbach and Colebrook-White.
Ap=pi*Dp^2/4; At=pi*D^2/4;
% To read in starting values for unknowns put this statements in
%init=input('Give guess for:Q2,Qp,x,d,Sf2,H,z,f,fp enclosed in [ ] ');
init=[570 30 530 4 .03 2.5 12 .03 .03]; 
option=optimset('display','off','TolX',1.e-4);
sol=fsolve('fep13ch3',init,option);
fprintf(1,'Solution:\n');
fprintf(1,'Q2=%8.3f\nQp=%8.3f\nx=%8.3f\nd=%8.3f\nSf2=%8.5f\n',sol(1:5));
fprintf(1,'H=%8.3f\nz=%8.2f\nf=%8.5f\nfp=%8.5f\n',sol(6:9));