% This script is designed to solve problems such as Example Problem 8 in
% Chapter 3.  It call on the MATLAB built-in function "fsolve" to solve the
% three simultaneous equation, namely the continuity and momentum equations
% from the view point of a moving observer, and the energy equation across
% the gate from the view point of a stationary observer.  The equations are
% defined in the script fep8ch3.  In these scripts the problem variables
% are stored in the vector "var", and the three unknowns are stored in the
% vector unk.  The dialog in the command window to solve Problem 8 is given
% below.
%>> ep8ch3
%Provide the following enclosed in square brackets [ ]
%g,b,m,V1,Y1,yG,Cc,b3,m3 [32.2 10 1 4.504 3.973 .5 .82 8 0]
%Gives guesses for: vw,Y2 & V2 (within [] [8 5 .7]
%Solution for: vw, Y2 and V2 is:
%sol =
%    8.1608    5.2023    0.7292
disp('Provide the following enclosed in square brackets [ ]');
var=input('g,b,m,V1,Y1,yG,Cc,b3,m3 '); g=var(1);
unk=input('Gives guesses for: vw,Y2 & V2 (within [] ');
Y3=var(7)*var(6); A3S=2*g*((var(8)+var(9)*Y3)*Y3)^2;
A1=(var(2)+var(3)*var(5))*var(5);
option=optimset('display','off');
disp('Solution for: vw, Y2 and V2 is:')
sol=fsolve('fep8ch3',unk,option,var,Y3,A1,g,A3S)

