%This script is designed to solve for the momentum function in either a
%trapezoidal or a circular channel.  Below two examples of its use are
%given.
%>>momentum
%Give:g,itype (0=trap.,1=circle) in [ ] [32.2 0]
%Give:Q,Y,b & m in [ ] [300 5 10 1.5]
%Momentum function =  219.4432
%>>momentum
%Give:g,itype (0=trap.,1=circle) in [ ] [9.81 1]
%Give:Q,Y & D in [ ] [40 4 9]
%Momentum function =   51.9399

var=input('Give:g,itype (0=trap.,1=circle) in [ ] '); g=var(1);itype=var(2);
if itype
    var=input('Give:Q,Y & D in [ ] ');
    Q=var(1);Y=var(2);D=var(3);
    cosb=1-2*Y/D; beta=acos(cosb);A=.25*D^2*(beta-sin(beta)*cosb);
    Mkn=D^3/24*(3*sin(beta)-3*beta*cosb-sin(beta)^3)+Q^2/(g*A);
else
    var=input('Give:Q,Y,b & m in [ ] ');
    Q=var(1); Y=var(2);b=var(3);m=var(4);
    A=(b+m*Y)*Y; Mkn=(b/2+m/3*Y)*Y^2+Q^2/(g*A);
end
fprintf('Momentum function =%10.4f\n',Mkn);