%This script is designed to solve for any of the variables associated with
%applying the momentum function equal across a hydraulic jump.  The
%flowrates upstream and downstream may be different.  When solving for
%either flowrate you will be prompted whether they are to be equal or not.
%trap:1=Q1,2=Q2,3=Y1,4=Y2,5=b1,6=m1,7=b2,8=m2
%circular:1=Q1,2=Q2,3=Y1,4=Y2,5=D1,6=D2
cx='Q1Q2Y1Y2b1m1b2m2';
g=input('Give g = '); itype=input('Give type of channel (0=trap,1=cir) ');
disp('Give number of the unknown'); N=15;  j=0; g2=2*g;  nnk=0;
if itype
    cx(9)='D';cx(11:12)='D2';cx(13:16)=[]; N=11;
end
for i=1:2:N
    j=j+1; fprintf('%3.0f    %2s\n',j,cx(i:i+1));
end
nuk=input(' '); disp('Give value to variables'); j=0;
if nuk<3, nnk=input('Are both flowrates equal? (0=no,1=yes) '); end;
for i=1:2:N
    j=j+1;
    if j==nuk
        var(j)=input([cx(i:i+1) '(guess) = ']);
    else
        var(j)=input([cx(i:i+1) '(known) = ']);
    end
end
opt=optimset('display','off');
if nuk>3
    if itype
        cosb=1-2*var(3)/var(5); beta=acos(cosb);
        A=.25*var(5)^2*(beta-sin(beta)*cosb);
        Ahc=var(5)^3/24*(3*sin(beta)-3*beta*cosb-sin(beta)^3);
    else
        A=(var(5)+var(6)*var(3))*var(3);Ahc=(var(5)/2+var(6)/3*var(3))*var(3)^2;
    end
   MOM=Ahc+var(1)^2/(g*A);
 else
    if itype
        cosb=1-2*var(4)/var(6); beta=acos(cosb);
        A=.25*var(6)^2*(beta-sin(beta)*cosb);
        Ahc=var(6)^3/24*(3*sin(beta)-3*beta*cosb-sin(beta)^3);
    else
        A=(var(7)+var(8)*var(4))*var(4);Ahc=(var(7)/2+var(8)/3*var(4))*var(4)^2;
            end
   MOM=Ahc+var(2)^2/(g*A);
end
  unk=var(nuk);
unk=fsolve('fmomentwo',unk,opt,itype,nuk,nnk,g,MOM,var);
j=0; if nnk, var(1)=unk;var(2)=unk; else var(nuk)=unk; end;
if itype
   cosb=1-2*var(3)/var(5); beta=acos(cosb);
   A=.25*var(5)^2*(beta-sin(beta)*cosb); T=var(5)*sin(beta);
else
   A=(var(5)+var(6)*var(3))*var(3); T=var(5)+2*var(6)*var(3);
end
E1=var(3)+(var(1)/A)^2/g2; Fr1=sqrt(var(1)^2*T/(g*A^3)); 
if itype
    cosb=1-2*var(4)/var(6); beta=acos(cosb); T=var(6)*sin(beta);
    A=.25*var(6)^2*(beta-sin(beta)*cosb);
else
    A=(var(7)+var(8)*var(4))*var(4); T=var(7)+2*var(8)*var(4);
end
E2=var(4)+(var(2)/A)^2/g2; Fr2=sqrt(var(2)^2*T/(g*A^3));
fprintf('Momentum function =%10.4f\n',MOM);
fprintf('Specific energy E1 =%9.4f,  E2 =%9.4f\n',E1,E2);
fprintf('Froude Numbers Fr1 =%9.4f,  Fr2 =%9.4f\n',Fr1,Fr2);
for i=1:2:N
    j=j+1;
    if j==nuk
        fprintf('%3.0f %2s (unknown) = %10.4f\n',j,cx(i:i+1),var(j));
    else
        fprintf('%3.0f %2s (known)   = %10.4f\n',j,cx(i:i+1),var(j));
    end
end
