%This script is the same as "GVFXY1.m" except that the channel is a pipe
%rather than a trapezoid.  It solve the equation dx=(So-Sf)dE by a crude
%trapezoidal rule numerical integration.
var=input('Give:Q,D,n,So,Y1,Y2,N,g enclosed in [ ] '); Cu=1.;
Q=var(1);D=var(2);n=var(3);So=var(4);Y1=var(5);Y2=var(6);N=var(7);g=var(8);
if g > 30.
Cu=1.486;
end;
Q2G=Q^2/(2.*g); QnC=n*Q/Cu; cosb=1-2*Y1/D;beta=acos(cosb);
A=.25*D^2*(beta-sin(beta)*cosb); P=D*beta;E1=Y1+Q2G/A^2;  x=0.;
Sf1=(QnC*(P/A)^.66666667/A)^2;
fprintf('     Y       E    delE      Sf      So-Sf   del x     x\n');
fprintf('---------------------------------------------------------\n');
fprintf('%8.3f %7.3f        %8.6f                %9.2f\n',Y1,E1,Sf1,x);
DY=(Y2-Y1)/N;
for i=1:N
Y=Y1+DY*i; cosb=1-2*Y/D;beta=acos(cosb); A=.25*D^2*(beta-sin(beta)*cosb);
P=D*beta; E=Y+Q2G/A^2;
Sf=(QnC*(P/A)^.66666667/A)^2;
SFOAV=So-.5*(Sf+Sf1); DELX=(E-E1)/SFOAV;  x=x+DELX;
fprintf('             %10.3f         %10.6f %8.1f\n',E-E1,SFOAV,DELX);
fprintf('%8.3f %7.3f        %8.6f                %9.2f\n',Y,E,Sf,x);
E1=E; Sf1=Sf;
end