%This script solves problems such as Ex. Prb. 66 in Chapter 4, in which a
%side weir discharges the entire amount of incoming flow over its length.
%The solution is for the bottom width of a rectangular channel, and a
%secondary quantity solved is the height of side weir as a function of
%position x so that the outflow is constant over the length of the weir.
%The input to solve Ex. Prb. 66 is [5280 400 20 1200 .013 -.0005 .52 32.2]
% Note that the function fdbx is used to define db/dx.
global Cu g n So Qo qs L
var=input('Give: L,DELX,bo,Qo,n,So,Cd,g enclosed in [ ] ');
L=var(1);DELX=var(2);bo=var(3);Qo=var(4);n=var(5);So=var(6);Cd=var(7);g=var(8);
qs=Qo/L; 
if g>25
    Cu=1.486; un1='(ft)'; un2='(cfs)';
else
    Cu=1; un1='(m) '; un2='m^3/s';
end 
Q=Qo; X=0; XZ=DELX;  Y=bo/2; bz=bo; DH=qs/(Cd*sqrt(2*g)*2/3);
fprintf('   x%4s  b%4s   Q%5s    Y%4s  Hw%4s\n',un1,un1,un2,un1,un1);
fprintf('----------------------------------------\n'); icont=1;
fprintf('%8.1f %7.3f %7.1f %7.2f %7.2f\n',X,bo,Qo,Y,Y-DH);
while (XZ<=L) && (icont)
    [xx,bb]=ode45('fdbx',[X XZ],bz);
    nn=size(xx,1);  X=XZ; if XZ==L icont=0; end;
    Q=Qo*(1-X/L);Y=bb(nn)/2;
    fprintf('%8.1f %7.3f %7.1f %7.2f %7.2f\n',X,bb(nn),Q,Y,Y-DH);
    bz=bb(nn);XZ=X+DELX; if XZ>L, XZ=L; end;
end