%This script solves the gutter problem that has inflow coming in over its
%length, and gutter at both ends that take in all of the water so that
%critical flow takes place at both ends. It performs the same task as the
%Fortran program GUTTER.FOR listed in the text.  The MATLAB built-in
%functions "fsolve" and and "ode45" are utilized, and this script call on
%function "fguttera" to supply the 4 equations, and "fdyxgutter" to define
%the ODE dY/dx with the lateral inflow.
global n So m fms qs Cu Hm g L GM2 Xs
var=input('Give:n,So,m,L,qs & g within [ ] ');
n=var(1);So=var(2);m=var(3);L=var(4);qs=var(5);g=var(6);
Hm=.5*m; fms=1+sqrt(m^2+1); Cu=1; if g>20 Cu=1.486; end; 
GM2=g/8*m^2; g2=2*g;
%X(4)=input('Give guess for position xs: ');
%X(1)=((qs*X(4))^2/GM2)^0.2; X(2)=((qs*(L-X(4)))^2/GM2)^0.4;X(3)=X(1)+X(2);
X=input('Give guesses for: Yl,Yr,Ys & Xs ');
fprintf('guesses for unknowns %8.2f %8.2f %8.2f %8.2f\n',X);
GM2=GM2*m;
option=optimset('display','off','TolX',1.e-3);
XX=fsolve('fguttera',X',option);
fprintf('Solution:Ycl =%10.4f, Ycr =%10.4f, Ys =%10.4f, Xs =%8.4f\n',XX');
[xx,yy]=ode45('fdyxgutter',[X(4) 0],X(1));
disp('Upstream GVF solution:')
fprintf('    x       Y         Q        E        A       Fr\n');
for i=1:size(xx,1)
    Q=(X(4)-xx(i))*qs; A=Hm*yy(i)^2; E=yy(i)+(Q/A)^2/g2;
    Fr=sqrt(m*Q^2*yy(i)/(g*A^3)); 
    fprintf('%7.2f %8.3f %8.3f %8.3f %8.3f %8.3f\n',xx(i),yy(i),Q,E,A,Fr);
end
disp('Downsstream GVF solution:')
fprintf('    x       Y         Q        E        A       Fr\n');
[xx,yy]=ode45('fdyxgutter',[X(4) L],X(2));
for i=1:size(xx,1)
    Q=(xx(i)-X(4))*qs; A=Hm*yy(i)^2; E=yy(i)+(Q/A)^2/g2;
    Fr=sqrt(m*Q^2*yy(i)/(g*A^3)); 
    fprintf('%7.2f %8.3f %8.3f %8.3f %8.3f %8.3f\n',xx(i),yy(i),Q,E,A,Fr);
end