%This script is designed to solve the GVF between a reservoir at the 
%beginning of a channel and a gate at its downstream end.  The channel may
%either be trapezoidal or circular.
%An example of a problem in a trapezoidal channel follows:
5>>gvfresgate
%Give:g,H,Ke,KL,Cc,YG & itype(trap.=0,cir.=1) enclosed in [ ] [32.2 5 .2 .1 .6 3.5 0]
%Give: n,So,L,b1,m & b2 in [ ] [.013 .002 1500 10 1.5 10]
%Give guesses for: Q,Y1 & Y2 in [ ] [250 4.8 5.3]
%unk =
%  272.0332    4.7974    7.8089
% An example of a circular channel is:
%>>gvfresgate
%Give:g,H,Ke,KL,Cc,YG & itype(trap.=0,cir.=1) enclosed in [ ] [9.81 4 .1 .05 .8 2.4 1]
%Give: n,So,L & D in [ ] [.013 .002 1500 9]
%Give guesses for: Q,Y1 & Y2 in [ ] [40 3.8 5]
%unk =
%   61.4247    3.6349    6.6298

global g g2 H Ke KL YG So b1 m b2 D D2 L A3 ncu itype Q
var=input('Give:g,H,Ke,KL,Cc,YG & itype(trap.=0,cir.=1) enclosed in [ ] ');
g=var(1);g2=2*g; H=var(2);Ke=(var(3)+1)/g2;KL=(var(4)+1)/g2;
YG=var(5)*var(6);itype=var(7);
Cu=1; if g>25, Cu=1.486; end;
if itype
    var=input('Give: n,So,L & D in [ ] ');
    n=var(1);So=var(2);L=var(3);D=var(4); D2=.25*D^2;
    cosb=1-2*YG/D; beta=acos(cosb);A3=D2*(beta-sin(beta)*cosb);
else
    var=input('Give: n,So,L,b1,m & b2 in [ ] ');
    n=var(1);So=var(2);L=var(3);b1=var(4);m=var(5);b2=var(6);
    A3=b2*YG;
end
unk=input('Give guesses for: Q,Y1 & Y2 in [ ] '); ncu=n/Cu; Q=unk(1);
opt=optimset('TolFun',1.e-4);
unk=fsolve('fgvfresgate',unk,opt)
