%This script solve GVF problems governed by the equation dx/dY in which x
%is the dependent variable, and Y is the independent variables.  This the
%solution entails doing a numerical integration.  It calls on the function
%simpr, described in Appendix C to do this intergration.
global Q Cun So D b m g itype
g=input('Give:g = '); g2=2*g; Cu=1; if g>25, Cu=1.486;  end;
itype=input('Give itype (0=trap, 1=cir) ');
if itype
    var=input('Give: Q,So,n,Ybeg,Yend,xbeg,D & No steps in [ ] ');
    Q=var(1);So=var(2);n=var(3);Ybeg=var(4);Yend=var(5);xbeg=var(6);
    D=var(7);N=var(8);
else
    var=input('Give: Q,So,n,Ybeg,Yend,xbeg,b,m No steps in [ ] ');
    Q=var(1);So=var(2);n=var(3);Ybeg=var(4);Yend=var(5);xbeg=var(6);
    b=var(7);m=var(8);N=var(9);
end
dY=(Yend-Ybeg)/N; Y1=Ybeg; x=xbeg; Cun=n/Cu;
if itype
    cosb=1-2*Y1/D; beta=acos(cosb);A=D^2/4*(beta-sin(beta)*cosb);T=D*sin(beta);
    Ahc=D^3/24*(3*sin(beta)-3*beta*cosb-sin(beta)^3);
else
    A=(b+m*Y1)*Y1; T=b+2*m*Y1;Ahc=(b/2+m/3*Y1)*Y1^2;
end
E=Y1+(Q/A)^2/g2; Fr=sqrt(Q^2*T/(g*A^3)); Mom=Ahc+Q^2/(g*A);
fprintf('   Depth Position      E    Froude No.   Momentum\n');
fprintf('%8.3f %8.2f  %8.3f %10.3f %10.2f\n',Y1,x,E,Fr,Mom);
for i=1:N
    Y2=Y1+dY;
    dx=simpr('fintegrdxY',Y1,Y2,1.e-5,20);
    x=x+dx;
    if itype
        cosb=1-2*Y2/D; beta=acos(cosb);A=D^2/4*(beta-sin(beta)*cosb);T=D*sin(beta);
        Ahc=D^3/24*(3*sin(beta)-3*beta*cosb-sin(beta)^3);
    else
        A=(b+m*Y2)*Y2; T=b+2*m*Y2;Ahc=(b/2+m/3*Y2)*Y2^2;
    end
    E=Y2+(Q/A)^2/g2; Fr=sqrt(Q^2*T/(g*A^3)); Mom=Ahc+Q^2/(g*A);
    fprintf('%8.3f %8.2f  %8.3f %10.3f %10.2f\n',Y2,x,E,Fr,Mom);
    Y1=Y2;
end