% This script uses the MATLAB function ode45 to solve the ODE dY/Dx=
% (So-Sf)/(1-Fr^2) in a circular section.  It is similar to script odedYdx
% except it assumes a circular, rather than, a trapezoidal channel.
var=input('Give: Q,D,n,So,g,xbeg,xend Y1 enclosed in []: ');
xbeg=var(6);  xend=var(7); Y=var(8);  Cu=1;  
if var(5)>20
    Cu=1.486;
end
fid=input('Should output be written to file? (2=yes,1=no)');
if fid>1 
    FILN=input('Give name of this file ');
    fid=fopen(FILN,'w');
end
fprintf(1,'     x         Y        A        E        M       Fr\n');

[xx,yy]=ode45(@dYcirx,[xbeg,xend],Y,[],Cu,var);
N=size(xx,1);
for i=1:N
    cosb=1-2*yy(i)/var(2);  beta=acos(cosb);
    A=var(2)^2/4*(beta-cosb*sin(beta));
    E=yy(i)+(var(1)/A)^2/(2*var(5));
    M=var(2)/2*(var(2)^2/6*sin(beta)^3-A*cosb)+var(1)^2/(var(5)*A);
    Fr2=sqrt(var(1)^2*(var(2)*sin(beta))/(var(5)*A^3));
    fprintf(fid,'%8.2f %8.3f %8.2f %8.2f %8.2f %8.3f\n',xx(i),yy(i),A,E,M,Fr2);
end
    