% This script uses the MATLAB function ode45 to solve the ODE dY/Dx=
% (So-Sf)/(1-Fr^2). For example it can be used to solve problems like
% Problem 3 and Problem 4 in Chapter 4. 
var=input('Give: Q,b,m,n,So,g,xbeg,xend Y1 enclosed in []: ');
xbeg=var(7);  xend=var(8); Y=var(9);  Cu=1;  
if var(6)>20
    Cu=1.486;
end
fid=input('Should output be written to file? (2=yes,1=no)');
if fid>1 
    FILN=input('Give name of this file ');
    fid=fopen(FILN,'w');
end
fprintf(1,'     x         Y        A        E        M       Fr\n');

[xx,yy]=ode45(@dYx,[xbeg,xend],Y,[],Cu,var);
N=size(xx,1);
for i=1:N
    A=(var(2)+var(3)*yy(i))*yy(i);
    E=yy(i)+(var(1)/A)^2/(2*var(6));
    M=(var(2)/2+var(3)/3*yy(i))*yy(i)^2+var(1)^2/(var(6)*A);
    Fr2=sqrt(var(1)^2*(var(2)+2*var(3)*yy(i))/(var(6)*A^3));
    fprintf(fid,'%8.2f %8.3f %8.2f %8.2f %8.2f %8.2f\n',xx(i),yy(i),A,E,M,Fr2);
end
    