% This script uses the MATLAB function quad to numerically integrate dx/DY=
% (1-Fr^2)/(So-Sf). For example if it is used to solve Example Problem 2
% in Chapter 4, the dialog in the command window giving the input would be
% as follows: (with the solution thereafter)
%>>odedxdY
%Give: Q,b,m,n,So,g,Y1,Y2 & DelY enclosed in [][450 10 1.4 .015 .0008 32.2 6 4.75 -.25]
%     Y        E        x
%   5.750     6.04  -369.61
%   5.500     5.83  -757.00
%   5.250     5.63 -1171.19
%   5.000     5.44 -1629.22  (NOte the length is smaller than obtained by
%   4.750     5.25 -2169.42  the crude integration in the text.)
var=input('Give: Q,b,m,n,So,g,Y1,Y2 & DelY enclosed in []');
N=(var(8)-var(7))/var(9); Cu=1; x=0.; Y1=var(7);
if var(6)>20
    Cu=1.486;
end
fprintf(1,'     Y        E        x\n');
for i=1:N
    YE=Y1+var(9);
    x=x+quad(@(y)dxY(y,Cu,var),Y1,YE);
    E=YE+(var(1)/((var(2)+var(3)*YE)*YE))^2/(2*var(6));
    fprintf(1,'%8.3f %8.2f %8.2f\n',YE,E,x);
    Y1=YE;
end
    