%This script performs the task of the programs SOLGVF in Chapter 4.  It uses
% MATLAB's function "fsolve" and "ode45" to solve the 3 simultaneous
%equations. It uses function "fsolgvfa" to define the 3 equation, and the
% function "fdyx" to supply dY/dx to ode45. The following dialog in the
%command window show an example of input and the solution.
%>>solgvfa
%Give:b1,m1,n,So,b2,H,L,KL,KE,g in [ ] [12 1 .02 .0009 10 7 1000 .05 .03 32.2]
%Give guesses for: Q,Y1 & Y2 in [ ] [500 6.8 6.5]
%Q =    590.88 Y1 =     6.635 Y2 =     6.961 Yc =   4.768
%
global b1 m1 n So b2 H L KL KE1 Cu g g2 Q2G QN
var=input('Give:b1,m1,n,So,b2,H,L,KL,KE,g in [ ] ');
b1=var(1);m1=var(2);n=var(3);So=var(4);b2=var(5);H=var(6);L=var(7);
KL=var(8);KE=var(9);g=var(10);  Cu=1.; g2=2*g;KE1=KE+1;
if g>20
    Cu=1.486;
end
X=zeros(1,3);
X=input('Give guesses for: Q,Y1 & Y2 in [ ] ');
option=optimset('display','off','TolX',1.e-4);
XX=fsolve('fsolgvfa',X',option);
fprintf('Q =%10.2f Y1 =%10.3f Y2 =%10.3f Yc =%8.3f\n',XX',((XX(1)/b2)^2/g)^.333333);