%This script is designed to solve problems with lateral inflow over a
%middle length L of channel with the slope of the channel possibly being
%differnt at the beginning of the lateral inflow section. It is designed to
%handle the same type of problem that program SOLINF2 in the text solve.
%The convention in those programs assumes that the flow rate in the
%upstream channel is positive if toward the left (and that in the
%downstream channel beyond the lateral inflow is to the right.  This script
%uses the convention that flow rates to the right are positive, and to the
%left are negative.  Thus if the upstream flow rate is to the left it is
%negative.  The programs listed in the text assume the same bottom slope
%since only one So is input, with the upstream channel with a negative So.
%This script allows for two bottom slopes So1 and So2, in which So1 would
%generally be negative, but can be positive. The function "fsolin2a" is
%called to define the 5 equation, and function "fdyxinf2" is used to supply
%the derivative dY/dx to ode45, that is used to solve the ODE.  The system
%of 5 equations is solved using the MATLAB function fsolve.  

global b m m2 fms n Cu qs Uqs L L1 So1 So2 ss1 ss2 g Q1 IBC WS
var=input('Give:n,So1,So2,b,m,L,L1,qs,Uq,angle & g within [ ] ');
n=var(1);So1=var(2);So2=var(3);b=var(4);m=var(5);L=var(6);L1=var(7);qs=var(8);
  Uq=var(9);theta=var(10); g=var(11); Cu=1; if g>20, Cu=1.486; end;
IBC=input('Give no. for BC (1=crit., 2=WS given, 3=uniform) ');
if IBC==2, WS=input('Give WS = '); end;
X=input('Give guesses for: Q1(may be -),Q2,Y1,Y2,Yu within [ ] ');
Uqs=Uq*cos(pi*theta/180); m2=2*m; fms=2*sqrt(m^2+1);ss2=sqrt(So2);
if So1<0, ss1=-sqrt(abs(So1)); else ss1=sqrt(So1); end;
option=optimset('display','off','TolX',1.e-4);
XX=fsolve('fsolinf2a',X',option);
fprintf('Q1 =%10.3f, Q2 =%10.3f, Y1 =%10.4f, Y2 =%8.4f, Yu =%8.4f\n',XX');