%This script is designed to solve problems with lateral inflow over a
%middle length L of channel with the slope of the channel possibly being
%differnt at the beginning of the lateral inflow section. It is designed to
%handle the same type of problem that program SOLINF in the text solve.
%The convention in those programs assumes that the flow rate in the
%upstream channel is positive if toward the left (and that in the
%downstream channel beyond the lateral inflow is to the right.  This script
%uses the convention that flow rates to the right are positive, and to the
%left are negative.  Thus if the upstream flow rate is to the left it is
%negative.  The programs listed in the text assume the same bottom slope
%since only one So is input, with the upstream channel with a negative So.
%This script allows for two bottom slopes So1 and So2, in which So1 would
%generally be negative, but can be positive. At the beginning of the
%lateral
%inflow Y1 is assume normal for the upstream channel, i.e. nothing upstream
%effects this depth (see script solinf2a if not.) The function "fsolina" is
%called to define the 4 equation, and function "fdyxinf" is used to supply
%the derivative dY/dx to ode45, that is used to solve the ODE.  The system
%of 4 equations is solved using the MATLAB function fsolve.  The input and
%solution to Example Problem 16 in Chapter 4 is given in the following
%dialog from the command window.
%>>solinfa
%Give:n,So1,So2,b,m,L,qs,Uq,angle & g within [ ] [.018 -.0005 .0005 10 1.5 30 25 8 45 32.2]
%Give guesses for: Q1(may be -),Q2,Y1 & Y2 within [ ] [-290 460 4.6 5.8]
%Q1 =   -287.73 Q2 =   462.266 Y1 =     4.385 Y2 =   5.573

global b m m2 fms n Cu qs Uqs L So2 ss1 ss2 g Q1
var=input('Give:n,So1,So2,b,m,L,qs,Uq,angle & g within [ ] ');
n=var(1);So1=var(2);So2=var(3);b=var(4);m=var(5);L=var(6);qs=var(7);
  Uq=var(8);theta=var(9); g=var(10); Cu=1; if g>20, Cu=1.486; end;
X=input('Give guesses for: Q1(may be -),Q2,Y1 & Y2 within [ ] ');
Uqs=Uq*cos(pi*theta/180); m2=2*m; fms=2*sqrt(m^2+1);ss2=sqrt(So2);
if So1<0, ss1=-sqrt(abs(So1)); else ss1=sqrt(So1); end;
option=optimset('display','off','TolX',1.e-4);
XX=fsolve('fsolinfa',X',option);
fprintf('Q1 =%10.3f Q2 =%10.3f Y1 =%10.4f Y2 =%8.4f\n',XX');