% This script is designed to solve the 7 unknowns for the solution of a
% supercritical transition.  Below the dialog, e.g. input, needed to solve
% Example Problem 4 in Chapter 5 is given.  The variables needed to solve a
% problem are in the vector "var", and their order is as follows:
% 1 = b1 (upstream width of rect. channel), 2 = b2 (downstream width of ch)
% 3 = Y1 (upstream depth), 4 = V1 (upstream velocity), 5 = Y3 (downstream
% depth and 6 = g (acceleration of gravity)
% The unknowns are in the vector "unk" and their order is as follows:
% 1=L (length of transition), 2=x (length of converges of waves),
% 3=z (length from converges of waves to end of transition)
% 4=Y2 (depth within trasition), 5=angle theta, 6=angle beta, &
% 7=angle beta prime.
%>>ep4ch5
%Provide the values of the known variables
%b1,b2,Y1,V1,Y3 & g enclosed in [ ] [10 5 2 25 5 32.2]
%Provide guesses for 7 unknowns
%L,x,z,Y2,theta,beta & betaprime enclosed in [ ] [14 9 5 2 .18 .5 .7]
%suptras =
%   13.1559    9.0661    4.0898    3.3712    0.1878    0.5040    0.7365
disp('Provide the values of the known variables');
var=input('b1,b2,Y1,V1,Y3 & g enclosed in [ ] ');
disp('Provide guesses for 7 unknowns');
unk=input('L,x,z,Y2,theta,beta & betaprime enclosed in [ ] ');
option=optimset('display','off');
suptras=fsolve('fep4ch5',unk,option,var)