% This script solves a supercritical transition, as does script ep4ch5,
% with the exception that in this script the upstream depth and velocity,
% and the downstream depth have been added to the list of unknowns, and the
% continuity and two Mannings equation have been added to the equations, so
% that in this script there are 10 equations and 10 unknowns.  The unknowns
% are as given in the comments for ep4ch5 with Y1, V1 and Y3 added at the
% end.  
disp('Provide the values of the known variables');
var=input('b1,b2,Q,n,So1,So2 & g enclosed in [ ] ');  g=var(7);Cu=1;
if g>20
    Cu=1.486;
end
disp('Provide guesses for 10 unknowns');
unk=input('L,x,z,Y2,theta,beta,betaprime,Y1,V1 & Y3 enclosed in [ ] ');
option=optimset('display','off');
suptras=fsolve('fep4ch5e',unk,option,var,Cu)
Fr1=suptras(9)/sqrt(g*suptras(8));
Fr3=var(3)/(var(2)*suptras(10))/sqrt(g*suptras(10));
fprintf(1,'Upstream & downstream Froude No.s are:%8.3f %8.3f\n',Fr1,Fr3);