%This script generates the three roots of Eq. 35 (Example Problem 5 in
%Chapter 5) for a range of r=b2/b1 from 1.2 to 2.2 in increments of 0.2,
%and for the Froude Number squares from 0.1 to 0.6 within each of the r's.
%You might add the statements to complete the tables given in Problem 5.
r=1.2:.2:2.2;  Fr2=.1:.1:.6;
for i=1:6
    for j=1:6
        a=2*Fr2(j)/r(i)+1;
        b=2*Fr2(j)/r(i)^2;
        eq=inline(['y^3-' num2str(a) '*y+' num2str(b)]);      
        yy=solve(eq);
        y1=double(yy(1));
        y2=double(yy(2));
        y3=double(yy(3));
        fprintf(1,'%4.1f %4.1f %8.4f %8.4f %8.4f\n',r(i),Fr2(j),y1,y2,y3);
    end
end