%This script solve the submerged flow past a gate in a rectangular channel,
%such as Example Problem 6 in Chapter 5. The MATLAB built-in function
%fsolve is used to solve the 3 equations.  It is very similar to TK-Solver
%model used to solve this example problem. Note it uses the function
%fsubmerged. The dialog in the commmand window to solve this problem is as
%follows:
%>>exprb5_6
%Give upstread depth Y1 = 8
%Give gate's contraction Coef., Cc = .8
%Give height of gate, YG = 2
%Acceleration of gravity, g = 32.2
%Give bottom width, b = 10
%Give Mannings n = .014
%Give bottom slope (downst.), So = .000518
%Give guesses for Y3,Y & q enclosed in [ ] [6 4 30]
%Solution is Y3 =  5.8590, Y =  3.6190, q = 27.4293

Y1=input('Give upstream depth Y1 = ');
Cc=input('Give gate''s contraction Coef., Cc = ');
Y2=Cc*input('Give height of gate, YG = ');
g=input('Acceleration of gravity, g = '); g2=2*g;
b=input('Give bottom width, b = ');
n=input('Give Mannings n = ');
So=sqrt(input('Give bottom slope (downst.), So = '));
X(1)=Y1; X(2)=Y2; X(3)=g; X(4)=b; X(5)=n; X(6)=So; X(7)=g2;
X(8)=1; if g>25, X(8)=1.486; end;
unk=input('Give guesses for Y3,Y & q enclosed in [ ] ');
opt=optimset('display','off');
unk=fsolve('fsubmerged',unk,opt,X);
fprintf('Solution is Y3 =%8.4f, Y =%8.4f, q =%8.4f\n',unk);
