%This script find the size of a trapezoidal channel to minimize the total
%costs including lining and right-of-way cost, just as Fortran Program
%OPTIMAES.FOR does this.  It accomodates either ES or SI units.  It
%utilizes "newt.m" to define the system of equations that are solved using
%the MATLAB built-in function "fsolve."  The dialog to solve Example
%Problem 15 in Chapter 5 is as follows:
%>>optimalcost
%Profile type = 1 or 2: 1
%Give 1 for SI units or 2 for ES units 1
%Canal maximum capacity (m^3/s) =      20
%Bottom slope =                       .0002
%Mannings Coef. =                      .016
%Rv Free Board (m) =                     .5
%Eb Sides lining thickness (m) =         .1
%Er Bottom lining thickness (m) =        .1
%Cb Sides lining unit cost ($/m^3) =     100
%Cr Bottom lining unit cost ($/m^3) =    100
%Cx Excavation unit cost ($/m^3) =       60
%Ce Right of way unit cost ($/m^2) =     15
%Is the canal Side Slope known or not? Y or N in ' ' 'n'
%Uniform depth (m) =     3.8226
%Bottom width (m) =      4.1338
Side slope =            0.1132
%Flow velocity (m/s)=     1.146
%Canal total cost =    1461.726

ves=['Q Canal maximum capacity (ft^3/s) =     ';'So Bottom slope =                       ';
     'n Mannings Coef. =                      ';'Rv Free Board (ft) =                    ';
     'Eb Sides lining thickness (ft) =        ';'Er Bottom lining thickness (ft) =       ';
     'Cb Sides lining unit cost ($/ft^3) =    ';'Cr Bottom lining unit cost ($/ft^3) =   ';
     'Cx Excavation unit cost ($/ft^3) =      ';'Ce Right of way unit cost ($/ft^2) =    '];
vsi=['Q Canal maximum capacity (m^3/s) =      ';'So Bottom slope =                       ';
     'n Mannings Coef. =                      ';'Rv Free Board (m) =                     ';
     'Eb Sides lining thickness (m) =         ';'Er Bottom lining thickness (m) =        ';
     'Cb Sides lining unit cost ($/m^3) =     ';'Cr Bottom lining unit cost ($/m^3) =    ';
     'Cx Excavation unit cost ($/m^3) =       ';'Ce Right of way unit cost ($/m^2) =     '];
var1=['Uniform depth (m) = ';'Bottom width (m) =  ';'Side slope =        ';'Flow velocity (m/s)=';
'Canal total cost =  '];
var2=['Uniform depth (ft)= ';'Bottom width (ft)=  ';'Side slope =        ';'Flow velocity(fps)= ';
'Canal total cost =  '];
itype=input('Profile type = 1 or 2: ');
icu=input('Give 1 for SI units or 2 for ES units ');  Cu=1.; CO=0; NV=10;
if itype==2, CO=1; end;
if icu>1, Cu=1.486; end;
for i=1:NV
    if icu==1
        Y(i)=input(vsi(i,:));
    else
        Y(i)=input(ves(i,:));
    end
end
s=input('Is the canal Side Slope known or not? Y or N in '' '' ');
if (s=='n') | (s=='N')
    N=3; X(3)=1/sqrt(3);
else
    N=2; X(3)=input('Side Slope m = ');
end
QNS=Y(1)*Y(3)/(Cu*sqrt(Y(2)));  SM=2*sqrt(1+X(3)^2);
%Dimensions of the most efficient section are used to get the initial value
%of the variable Yo and b
X(1)=(4.*(QNS/(2*SM-X(3)))^3)^.125; X(2)=2*X(1)*(SM-X(3));
opt=optimset('display','off');
X=fsolve('newt',X,opt,Y,QNS,CO);
YY(1)=Y(1)/((X(2)+X(1)*X(3))*X(1));
Z=X(1)+Y(4); SM=2*sqrt(1+X(3)^2); B1=X(2)+SM*Y(5);TOP=B1+2*X(3)*Z;A=(B1+X(3)*Z)*Z;
YY(2)=Y(8)*Y(6)*(B1-CO*X(3)*Y(6))+Y(7)*Y(5)*SM*Z+Y(9)*A+Y(6)*(B1-CO*X(3)*Y(6))+Y(10)*TOP;
for i=1:3
    if icu==1
        for j=1:20
        fprintf('%s',var1(i,j));
        end
        fprintf('%10.4f\n',X(i));
    else
        for j=1:20
        fprintf('%s',var2(i,j));
        end
        fprintf('%10.4f\n',X(i));
    end
end
for i=4:5
    if icu==1
        for j=1:20
            fprintf('%s',var1(i,j));
        end
        fprintf('%10.3f\n',YY(i-3));
    else
        for j=1:20
            fprintf('%s',var2(i,j));
        end
        fprintf('%10.3f\n',YY(i-3));    
    end
end
