%This script is designed to help you produce tables giving the flow
%conditions past a gate that may be free flowing, or submerged, such as the
%table given with the solution of Example Problem 12 in Chapter 5. 
%To solve the Ex. Problem 12 your input would consist of:
% [.013 .001 5 4 .05 2 800 9.81 0 0] 0 (for not submerged) followed by [4 2 2.8 .7]
% and a file name such as 'solgvfsu.out', and provide additional values for
%y2 (the first column in the table associated with Ex. Pr. 12)

global b1 b2 H g g2 KL2 KE1 L n So Cu QN Q2G yG2 submer
var=input('Give: n,So,b1,b2,y2,H,L,g,KL,Ke within [ ] ');
n=var(1);So=var(2);b1=var(3);b2=var(4);yG2=var(5);H=var(6);L=var(7);g=var(8);
KL2=1+var(9);KE1=1+var(10); g2=2*g; Cu=1; 
if g>25, Cu=1.486; end;
submer=input('Is gate submerged? give 1, if not submerged give 0 ');
if submer
    unk=input('Give guess for: Q,Ybeg,Y1,Y3,Y within [ ] '); N=5;
else
    unk=input('Give guesses for: Q,Ybeg,Y1,Y3 within [ ] '); N=4;
end
filn=input('Give name of file for output: (within '' '') ');
fid=fopen(filn,'w');opt=optimset('display','off','TolX',1.e-4);
while yG2>0
unk=fsolve('fsubmgate',unk,opt);
Fr1=unk(1)/(b1*unk(3))/sqrt(g*unk(3));  Y2=yG2*unk(3);
if submer
fprintf(fid,'%5.3f %7.3f %7.3f %7.4f %7.3f %7.3f %7.3f %7.3f %7.3f\n',...
    yG2,Y2,unk(3),Fr1,unk(1)/b1,unk(1),unk(2),unk(4),unk(5));
fprintf(1,'%5.3f %7.3f %7.3f %7.4f %7.3f %7.3f %7.3f %7.3f %7.3f\n',...
    yG2,Y2,unk(3),Fr1,unk(1)/b1,unk(1),unk(2),unk(4),unk(5));
else
Y=.5*unk(4)*(sqrt(1+8*(unk(1)/(b2*unk(4))))^2/(g*unk(4))-1);    
fprintf(fid,'%5.3f %7.3f %7.3f %7.4f %7.3f %7.3f %7.3f %7.3f %7.3f\n',...
    yG2,Y2,unk(3),Fr1,unk(1)/b1,unk(1),unk(2),unk(4),Y);
fprintf(1,'%5.3f %7.3f %7.3f %7.4f %7.3f %7.3f %7.3f %7.3f %7.3f\n',...
    yG2,Y2,unk(3),Fr1,unk(1)/b1,unk(1),unk(2),unk(4),Y);
end
if (Y<Y2) & (submer==0)
   yguess=input('Give guess for submergence depth Y (0 if still not subm.) ');
   if yguess>0
       submer=1; N=5; unk(5)=yguess;
   end
elseif submer & unk(5)<Y2 
    submer=0; N=4;
end
if submer
    fprintf(1,'%10.3f %9.2f %7.3f %7.3f %7.3f %7.3f %d\n',Y2,unk,submer);
else
    fprintf(1,'%10.3f %9.2f %7.3f %7.3f %7.3f %d\n',Y2,unk,submer);
end
yG2=input('Give next value of y2 (0=stop) ');
end
fclose(fid);