%This script solves Eq. 19, as requested by Example Problem 2 in Chap. 6 by
%calling on the MATLAB built-in function roots. The first root supplied is
%the real root, with no imaginary part, and then it uses this root to
%compute Y,V and dx/dt=V+c. The dialog in the command window to solve
%Ex.Pr. 2 is as follows (including solution):
%>>eprb6_2
%Give Vo = 5
%Give Yo = 4
%Give g =32.2
%Give starting q 20
%Give number of q 11
%    q        c        Y         V    dx/dt
%   20.00  11.3490   4.0000   5.0000  16.3490
%   18.00  11.1712   3.8756   4.6444  15.8156
%   16.00  10.9841   3.7469   4.2702  15.2543
%   14.00  10.7863   3.6132   3.8747  14.6610
%   12.00  10.5762   3.4738   3.4544  14.0306
%   10.00  10.3515   3.3278   3.0050  13.3565
%    8.00  10.1093   3.1739   2.5206  12.6299
%    6.00   9.8456   3.0104   1.9931  11.8386
%    4.00   9.5545   2.8350   1.4109  10.9654
%    2.00   9.2272   2.6441   0.7564   9.9836
%    0.00   0.0000   0.0000   0.0000   0.0000
%Notice that the first root returned when q=0 is c=0, and not 8.849 which
%is return as an additional real root.  Logic should be included to use
%this alternative real root.

Vo=input('Give Vo = ');Yo=input('Give Yo = ');g=input('Give g =');
co=sqrt(g*Yo);q1=input('Give starting q ');N=input('Give number of q '); 
q=linspace(q1,0,N);
fprintf('    q        c        Y         V    dx/dt\n');
for i=1:N
r=roots([1,0.5*Vo-co,0,-g*q(i)/2]);
c=r(1); Y=c^2/g; 
if Y>0
    V=q(i)/Y;
else
    V=0;
end
dxdt=V+c;
fprintf('%8.2f %8.4f %8.4f %8.4f %8.4f\n',q(i),c,Y,V,dxdt);
end