%This script solves for c from Eq. 19 using the MATLAB built-in function
%fsolve.  It solves Ex. Prb. 2 in Chap. 6, just as the Fortran Program
%EPRB2_6B.FOR does except rather than using the Newton method the desired
%root is that produced by fsolve.
Vo=input('Give Vo = ');Yo=input('Give Yo = ');g=input('Give g =');
co=sqrt(g*Yo);q1=input('Give starting q ');N=input('Give number of q '); 
VOC=(Vo-2*co); q=linspace(q1,0,N);opt=optimset('display','off');
fprintf('    q        c        Y         V    dx/dt\n');
fprintf(' -------------------------------------------\n'); c=co;
for i=1:N
    gq=g*q(i);
    c=fsolve(inline('c^2*(2*(c-co)+Vo)-gq','c','co','Vo','gq'),c,opt,co,Vo,gq);
    Y=c^2/g; V=q(i)/Y; dxdt=V+c;
    fprintf('%8.2f %8.4f %8.4f %8.4f %8.4f\n',q(i),c,Y,V,dxdt);
end