%This script produces a table that shows how Y and V vary as a function of
%time as the unit flow rate is specified to vary as a function of time
%by solving the equation 2c^3+(Vo-2co)c^2-gq = 0, as called for by Ex.
%Prb. 5 in Chapter 6, in other words is performs the same task as Program
%EXPRB6_5.FOR. The dialog from the command window to solve Pr. 5 is as
%follows: (with some of the solution omitted)
%>>eprb6_5
%Give:Vo,Yo,dq/dt,Nt,Dt,g within [ ] [-3 5 .01 20 30 32.2]
%Should output be written to file? 0=no,1=yes 0
%   0.0  12.6886   5.0000  -3.0000 -15.0000
%  30.0  12.6490   4.9688  -3.0792 -15.3000
%  60.0  12.6088   4.9373  -3.1596 -15.6000
    .
% 570.0  11.7917   4.3182  -4.7937 -20.7000
% 600.0  11.7323   4.2747  -4.9126 -21.0000
 
var=input('Give:Vo,Yo,dq/dt,Nt,Dt,g within [ ] ');
Vo=var(1);Yo=var(2);dqdt=var(3);Nt=var(4); Dt=var(5); g=var(6);
co=sqrt(g*Yo); qo=Yo*Vo; VOC=Vo-2*co; c=co;
IOUT=input('Should output be written to file? 0=no,1=yes ');
fid=1; opt=optimset('display','off');
if IOUT
    filn=input('Give name of file in '' '' ');
    fopen(fid,filn);
end
for k=0:Nt
    t=k*Dt;
    q=qo-t*dqdt;
    c=fsolve(inline('(2*c+VOC)*c^2-g*q','c','g','q','VOC'),c,opt,g,q,VOC);
    Y=c^2/g; V=2*c+VOC; 
    fprintf(fid,'%6.1f %8.4f %8.4f %8.4f %8.4f\n',t,c,Y,V,q);
end