C  Program to solve Flow in Culvert with upstream control.
      PARAMETER (N=3,NP=31)
      EXTERNAL DYX
      CHARACTER*3 CASE
      REAL FMU(NP),FMD(NP),YU(NP),YD(NP)
      REAL W(1,13),Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/D,DH,DS6,D25,So,G,QN,Q2G,H1,H2,A,YC,IOUT
      WRITE(*,*)' GIVE:IOUT,TOL,D,Q,H1,H2,Ke,L,n,So,g'
      READ(*,*) IOUT,TOL,D,Q,H1,H2,FKE,FL,FN,So,G
      IF(Q.EQ.0. .OR. H1.EQ.0.) GO TO 1
      WRITE(*,*)' Both Q and H1 cannot be given.  Which is unknown?'
      WRITE(*,*)' Give 1 = Q, or 2 = H1'
      READ(*,*) M
      IF(M.EQ.1) THEN
      Q=0.
      ELSE
      H1=0.
      ENDIF
1     IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      DH=.5*D
      DS6=D*D/6.
      D25=.25*D*D
      AT=.78539816*D*D
      FKE1=(FKE+1.)/(2.*G)
      FKE=(FKE+1.)/8.
      M=0
      IF(Q.EQ. 0.) THEN
      IQ=0
      H1D=H1/D
      Q=.2687*H1D**3.906
      YC=Q**.254
      COSB=1.-2.*YC
      IF(COSB.LT. -1.) COSB=-.98
      BETA=ACOS(COSB)
2     F=.5*(1.-COS(BETA))+FKE*(BETA-COS(BETA)*SIN(BETA))/SIN(BETA)-H1D
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 3
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 2
3     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      IF(ABS(DIF).GT. 1.E-6 .AND. M.LT.30) GO TO 2
      IF(M.GE.30) WRITE(*,*)' Did not comverge. DIF=',DIF,BETA
      Q=(BETA-COS(BETA)*SIN(BETA))**3/(64.*SIN(BETA))
      Q=SQRT(G*Q*D**5)
      YC=DH*(1.-COS(BETA))
      Q2G=Q*Q/G
      QN=(FN*Q/CC)**2
      ELSE
      IQ=1
      Q2G=Q*Q/G
      QN=(FN*Q/CC)**2
      BETA=1.5
      Q2GD=D*Q2G
4     F=Q2GD*SIN(BETA)-(D25*(BETA-COS(BETA)*SIN(BETA)))**3
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 5
      F1=F
      BET=BETA
      BETA=1.01*BETA
      GO TO 4
5     DIF=(BETA-BET)*F1/(F-F1)
      BETA=BET-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 4
      YC=DH*(1.-COS(BETA))
      H1=YC+4.*FKE*Q2G/(D25*(BETA-COS(BETA)*SIN(BETA)))**2
      ENDIF
      WRITE(IOUT,100) Q,YC,H1,H2,D,FL,FN,So
100   FORMAT(' Q=',F8.2,', Yc=',F8.3,', H1=',F8.3,', H2=',F8.3,/' D=',
     &F7.1,', L=',F8.0, ', n=',F8.4,', So=',F8.6)
      FMT=DH*AT+Q2G/AT
      YCP=(1.15+SO)*YC
      HMIN=.000001
      DELX=FL/FLOAT(NP-1)
C  Solves S2-GVF from entrance to end of culvert
      XX=0.
      XZ=DELX
      H11=.05
      Y(1)=.95*YC
      YU(1)=Y(1)
      FMU(1)=FMOM(Y(1))
      WRITE(IOUT,115) 'S2',0.,YU(1),A,FMU(1)
115   FORMAT(/,A3,' - GVF Profile',/,4F10.3)
118   FORMAT(4F10.3)
      DO 10 I=2,NP
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
      YU(I)=Y(1)
      FMU(I)=FMOM(Y(1))
      WRITE(IOUT,118) XZ,YU(I),A,FMU(I)
      XX=XZ
10    XZ=XZ+DELX
      Y2=2.*YC-YU(NP)
      IF(Y2.GT.D) Y2=.9*D
      FMOM1=FMOM(YU(NP))
C  Solves Conjugate Depth at end of culvert
      M=0
12    F=FMOM1-FMOM(Y2)
      M=M+1
      IF(MOD(M,2).EQ.0) GO TO 13
      F1=F
      Y22=Y2
      Y2=1.01*Y2
      GO TO 12
13    IF(ABS(F-F1).LT.1.E-20) THEN
      DIF=0.
      ELSE
      DIF=F1*(Y2-Y22)/(F-F1)
      ENDIF
      Y2=Y22-DIF
      IF(ABS(DIF).GT.1.E-6 .AND. M.LT.30) GO TO 12
      IF(M.GE.30) WRITE(*,*)' Did not converge for conj. Y',DIF,Y2
      IF(H2.GT.Y2) THEN
      IF(Y2.GT.D) WRITE(IOUT,106) Y2
106   FORMAT(' Conjugate depth at end is above top of culvert',F8.2)
      GO TO 15
      ENDIF
      WRITE(IOUT,110) H1,H2,Q,YC,YU(NP),Y2
110   FORMAT(' Case I occurs with S2-GVF thru entire length of culvert',
     &/,' H1 =',F8.2,' H2 =',F8.2,' Q =',F8.2,' Yc =',F8.2,' Depth at en
     &d =',F8.2,/,' Conjugate depth =',F8.2)
      IF(H2.GE.Y2) WRITE(IOUT,120) Y2-YU(NP)
120   FORMAT(' Roller exists at end of culvert with height =',F8.2)
      STOP
15    IF(H2.GT.D) GO TO 40  
C     Case II - Hyd. Jump in culvert
      XX=FL
      H11=-1.
      XZ=XX-DELX
      IB=1
      Y(1)=H2
      YD(NP)=H2
      FMD(NP)=FMOM(Y(1))
      WRITE(IOUT,115)'S1',FL,YD(NP),A,FMD(NP)
      IE=NP
      CASE='II '
C  Solves S1-GVF profile
19    DO 20 I=IE-1,1,-1
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX)
      YD(I)=Y(1)
      FMD(I)=FMOM(Y(1))
      WRITE(IOUT,118) XZ,YD(I),A,FMD(I)
      IF(Y(1).LT.YCP) THEN
      IB=I
      GO TO 22
      ENDIF
      XX=XZ
20    XZ=XZ-DELX
22    IF(IB.EQ.1 .AND. FMD(1).GT.FMU(1)) THEN
      WRITE(IOUT,160) H1,H2,Q
160   FORMAT(' Effects extend to entrance so downstream control occurs.'
     &,/,' Change specifications.',/,' H1=',F7.2,' H2=',F7.2,' Q=',F8.2)
      STOP
      ENDIF
      DO 25 I=IB,NP
      IF(FMU(I).LT.FMD(I)) GO TO 26
25    CONTINUE
26    IP=I-1
      FAC=(FMU(IP)-FMD(IP))/(FMD(IP+1)-FMD(IP)-FMU(IP+1)+FMU(IP))
      XX=DELX*(FLOAT(IP-1)+FAC)
      WRITE(IOUT,130) CASE,Q,YC,YU(IP)+FAC*(YU(IP+1)-YU(IP)),YD(IP)+FAC*
     &(YD(IP+1)-YD(IP)),XX
130   FORMAT(' Case ',A3,' Jump occurs within culvert: Q =',F8.2,' Yc ='
     &,F7.2,/,' Depth upst. jump=',F6.2,' Depth downst. jump =',F6.2,
     &' Jump position x=',F7.1)
      STOP
30    XX=(H2-D)/(SO-SF)
      WRITE(IOUT,150) XX
150   FORMAT(' Case III - Culvert full at downstr. end for a distance of
     &',F8.2)
      IE=NP-XX/DELX-1.9
32    Y(1)=.98*D
      YD(IE)=D
      FMD(IE)=FMOM(Y(1))
      XX=DELX*FLOAT(IE-1)
      XZ=XX-DELX
      H11=-1.
      IB=1
      WRITE(IOUT,115)'S1',XX,Y(1),A,FMD(IE)
      CASE='III'
      GO TO 19
40    SF=(FN*Q/(CC*AT*(.25*D)**.6666667))**2
      XX=(H2-D)/(SO-SF)
      IF(XX.GE.FL) THEN
      WRITE(IOUT,155) (XX-FL)*(SO-SF)+FKE1*(Q/AT)**2
155   FORMAT(' Case V - Downstream H2 causes depth at entrance of',F9.2,
     &/,' Flow is downstream controlled.')
      STOP
      ENDIF
      DO 41 I=NP,1,-1
      IF(FMU(I).LT.FMT) GO TO 42
41    CONTINUE
      WRITE(IOUT,160) H1,H2,Q
      STOP
42    IE=I
      IF(IE.EQ.NP) GO TO 30
      X24L=DELX*(FLOAT(IE-1)+(FMT-FMU(IE))/(FMU(IE+1)-FMU(IE)))
      H24L=D+(SO-SF)*(FL-X24L)
      WRITE(IOUT,180) X24L,FL-X24L,H24L
180   FORMAT(' Start of Case IV at x =',F8.2,' (from end=',F8.2,') Downs
     &tr. H2 required=',F8.2)
      DO 50 I=IE-1,NP
      PHEAD=H2-D-(SO-SF)*(FL-DELX*FLOAT(I-1))
C      WRITE(IOUT,*) I,PHEAD,PHEAD*AT+FMT,FMU(I)
      IF(PHEAD.LT.0.) GO TO 50
      IF(PHEAD*AT+FMT.GT.FMU(I)) GO TO 50
      WRITE(IOUT,140) DELX*FLOAT(I-1),PHEAD,FMU(I)
140   FORMAT(' Case IV, H. Jump causes pipe flow downstream from x=',F8.
     &2,/,' The pressure head on top of culvert=',F8.2,' Mom=',F10.1)
      STOP
50    CONTINUE
      WRITE(IOUT,170) 
170   FORMAT(' Did not find location where Mu=Mt+AtPh')
      GO TO 32
      END
      FUNCTION FMOM(Y)
      COMMON /TRAS/D,DH,DS6,D25,So,G,QN,Q2G,H1,H2,A,YC,IOUT
      COSB=1.-Y/DH
      IF(COSB.GT.1.) COSB=1.
      IF(COSB.LT.-1.) COSB=-1.
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=D25*(BETA-COSB*SINB)
      FMOM=DH*(DS6*SINB**3-A*COSB)+Q2G/A
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON /TRAS/D,DH,DS6,D25,So,G,QN,Q2G,H1,H2,A,YC,IOUT
      YY=Y(1)
      IF(YY.LT. 0.05) YY=.05
      COSB=1.-YY/DH
      IF(COSB.LT. -1.) COSB=-.995
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      P=D*BETA
      A=D25*(BETA-COSB*SINB)
      SoSf=So-QN*((P/A)**.666666667/A)**2
      FRM1=1.-Q2G*D*SINB/A**3
      DY(1)=SoSf/FRM1
      RETURN
      END