/* Solves Mannings and Specific Energy for Y & Q by substituting Mannings Eq.
   into Energy and first solving for Y and thereafter Q.  (This is the procedure
   to use with a pocket calculator)  See program E_UN to solve any 2 variables. */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float b,m,d,n,so,h,c; int itype;
void areap(float y,float *a,float *p){float cosb,beta;
 if(itype){cosb=1.-2.*y/d;beta=acos(cosb);*p=d*beta;*a=.25*d*d*(beta-cosb*sin(beta));}
  else {*p=b+2.*y*sqrt(m*m+1.); *a=(b+m*y)*y;return; } }
float fun(float y){float *a,*p; areap(y,a,p);return(h-y-c*pow((*a)/(*p),1.333333));}
void main(void){float g,dif,ke,y,f,q,cu=1.,*a,*p; int nct=0;
 printf("Give: g(0=trap or 1=cir)\n"); scanf("%f %d",&g,&itype);
 if(itype){printf("Give: D,n,So,H,Ke\n"); scanf("%f %f %f %f %f",&d,&n,&so,&h,&ke);}
  else {printf("Give: b,m,n,So,H,Ke\n"); scanf("%f %f %f %f %f %f",&b,&m,&n,&so,&h,&ke);}
 y=.8*h; if(g>15.) cu=1.486; c=pow(cu/n,2.)*so*(1.+ke)/(2.*g);
do{f=fun(y); dif=.05*f/(fun(y+.05)-f); y-=dif;printf("%d %f %f\n",++nct,dif,y);
  }while((nct<30) && (fabs(dif)>1.e-5));
 areap(y,a,p); q=cu/n*(*a)*pow((*a)/(*p),.6666667)*sqrt(so);
 printf("Solution: Y = %8.3f Q = %10.2f\n",y,q);
}