C Solves Mannings and Specific Energy for Y & Q by substituting Mannings Eq.
C into Energy and first solving for Y and thereafter Q.  (This is the procedure
C to use with a pocket calculator)  See program E_UN to solve any 2 variables.
      COMMON B,FM,D,FN,SO,H,C,ITYPE
      WRITE(*,*)' Give: g,(0=trap or 1=cir)'
      READ(*,*) G,ITYPE
      IF(ITYPE.EQ.0) THEN
      WRITE(*,*)' Give: b,m,n,So,H,Ke'
      READ(*,*) B,FM,FN,SO,H,FKE
      ELSE
      WRITE(*,*)' Give: D,n,So,H,Ke'
      READ(*,*) D,FN,SO,H,FKE
      ENDIF
      Y=.8*H
      Cu=1.
      IF(G.GT.15.) Cu=1.486
      C=(Cu/FN)**2*SO*(1.+FKE)/(2.*G)
      NCT=0
10    F=FUN(Y)
      DIF=.05*F/(FUN(Y+.05)-F)
      Y=Y-DIF
      NCT=NCT+1
      WRITE(*,*) NCT,DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-5) GO TO 10
      CALL AREAP(Y,A,P)
      Q=CU/FN*A*(A/P)**.6666667*SQRT(SO)
      WRITE(*,100) Y,Q
100   FORMAT(' Solution: Y =',F8.3,' Q =',F10.2)
      END
      SUBROUTINE AREAP(Y,A,P)
      COMMON B,FM,D,FN,SO,H,C,ITYPE
      IF(ITYPE.EQ.1) THEN
      COSB=1.-2.*Y/D
      BETA=ACOS(COSB)
      P=D*BETA
      A=.25*D*D*(BETA-COSB*SIN(BETA))
      ELSE
      P=B+2.*Y*SQRT(FM**2+1.)
      A=(B+FM*Y)*Y
      ENDIF
      RETURN
      END
      FUNCTION FUN(Y)
      COMMON B,FM,D,FN,SO,H,C,ITYPE
      CALL AREAP(Y,A,P)
      FUN=H-Y-C*(A/P)**1.3333333
      RETURN
      END