C This program is designed to solve: (1) the problem of a gate instantly
C shutting to produce a new downstream depth of Y2, and (2) thereafter
C have the gate reduce the flow rate further by specifying dq/dt.  For the
C first problem 6 eqs. in 6 unknowns are solved.  In the second problem 11
C eqs. in 11 unknowns are solve. These variables are:
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d,11=wd
      CHARACTER*2 UNK(6)/'Y1','V1','Y3','V3','Wu','Wd'/
      INTEGER*2 INDX(11)
      REAL F(11),FF(11),D(11,11)
      COMMON Y2,X(11),Yo1,Vo1,Yo2,Vo2,G,G2,Yo1S,Vo2S,Yo2S,TIME,qo
     &,dqdT,qd,Yod,XSU,XSD,V2C,VO2CU,VO2CD,INIT
      INIT=0
      WRITE(*,*)' Give: g,Yo1,Vo1,Yo2,Y2,IOUT'
      READ(*,*) G,Yo1,Vo1,Yo2,Y2,IOUT
      Vo2=Vo1*Yo1/Yo2
      WRITE(*,100) UNK
100   FORMAT(' Give guesses for (initial condition):',/,5(A3,','),A3)
      READ(*,*) (X(I),I=1,6)
      G2=2.*G
      Yo1S=.5*Yo1**2
      Vo2S=Vo2-2.*SQRT(G*Yo2)
      Yo2S=.5*Y2**2
      V2C=Vo1-2.*SQRT(G*Yo1)
      NCT=0
12    SUM=0.
      CALL FUN(F)
      DO 20 J=1,6
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 15 I=1,6
15    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
20    X(J)=XT
      CALL SOLVEQ(6,1,11,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 30 I=1,6
      X(I)=X(I)-F(I)
30    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(X(I),I=1,6)
110   FORMAT(' NCT=',I3,', SUM=',E12.5,/11F9.3)
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 12
      V2=X(2)*X(1)/Y2
      WRITE(*,120)(UNK(I),X(I),I=1,6),' Y2',Y2,' V2',V2
      IF(IOUT.NE.6) THEN
      WRITE(IOUT,119)
119   FORMAT(' Solution to conditions immediately after dropping gate')
      WRITE(IOUT,120)(UNK(I),X(I),I=1,6),' Y2',Y2,' V2',V2
120   FORMAT(A3,' = ',F10.3)
      ENDIF
      VO2CU=X(2)-2.*SQRT(G*X(1))
      VO2CD=X(4)-2.*SQRT(G*X(3))
      WRITE(*,*)' Give: dq/dt, Delt & Number of steps'
      READ(*,*) dqdt,DELT,NUM
C New order of unknowns in array X for time simulation when dY/dt is given      
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d & 11=wd
      qo=X(1)*ABS(X(2))
      X(11)=X(6)
      X(10)=X(4)
      X(9)=X(3)
      X(8)=V2
      X(7)=Y2
      X(4)=X(1)
      X(6)=V2
      X(3)=X(5)
      X(5)=X(2)
      X(4)=X(1)
      INIT=1
      XSUo=0.
      XSDo=0.
      WRITE(IOUT,129)
129   FORMAT(118('-'),/,'  t     Yu2     Vu2      wu     You     Vou    
     & Yod     Vod     Yd2     Vd2     Y3d     V3d      wd      Xsu     
     &Xsd',/,118('-'))
      WRITE(IOUT,130) 0,(X(I),I=1,5),qo/X(6),(X(I),I=6,11),XSUo,XSDo
      DO 50 K=1,NUM
      TIME=DELT*FLOAT(K)
      qd=qo-dqdt*TIME
      NCT=0
52    SUM=0.
      XSU=XSUo+DELT*X(3)
      XSD=XSDo+DELT*X(11)
      CALL FUN(F)
      DO 53 J=1,11
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 55 I=1,11
55    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
53    X(J)=XT
      CALL SOLVEQ(11,1,11,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 56 I=1,11
      X(I)=X(I)-F(I)
56    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 52
      XSUo=XSUo+DELT*X(3)
      XSDo=XSDo+DELT*X(11)
50    WRITE(IOUT,130) IFIX(TIME),(X(I),I=1,5),qd/X(6),(X(I),I=6,11),
     &XSU,XSD
130   FORMAT(I4,12F8.3,2F9.1)
      END
      SUBROUTINE FUN(F)
      REAL F(11)
      COMMON Y2,X(11),Yo1,Vo1,Yo2,Vo2,G,G2,Yo1S,Vo2S,Yo2S,TIME,qo
     &,dqdT,qd,Yod,XSU,XSD,V2C,VO2CU,VO2CD,INIT
      IF(INIT.GT.0) GO TO 10
      V2=X(2)*X(1)/Y2
      F(1)=X(1)+X(2)**2/G2-Y2-V2**2/G2
      F(2)=(X(5)+Vo1)*Yo1-(X(5)+X(2))*X(1)
      F(3)=Yo1S+(X(5)+Vo1)**2*Yo1/G-.5*X(1)**2-(X(5)+X(2))**2*X(1)/G
      F(4)=(V2-X(6))*Y2-(X(4)-X(6))*X(3)
      F(5)=.5*X(3)**2+(X(4)-X(6))**2*X(3)/G-Yo2S-(V2-X(6))**2*Y2/G
      F(6)=X(4)-2.*SQRT(G*X(3))-Vo2S
      RETURN
C Unknowns:1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d,11=wd
10    F(1)=(Vo1+X(3))*Yo1-(X(2)+X(3))*X(1)
      F(2)=.5*(Yo1**2-X(1)**2)+((Vo1+X(3))**2*Yo1-(X(2)+X(3))**2*X(1))/G
      F(3)=X(2)-X(5)-2.*(SQRT(G*X(1))-SQRT(G*X(4)))
      F(4)=X(4)*X(5)-qd
      F(5)=X(4)+X(5)**2/G2-qd/X(6)-X(6)**2/G2
      F(6)=X(8)-X(6)+2.*(SQRT(G*qd/X(6))-SQRT(G*X(7)))
      F(7)=(X(8)-X(11))*X(7)-(X(10)-X(11))*X(9)
      F(8)=.5*(X(7)**2-X(9)**2)+((X(8)-X(11))**2*X(7)-(X(10)-X(11))**2*
     &X(9))/G
      F(9)=X(10)-2.*SQRT(G*X(9))-Vo2S
      F(10)=TIME-ABS(qo-X(7)*X(8))/dqdt-XSD/(3.*SQRT(G*X(7))-VO2CD)
      F(11)=TIME-ABS(qo-X(1)*X(2))/dqdt-XSU/(3.*SQRT(G*X(1))-VO2CU)
      END