C This program handles: First when a gate in instantly partially closed in a
C trapezoidal channel, and second thereafter the flow rate dQ/dt is given.  
C This 1st portion of the program solves 7 eqs, as does GATETR, and for the
C 2nd portion solves 11 variables in which theory of Charertistics is used to
C handle the upstream and downstream unsteady flows. For the 1st problem the
C  unknowns are: 1=Y1, 2=V1, 3=V2, 4=Y3, 5=V3, 6=Wu, and 7=Wd
C For the 2nd problem the unknonws are:
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d,11=wd
      PARAMETER (N=200)
      CHARACTER*2 UNK(7)/'Y1','V1','V2','Y3','V3','Wu','Wd'/
      INTEGER*2 INDX(11)
      REAL F(11),FF(11),D(11,11)
      COMMON B,FM,BH,FM3,Y2,W(N),X(11),DY,VOW,Yo1,Vo1,G,G2,dQdt,TIME,BS,
     &FM2,FM4,Ao1,Ao2,Ao1G,A2,A2G,FMON1,FMON2,Qd,VOWU,VOWD,Qo,XSU,XSD,
     &INIT
      FW(Y)=SQRT(G*(B+FM2*Y)/((B+FM*Y)*Y))
      INIT=0
      WRITE(*,*)' Give: g,b,m,Yo1,Vo1,IOUT'
      READ(*,*) G,B,FM,Yo1,Vo1,IOUT
      IOU1=IOUT+1
      BS=B*B
      FM4=4.*FM
      G2=2.*G
      Aunif=(B+FM*Yo1)*Yo1
      Qunif=Aunif*Vo1
      Eo1=Yo1+Vo1**2/G2
      Yo2=Yo1/2.5
      NCT=0
2     FE=Eo1-Yo2-(Qunif/((B+FM*Yo2)*Yo2))**2/G2
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 3
      FEE=FE
      Yo2=Yo2+.01
      GO TO 2
3     DIF=FEE/(100.*(FE-FEE))
      Yo2=Yo2-.01-DIF
      IF(NCT.LT.30 .AND. ABS(DIF).GT.1.E-5) GO TO 2
      Ao2=(B+FM*Yo2)*Yo2
      Vo2=Qunif/Ao2
      WRITE(IOUT,212) Yo1,Vo1,Aunif,Qunif,Yo2,Vo2,Ao2
212   FORMAT(' Uniform upstream and downstream conditions',/,' Yo1=',
     &F7.3,' Vo1=',F7.3,' Ao1=',F7.2,' Qunif=',F8.2,' Yo2=',F7.3,' Vo2='
     &,F7.3,' Ao2=',F8.2)
      WRITE(*,213) Qunif,Yo2,Vo2
213   FORMAT(' Qunif=',F9.2,' Yo2=',F8.3,' Vo2=',F8.3)
      WRITE(*,100) UNK
100   FORMAT(' Give Y2 & guesses for:',6(A3,','),A3)
      READ(*,*) Y2,(X(I),I=1,7)
      N23=2*N/3
      DY=(Yo1-.01)/FLOAT(N23)
      FM2=2.*FM
      FM3=FM/3.
      BH=B/2.
      Ao1=(B+FM*Yo1)*Yo1
      Ao1G=Ao1/G
      A2=(B+FM*Y2)*Y2
      A2G=A2/G
      FMON1=(BH+FM3*Yo1)*Yo1**2
      FMON2=(BH+FM3*Y2)*Y2*Y2
      DY2=DY/10.
      DYH=DY2/2.
      Y=.01
      WF1=FW(Y)
      W(1)=0.
      DO 10 I=2,N
      SUM=0.
      DO 5 J=1,10
      WF=FW(Y+DY2*FLOAT(J))
      SUM=SUM+DYH*(WF1+WF)
5     WF1=WF
      W(I)=W(I-1)+SUM
10    Y=Y+DY
      WRITE(IOUT,338) Y
338   FORMAT(' Largest depth for stage variable look-up table=',F9.2)
      WRITE(*,338) Y
      IM=(Yo2-.01)/DY+1.
      FAC=(Yo2-.01-DY*FLOAT(IM-1))/DY
      VOW=Vo2-W(IM)+FAC*(W(IM+1)-W(IM))
      NCT=0
12    SUM=0.
      CALL FUN(F)
      DO 20 J=1,7
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 15 I=1,7
15    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
20    X(J)=XT
      CALL SOLVEQ(7,1,11,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 30 I=1,7
      X(I)=X(I)-F(I)
30    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,(X(I),I=1,7)
110   FORMAT(' NCT=',I3,', SUM=',E12.5,/11F9.3)
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 12
      IF(IOUT.NE.6) THEN
      WRITE(IOUT,119)
119   FORMAT(' Solution to conditions immediately after dropping gate')
      WRITE(IOUT,120)(UNK(I),X(I),I=1,7)
      ENDIF
      WRITE(*,120)(UNK(I),X(I),I=1,7)
120   FORMAT(A3,' = ',F10.3)
      INIT=1
      IM=(X(1)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(1)-.01-DY*FLOAT(IM-1))/DY
      VOWU=X(2)-W(IM)+FAC*(W(IM+1)-W(IM))
      IM=(X(4)-.01)/DY+1.
      FAC=(X(4)-.01-DY*FLOAT(IM-1))/DY
      VOWD=X(5)-W(IM)+FAC*(W(IM+1)-W(IM))
      Qo=(B+FM*X(1))*X(1)*ABS(X(2))
      WRITE(IOUT,121) Qo
121   FORMAT(' The flow rate past gate after instant drop, Qo=',F9.3)
      WRITE(*,*)' Give: dQ/dt, Delt & Number of steps'
      READ(*,*) dQdt,DELT,NUM
C New order of unknowns in array X for time simulation when dY/dt is given      
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d & 11=wd
      X(11)=X(7)
      X(10)=X(5)
      X(9)=X(4)
      X(8)=X(3)
      X(7)=Y2
      X(4)=X(1)
      VWAVE=X(6)
      X(6)=X(3)
      X(3)=VWAVE
      X(5)=X(2)
      X(4)=X(1)
      XSUo=0.
      XSDo=0.
      WRITE(IOUT,129)
129   FORMAT(118('-'),/,'  t     Yu2     Vu2      wu     You     Vou    
     & Yod     Vod     Yd2     Vd2     Y3d     V3d      wd      Xsu     
     &Xsd',/,118('-'))
      WRITE(IOU1,128)
128   FORMAT(84('-'),/,'  t    Au2     Qu2     Aou     Qou     Aod  
     &Qod     Ad2     Qd2      A3d     Q3d',/,84('-'))  
      Yd2=(SQRT(BS+FM4*Qo/X(6))-B)/FM2
      WRITE(IOUT,130) 0,(X(I),I=1,5),Yd2,(X(I),I=6,11),XSUo,XSDo
      Au2=(B+FM*X(1))*X(1)
      Qu2=Au2*X(2)
      Aou=(B+FM*X(4))*X(4)
      Qou=Aou*X(5)
      Aod=(B+FM*Yd2)*Yd2
      Qod=Aod*X(6)
      Ad2=(B+FM*X(7))*X(7)
      Qd2=Ad2*X(8)
      A3d=(B+FM*X(9))*X(9)
      Q3d=A3d*X(10)
      WRITE(IOU1,131) 0,Au2,Qu2,Aou,Qou,Aod,Qod,Ad2,Qd2,A3d,Q3d
      DO 50 K=1,NUM
      TIME=DELT*FLOAT(K)
      Qd=Qo-dQdt*TIME
      NCT=0
52    SUM=0.
      XSU=XSUo+DELT*X(3)
      XSD=XSDo+DELT*X(11)
      CALL FUN(F)
      DO 53 J=1,11
      XT=X(J)
      X(J)=1.005*X(J)
      CALL FUN(FF)
      DO 55 I=1,11
55    D(I,J)=(FF(I)-F(I))/(X(J)-XT)
53    X(J)=XT
      CALL SOLVEQ(11,1,11,D,F,1,DD,INDX)
      NCT=NCT+1
      DO 56 I=1,11
      X(I)=X(I)-F(I)
56    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
      IF(NCT.LT.30 .AND. SUM.GT.1.E-5) GO TO 52
      XSUo=XSUo+DELT*X(3)
      XSDo=XSDo+DELT*X(11)
      Yd2=(SQRT(BS+FM4*Qd/X(6))-B)/FM2
      WRITE(IOUT,130) IFIX(TIME),(X(I),I=1,5),Yd2,(X(I),I=6,11),
     &XSU,XSD
130   FORMAT(I4,12F8.3,2F9.1)
      Au2=(B+FM*X(1))*X(1)
      Qu2=Au2*X(2)
      Aou=(B+FM*X(4))*X(4)
      Qou=Aou*X(5)
      Aod=(B+FM*Yd2)*Yd2
      Qod=Aod*X(6)
      Ad2=(B+FM*X(7))*X(7)
      Qd2=Ad2*X(8)
      A3d=(B+FM*X(9))*X(9)
      Q3d=A3d*X(10)
50    WRITE(IOU1,131) IFIX(TIME),Au2,Qu2,Aou,Qou,Aod,Qod,Ad2,Qd2,A3d,Q3d
131   FORMAT(I4,10F8.2)
      END
      SUBROUTINE FUN(F)
      PARAMETER (N=200)
      REAL F(11)
      COMMON B,FM,BH,FM3,Y2,W(N),X(11),DY,VOW,Yo1,Vo1,G,G2,dQdt,TIME,BS,
     &FM2,FM4,Ao1,Ao2,Ao1G,A2,A2G,FMON1,FMON2,Qd,VOWU,VOWD,Qo,XSU,XSD,
     &INIT
C  1=Y1,2=V1,3=V2,4=Y3,5=V3,6=Wu,and 7=Wd
      IF(INIT.GT.0) GO TO 10
      F(1)=X(1)+X(2)**2/G2-Y2-X(3)**2/G2
      A1=(B+FM*X(1))*X(1)
      A3=(B+FM*X(4))*X(4)
      F(2)=X(2)*A1-X(3)*A2
      F(3)=FMON1+(X(6)+Vo1)**2*Ao1G-(BH+FM3*X(1))*X(1)**2-(X(6)+X(2))**
     &2*A1/G
      F(4)=(X(6)+Vo1)*Ao1-(X(6)+X(2))*A1
      F(5)=FMON2+(X(7)-X(3))**2*A2G-(BH+FM3*X(4))*X(4)**2-(X(7)-X(5))
     &**2*A3/G
      F(6)=(X(7)-X(3))*A2-(X(7)-X(5))*A3
      IM=(X(4)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(4)-.01-DY*FLOAT(IM-1))/DY
      F(7)=X(5)-(W(IM)+FAC*(W(IM+1)-W(IM)))-VOW
      RETURN
C 1=Yu2,2=Vu2,3=wu,4=You,5=Vou,6=Vod,7=Yd2,8=Vd2,9=Y3d,10=V3d,11=wd
10    Au2=(B+FM*X(1))*X(1)
      F(1)=(Vo1+X(3))*Ao1-(X(2)+X(3))*Au2
      F(2)=BH*(Yo1**2-X(1)**2)+FM3*(Yo1**3-X(1)**3)+((Vo1+X(3))**2*Ao1-
     &(X(2)+X(3))**2*Au2)/G
      IM=(X(1)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(1)-.01-DY*FLOAT(IM-1))/DY
      Wu2=W(IM)+FAC*(W(IM+1)-W(IM))
      IM=(X(4)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(4)-.01-DY*FLOAT(IM-1))/DY
      Wou=W(IM)+FAC*(W(IM+1)-W(IM))
      F(3)=X(2)-X(5)-Wu2+Wou
      Aou=(B+FM*X(4))*X(4)
      F(4)=Aou*X(5)-Qd
      Aod=Qd/X(6)
      Yod=(SQRT(BS+FM4*Aod)-B)/FM2
      F(5)=X(4)-Yod+(X(5)**2-X(6)**2)/G2
      IM=(X(7)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(7)-.01-DY*FLOAT(IM-1))/DY
      Wd2=W(IM)+FAC*(W(IM+1)-W(IM))
      IM=(Yod-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(Yod-.01-DY*FLOAT(IM-1))/DY
      Wod=W(IM)+FAC*(W(IM+1)-W(IM))
      F(6)=X(8)-X(6)+Wod-Wd2
      Ad2=(B+FM*X(7))*X(7)
      A3d=(B+FM*X(9))*X(9)
      F(7)=(X(8)-X(11))*Ad2-(X(10)-X(11))*A3d
      F(8)=BH*(X(7)**2-X(9)**2)+FM3*(X(7)**3-X(9)**3)+((X(8)-X(11))**2*
     &Ad2-(X(10)-X(11))**2*A3d)/G
      IM=(X(9)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(9)-.01-DY*FLOAT(IM-1))/DY
      W3d=W(IM)+FAC*(W(IM+1)-W(IM))
      F(9)=X(10)-W3d-VOW
      cd=X(8)/SQRT(G*Ad2/(B+FM2*X(7)))
      cu=X(2)/SQRT(G*Au2/(B+FM2*X(1)))
      IM=(X(7)-.01)/DY+1.
      IF(IM.GT.199) IM=199
      FAC=(X(7)-.01-DY*FLOAT(IM-1))/DY
      Wd2=W(IM)+FAC*(W(IM+1)-W(IM))
      F(10)=TIME-ABS(Qo-Ad2*X(8))/dQdt-XSD/(Wd2-cd-VOWD)      
      F(11)=TIME-ABS(Qo-Au2*X(2))/dQdt-XSU/(Wu2-cu-VOWU)
      END