C  Program to generate geometric properties of an irregular channel.
C  This program does the same thing as the Pascal Program GEONAT.PAS
C  given in Appendix A
      PARAMETER (N1=25,N2=20)
      REAL X(N1),Y(N1),Y1(N2),T(N2),A(N2),P(N2)
      LOGICAL*2 POSCOR/.FALSE./,WIDCOR/.FALSE./,LINEAR/.FALSE./
      CHARACTER*20 FILN
1     WRITE(*,*)' Give no. of pts, and then this many pairs'
      WRITE(*,*)' Precede no. with a - to change type of interpolation -
     & LINEAR=',LINEAR
      WRITE(*,*)' Add 100 to no. if on file'
      IF(.NOT.POSCOR .AND. .NOT.WIDCOR) THEN
      WRITE(*,*)' Give 1000 if x & el for y are given'
      WRITE(*,*)' Give 2000 if x=top width & y=depth are given'
      ENDIF
      READ(*,*) N
      IF(N.EQ.1000) THEN
      POSCOR=.TRUE.
      GO TO 1
      ENDIF
      IF(N.EQ.2000) THEN
      WIDCOR=.TRUE.
      GO TO 1
      ENDIF
      IF(N.LT.0) THEN
      N=ABS(N)
      LINEAR=.NOT.LINEAR
      ENDIF
      IF(N.GT.100) THEN
      WRITE(*,*)' Give file name containing input data'
      READ(*,*) FILN
      N=N-100
      IF(N.GT.N1) GO TO 2
      OPEN(2,FILE=FILN)
      READ(2,*) (X(I),Y(I),I=1,N)
      CLOSE(2)
      GO TO 4
      ENDIF
2     IF(N.GT.N1) THEN
      WRITE(*,*)' Program dimensioned to only 25 values of input'
      STOP
      ENDIF
      WRITE(*,100)
100   FORMAT(13X,'x     y')
      DO 3 I=1,N
3     READ(*,*) X(I),Y(I)
4     IF(POSCOR) THEN
      YM=Y(1)
      IF(Y(N).GT.YM) YM=Y(N)
      DO 5 I=1,N
5     Y(I)=YM-Y(I)
      ENDIF
      IF(WIDCOR) THEN
      IF(Y(1).GT. 0.) THEN
      N=N+1
      DO 6 I=N,2,-1
      X(I)=X(I-1)
6     Y(I)=Y(I-1)
      X(1)=0.
      Y(1)=0.
      ENDIF
      YM=Y(N)
      YMI=X(N)/2.
      DO 7 I=1,N
      X(N+I-1)=YMI+X(I)/2.
7     Y(N+I-1)=YM-Y(I)
      YMI=2.*YMI
      DO 20 I=1,N-1
      Y(I)=Y(2*N-I)
20    X(I)=YMI-X(2*N-I)
      N=2*N-1
      ENDIF
      NM=N-1 
      YM=Y(1)
      YMI=YM
      IF(Y(N).LT.YMI) YMI=Y(N)
      DO 8 I=2,N
      IF(Y(I).GT.YM) THEN
      YM=Y(I)
      IL=I
      ENDIF
8     CONTINUE
      DY=(YM-YMI)/N2
      AA=0.
      PP=0.
      XR1=X(IL)
      XL1=XR1
      DY2=0.5*DY
      DYS=DY*DY
      YY=YM
      IR=IL+1
      IL=IL-1
      DO 9 I=1,N2
      YY=YY-DY
      IF(LINEAR) THEN
      DO 11 WHILE (YY.LT.Y(IL).AND.IL.GT.1)
11    IL=IL-1
      DO 12 WHILE (YY.LT.Y(IR).AND.IR.LT.N)
12    IR=IR+1
      XL=X(IL+1)+(YY-Y(IL+1))/(Y(IL)-Y(IL+1))*(X(IL)-X(IL+1))
      XR=X(IR-1)+(YY-Y(IR-1))/(Y(IR)-Y(IR-1))*(X(IR)-X(IR-1))
      ELSE
C  Uses Lagrange's formula for quadratic interpolation
      DO 13 WHILE (YY.LT.Y(IL-1).AND.IL.GT.2)
13    IL=IL-1
      DO 14 WHILE (YY.LT.Y(IR+1).AND.IR.LT.NM)
14    IR=IR+1
      XL=(YY-Y(IL))*(YY-Y(IL+1))*X(IL-1)/((Y(IL-1)-Y(IL))*(Y(IL-1)-Y(IL+
     &1)))+(YY-Y(IL-1))*(YY-Y(IL+1))*X(IL)/((Y(IL)-Y(IL-1))*(Y(IL)-Y(IL+
     &1)))+(YY-Y(IL-1))*(YY-Y(IL))*X(IL+1)/((Y(IL+1)-Y(IL-1))*(Y(IL+1)-
     &Y(IL))) 
      XR=(YY-Y(IR))*(YY-Y(IR-1))*X(IR+1)/((Y(IR+1)-Y(IR))*(Y(IR+1)-Y(IR-
     &1)))+(YY-Y(IR+1))*(YY-Y(IR-1))*X(IR)/((Y(IR)-Y(IR+1))*(Y(IR)-Y(IR-
     &1)))+(YY-Y(IR+1))*(YY-Y(IR))*X(IR-1)/((Y(IR-1)-Y(IR+1))*(Y(IR-1)-
     &Y(IR)))
      ENDIF
      Y1(I)=YM-YY
      T(I)=ABS(XR-XL)
      AA=AA+DY*ABS(XR1-XL1)+DY2*(ABS(XR-XR1)+ABS(XL1-XL))
      A(I)=AA
      PP=PP+SQRT(DYS+(XR-XR1)**2)+SQRT(DYS+(XL1-XL)**2)
      P(I)=PP
      XR1=XR
9     XL1=XL
      IOUT=6
      WRITE(*,*)' Should output be written to file? 1=yes, 0=no'
      READ(*,*) I
      IF(I.EQ.1) THEN
      WRITE(*,*)' Give name of this file'
      READ(*,*) FILN
      OPEN(3,FILE=FILN)
      IOUT=3
      ENDIF
      WRITE(IOUT,*)'     Depth  Top Width    Area  Perimeter'
      DO 10 I=1,N2
10    WRITE(IOUT,101) Y1(I),T(I),A(I),P(I)
101   FORMAT(4F10.2)
      IF(IOUT.NE.6) CLOSE(3)
      END