C Solves the problem of side flow into a triangular gutter, and the outflow
C from grates in its bottom.  The case being solved is when Q =Qin at beginning
C of the gutter, i.e. all the lateral inflow moves down the gutter channel, with
C no reverse flow.  However not all of the accumulated lateral inflow plus Qin 
C is require to discharge through the grate; some amount Qout may flow beyond
C into the next gutter so that Yl (at begin. of gutter) equals Yl (at end of grate.)
C  Yl=X(1), Yr=X(2) Qout=X(3)
      INTEGER*2 INDX(3)
      LOGICAL DONE
      REAL F(3),D(3,3),FFF(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XX,DONE,IOUT
      WRITE(*,*)' Give:IO,TOL,ERR,n,So,m,L,Lgrate,g,DX,DXG,Qin,q*,b,frac
     &,Cd'
      READ(*,*) IOUT,TOL,ERR,FN,SO,FM,FL,FLG,G,DX,DXG,Qin,QS,B,FRAC,CD
      QT=QS*FL
      DONE=.FALSE.
      DXGH=DXG/2.
      HM=.5*FM
      FMS=1.+SQRT(FM*FM+1.)
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      CD=CD*SQRT(G2)*FRAC*B
      G8=.125*G
      WRITE(*,*)' GIVE guess for:Yl, Yr & Qout'
      READ(*,*) X
      NCT=0
8     CALL FUN(F)
      WRITE(*,*) NCT,F
      DO 10 J=1,3
      DXX=.005*X(J)
      X(J)=X(J)+DXX
      CALL FUN(FFF)
      DO 9 I=1,3
9     D(I,J)=(FFF(I)-F(I))/DXX
10    X(J)=X(J)-DXX
      CALL SOLVEQ(3,1,3,D,F,1,DD,INDX)
      NCT=NCT+1
      SUM=0.
      DO 20 I=1,3
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      WRITE(*,110) NCT,SUM,X
110   FORMAT(' NCT=',I3,' SUM=',E12.6,/,6F10.3)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 8
      WRITE(IOUT,100) X
100   FORMAT(' Yl=',F7.3,', Yr=',F7.3,', Qout=',F8.3)
      DONE=.TRUE.
      CALL FUN(F)
      END
      SUBROUTINE FUN(F)
      LOGICAL DONE
      EXTERNAL DYX,DYXG
      REAL WW(1,13),Y(1),DY(1),XP(1),YP(1,1),F(3)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XX,DONE,IOUT
      HMIN=1.E-8
      IF(DONE) THEN
      A=HM*X(1)**2
      WRITE(IOUT,100) 0.,X(1),Qin,X(1)+(Qin/A)**2/G2,A,Qin/(FM*SQRT(G8*
     & X(1)**5))
      ENDIF
100   FORMAT(/,'       x          Y         Q        E        A         
     & Fr',/,1X,59('-'),/,F10.1,5F10.3)
      H1=.1
      XX=0.
      Y(1)=X(1)
10    XZ=XX+DX
      IF(XZ.GT.FL) XZ=FL
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYX)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QS*XZ+Qin
      WRITE(IOUT,110) XZ,Y,Q,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**5))
110   FORMAT(F10.1,5F10.3)
      ENDIF
      XX=XZ
      IF(XZ.LT.FL) GO TO 10
      F(1)=X(2)-Y(1)
      H1=.005
      XX=0.
      SQSTAR=0.
      QS1=CD*SQRT(X(2))
      IF(DONE) THEN
      A=HM*X(2)**2
      Q=QT+Qin
      WRITE(IOUT,120) 0.,X(2),Q,QS1,X(2)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*
     &X(2)**5))
120   FORMAT(/,'       x          Y         Q        q*        E         
     &A           Fr',/,1X,69('-'),/,F10.1,6F10.3)
      ENDIF
30    XZ=XX+DXG
      IF(XZ.GT.FLG) XZ=FLG
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,WW,DYXG)
      QS2=CD*SQRT(Y(1))
      SQSTAR=SQSTAR+DXGH*(QS1+QS2)
      IF(DONE) THEN
      A=HM*Y(1)**2
      Q=QT-SQSTAR+Qin
      WRITE(IOUT,130) XZ,Y,Q,QS2,Y(1)+(Q/A)**2/G2,A,Q/(FM*SQRT(G8*Y(1)**
     &5))
130   FORMAT(F10.3,6F10.3)
      ENDIF
      QS1=QS2
      XX=XZ
      IF(XZ.LT.FLG) GO TO 30
      F(2)=X(1)-Y(1)
      F(3)=QT-X(3)-SQSTAR+Qin
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XDUM,DONE,IOUT
      YY=ABS(Y(1))
      A=HM*YY**2
      Q=QS*XX+Qin
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF-2.*Q*QS/(G*A**2))/(1.-FR2)
      RETURN
      END
      SUBROUTINE DYXG(XP,Y,DY)
      LOGICAL DONE
      REAL Y(1),DY(1)
      COMMON /TRAS/X(3),SO,FM,FMS,QS,QT,CC,FN,HM,G,G2,G8,FL,DX,DXG,TOL,
     &FLG,DXGH,CD,SQSTAR,QS1,Qin,XX,DONE,IOUT
      YY=Y(1)
      QS2=CD*SQRT(YY)
      A=HM*YY**2
      Q=QT-SQSTAR-.5*(XP-XX)*(QS1+QS2)+Qin
      SF=FN*Q/CC*(FMS*YY/A)**.66666667/A
      SF=SF*ABS(SF)
      FR2=Q*Q*FM*YY/(G*A**3)
      DY(1)=(SO-SF+Q*QS2/(G*A**2))/(1.-FR2)
      RETURN
      END