//This program allows n to vary linearly between stations.  Now n is input with station and not in the original data.
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "odesolc.h"
 const int n=25;
 float qn,fn[2][3],so;
 float y[26][2],t[26][2],a[26][2],p[26][2],e[26][2],alpa[26][2],rks[26][2],cc\
,xsta1,xsta2,zsta1,yy,zsta2,psta,asta,fna,q2g,xmid,xld,xrd,qsta;
 int linear,ip1,ip2,ir,ir1,il,il1,iotab;  char fnam[20];
 FILE *fili,*filo,*fil1;
 void interp(float x,float se,int knwy){int linear,twice,nct,jp1,jp2;
  float fax,fa1,fa2,f,f1,dif;
 fax=(x-xsta1)/(xsta2-xsta1); nct=0;
 if(fax> .99) fax=1.;
 if(fax< .01) fax=0.;
 jp1=ip1-1;
 jp2=ip2-1;
do{  twice=1;
 while ((ip1<n) && (yy>y[ip1][0])){jp1=ip1;ip1++;}
 while ((ip1>1) && (yy<y[jp1][0])){ip1=jp1;jp1--;}
 if(fax<1.e-5) goto L50;
 while ((ip2<n) && (yy>y[ip2][1])){jp2=ip2;ip2++;}
 while ((ip2>1) && (yy<y[jp2][1])){ip2=jp2;jp2--;}
L50: fa1=(yy-y[jp1][0])/(y[ip1][0]-y[jp1][0]);
 fa2=(yy-y[jp2][1])/(y[ip2][1]-y[jp2][1]);
 asta=(1.-fax)*(a[jp1][0]+fa1*(a[ip1][0]-a[jp1][0]))+fax*(a[jp2][1]+fa2*(a[ip2][1]-a[jp2][1]));
 psta=(1.-fax)*(p[jp1][0]+fa1*(p[ip1][0]-p[jp1][0]))+fax*(p[jp2][1]+fa2*(p[ip2][1]-p[jp2][1]));
 qsta=(1.-fax)*(rks[jp1][0]+fa1*(rks[ip1][0]-rks[jp1][0]))+fax*(rks[jp2][1]+fa2*(rks[ip2][1]-rks[jp2][1]));
 fna=(1.-fax)*fn[0][0]+fax*fn[1][0];
 if(knwy) return;
 f=se-yy-q2g/(asta*asta);
 if(twice){
 twice=0;
 f1=f;
 yy=yy-.01;
 goto L50;}
 dif=.01*f1/(f1-f);
 nct++;
 yy=yy+.01-dif;
}while ((nct<10) && (fabs(dif)> .0001));
 if(nct==10) printf(" Failed to converge, dif= %10.4e yy= %10.4e %10.4e\n",dif,yy,se,q2g);
} //End of interp
 void slope(float x,float *se,float *eprime){
 interp(x,*se,0);
 eprime[0]=so-qn*pow(qsta*fna*pow(fabs(psta/asta),.666666667)/asta,2.);
}  // End of slope
void chtabl(int nosec,int m){
 int nvalue,imin,irm,ilm,ilp,irp,i,nsta;
 float xsta,zsta,ymax,dy,dy2,dys,yz,xr,xl,xr1,xl1,aa,pp,vs,al,ar,pl,pr,fk1,fk2,fk3,at,pt;
 float x[20],h[20];
 fscanf(fili,"%d %d %f %f %f %f %f %f %d",&nsta,&nvalue,&xsta,&fn[m][0],&fn[m][1],&fn[m][2],&xld,&xrd,&linear);
// nsta-Station No. starting at downstream end with1, nvalue-No. of pts to define sec.
// xsta-x position of station, n-main,n-left,n-right, xld-x at start of left channel.
// xrd-x at start of right channel, linear =1 if linear interpolation, 0=2nd degree polynomial.
 if(m) xsta2=xsta; else xsta1=xsta;
 if(nvalue>20){printf("program dimension to allow only 20 coordinate pairs");exit(0);}
 if(nsta!=nosec){printf("Next station with data is %4d\n Expecting data for station %4d",nsta,nosec);exit(0);}
 al=.001;ar=.001;pl=0.;pr=0.;fk2=0.,fk3=0.;
 for(i=0;i<nvalue;i++) fscanf(fili,"%f %f",&x[i],&h[i]);
 zsta=h[0]; imin=0; ymax=zsta;
 for(i=1;i<nvalue;i++){if(h[i]<zsta){zsta=h[i];imin=i;}
 if(h[i]>ymax) ymax=h[i];}
 if(h[imin+1]<zsta+1.e-5){t[0][m]=x[imin+1]-x[imin];xmid=.5*(x[imin+1]+x[imin]);p[0][m]=t[0][m];ir1=imin+1;}
   else {t[0][m]=0.;p[0][m]=0.;ir1=imin;xmid=x[imin];}
 xr1=x[ir1];xl1=x[imin]; aa=0.; pp=p[0][m]; a[0][m]=0.; y[0][m]=0.; il1=imin; il=il1-1; ir=ir1+1;
 dy=(ymax-zsta)/(float)n; dy2=.5*dy; dys=dy*dy; ilm=0; irm=nvalue-1;
 if(linear==0){irm=irm-1; ilm=1;}
 if(m) zsta2=zsta; else zsta1=zsta;
 if(iotab){fprintf(filo,"\nStation no.=%4d x =%10.1f Elev. Bot=%8.2f n's=%7.4f %6.4f %6.4f\n",nsta,xsta,zsta,fn[m][0],fn[m][1],fn[m][2]);
  fprintf(filo," No.  Depth   Amain   Aleft  Aright      A   Pmain  Pleft Pright    P     Top   S-En.  alpha\n");
 for(i=0;i<93;i++)fprintf(filo,"-"); fprintf(filo,"\n");}
 for(i=1;i<=n;i++){ y[i][m]=dy*(float)i; yz=y[i][m]+zsta;
  while ((ir<irm)&&(h[ir]<yz)){ir1=ir;ir++;}
  while ((il>ilm)&&(h[il]<yz)){il1=il;il--;}
 if(linear){xr=x[ir1]+(yz-h[ir1])/(h[ir]-h[ir1])*(x[ir]-x[ir1]);
   xl=x[il1]+(yz-h[il1])/(h[il]-h[il1])*(x[il]-x[il1]);} else {ilp=il-1;irp=ir+1;
 xr=(yz-h[ir])*(yz-h[irp])*x[ir1]/((h[ir1]-h[ir])*(h[ir1]-h[irp]))+(yz-h[ir1])*(yz-h[irp])*x[ir]/\
 ((h[ir]-h[ir1])*(h[ir]-h[irp]))+(yz-h[ir1])*(yz-h[ir])*x[irp]/((h[irp]-h[ir1])*(h[irp]-h[ir]));
 xl=(yz-h[il])*(yz-h[ilp])*x[il1]/((h[il1]-h[il])*(h[il1]-h[ilp]))+(yz-h[il1])*(yz-h[ilp])*x[il]/\
 ((h[il]-h[il1])*(h[il]-h[ilp]))+(yz-h[il1])*(yz-h[il])*x[ilp]/((h[ilp]-h[il1])*(h[ilp]-h[il]));}
 t[i][m]=xr-xl; if((xl>=xld)&&(xr<=xrd)){
 aa+=dy*(xr1-xl1)+dy2*(xr-xr1+xl1-xl);pp+=sqrt(dys+pow(xr-xr1,2.))+sqrt(dys+pow(xl1-xl,2.));pt=pp;at=aa;
 alpa[i][m]=1.;rks[i][m]=1.;}  else { if(xl<xld){
  al+=dy*(xld-xl1)+dy2*(xl1-xl);pl+=sqrt(dys+pow(xl1-xl,2.));aa+=dy*(xmid-xld);} else
  {pp+=sqrt(dys+pow(xl1-xl,2.));aa+=dy*(xmid-xl1)+dy2*(xl1-xl);}
 if(xr>xrd){ar+=dy*(xr1-xrd)+dy2*(xr-xr1);pr+=sqrt(dys+pow(xr-xr1,2.));aa+=dy*(xrd-xmid);} else
  {pp+=sqrt(dys+pow(xr-xr1,2.));aa+=dy*(xr1-xmid)+dy2*(xr-xr1);}
 at=aa+al+ar; pt=pp+pl+pr;fk1=cc*aa*pow(aa/pp,.66666667)/fn[m][0];
  if(al<0.) al=fabs(al); if(ar<0.)ar=fabs(ar);if(pl>.001) fk2=cc*al*pow(al/pl,.6666667)/fn[m][1];
   if(pr>.001) fk3=cc*ar*pow(ar/pr,.66666667)/fn[m][2];
  alpa[i][m]=at*at*(fk1*pow(fk1/aa,2.)+fk2*pow(fk2/al,2.)+fk3*pow(fk3/ar,2.))/pow(fk1+fk2+fk3,3.);
  rks[i][m]=fk1/(fk1+fk2+fk3);}
 if(aa>1.e-5){vs=q2g/(at*at); if(vs<5.*y[i][m]) e[i][m]=y[i][m]+vs*alpa[i][m];} else e[i][m]=0.;
 p[i][m]=pp; a[i][m]=aa; xr1=xr; xl1=xl;
 if(iotab>0) fprintf(filo,"%4d %6.3f %7.2f %7.2f %7.2f %7.2f %6.2f %6.2f %6.2f %6.2f %6.3f %6.3f %6.3f\n",\
    i+1,y[i][m],aa,al,ar,at,pp,pl,pr,pt,t[i][m],e[i][m],alpa[i][m]);}
}  //End of chtabl
void main(void){
 float se[1],de[1],xp[1],yp[1][1],wk1[1][13],tol,delx,yb,q,xbeg,xend,hy,hmin,g,g2,xs,h1,xz,fnl,fnr,fax;
 char unit[2];
 char *fmt40="%9.0f %7.2f %7.2f %7.2f %7.2f %7.2f %9.7f %6.4f %6.4f %6.4f %6.4f\n";
 int nstat,nsta,nvalue,i;
 printf("Give name of file that contains input data\n");scanf("%s",fnam);
 if((fili=fopen(fnam,"r"))==NULL){printf("File does not exist.\n");exit(0);}
 printf("Give name of output file\n"); scanf("%s",fnam);
 if((fil1=fopen(fnam,"w"))==NULL){printf("File cannot be opened\n");exit(0);}
 printf("Give: UNIT,IOTAB,NSTAT,TOL,DELX,YB,Q,XBEG,XEND\n");
 scanf("%s %d %d %f %f %f %f %f %f",&unit,&iotab,&nstat,&tol,&delx,&yb,&q,&xbeg,&xend);
if(iotab){printf("Give name of file for cross-section data\n");scanf("%s",fnam);
 if((filo=fopen(fnam,"w"))==NULL){printf("File cannot be opened\n");exit(0);}}
  h1=-.1; hmin=1.e-4; cc=1.486; g=32.2;
 if((unit=="SI") || (unit=="si")) { cc=1.; g=9.81; }
 g2=2.*g; qn=pow(q/cc,2.); q2g=q*q/g2; xs=xbeg; chtabl(1,0); chtabl(2,1);
 nsta=2; so=(zsta2-zsta1)/(xsta1-xsta2); yy=yb; ip1=n/2; ip2=n/2;
 interp(xs,yy,1);
 se[0]=yy+q2g/(asta*asta);
 fprintf(fil1," Solution to gradually varied flow in natural channel with\n  Q = %10.2f\n \
---------------------------------------------------------------------------------------\n\
     X         Y       E     Per.   Area Velocity  Bot. S.  n-main n-left n-right Qm/Qt\n \
---------------------------------------------------------------------------------------\n",q);
 fprintf(fil1,fmt40,xs,yy,se[0],psta,asta,q/asta,so,fn[0][0],fn[0][1],fn[0][2],qsta);
do{xz=xs+delx;
 odesolc(se,xs,xz,tol,h1,hmin,1); fax=(xz-xsta1)/(xsta2-xsta1);if(fax>.99)fax=1.;if(fax<.01)fax=0.;
 fnl=(1.-fax)*fn[0][1]+fax*fn[1][1]; fnr=(1.-fax)*fn[0][2]+fax*fn[1][2];
 fprintf(fil1,fmt40,xz,yy,se[0],psta,asta,q/asta,so,fna,fnl,fnr,qsta); xs=xz;
 if((xz<=xsta2) && (nsta<nstat)) {
for(i=0;i<n;i++){ y[i][0]=y[i][1];a[i][0]=a[i][1];p[i][0]=p[i][1];alpa[i][0]=alpa[i][1];
 rks[i][0]=rks[i][1];e[i][0]=e[i][1];} for(i=0;i<3;i++)fn[0][i]=fn[1][i];
 zsta1=zsta2; xsta1=xsta2; ip1=ip2; nsta++;
 chtabl(nsta,1); so=(zsta2-zsta1)/(xsta1-xsta2);}
}while (xz>xend);  fclose(fili); fclose(fil1); if(iotab) fclose(filo);
}
