      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NV=10)
      EXTERNAL AR,TOP,RH,PER,FUN
      CHARACTER*40 VAR1(5),ANS*1
      DIMENSION X(3),YY(2)
      COMMON /ALL/ Y(10),C0,QNS
      DATA var1/' Uniform depth (m) =','Bottom width (m)= '
     &,' Side slope  = ',' Flow velocity (m/s) =',
     &' Canal total cost  ($)  = '/
      WRITE(*,'(//30X,A\)') ' Profile of type 1 or 2:  ' 
      READ(*,*) ITYPE
      C0=0.
      IF(ITYPE.EQ.2) C0=1.
      WRITE(*,'(//,2X,A2)') '  '
      CALL KNOWN(Y,NV)
 2    WRITE(*,'(//10X,A\)')
     &' Is the canal Side Slope known or not ? [Y/N] '
      READ(*,'(A1)') ANS
      IF(ANS.EQ.'n'.OR.ANS.EQ.'N') THEN
      N=3
C   Initial value of the side slope
      X(3)=1./SQRT(3.)
      ELSE
      N=2
      WRITE(*,'(/20X,A\)') ' Side Slope  m = '
      READ(*,*) X(3)
      ENDIF
      QNS=Y(1)*Y(3)/SQRT(Y(2))
      SM=SQRT(1.+X(3)*X(3))
C Dimensions of the most efficient section are used to get
C the initial value of the variable Y0 and b
      X(1)=(4.*(QNS/(2.*SM-X(3)))**3)**.125
      X(2)=2.*X(1)*(SM-X(3))
      CALL NEWT(X,N)
      YY(1)=Y(1)/AR(X(1),X(2),X(3))
      CALL COST(YY,X)
      DO 10 I=1,3
10    WRITE(*,'(15X,A30,2X,F12.6)') VAR1(I),X(I)
      DO 20 I=1,2
20    WRITE(*,'(15X,A30,2X,F12.3)') VAR1(I+3),YY(I)
      END
      SUBROUTINE NEWT(X,N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION D(3,3),F(3),X(3)
      COMMON /ALL/ Y(10),C0,QNS
      DATA EPS,FAC,KMAX/.0000001,.001,25/
      ITER=0
 4    ITER=ITER+1
      DO 10 I=1,N
10    F(I)=FUN(X,I)
      DO 30 I=1,N
      DX=FAC*(X(I)+1.)
      X(I)=X(I)-DX
      DO 20 J=1,N
20    D(J,I)=(F(J)-FUN(X,J))/DX
30    X(I)=X(I)+DX
      CALL SOLVE(D,F,N)
      SUM=0.0
      DO 40 I=1,N
      X(I)=X(I)-F(I)
      IF(X(I).LT.0.) X(I)=0.001
40    SUM=SUM+F(I)*F(I)
      SUM=SQRT(SUM)
      IF(ITER.GT.KMAX) THEN
      WRITE(*,100) ITER
      ELSE
      IF(SUM.GT.EPS) GO TO 4
      ENDIF
      RETURN
 100  FORMAT(//20X,' Does not converge after:',I4,
     &	' ITERATIONS'/)
      RETURN
      END
      FUNCTION FUN(X,I)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(3)
      COMMON /ALL/ Y(10),C0,QNS
      GO TO (4,6,8),I
 4    FUN=AR(X(1),X(2),X(3))*
     &	RH(X(1),X(2),X(3))**.66666667-QNS
      RETURN
 6    CALL DIFF(X,DCY,DCB,DCM,DFY,DFB,DFM)
      FUN=DCY*DFB-DFY*DCB
      RETURN
 8    CALL DIFF(X,DCY,DCB,DCM,DFY,DFB,DFM)
      FUN=DCM*DFB-DFM*DCB
      RETURN
      END
      SUBROUTINE DIFF(X,DCY,DCB,DCM,DFY,DFB,DFM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(3)
      COMMON /ALL/ Y(10),C0,QNS
      EQUIVALENCE (Y(4),RV),(Y(5),EB),(Y(6),ER),
     &	(Y(7),CB) ,(Y(8),CR),(Y(9),CX),(Y(10),CE)
      Z=X(1)+RV
      SM=SQRT(1.+X(3)*X(3))
      B1=X(2)+2.*SM*EB
      RH1=RH(X(1),X(2),X(3))
      DCY=2.*SM*CB*EB+CX*TOP(Z,B1,X(3))+2.*CE*X(3)
      DCB=CR*ER+CX*(Z+ER)+CE
      DCM=2.*EB*X(3)*(ER*(CR+CX)+Z*(CB+CX)+CE)/SM+Z*(Z*CX+2.*CE)-C0*
     &ER**2*(CR+CX)
      DFY=5.*TOP(X(1),X(2),X(3))-4.*RH1*SM
      DFB=5.*X(1)-2.*RH1
      DFM=X(1)*(5.*X(1)-4.*RH1*X(3)/SM)
      RETURN
      END
      SUBROUTINE SOLVE(D,F,N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION D(3,3),F(3)
      DO 20 K=1,N-1
      DO 20 I=K,N-1
      XMULT=D(I+1,K)/D(K,K)
      DO 10 J=K+1,N
10    D(I+1,J)=D(I+1,J)-XMULT*D(K,J)
20    F(I+1)=F(I+1)-XMULT* F(K)
      F(N)=F(N)/D(N,N)
      F(N-1)=(F(N-1)- F(N)*D(N-1,N))/D(N-1,N-1)
      IF(N.GT.2) THEN
      F(N-2)=(F(N-2)-F(N-1)*D(N-2,N-1)-F(N)*D(N-2,N))/D(N-2,N-2)
      ENDIF
      RETURN
      END
      SUBROUTINE COST(YY,X)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION X(3),YY(2)
      COMMON /ALL/ Y(10),C0,QNS
      EQUIVALENCE (Y(4),RV),(Y(5),EB),(Y(6),ER),(Y(7),CB),(Y(8),CR),
     &(Y(9),CX),(Y(10),CE)
      Z=X(1)+RV
      SM=SQRT(1.+X(3)*X(3))
      B1=X(2)+2.*SM*EB
      YY(2)=CR*ER*(B1-C0*X(3)*ER)+2.*CB*EB*SM*Z+CX*(AR(Z,B1,X(3))+ ER*(
     &B1-C0*X(3)*ER))+CE*TOP(Z,B1,X(3))
      RETURN
      END
      SUBROUTINE KNOWN(Y,NV)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*40 VAR(10)
      DIMENSION Y(NV)
      DATA var/' Q Canal maximum Capacity (m3/s)   ',
     &' S0 Bottom slope                   ',
     &' n Manning coefficient             ',
     &' Rv Free board (m)                 ',
     &' Eb Sides lining thickness (m)     ',
     &' Er Bottom lining thickness(m)     ',
     &' Cb Sides lining unit cost  ($/m3)',
     &' Cr Bottom lining unit cost ($/m3)',
     &' Cx Excavation unit ($/m3)        ',
     &' Ce Right of way unit cost ($/m2) '/
      DO 10 I=1,NV
      WRITE(*,'(15X,A45,2X,A3\)') VAR(I),'= '
10    READ(*,*) Y(I)
      RETURN
      END
      FUNCTION AR(Y,B,FM)
      IMPLICIT REAL*8(A-H,O-Z)
      AR=(B+FM*Y)*Y
      RETURN
      END
      FUNCTION TOP(Y,B,FM)
      IMPLICIT REAL*8(A-H,O-Z)
      TOP=B+2.*FM*Y
      RETURN
      END
      FUNCTION PER(Y,B,FM)
      IMPLICIT REAL*8(A-H,O-Z)
      PER=B+2.*Y*SQRT(1.+FM*FM)
      RETURN
      END
      FUNCTION RH(Y,B,FM)
      IMPLICIT REAL*8(A-H,O-Z)
      RH=AR(Y,B,FM)/PER(Y,B,FM)
      RETURN
      END