C  This program is based on the PREISSMANN method & uses double Sweep to solve eqs.
      PARAMETER(ND=41,NDT=100)  ! ND= No. of grid pts. NDT= No. time steps allowed.
      REAL Y(ND),Q(ND),Y1(ND),Q1(ND),B(ND),FM(ND),FN(ND),SO(ND),A(ND),
     &P(ND),T(ND),SMS(ND),QGIU(0:NDT),QGID(0:NDT),ALF(ND),FK(ND),
     &DKDY(ND),H(ND),FB(ND),C(ND),D(ND),FG(ND),H1(ND
     &),FB1(ND),C1(ND),D1(ND),FG1(ND),E(ND),F(ND),FL(ND),FMM(ND),FNN(ND)
      DATA ONE/-1./
      READ(2,*) IOUT,NFORW,NX,NT,IFREQ,DELT,DELX,G,DELTA,IUBC,IDBC
C IUBC & IDBC are Upst. & Downst B.C. according to: 1-DEPTH known(given in
C  QGIU or QGID;  2-FLOWRATE known(given in QGIU or QGID);  3-STAGE-DISCHARGE
C  given as pairs Y and Q in QGIU or QGID; 4-H(t)=y+Q*Q/(2gA*A) given in
C  QGIU and VELOCITY known for downstr. B.C. & given in QGID.
      G2=2.*G
      CMAN=1.
      IF(G.GT.30.) CMAN=1.486
      DXT=DELX/DELT
      GDELT=G*DELT
      GTDELT=GDELT*DELTA
      GEDELT=G2*DELTA*DELT
      NXM=NX-1
      DO 10 I=2,NX
      Q(I)=ONE
      B(I)=ONE
      FM(I)=ONE
      FN(I)=ONE
      ALF(I)=ONE
10    SO(I)=ONE
      DO 12 I=1,NT
      QGIU(I)=ONE
12    QGID(I)=ONE
      READ(2,*) (Q(I),I=1,NX)
      READ(2,*) (B(I),I=1,NX)
      READ(2,*) (FM(I),I=1,NX)
      READ(2,*) (FN(I),I=1,NX)
      READ(2,*) (SO(I),I=1,NX)
      READ(2,*) (ALF(I),I=1,NX)
      READ(2,*) (QGIU(I),I=0,NT)
      READ(2,*) (QGID(I),I=0,NT)
      DO 20 I=2,NX
      IM=I-1
      IF(Q(I).EQ.ONE) Q(I)=Q(IM)
      IF(B(I).EQ.ONE) B(I)=B(IM)
      IF(FM(I).EQ.ONE) FM(I)=FM(IM)
      IF(FN(I).EQ.ONE) FN(I)=FN(IM)
      IF(SO(I).EQ.ONE) SO(I)=SO(IM)
      IF(ALF(I).EQ.ONE) ALF(I)=ALF(IM)
20    SMS(I)=2.*SQRT(FM(I)**2+1.)
      SMS(1)=2.*SQRT(FM(1)**2+1.)
      NUSD=0
      NDSD=0
      DO 22 I=1,NT
      IF(QGIU(I).EQ.ONE) THEN
      IF(IUBC.NE.3) THEN
      QGIU(I)=QGIU(I-1)
      ELSE IF(NUSD.EQ.0) THEN
      NUSD=I-2
      ELSE
      GO TO 18
      ENDIF
      ENDIF
18    IF(QGID(I).EQ.ONE) THEN
      IF(IDBC.NE.3) THEN
      QGID(I)=QGID(I-1)
      ELSE IF(NDSD.EQ.0) THEN
      NDSD=I-2
      ELSE
      GO TO 22
      ENDIF
      ENDIF
22    CONTINUE
      JUBC=NUSD/2
      JDBC=NDSD/2
      IF(NFORW.EQ.1) THEN
      READ(2,*)(Y(I),I=1,NX)
      ELSE
      READ(2,*)(Y(I),I=NX,1,-1)
      ENDIF
      K=0
25    K=K+1
      DO 30 I=1,NX
      T(I)=B(I)+2.*FM(I)*Y(I)
      P(I)=B(I)+SMS(I)*Y(I)
      A(I)=(B(I)+FM(I)*Y(I))*Y(I)
      FK(I)=CMAN/FN(I)*A(I)*(A(I)/P(I))**.6666667
30    DKDY(I)=FK(I)/A(I)*(5.*B(I)/3.-2.*A(I)/3./P(I)*SMS(I))
      IF(MOD(K-1,IFREQ).EQ.0) THEN
      WRITE(IOUT,110) DELT*FLOAT(K-1)
110   FORMAT(///1X,'Solution for time=',F8.2/1X,57('-')/,4X,'x',7X,'Y',
     &7X,'V',7X,'P',7X,'Q',7X,'A',5X,'TOP'/1X,57('-'))
      WRITE(IOUT,120) (DELX*FLOAT(I-1),Y(I),Q(I)/A(I),P(I),Q(I),A(I),
     &T(I),I=1,NX)
120   FORMAT(F8.1,6F8.3)
      ENDIF
      IF(K.GT.NT) STOP
C  equation coefficients
      A0=4.*DELTA/DXT
      DO 40 I=1,NX-1
      TTT=T(I+1)+T(I)
      TTT2=TTT*TTT
      VV=Q(I)/A(I)
      VV2=VV*VV
      VVP=Q(I+1)/A(I+1)
      VVP2=VVP*VVP
      H(I)=1.-A0*(Q(I+1)-Q(I))/TTT2*2.*FM(I+1)
      FB(I)=A0/TTT
      C(I)=-H(I)
      D(I)=FB(I)
      FG(I)=-4./DXT*(Q(I+1)-Q(I))/TTT
      A1=DELTA/DXT
      A3=.5*(VVP*T(I+1)+VV*T(I))
      A4=ALF(I+1)*VVP2+ALF(I)*VV2
      H1(I)=A1*((Q(I+1)-Q(I))*(-Q(I+1)*T(I+1)*ALF(I+1)/A(I+1)**2)-
     &T(I+1)*A4-VVP2*(A(I)-A(I+1))*(2.*ALF(I+1)*T(I+1)/A(I+1))+G*T(I+1)
     &*(Y(I+1)-Y(I))-.5*VVP2*T(I+1)*(ALF(I+1)-ALF(I))+G*(A(I+1)+A(I)))+
     &GTDELT*Q(I+1)*ABS(Q(I+1))/FK(I+1)**2*(T(I+1)-2.*A(I+1)/FK(I+1)*
     &DKDY(I+1))-A3
      FB1(I)=1.+A1*(ALF(I+1)*VVP+ALF(I)*VV+(Q(I+1)-Q(I))*ALF(I+1)/A(I+1)
     &-(A(I+1)-A(I))*2.*ALF(I+1)*VVP2+(ALF(I+1)-ALF(I))*VVP)+GEDELT*
     &A(I+1)*ABS(Q(I+1))/FK(I+1)**2
      C1(I)=A3-A1*((Q(I+1)-Q(I))*(-Q(I)*T(I)*ALF(I)/A(I)**2)+T(I)*A4-VV2
     &*(A(I)-A(I+1))*(2.*ALF(I)*T(I)/A(I))+G*T(I)*(Y(I+1)-Y(I))-.5*VV2*
     &(ALF(I+1)-ALF(I))-G*(A(I+1)+A(I)))-GTDELT*Q(I)*ABS(Q(I))/FK(I)**2*
     &(T(I)-2.*A(I)/FK(I)*DKDY(I))
      D1(I)=-1.-A1*(-ALF(I+1)*VVP-ALF(I)*VV+(Q(I+1)-Q(I))*ALF(I)/A(I)-
     &(A(I+1)-A(I))*2.*ALF(I)*VV2+(ALF(I+1)-ALF(I))*VV)-GEDELT*A(I)*
     &ABS(Q(I))/FK(I)**2
      FG1(I)=-((Q(I+1)-Q(I))*(ALF(I+1)*VVP+ALF(I)*VV)-(A(I+1)-A(I))*(
     &ALF(I+1)*VVP2+ALF(I)*VV2)+G*(Y(I+1)-Y(I))*(A(I+1)+A(I))+(.5*Q(I+1)
     &*VVP+.5*Q(I)*VV)*(ALF(I+1)-ALF(I)))/DXT-GDELT*(Q(I+1)*ABS(Q(I+1))*
     &A(I+1)/FK(I+1)**2+Q(I)*ABS(Q(I))*A(I)/FK(I)**2)+GDELT*SO(I)*(A(I)+
     &A(I+1))
40    CONTINUE
C  compute E1, F1 from boundary condition at point I=1
      IF(IUBC.EQ.1) THEN                !Y(0,t) is given
      E(1)=1000000.
      F(1)=-1000000.*(QGIU(K)-Y(1))
      ELSE IF(IUBC.EQ.2) THEN                !Q(0,T) is given
      E(1)=0.
      F(1)=QGIU(K)-Q(1)
      ELSE IF(IUBC.EQ.3)THEN  !stage-discharge is given in tabulated form
      CALL BOUNDY(NUSD,JUBC,QGIU,Y(1),f1,E(1))
      F(1)=f1-Q(1)
      ELSE                          ! Ho(t)=Y+V**2/2g is given
      TT=B(1)+2.*FM(1)*Y(1)
      AA=(B(1)+FM(1)*Y(1))*Y(1)
      f1=AA*SQRT(G2*(QGIU(K)-Y(1)))
      VV=f1/AA
      E(1)=TT*VV-AA*G/VV
      F(1)=f1-Q(1)
      ENDIF
C compute Li, Mi, Ni, and E(i+1), F(i+1)
      DO 50 I=1,NX-1
      CC1=C(I)+D(I)*E(I)
      FL(I)=H(I)/CC1
      FMM(I)=FB(I)/CC1
      FNN(I)=-(FG(I)+D(I)*F(I))/CC1
      CC2=FB1(I)*CC1-FB(I)*(C1(I)+D1(I)*E(I))
      E(I+1)=(H(I)*(C1(I)+D1(I)*E(I))-H1(I)*(C(I)+D(I)*E(I)))/CC2
      F(I+1)=((FG1(I)+D1(I)*F(I))*(C(I)+D(I)*E(I))-(FG(I)+D(I)*F(I))*
     &(C1(I)+D1(I)*E(I)))/CC2
50    CONTINUE
      IF(IDBC.EQ.1) THEN                 !Y(L,t) is given
      DY=QGID(K)-Y(NX)
      DQ=E(NX)*DY+F(NX)
      ELSE IF(IDBC.EQ.2) THEN            !Q(L,t) is given
      DQ=QGID(K)-Q(NX)
      DY=(DQ-F(NX))/E(NX)
      ELSE IF(IDBC.EQ.3) THEN !stage-discharge in tabulated form is given
      CALL BOUNDY(NDSD,JDBC,QGID,Y(NX),f2,df2dy)
      DY=(f2-F(NX)-Q(NX))/(E(NX)-df2dy)  
      DQ=E(NX)*DY+F(NX)
      ELSE                      !V(L,t) is given
      DY=(QGID(K)*A(NX)-Q(NX)-F(NX))/(E(NX)-QGID(K)*T(NX))
      DQ=E(NX)*DY+F(NX)
      ENDIF
      Y1(NX)=Y(NX)+DY
      Q1(NX)=Q(NX)+DQ
C Compute DQ, DY, and compute new Y, Q at new time.
      DO 60 I=NX-1,1,-1
      DY1=FL(I)*DY+FMM(I)*DQ+FNN(I)
      DQ1=E(I)*DY1+F(I)
      Y1(I)=Y(I)+DY1
      Q1(I)=Q(I)+DQ1
      DY=DY1
      DQ=DQ1
60    CONTINUE
C reinitialize the values for next time step
      DO 70 I=1,NX
      Q(I)=Q1(I)
      Y(I)=Y1(I)
70    CONTINUE
      GO TO 25
      END
      SUBROUTINE BOUNDY(N,JJ,QGIV,YY,f1,df1dy)
      REAL QGIV(0:100)
10    IF(QGIV(JJ+2).GT.YY .OR. JJ+2.GE.N) GO TO 20
      JJ=JJ+2
      GO TO 10
20    IF(QGIV(JJ).LE.YY .OR.JJ.LT.1) GO TO 30
      JJ=JJ-2
      GO TO 20
30    df1dy=(QGIV(JJ+3)-QGIV(JJ+1))/(QGIV(JJ+2)-QGIV(JJ))
      f1=QGIV(JJ+1)+df1dy*(YY-QGIV(JJ))
      RETURN
      END