#include <math.h>
#include <stdlib.h>
extern void slope(float x,float *y,float *dy);
float yt[5],dy1[5],dyt[5],dym[5];
void ruku4s(int nm,float x,float dx, float *y){
/* nm = No. of ODE's, or order of ODE; x=indep. var. dx=inc. ind. var;
    y=dep. var. (array, i.e. pointer, allocated with nm elements)
    yt,dy1,dyt & dym must be global arrays (pointers) dimensioned to nm */
 float dx5,xh;  int i;
 dx5=.5*dx; xh=x+dx5;
 slope(x,y,dy1);    /*  1st sub-step */
 for(i=0;i<nm;i++) yt[i]=y[i]+dx5*dy1[i];
 slope(xh,yt,dyt);   /* 2nd sub-step */
 for(i=0;i<nm;i++) yt[i]=y[i]+dx5*dyt[i];
 slope (xh,yt,dym);   /* 3rd sub-step  */
 for(i=0;i<nm;i++){yt[i]=y[i]+dx*dym[i];dym[i]+=dyt[i];}
 slope (x+dx,yt,dyt);    /* 4th sub-step   */
 for(i=0;i<nm;i++) y[i]+=dx*((dy1[i]+dyt[i])/6.+dym[i]/3.);
}   /*  End of function ruku4s  */
void rukust(int neq,float *dxs,float xbeg,float xend,float error,float *y,float *ytt){
int i; float errm,dx,x,dx5,x1,yori[5];
 x1=xbeg; dx=*dxs;
L1: for(i=0;i<neq;i++){ytt[i]=y[i]; yori[i]=y[i];} x=x1; if(fabs(x+dx)>fabs(xend)) dx=xend-x;
L2: dx5=.5*dx;
 ruku4s(neq,x,dx5,y); /* Solve with 1/2 inc. */
 ruku4s(neq,x+dx5,dx5,y);
 x1=x+dx; if(fabs(x1)>fabs(xend)-1.e-8) return;
 ruku4s(neq,x,dx,ytt); /* Solve with full inc. */
 errm=0.; x1=x+dx;
 for(i=0;i<neq;i++){ytt[i]=y[i]-ytt[i];
//   errm=max(errm,fabs(ytt[i]/y[i]));}
 if(fabs(ytt[i]/y[i])>errm) errm=fabs(ytt[i]/y[i]);}
 if(errm==0.){dx*=5.;*dxs=dx;goto L1;} else {errm/=error; dx/=pow(errm,.2);*dxs=dx;
  if(errm > 1.){for(i=0;i<neq;i++){ytt[i]=yori[i];y[i]=yori[i];}
  goto L2;} }
 for(i=0;i<neq;i++) y[i]+=ytt[i]/15.;
 goto L1;
}  /* End of function rukust */