C  Solves submerged flow by gate downstream from reservoir.
      LOGICAL*2 SUBMER
      INTEGER*2 INDX(5)
      REAL F(5),D(5,5),X(5),KL2,KE1,KL,KE
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,B2,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,yG2,
     &SUBMER
      EQUIVALENCE (Q,X(1)),(Ybeg,X(2)),(Y1,X(3)),(Y3,X(4)),(Y,X(5))
      WRITE(*,*)' GIVE:IOUT,TOL,ERR,FN,SO,B1,B2,y2,H,L,g,KL,KE'
      READ(*,*) IOUT,TOL,ERR,FN,SO,B1,B2,yG2,H,FL,G,KL,KE
C  yG2 is the dimensionless depth of flow under the gate y2=Y2/Y1
      SUBMER=.FALSE.
      N=4
      IF(G.GT.30.) THEN
      CC=1.486
      ELSE
      CC=1.
      ENDIF
      G2=2.*G
      KL2=1.+KL2
      KE1=1.+KE
      WRITE(*,*)' GIVE guess for: Q,Ybeg,Y1,Y3,Y'
      READ(*,*) X
2     NCT=0
1     DO 10 I=1,N
      F(I)=FUN(I)
      DO 10 J=1,N
      DX=.005*X(J)
      X(J)=X(J)+DX
      D(I,J)=(FUN(I)-F(I))/DX
10    X(J)=X(J)-DX
      CALL SOLVEQ(N,5,D,F,1,DD,INDX)
      SUM=0.
      DO 20 I=1,N
      X(I)=X(I)-F(I)
20    SUM=SUM+ABS(F(I))
      NCT=NCT+1
      WRITE(*,*)' NCT=',NCT,SUM
      WRITE(*,*) (X(I),I=1,N)
      IF(NCT.LT.30 .AND. SUM.GT. ERR) GO TO 1
      Fr1=Q/(B1*Y1)/SQRT(G*Y1)
      Y2=yG2*Y1
      IF(.NOT.SUBMER) Y=.5*Y3*(SQRT(1.+8.*(Q/(B2*Y3))**2/(G*Y3))-1.)
      WRITE(IOUT,100) yG2,Y2,Y1,Fr1,Q/B1,Q,Ybeg,Y3,Y
100   FORMAT(F5.2,2F8.3,F8.4,5F8.3)
      IF(Y.LT.Y2 .AND. .NOT.SUBMER) THEN
      SUBMER=.TRUE.
      N=5
      ELSE IF(Y.LT.Y2 .AND. SUBMER) THEN
      SUBMER=.FALSE.
      N=4
      ENDIF
      WRITE(*,110) Y2,Q,Ybeg,Y1,Y3,Y,SUBMER
110   FORMAT(F10.3,F10.2,4F8.3,L8,/,' Give new y2 ')
      READ(*,*) yG2
      IF(yG2.GT. 0.) GO TO 2
      END
      FUNCTION FUN(II)
      EXTERNAL DYX
      LOGICAL*2 SUBMER
      REAL X(5),W(1,13),KL2,KE1,Y(1),DY(1),XP(1),YP(1,1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/B1,B2,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,yG2,
     *SUBMER
      Y2=yG2*X(3)
      H1=-.05
      HMIN=.001
      Q2G=X(1)*X(1)/G2
      Q2S1=Q2G/B1**2
      Q2S2=Q2G/B2**2
      IF(SUBMER) THEN
      GO TO (1,2,3,3,5),II
      ELSE
      GO TO (1,2,3,5),II
      ENDIF
1     AA=B2*X(4)
      FUN=FN*X(1)-CC*AA*(AA/(B2+2.*X(4)))**.6666667*SQRT(SO)
      RETURN
2     FUN=H-X(2)-KE1*Q2S1/X(2)**2
      RETURN
3     IF(SUBMER) THEN
      IF(II.EQ.3) THEN
      FUN=X(3)+Q2S1/X(3)**2-X(5)-Q2S2/Y2**2
      ELSE
      FUN=2.*Q2S2-.5*(X(4)**2-X(5)**2)*Y2*X(4)/(X(4)-Y2)
      ENDIF
      ELSE
      FUN=X(3)+Q2S1/X(3)**2-Y2-Q2S2/Y2**2
      ENDIF
      RETURN
5     Y(1)=X(3)
      XX=FL
      XZ=0.
      IND=1
      QN=(FN*X(1)/CC)**2
      Q2G=X(1)*X(1)/G
      CALL ODESOL(Y,DY,1,XX,XZ,TOL,H1,HMIN,1,XP,YP,W,DYX)
      FUN=X(2)-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1),KL2,KE1,X(5)
      LOGICAL*2 SUBMER
      COMMON/TRAS/B1,B2,H,G,G2,KL2,KE1,FL,TOL,FN,SO,CC,QN,Q2G,X,yG2,
     &SUBMER
      YY=ABS(Y(1))
      P=B1+2.*YY
      A=B1*YY
      SF=QN*((P/A)**.666666667/A)**2
      DY(1)=(SO-SF)/(1.-Q2G*B1/A**3)
      RETURN
      END