      REAL Y(1),DY(1),XP(1),YP(1,1),W(1,13)
      LOGICAL NFS
      EXTERNAL DYX
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ DI,G,FL,TOL,FN,SO,QS,YC,DLIM,DI2,CU,ICRIT
C If icrit=1 then critical depth is solved at end of lateral inflow length
C If icrit=0 then the last input is taken as the depth at end.
C If icrit=2 then L is the specified length and Yc is the specified end depth
      WRITE(*,*)' Give: Dia,n,So,q*,g,TOL,icrit,(guess for) L,Yc(Yend)'
      READ(*,*) DI,FN,SO,QS,G,TOL,ICRIT,FL,YC
      DLIM=.93*DI
      G2=2.*G
      DI2=.25*DI**2
      CU=1.486
      IF(G.LT.30.) CU=1.
      IF(ICRIT.EQ.2) GO TO 12
      NCT=0
10    F1=FUN(FL)
      DIF=F1/(FUN(FL+1.)-F1)
      NCT=NCT+1
      FL=FL-DIF
      WRITE(*,*)' NCT=',NCT,DIF,FL
      IF(ABS(DIF).GT. .05 .AND. NCT.LT.30) GO TO 10
      WRITE(3,100) FL,QS*FL
100   FORMAT(' Length =',F9.1,' Flowrate =',F10.5)
12    DX=FL/20.
      H11=.05
      HMIN=1.E-5
      XX=FL
      NFS=.TRUE.
      WRITE(3,109)
109   FORMAT(/,'     X     Depth     Q       E        A      Fr',/,2X,
     &47('-'))
      Q=QS*FL
      COSB=1.-2.*YC/DI
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=DI2*(BETA-SINB*COSB)
      FR=SQRT(Q*Q*DI*SINB/(G*A**3))
      E=YC+(Q/A)**2/G2
      WRITE(3,110) FL,YC,Q,E,A,FR
      Y(1)=1.01*YC
      DO 20 I=1,20
      XZ=FL-DX*FLOAT(I)
      CALL ODESOLF(Y,DY,1,XX,XZ,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      Q=QS*XZ
      COSB=1.-2.*Y(1)/DI
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=DI2*(BETA-SINB*COSB)
      FR=SQRT(Q*Q*DI*SINB/(G*A**3))
      E=Y(1)+(Q/A)**2/G2
      WRITE(3,110) XZ,Y,Q,E,A,FR
110   FORMAT(F8.1,5F8.3)
      NFS=.FALSE.
20    XX=XZ
      END
      FUNCTION FUN(FLL)
      EXTERNAL DYX
      LOGICAL NFS
      REAL Y(1),DY(1),XP(1),YP(1,1),W(1,13)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ DI,G,FL,TOL,FN,SO,QS,YC,DLIM,DI2,CU,ICRIT
      HMIN=1.E-5
      Q=QS*FLL
      IF(ICRIT.EQ.0) THEN
      Y(1)=YC
      ELSE
C   Solves Critical depth
      NCT=0
1     IF(YC.GT.DI) YC=.95*DI
      COSB=1.-2.*YC/DI
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      A=DI2*(BETA-SINB*COSB)
      F2=Q*Q*DI*SINB-G*A**3
      NCT=NCT+1
      IF(MOD(NCT,2).EQ.0) GO TO 2
      YC1=YC
      YC=1.05*YC
      F1=F2
      GO TO 1
2     DIF=(YC-YC1)*F1/(F2-F1)
      YC=YC1-DIF
      IF(ABS(DIF).GT. .00001 .AND. NCT.LT.40) GO TO 1
      IF(NCT.GE.40) WRITE(*,*)' Failed with critical',YC,DIF
      Y(1)=1.1*YC
      ENDIF
      H11=.05
      NFS=.TRUE.
      CALL ODESOLF(Y,DY,1,FLL,0.,TOL,H11,HMIN,1,XP,YP,W,DYX,NFS)
      FUN=DLIM-Y(1)
      RETURN
      END
      SUBROUTINE DYX(XX,Y,DY)
      REAL Y(1),DY(1)
      COMMON NGOOD,NBAD,KMAX,KOUNT,DXSAVE
      COMMON /TRAS/ DI,G,FL,TOL,FN,SO,QS,YC,DLIM,DI2,CU,ICRIT
      Q=QS*XX
      YY=Y(1)
      IF(YY.LT. .001) YY=.001
      IF(YY.GT.DI) YY=DI-1.E-4
      COSB=1.-2.*YY/DI
      BETA=ACOS(COSB)
      SINB=SIN(BETA)
      P=DI*BETA
      A=DI2*(BETA-COSB*SINB)
      SF=(FN*Q/CU*(P/A)**.66666667/A)**2
      FR2=Q*Q/G*DI*SINB/A**3
      DY(1)=(SO-SF-1.5*Q*QS/(G*A*A))/(1.-FR2)
      RETURN
      END