/* Solves Chezys and Specific Energy for Y & Q by substituting Chezys Eq.
   into Energy and first solving for Y and thereafter Q.  The needed Chezy's 
   C is solved using Gauss_Seidel iteration (This is the procedure
   to use with a pocket calculator)  See program E_UN to solve any 2 variables. */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float b,m,d,h,cc,fms,c; int itype;
void areap(float y,float *a,float *p){float cosb,beta;
 if(itype){cosb=1.-2.*y/d;beta=acos(cosb);*p=d*beta;*a=.25*d*d*(beta-cosb*sin(beta));}
  else {*p=b+fms*y; *a=(b+m*y)*y;return; } }
float fun(float y){float *a,*p; areap(y,a,p);return(h-y-cc*((*a)/(*p))*c*c);}
void main(void){float g,dif,ke,y,f,q,e,so,vis,g32,cg,rh,c1,*a,*p; int mct,nct=0;
 printf("Give: g,viscosity,(0=trap or 1=cir)\n"); scanf("%f %f %d",&g,&vis,&itype);
 if(itype){printf("Give: D,e,So,H,Ke\n"); scanf("%f %f %f %f %f",&d,&e,&so,&h,&ke);}
  else {printf("Give: b,m,e,So,H,Ke\n"); scanf("%f %f %f %f %f %f",&b,&m,&e,&so,&h,&ke);
  fms=2.*sqrt(m*m+1.);} if(g>15.) c=100.; else c=70.;
 g32=-sqrt(32.*g);cg=.884*vis/(4.*sqrt(g)); cc=so*(1.+ke)/(2.*g); y=.8*h;
do{f=fun(y); dif=.05*f/(fun(y+.05)-f); y-=dif;printf("%d %f %f\n",++nct,dif,y);
 areap(y,a,p); rh=(*a)/(*p);q=c*(*a)*sqrt(rh*so); mct=0;
  do{c1=c;c=g32*log10(e/(12.*rh)+cg*c1*(*p)/q);}while((fabs(c-c1)>5.e-6) && (++mct<30));
  }while((nct<30) && (fabs(dif)>1.e-5));
 printf("Solution: Y = %8.3f Q = %10.2f C= %9.2f\n",y,q,c);
}