C Solves Chezys and Specific Energy for Y & Q by substituting Chezys Eq.
C into Energy and first solving for Y and thereafter Q.  The needed Chezy's
C C is solved using Gauss_Seidel iteration (This is the procedure
C to use with a pocket calculator)  See program E_UN to solve any 2 variables.
      COMMON B,FM,D,H,CC,FMS,C,ITYPE
      WRITE(*,*)' Give: g,viscosity,(0=trap or 1=cir)'
      READ(*,*) G,VIS,ITYPE
      IF(ITYPE.EQ.0) THEN
      WRITE(*,*)' Give: b,m,e,So,H,Ke'
      READ(*,*) B,FM,e,SO,H,FKE
      FMS=2.*SQRT(FM*FM+1.)
      ELSE
      WRITE(*,*)' Give: D,e,So,H,Ke'
      READ(*,*) D,e,SO,H,FKE
      ENDIF
      G32=-SQRT(32.*G)
      CG=.884*VIS/(4.*SQRT(G))
      CC=SO*(1.+FKE)/(2.*G)
      IF(G.GT.15.) THEN 
      C=100.
      ELSE
      C=60.
      ENDIF
      Y=.8*H
      NCT=0
10    F=FUN(Y)
      DIF=.05*F/(FUN(Y+.05)-F)
      Y=Y-DIF
      CALL AREAP(Y,A,P)
      Rh=A/P
      Q=C*A*SQRT(Rh*SO)
      MCT=0
12    C1=C
      C=G32*ALOG10(e/(12.*Rh)+CG*C1*P/Q)
      MCT=MCT+1
      IF(ABS(C-C1).GT. 5.E-6 .AND. MCT.LT.30) GO TO 12
      IF(MCT.EQ.30) WRITE(*,*)' Did not converge',C,C1
      NCT=NCT+1
      WRITE(*,*) NCT,DIF,Y,Q
      IF(NCT.LT.30 .AND. ABS(DIF).GT. 1.E-5) GO TO 10
      WRITE(*,100) Y,Q,C
100   FORMAT(' Solution: Y =',F8.3,' Q =',F10.2,' C=',F9.2)
      END
      SUBROUTINE AREAP(Y,A,P)
      COMMON B,FM,D,H,CC,FMS,C,ITYPE
      IF(ITYPE.EQ.1) THEN
      COSB=1.-2.*Y/D
      BETA=ACOS(COSB)
      P=D*BETA
      A=.25*D*D*(BETA-COSB*SIN(BETA))
      ELSE
      P=B+FMS*Y
      A=(B+FM*Y)*Y
      ENDIF
      RETURN
      END
      FUNCTION FUN(Y)
      COMMON B,FM,D,H,CC,FMS,C,ITYPE
      CALL AREAP(Y,A,P)
      FUN=H-Y-CC*(A/P)*C*C
      RETURN
      END